use crate::math_symbol_key::*;
pub static HANJA_ENTRIES: &[(&str, &[(&str, &str)])] = &[
("가", &[("可", "옳을 가"),("家", "집 가"),("加", "더할 가"),("歌", "노래 가"),("價", "값 가"),("街", "거리 가"),("假", "거짓 가"),("佳", "아름다울 가"),("暇", "겨를 가"),("架", "시렁 가"),("賈", "값 가, 값/성 가"),("伽", "절 가"),("柯", "가지 가"),("迦", "부처이름 가"),("軻", "수레 가기 힘들 가, 바퀴굴대 가"),("嘉", "아름다울 가"),("駕", "멍에 가"),("嫁", "시집갈 가"),("稼", "심을 가, 곡식심을 가"),("哥", "노래 가, 형언니 가"),("呵", "꾸짖을 가"),("苛", "매울 가, 까다로울 가"),("袈", "가사 가"),("訶", "꾸짖을 가"),("枷", "목칼 가, 도리깨채 가, 형구 가"),("珂", "옥 이름 가"),("茄", "가지 가"),("痂", "헌데 딱지 가"),("跏", "책상다리할 가, 도사리어 앉을 가"),("斝", "옥잔 가"),("葭", "갈대 가"),("舸", "큰 배 가"),("笳", "갈잎피리 가"),("哿", "좋을 가"),("坷", "험할 가"),("檟", "오동나무 가"),("謌", "歌와 同字"),("珈", "머리꾸미개 가"),("榎", "檟와 同字"),("仮", "假의 略字"),("傢", "세간 가"),("咖", "커피차 가, 커피의 음차로 쓰는자 가"),("耞", "도리깨 가"),]),
("가경동", &[("佳景洞", "지명"),]),
("가곡동", &[("佳谷洞", "지명"),("駕谷洞", "지명"),]),
("가곡면", &[("佳谷面", "지명"),]),
("가금면", &[("可金面", "지명"),]),
("가나다", &[("加那陀", "캐나다"),("加奈陀", "캐나다"),]),
("가나태", &[("加那太", "캐나다"),]),
("가남면", &[("加南面", "지명"),]),
("가납", &[("加納", "가나"),]),
("가능동", &[("佳陵洞", "지명"),]),
("가대동", &[("加大洞", "지명"),]),
("가덕면", &[("加德面", "지명"),]),
("가락동", &[("可樂洞", "지명"),("駕洛洞", "지명"),]),
("가례면", &[("嘉禮面", "지명"),]),
("가륜비아", &[("哥倫比亞", "콜롬비아"),]),
("가리봉동", &[("加里峰洞", "지명"),]),
("가봉", &[("加蓬", "가봉"),]),
("가북면", &[("加北面", "지명"),]),
("가사달리가", &[("哥斯達利加", "코스타리카"),]),
("가사동", &[("加士洞", "지명"),]),
("가산동", &[("加山洞", "지명"),]),
("가산면", &[("加山面", "지명"),("架山面", "지명"),]),
("가수동", &[("佳水洞", "지명"),]),
("가수원동", &[("佳水院洞", "지명"),]),
("가야곡면", &[("可也谷面", "지명"),]),
("가야동", &[("伽倻洞", "지명"),]),
("가야면", &[("伽倻面", "지명"),]),
("가야읍", &[("伽倻邑", "지명"),]),
("가양동", &[("加陽洞", "지명"),("佳陽洞", "지명"),]),
("가연방", &[("加連邦", "캐나다"),]),
("가오동", &[("加午洞", "지명"),]),
("가운동", &[("加雲洞", "지명"),]),
("가은읍", &[("加恩邑", "지명"),]),
("가음동", &[("加音洞", "지명"),]),
("가음면", &[("佳音面", "지명"),]),
("가음정동", &[("加音丁洞", "지명"),]),
("가장동", &[("佳長洞", "지명"),("佳狀洞", "지명"),("佳庄洞", "지명"),]),
("가재동", &[("佳才洞", "지명"),]),
("가정동", &[("佳亭洞", "지명"),("柯亭洞", "지명"),]),
("가조면", &[("加祚面", "지명"),]),
("가좌동", &[("加佐洞", "지명"),("佳佐洞", "지명"),]),
("가주동", &[("佳主洞", "지명"),("佳州洞", "지명"),]),
("가창면", &[("嘉昌面", "지명"),]),
("가천", &[("佳川", "지명"),]),
("가천면", &[("伽泉面", "지명"),]),
("가평군", &[("加平郡", "지명"),]),
("가평읍", &[("加平邑", "지명"),]),
("가포동", &[("架浦洞", "지명"),]),
("가학동", &[("駕鶴洞", "지명"),]),
("가현동", &[("加峴洞", "지명"),]),
("가회동", &[("嘉會洞", "지명"),]),
("가회면", &[("佳會面", "지명"),]),
("가흥동", &[("可興洞", "지명"),]),
("각", &[("各", "각각 각"),("角", "뿔 각"),("脚", "다리 각, 종아리 각"),("覺", "깨달을 각"),("閣", "문설주 각, 다락집 각"),("刻", "새길 각"),("却", "물리칠 각"),("珏", "쌍옥 각"),("恪", "삼갈 각, 공경할 각"),("殼", "껍질 각"),("慤", "삼갈 각, 정성 각"),("桷", "서까래 각"),("搉", "칠 각"),("卻", "却의 本字"),("咯", "토할 각"),("埆", "메마를 각"),("擱", "놓을 각"),]),
("각남면", &[("角南面", "지명"),]),
("각북면", &[("角北面", "지명"),]),
("각산", &[("角山", "지명"),]),
("각화동", &[("角化洞", "지명"),]),
("간", &[("間", "틈 간, 사이 간"),("干", "방패 간"),("看", "볼 간"),("乾", "마를 간"),("幹", "줄기 간, 우물난간 간"),("姦", "간사할 간"),("刊", "책 펴낼 간"),("肝", "간 간"),("簡", "대쪽 간"),("懇", "정성 간, 간절할 간"),("奸", "범할 간, 간악할 간, 간사할 간"),("艮", "괘이름 간, 간방 간"),("杆", "지레 간, 나무이름 간, 산뽕나무 간"),("諫", "간할 간"),("艱", "어려울 간, 고생살이 간"),("揀", "가릴 간, 분별할 간"),("澗", "산골물 간"),("竿", "장대 간, 화살대 간, 횃대 간, 대줄기 간"),("墾", "따비질할 간, 개간할 간"),("癎", "경풍 간, 간질 간"),("侃", "강직할 간"),("柬", "가릴 간"),("磵", "산골 시내 간, 석간수 간, 산골물 간"),("桿", "줄기"),("稈", "짚 간, 볏짚 간"),("赶", "달릴 간"),("衎", "즐길 간, 바를 간"),("慳", "아낄 간"),("榦", "幹의 本字"),("玕", "옥돌 간"),("迀", "구할 간, 권할 간"),("偘", "侃과 同字"),("秆", "稈과 同字"),("栞", "도표 간"),("茛", "독초이름 간, 미나리아재비 간"),("齦", "물을 간"),]),
("간동면", &[("看東面", "지명"),]),
("간보채", &[("柬蒲塞", "캄보디아"),("柬埔寨", "캄보디아"),]),
("간석동", &[("間石洞", "지명"),]),
("간성읍", &[("杆城邑", "지명"),]),
("간전면", &[("艮田面", "지명"),]),
("갈", &[("渴", "목마를 갈, 급할 갈"),("葛", "칡 갈"),("鞨", "말갈나라 갈, 말갈보석 갈"),("竭", "다할 갈, 마를 갈"),("喝", "꾸짖을 갈, 성낸 소리 갈"),("褐", "털베 갈, 굵은 베 갈, 천한사람 갈, 갈옷 갈"),("曷", "어찌 갈, 그칠 갈, 벌레이름 갈"),("碣", "비 갈, 우뚝선 돌 갈, 동해의 산이름 갈"),("蝎", "전갈 갈, 빈대 갈"),("乫", "땅이름 갈"),("羯", "불친 양 갈, 땅이름 갈"),("秸", "볏짚 갈, 짚 고갱이 갈"),("楬", "패를 써서 표시할 갈"),("噶", "벼슬이름 갈, 땅이름 갈"),("蠍", "전갈 갈"),]),
("갈공", &[("葛公", "지명"),]),
("갈곶동", &[("葛串洞", "지명"),]),
("갈마동", &[("葛馬洞", "지명"),]),
("갈말읍", &[("葛末邑", "지명"),]),
("갈매동", &[("葛梅洞", "지명"),]),
("갈산", &[("葛山", "지명"),]),
("갈산동", &[("葛山洞", "지명"),]),
("갈산면", &[("葛山面", "지명"),]),
("갈월동", &[("葛月洞", "지명"),]),
("갈전동", &[("葛田洞", "지명"),]),
("갈천동", &[("葛川洞", "지명"),]),
("갈치동", &[("葛峙洞", "지명"),]),
("갈현동", &[("葛峴洞", "지명"),]),
("감", &[("感", "감동할 감, 찌를 감, 깨달을 감, 느낄 감"),("減", "덜 감, 무지러질 감, 가벼울 감, 물이름 감, 감할 감"),("敢", "감히 감, 구태여 감, 날랠 감, 용맹할 감"),("甘", "달 감, 달게 여길 감"),("監", "거느릴 감, 살필 감, 볼 감, 벼슬 감, 감옥 감"),("鑑", "거울 감, 밝을 감, 비칠 감, 경계할 감"),("憾", "섭섭할 감, 한할 감, 한혐할 감"),("邯", "조나라 서울"),("堪", "견딜 감, 이길 감, 맡을 감, 하늘 감, 산 모양이 기괴할 감"),("勘", "마감할 감, 정할 감"),("瞰", "굽어볼 감, 내려다 볼 감"),("紺", "아청 감, 보랏빛 감, 연보라 감"),("柑", "감귤 감, 감자 감"),("疳", "감질병 감, 궤양 감, 창병 감, 종기 아플 감"),("坎", "구덩이 감, 험할 감, 작은 잔 감, 괘 이름 감, 불우하여 뜻을 이루지 못할 감"),("戡", "찌를 감, 이길 감, 죽일 감"),("鑒", "鑑과 同字, 거울 감"),("嵌", "깊은 골 감, 곁굴 감, 깊은 산 감, 산골짜기 감"),("橄", "감람나무 감"),("龕", "취할 감, 이길 감, 감실 감"),("撼", "흔들 감, 움직일 감, 깨뜨릴 감"),("欿", "서운할 감, 찌푸릴 감, 걱정할 감"),("弇", "뚜껑 감, 사람이름 감"),("嵁", "산 험할 감"),("憨", "어리석을 감, 미련할 감"),("坩", "도가니 감"),("埳", "구덩이 감"),("凵", "입벌리다"),]),
("감곡면", &[("甘谷面", "지명"),]),
("감만동", &[("戡蠻洞", "지명"),]),
("감문면", &[("甘文面", "지명"),]),
("감물면", &[("甘勿面", "지명"),]),
("감북동", &[("甘北洞", "지명"),]),
("감삼동", &[("甘三洞", "지명"),]),
("감이동", &[("甘二洞", "지명"),]),
("감일동", &[("甘一洞", "지명"),]),
("감전동", &[("甘田洞", "지명"),]),
("감정동", &[("坎井洞", "지명"),]),
("감천동", &[("甘川洞", "지명"),]),
("감천면", &[("甘川面", "지명"),("甘泉面", "지명"),]),
("감포읍", &[("甘浦邑", "지명"),]),
("감호동", &[("甘湖洞", "지명"),]),
("갑", &[("甲", "갑옷 갑, 첫째 천간 갑, 비롯할 갑, 떡잎 날 갑, 법령 갑, 대궐 갑"),("閘", "문 빗장 갑, 물 문 갑"),("岬", "산 허구리 갑, 줄이 느런할 갑, 산허리 갑"),("鉀", "갑옷 갑"),("匣", "궤 갑, 상자 갑, 궤짝 갑"),("胛", "어깻죽지 갑"),("韐", "가죽바지 갑"),]),
("갑동", &[("甲洞", "지명"),]),
("갑제동", &[("鉀堤洞", "지명"),]),
("갑천면", &[("甲川面", "지명"),]),
("강", &[("江", "가람 강, 물 강"),("强", "강할 강, 나머지 강, 바구미 강"),("講", "강론할 강, 강구할 강, 익힐 강, 강화할 강"),("降", "내릴 강, 떨어질 강, 돌아갈 강"),("康", "편안할 강, 즐거울 강, 다섯거리 강"),("綱", "벼리 강, 근본 강, 법 강, 대강 강"),("鋼", "쇠 강, 강철 강"),("姜", "성씨 강, 강할 강"),("剛", "굳을 강, 굳셀 강, 꼬장할 강, 바야흐로 강"),("疆", "땅 경계 강, 갈피 강, 굳셀 강, 변방 강, 지경 강"),("岡", "멧동 강, 산등성이 강"),("彊", "굳셀 강, 센 활 강, 사나울 강, 송장 뻣뻣할 강, 꿋꿋할 강"),("崗", "岡의 俗字, 산등성이 강"),("慷", "강개할 강"),("腔", "창자 강, 속 빌 강, 뼈대 강, 말 허구리 강"),("薑", "생강 강, 새앙 강"),("糠", "겨 강, 번쇄할 강"),("舡", "오나라 배 강"),("絳", "깊게 붉을 강, 강초 강, 깊게 붉은 강"),("襁", "포대기 강"),("羌", "오랑캐 강, 말 끝낼 강"),("堈", "언덕 강, 밭 두둑 강, 독 강"),("畺", "疆과 同字, 지경 강"),("鱇", "천징어 강"),("杠", "외나무 다리 강, 깃대 강, 상 앞 가로막대 강, 올릴 강"),("僵", "엎드러질 강, 쓰러질 강"),("忼", "강개할 강, 뜻이 크고 기개있을 강, 탄식할 강"),("橿", "참죽나무 강, 호미자루 강, 사닥다리 강, 억셀 강"),("韁", "고삐 강"),("茳", "강리풀 강"),("壃", "疆과 同字"),("扛", "마주 들 강"),("殭", "죽어 썩지 않을 강, 마른 누에 강"),("矼", "돌다리 강, 징검다리 강, 성실할 강"),("繈", "繦의 本字"),("穅", "겨 강, 악기이름 강"),("罡", "강별 강"),("羗", "羌과 同字"),("羫", "밭 갈 강"),("傋", "아첨 아니할 강"),("豇", "광저기 강"),("強", "강할"),]),
("강강수월래", &[("强羌水越來", "강강술래의 잘못"),]),
("강경읍", &[("江景邑", "지명"),]),
("강과공화국", &[("剛果共和國", "콩고 공화국"),]),
("강과민주공화국", &[("剛果民主共和國", "콩고 민주 공화국"),]),
("강구면", &[("江口面", "지명"),]),
("강남구", &[("江南區", "지명"),]),
("강남동", &[("江南洞", "지명"),]),
("강남콩", &[("江南콩", "강낭콩"),]),
("강내면", &[("江內面", "지명"),]),
("강동", &[("江洞", "지명"),]),
("강동구", &[("江東區", "지명"),]),
("강동동", &[("江東洞", "지명"),]),
("강동면", &[("江東面", "지명"),]),
("강릉시", &[("江陵市", "지명"),]),
("강림면", &[("講林面", "지명"),]),
("강매동", &[("江梅洞", "지명"),]),
("강문동", &[("江門洞", "지명"),]),
("강북구", &[("江北區", "지명"),]),
("강비아", &[("岡比亞", "감비아"),]),
("강산동", &[("薑山洞", "지명"),]),
("강상면", &[("江上面", "지명"),]),
("강서구", &[("江西區", "지명"),]),
("강서동", &[("江西洞", "지명"),]),
("강외면", &[("江外面", "지명"),]),
("강원도", &[("江原道", "지명"),]),
("강정동", &[("江汀洞", "지명"),]),
("강제동", &[("江諸洞", "지명"),]),
("강진군", &[("康津郡", "지명"),]),
("강진면", &[("江津面", "지명"),]),
("강진읍", &[("康津邑", "지명"),]),
("강천면", &[("康川面", "지명"),]),
("강하면", &[("江下面", "지명"),]),
("강현면", &[("降峴面", "지명"),]),
("강화군", &[("江華郡", "지명"),]),
("강화읍", &[("江華邑", "지명"),]),
("강흥동", &[("江興洞", "지명"),]),
("개", &[("改", "고칠 개, 거듭할 개, 바꿀 개"),("開", "열 개, 통할 개, 발할 개, 베풀 개, 풀 개"),("個", "낱 개, 치우칠 개"),("皆", "모두 개, 한 가지 개, 같을 개, 다 개"),("豈", "승전악 개, 일찍 개"),("槪", "평두목 개, 절개 개, 대강 개, 거리낄 개, 칠한 술통 개, 대개 개"),("介", "낄 개, 도울 개, 맬 개, 클 개, 중매할 개"),("蓋", "뚜껑 개, 덮개 개, 이엉 개, 우산 개, 가리울 개, 덮을 개"),("慨", "분할 개, 강개할 개, 슬플 개, 분개할 개"),("价", "착할 개, 클 개, 사신 개"),("塏", "시원한 땅 개"),("箇", "낱 개, 개수 개"),("漑", "물 댈 개, 씻을 개, 물 천천히 흐를 개"),("芥", "겨자 개, 갓 개, 지푸라기 개, 티끌 개"),("凱", "싸움 이긴 풍류 개, 착할 개, 마파람 개, 좋은 사람 개, 승전악 개"),("愾", "한숨 쉴 개, 성낼 개, 노할 개"),("盖", "蓋의 俗字, 뚜껑 개"),("鎧", "투구 개, 갑옷 개"),("愷", "탐할 개, 급할 개, 편안할 개"),("恝", "걱정 없을 개"),("疥", "옴 개"),("槩", "槪와 同字"),("剴", "낫 개, 가까울 개, 간절할 개"),("玠", "큰 서옥 개"),("揩", "문지를 개, 문질러 훔칠 개"),("匃", "청구할 개, 줄 개, 빌 개"),("闓", "열 개, 풀 개, 활깍지 개"),("磕", "돌 부딪는 소리 개"),]),
("개군면", &[("介軍面", "지명"),]),
("개금동", &[("開琴洞", "지명"),]),
("개령면", &[("開寧面", "지명"),]),
("개복동", &[("開福洞", "지명"),]),
("개봉동", &[("開峰洞", "지명"),]),
("개사동", &[("開寺洞", "지명"),]),
("개신동", &[("開新洞", "지명"),]),
("개운동", &[("開雲洞", "지명"),]),
("개정", &[("開井", "지명"),]),
("개정면", &[("開井面", "지명"),]),
("개진면", &[("開津面", "지명"),]),
("개천면", &[("介川面", "지명"),]),
("개포동", &[("開浦洞", "지명"),]),
("개포면", &[("開浦面", "지명"),]),
("개화동", &[("開花洞", "지명"),]),
("객", &[("客", "손님 객, 부칠 객, 나그네 객, 지날 객"),("喀", "기침할 객, 토할 객"),]),
("갱", &[("更", "다시 갱"),("坑", "빠질 갱, 묻을 갱, 구덩이 갱"),("羹", "국 갱"),("粳", "메벼 갱"),("賡", "이을 갱, 일 갱"),("鏗", "금석 소리 갱, 사람이름 갱"),("硜", "아릿아릿할 갱, 알랑알랑할 갱, 돌소리 갱"),]),
("갹", &[("醵", "술추렴"),]),
("거", &[("車", "수레 거, 그물 거, 잇몸 거"),("去", "갈 거, 버릴 거, 오래될 거, 떨어질 거, 쫓을 거, 감출 거"),("居", "살 거, 곳 거, 앉을 거, 놓을 거, 쌓을 거"),("巨", "클 거, 많을 거, 억 거"),("擧", "들 거, 받들 거, 움직일 거, 일걸을 거"),("拒", "막을 거, 맞설 거, 다닥칠 거, 다다를 거"),("距", "며느리 발톱 거, 지낼 거, 뛸 거, 겨룰 거, 미눌 거, 떨어질 거"),("據", "의지할 거, 기댈 거, 웅거할 거, 짚을 거"),("渠", "개천 거, 도랑 거, 휑덩그렁할 거, 클 거, 껄껄 웃을 거, 무엇 거"),("倨", "거만할 거, 걸터 앉을 거, 굽을 거"),("醵", "술추렴 거, 추렴 걷을 거"),("遽", "급할 거, 두려울 거, 역말 수레 거"),("据", "가질 거, 길거할 거, 의지할 거, 손병 거"),("祛", "물리칠 거, 빌 거, 굳셀 거"),("鉅", "갈고리 거, 클 거, 강한 쇠 거, 갈구리 거"),("炬", "횃불 거, 불 땔 거, 햇불 거"),("踞", "걸터앉을 거"),("鋸", "톱 거, 다리 꺾는 형벌 거"),("裾", "옷 뒷자락 거"),("袪", "소매 거, 소매 아귀 거"),("蘧", "패랭이꽃 거, 석죽화 거, 마음에 든든할 거"),("莒", "모시풀 거, 나라이름 거, 고을이름 거"),("蕖", "연꽃 거"),("秬", "검은 기장 거"),("籧", "대자리 거, 천상바라기 거, 양잠기 거"),("駏", "튀기 거, 거공벌레 거"),("腒", "건치 거, 꿩 포 거"),("苣", "상추 거, 검은 깨 거"),("胠", "열 거, 갈비 거"),("筥", "쌀 담는 광주리 거, 볏단 거"),("佉", "나라이름 거"),("呿", "입 딱 벌일 거"),("昛", "밝을 거"),]),
("거동동", &[("巨東洞", "지명"),]),
("거류면", &[("巨流面", "지명"),]),
("거모동", &[("去毛洞", "지명"),]),
("거여동", &[("巨餘洞", "지명"),]),
("거의", &[("居依", "지명"),]),
("거제동", &[("巨堤洞", "지명"),]),
("거제면", &[("巨濟面", "지명"),]),
("거제시", &[("巨濟市", "지명"),]),
("거진읍", &[("巨津邑", "지명"),]),
("거창군", &[("居昌郡", "지명"),]),
("거창읍", &[("居昌邑", "지명"),]),
("건", &[("建", "세울 건, 둘 건, 심을 건, 칼집 건, 별이름 건"),("乾", "하늘 건, 괘 이름 건, 서북쪽 건, 굳셀 건, 임금 건"),("件", "조건 건, 가지 건, 구별할 건, 나눌 건"),("健", "굳셀 건, 병 없을 건, 탐할 건"),("巾", "수건 건, 덮을 건"),("鍵", "열쇠 건, 수레 굴대 건, 열쇄 건"),("虔", "정성 건, 빼앗을 건, 죽일 건, 공경할 건"),("腱", "힘줄 건"),("愆", "죄 건, 허물 건, 어기어질 건"),("蹇", "절름거릴 건, 험할 건, 교만할 건, 절뚝발이 건"),("騫", "말 배 앓을 건, 이지러질 건, 휙 뛰어 나아갈 건, 이지러지는 건"),("楗", "문 빗장 건, 문지방 건"),("褰", "바지 건, 걷을 건, 발 걷을 건"),("謇", "말 더듬거릴 건, 바른말할 건"),("鞬", "칼집 건, 동개 건"),("揵", "멜 건, 막을 건, 들 건"),("犍", "불친 소 건, 짐승이름 건, 촉나라 고을이름 건"),("睷", "눈으로 세어볼 건"),]),
("건건동", &[("乾乾洞", "지명"),]),
("건입동", &[("健入洞", "지명"),]),
("건지동", &[("乾芝洞", "지명"),]),
("건천읍", &[("乾川邑", "지명"),]),
("걸", &[("傑", "호걸 걸, 준걸 걸, 뛰어날 걸, 거만할 걸, 떡잎 걸"),("乞", "구걸할 걸, 요구할 걸, 원할 걸, 거지 걸"),("杰", "傑의 俗字, 준걸 걸"),("桀", "찢을 걸, 홰 걸, 빼어날 걸, 멜 걸, 사나을 걸, 왕이름 걸"),("偈", "힘 빼두를 걸, 빠를 걸, 헌걸찰 걸"),("朅", "갈 걸"),("乬", "갈 걸"),("榤", "닭의 홰 걸"),]),
("걸산동", &[("傑山洞", "지명"),]),
("걸포동", &[("傑浦洞", "지명"),]),
("검", &[("檢", "교정할 검, 금제할 검, 법 검, 봉할 검, 책메뚜기 검, 수결둘 검, 검사할 검"),("儉", "검소할 검, 흉년들 검, 적을 검, 가난할 검"),("劍", "칼 검, 칼로 찔러 죽일 검, 칼 쓰는법 검"),("劒", "劎의 譌字, 칼 검"),("黔", "검을 검"),("鈐", "굴대 비녀장 검, 자물쇠 검, 큰 보습 검"),("瞼", "눈시울 검"),("撿", "잡을 검, 구속할 검, 관찰할 검, 비교할 검"),("芡", "마름 검, 가시연밥 검"),]),
("검단", &[("檢丹", "지명"),]),
("검사동", &[("檢沙洞", "지명"),]),
("검산동", &[("檢山洞", "지명"),("劒山洞", "지명"),]),
("검상동", &[("檢詳洞", "지명"),]),
("검암동", &[("黔岩洞", "지명"),]),
("검천동", &[("黔川洞", "지명"),]),
("겁", &[("怯", "무서워할 겁, 겁낼 겁, 으를 겁"),("劫", "위협할 겁, 겁탈할 겁, 부지런할 겁, 대궐 층계 겁, 겁 겁, 화재 겁, 빼앗을 겁"),("迲", "자내"),("刦", "겁탈할 겁, 구속할 겁"),("刧", "刦의 俗字"),]),
("게", &[("揭", "높이 들 게, 옷 걷고 물 건널 게, 등에 질 게"),("憩", "쉴 게"),("偈", "쉴 게, 게타 게, 글귀 게"),]),
("격", &[("格", "이를 격, 올 격, 바를 격, 대적할 격, 감동할 격, 격식 격"),("激", "물결 부딪혀 흐를 격, 찌를 격, 맑은 소리 격, 말 과격히 할 격, 급할 격"),("擊", "撃과 同字, 칠 격"),("隔", "막을 격, 멀 격"),("檄", "격서 격, 격문 격, 과격할 격"),("膈", "명치 격"),("覡", "박수 격, 남자무당 격"),("骼", "마른 뼈 격, 드러난 뼈 격, 짐승의 뼈 격"),("闃", "고요할 격"),("鬲", "오지병 격, 땅이름 격, 다리굽은솥 격"),("挌", "칠 격, 들 격"),("鴃", "왜가리 격, 때까치 격"),("毄", "맞부딛는 소리 격, 충돌할 격, 창 격"),]),
("격로길아", &[("格魯吉亞", "그루지야"),]),
("격림납달", &[("格林納達", "그레나다"),]),
("견", &[("見", "볼 견, 만날 견, 당할 견"),("犬", "큰 개 견"),("堅", "굳을 견, 굳셀 견, 반드시 견"),("遣", "보낼 견, 쫓을 견, 견전제 견"),("牽", "당길 견, 이끌 견, 빠를 견, 거리낄 견, 볏줄 견"),("肩", "어깨 견, 이길 견, 맡길 견, 멜 견, 세 살 된 짐승 견"),("絹", "비단 견, 깁 견"),("甄", "질그릇 견, 살필 견, 표시할 견, 진 이름 견, 면할 견, 밝을 견"),("譴", "꾸짖을 견, 성낼 견, 귀양갈 견"),("鵑", "접동새 견, 두견새 견, 뻐꾹새 견"),("繭", "고치 견, 발 부르틀 견, 목 쉴 견, 비단 견"),("蠲", "밝을 견, 조촐할 견, 반딧불 견"),("畎", "밭 도랑 견, 산골 도랑 견"),("狷", "고집스러울 견, 조수할 견, 편협할 견"),("繾", "곡진할 견, 마지 않을 견"),("筧", "대 홈통 견"),("羂", "걸 견, 걸릴 견"),("樫", "떡갈나무 견"),("鰹", "큰 가물치 견, 물치 견, 강고도리 견"),("犭", "개사슴변"),]),
("견소동", &[("見召洞", "지명"),]),
("견지동", &[("堅志洞", "지명"),]),
("결", &[("結", "맺을 결, 마칠 결, 나중 결, 몫 결"),("決", "결단할 결, 물이름 결, 물골 터 놓을 결, 끊을 결, 이별할 결"),("潔", "맑을 결, 정결할 결, 조촐할 결"),("缺", "이지러질 결, 번개 번쩍거릴 결, 깨어질 결, 이 빠질 결"),("訣", "이별할 결, 열결할 결, 사례할 결, 비결 결"),("拮", "길거할 결, 열심히 일할 결"),("抉", "긁을 결, 당길 결"),("闋", "쉴 결, 다할 결, 풍류 마칠 결, 문 닫을 결"),("觖", "서운할 결, 들쳐낼 결, 바랄 결"),("玦", "옥패 결, 활 깍지 결"),]),
("결성면", &[("結成面", "지명"),]),
("겸", &[("兼", "겸할 겸, 아우를 겸, 둘 얻을 겸, 모을 겸"),("謙", "사양할 겸, 겸손할 겸, 괘 이름 겸"),("慊", "앙심먹을 겸, 불만족하게 생각할 겸, 싫을 겸"),("箝", "재갈 겸, 족집개 겸, 목 잠글 겸"),("鉗", "목사슬 겸, 세력으로써 남을 누를 겸, 입 다물 겸"),("鎌", "낫 겸"),("歉", "흉년들 겸, 적을 겸, 나쁠 겸"),("蒹", "갈대 겸"),("嗛", "부족히 여길 겸, 겸손 겸, 입에 밥 물고 있을 겸"),("縑", "합사비단 겸"),("傔", "겸종 겸"),("拑", "자갈 먹일 겸"),("黚", "얕은 금향빛 겸"),("鼸", "두더쥐 겸"),]),
("겸면", &[("兼面", "지명"),]),
("겸백면", &[("兼白面", "지명"),]),
("경", &[("京", "서울 경"),("敬", "공경할 경"),("輕", "가벼울 경"),("經", "날 경, 경서 경"),("慶", "경사 경"),("更", "고칠 경, 다시 경"),("景", "별 경, 볕 경"),("庚", "일곱째 천간 경"),("驚", "놀랄 경"),("耕", "밭갈 경"),("競", "겨룰 경, 다툴 경"),("境", "지경 경"),("竟", "다할 경, 마칠 경"),("警", "경계할 경"),("鏡", "거울 경"),("傾", "기울 경, 기울어질 경"),("卿", "벼슬 경"),("頃", "밭 넓이 단위 경, 백이랑 경"),("徑", "지름길 경"),("硬", "굳을 경, 단단할 경"),("梗", "대개 경, 곧을 경"),("瓊", "옥 경, 붉은옥 경"),("儆", "경계할 경"),("璟", "옥 빛 경, 옥광채날 경"),("炅", "빛날 경, 빗날 경"),("勁", "굳셀 경"),("鯨", "고래 경"),("磬", "경쇠 경"),("頸", "목 경"),("莖", "줄기 경"),("脛", "정강이 경"),("憬", "깨달을 경, 깨우칠 경"),("痙", "심줄 땅길 경, 목뻣뻣할 경"),("絅", "끌어 쥘 경, 낚을 경"),("耿", "빛날 경, 반짝거릴 경"),("逕", "소로 경, 가까울 경"),("坰", "들 경"),("璥", "경옥 경"),("擎", "들 경"),("勍", "셀 경, 굳셀 경"),("涇", "통할 경"),("烱", "빛날 경, 불김 경"),("暻", "밝을 경"),("俓", "徑과 同字, 곧을 경"),("倞", "굳셀 경"),("罄", "빌 경"),("扃", "빗장 경"),("竸", "競과 同字"),("冏", "빛날 경"),("煢", "외로울 경"),("惸", "근심할 경"),("畊", "耕의 古字"),("鯁", "생선뼈 경"),("哽", "목멜 경"),("檠", "도지개 경"),("綆", "두레박줄 경"),("黥", "묵형할 경"),("褧", "홑옷 경"),("謦", "기침 경"),("駉", "목장 경"),("剄", "목 벨 경"),("熲", "빛날 경"),("憼", "공경할 경"),("焭", "근싱할 경"),("顈", "홑옷 경"),("冂", "멀다"),]),
("경기도", &[("京畿道", "지명"),]),
("경동", &[("京洞", "지명"),]),
("경산시", &[("慶山市", "지명"),]),
("경상남도", &[("慶尙南道", "지명"),]),
("경상북도", &[("慶尙北道", "지명"),]),
("경서동", &[("景西洞", "지명"),]),
("경안동", &[("京安洞", "지명"),]),
("경암동", &[("京岩洞", "지명"),]),
("경운동", &[("慶雲洞", "지명"),]),
("경원동", &[("慶園洞", "지명"),]),
("경장동", &[("京場洞", "지명"),]),
("경주시", &[("慶州市", "지명"),]),
("경천면", &[("庚川面", "지명"),]),
("경현동", &[("景賢洞", "지명"),]),
("경호동", &[("鏡湖洞", "지명"),]),
("경화동", &[("慶和洞", "지명"),]),
("계", &[("計", "꾀 계, 셀 계"),("界", "지경 계"),("癸", "열째 천간 계"),("溪", "시내 계"),("季", "끝 계"),("鷄", "닭 계"),("啓", "열 계"),("繼", "이을 계"),("戒", "경계할 계"),("係", "걸릴 계, 이을 계"),("系", "이을 계, 실마리 계"),("階", "섬돌 계"),("契", "맺을 계, 계약할 계"),("桂", "계수나무 계"),("械", "형틀 계, 기계 계"),("繫", "맬 계, 맺을 계"),("悸", "두근거를 계, 두근거릴 계"),("谿", "시내 계"),("稽", "머무를 계"),("棨", "창 계, 창틀 계"),("誡", "경계할 계"),("屆", "이를 계, 다다를 계"),("磎", "谿와 同字, 시냇물 계"),("堺", "界와 同字, 지경 계"),("雞", "닭 계"),("烓", "화덕 계"),("罽", "물고기 그물 계"),("薊", "삽주 계"),("堦", "섬돌 계"),("髻", "상투 계"),("禊", "계제 계"),("筓", "비녀 계"),("綮", "발 고운 비단 계"),("瘈", "미칠 계"),("縘", "繫와 同字"),("葪", "베일 계, 삽주 계"),("彐", "고슴도치머리"),("彑", "고슴도치머리"),]),
("계곡면", &[("溪谷面", "지명"),]),
("계남면", &[("溪南面", "지명"),]),
("계동", &[("桂洞", "지명"),]),
("계룡면", &[("鷄龍面", "지명"),]),
("계림동", &[("鷄林洞", "지명"),]),
("계북면", &[("溪北面", "지명"),]),
("계산", &[("桂山", "지명"),]),
("계산동", &[("溪山洞", "지명"),("鷄山洞", "지명"),("桂山洞", "지명"),]),
("계성면", &[("桂城面", "지명"),]),
("계수동", &[("桂壽洞", "지명"),]),
("계양구", &[("桂陽區", "지명"),]),
("계양동", &[("桂陽洞", "지명"),]),
("계화면", &[("界火面", "지명"),]),
("고", &[("古", "옛 고"),("高", "높을 고"),("告", "알릴 고, 고할 고"),("苦", "쓸 고, 괴로울 고"),("固", "굳을 고"),("故", "옛 고, 연고 고"),("考", "상고할 고"),("姑", "시어미 고, 시어머니 고"),("孤", "외로울 고"),("庫", "곳집 고"),("鼓", "북 고"),("稿", "볏집 고"),("枯", "마를 고"),("顧", "돌아볼 고"),("雇", "새이름 고, 머슴 고"),("賈", "장사 고, 값/성 고"),("皐", "부르는 소리 고, 언덕 고"),("錮", "땜질할 고"),("拷", "가질 고, 때릴 고"),("痼", "고질 고, 고질병 고"),("辜", "허물 고"),("膏", "살찔 고, 기름 고"),("叩", "두드릴 고"),("股", "넓적다리 고"),("袴", "바지 고"),("敲", "두드릴 고"),("呱", "울 고, 아이우는 소리 고"),("誥", "고할 고, 가르칠 고"),("槁", "槀와 同字, 마른나무 고"),("藁", "마른 나무 고, 짚 고"),("攷", "考의 古字, 생각할 고"),("沽", "팔 고"),("蠱", "독 고, 회충 고"),("羔", "새끼양 고"),("苽", "줄 고"),("睾", "못 고, 고환 고"),("菰", "향초 고"),("暠", "흴 고, 밝고흰 고"),("尻", "꽁무니 고"),("瞽", "소경 고"),("刳", "가를 고"),("靠", "기댈 고"),("翺", "날 고"),("罟", "그물 고"),("觚", "술잔 고"),("杲", "밝을 고"),("栲", "북나무 고"),("槀", "마를 고"),("估", "값 고"),("詁", "주석 고"),("盬", "염지 고"),("篙", "상앗대 고"),("鴣", "자고 고"),("皋", "못 고"),("酤", "계명주 고"),("櫜", "활집 고"),("糕", "떡 고"),("胯", "사타구니 고"),("郜", "나라이름 고"),("羖", "검은 암양 고"),("槹", "두레박 고"),("鈷", "다리미 고"),("凅", "얼어붙을 고"),("牯", "암소 고"),("稁", "稿와 同字"),("箍", "테 고"),("鷱", "새이름 고"),]),
("고강동", &[("古康洞", "지명"),]),
("고강본동", &[("古康本洞", "지명"),]),
("고경면", &[("古鏡面", "지명"),]),
("고군면", &[("古郡面", "지명"),]),
("고금면", &[("古今面", "지명"),]),
("고기동", &[("古基洞", "지명"),]),
("고남면", &[("高南面", "지명"),]),
("고달면", &[("古達面", "지명"),]),
("고담동", &[("高潭洞", "지명"),]),
("고대면", &[("高大面", "지명"),]),
("고덕동", &[("高德洞", "지명"),]),
("고덕면", &[("古德面", "지명"),]),
("고등동", &[("高等洞", "지명"),("高登洞", "지명"),]),
("고랑동", &[("古浪洞", "지명"),]),
("고령군", &[("高靈郡", "지명"),]),
("고령읍", &[("高靈邑", "지명"),]),
("고로면", &[("古老面", "지명"),]),
("고로비아", &[("考老比亞", "콜롬비아"),]),
("고룡동", &[("古龍洞", "지명"),]),
("고륜비아", &[("古倫比亞", "콜롬비아"),]),
("고림동", &[("古林洞", "지명"),]),
("고명동", &[("高明洞", "지명"),]),
("고모동", &[("顧母洞", "지명"),]),
("고부면", &[("古阜面", "지명"),]),
("고북면", &[("高北面", "지명"),]),
("고사동", &[("高士洞", "지명"),("古沙洞", "지명"),]),
("고산동", &[("高山洞", "지명"),]),
("고산면", &[("高山面", "지명"),]),
("고삼면", &[("古三面", "지명"),]),
("고색동", &[("古索洞", "지명"),]),
("고서면", &[("古西面", "지명"),]),
("고성군", &[("高城郡", "지명"),("固城郡", "지명"),]),
("고성동", &[("古城洞", "지명"),]),
("고성읍", &[("固城邑", "지명"),]),
("고소동", &[("姑蘇洞", "지명"),]),
("고수면", &[("古水面", "지명"),]),
("고아읍", &[("高牙邑", "지명"),]),
("고암동", &[("古岩洞", "지명"),]),
("고암면", &[("高岩面", "지명"),]),
("고양동", &[("高陽洞", "지명"),]),
("고양시", &[("高陽市", "지명"),]),
("고잔동", &[("古棧洞", "지명"),]),
("고전면", &[("古田面", "지명"),]),
("고제면", &[("高梯面", "지명"),]),
("고죽동", &[("高竹洞", "지명"),]),
("고창군", &[("高敞郡", "지명"),]),
("고창읍", &[("高敞邑", "지명"),]),
("고척동", &[("高尺洞", "지명"),]),
("고천동", &[("古川洞", "지명"),]),
("고촌면", &[("高村面", "지명"),]),
("고하동", &[("高下洞", "지명"),]),
("고한읍", &[("古汗邑", "지명"),]),
("고현동", &[("古峴洞", "지명"),("高峴洞", "지명"),]),
("고현면", &[("古縣面", "지명"),]),
("고흥군", &[("高興郡", "지명"),]),
("고흥읍", &[("高興邑", "지명"),]),
("곡", &[("曲", "굽을 곡"),("谷", "골짜기 곡"),("穀", "곡식 곡"),("哭", "울 곡"),("鵠", "고니 곡, 과녁 곡"),("梏", "쇠고랑 곡, 수갑 곡"),("斛", "휘 곡, 헤아릴 곡"),("轂", "바퀴 곡"),("縠", "주름 비단 곡"),("觳", "뿔잔 곡"),("槲", "떡갈나무 곡"),]),
("곡반정동", &[("谷伴亭洞", "지명"),]),
("곡성군", &[("谷成郡", "지명"),]),
("곡성읍", &[("谷成邑", "지명"),]),
("곤", &[("困", "괴로울 곤, 곤할 곤"),("坤", "땅 곤"),("昆", "형 곤, 맏.형 곤"),("棍", "몽둥이 곤, 곤장 곤"),("袞", "곤룡포 곤, 천자의 옷 곤"),("崑", "산이름 곤"),("梱", "문지방 곤"),("鯤", "준마 이름 곤, 물고기 알 곤"),("滾", "흐를 곤, 끓는 물 곤"),("琨", "옥돌 곤, 아름다운옥 곤"),("衮", "袞과 同字"),("閫", "문지방 곤"),("悃", "정성 곤"),("髡", "머리 깍을 곤"),("鵾", "댓닭 곤"),("崐", "곤륜산 곤"),("褌", "잠방이 곤"),("捆", "두드릴 곤"),("堃", "따 곤"),("緄", "띠 곤"),("裍", "걷어 올릴 곤"),("錕", "붉은 쇠 곤"),("鶤", "댓닭 곤"),("齫", "이 빠질 곤"),("丨", "뚫다"),]),
("곤명면", &[("昆明面", "지명"),]),
("곤양면", &[("昆陽面", "지명"),]),
("골", &[("骨", "뼈 골"),("滑", "어지러울 골"),("汨", "골몰할"),("鶻", "송골매 골"),("榾", "등걸 골"),("搰", "팔 골"),]),
("공", &[("工", "장인 공"),("公", "공변될 공"),("功", "공 공"),("空", "빌 공"),("共", "함께 공, 한가지 공"),("恐", "두려울 공"),("恭", "공손할 공, 공순할 공"),("供", "이바지할 공, 베풀 공"),("貢", "바칠 공"),("孔", "구멍 공"),("攻", "칠 공"),("控", "당길 공"),("拱", "두 손 맞잡을 공, 팔짱길 공"),("鞏", "묶을 공, 가죽테 공"),("珙", "큰 옥 공, 옥이름 공"),("蚣", "지네 공"),("跫", "발자국 소리 공"),("倥", "어리석을 공"),("崆", "산이름 공"),("蛩", "메뚜기 공"),("釭", "굴대 공"),("箜", "공후 공"),("悾", "정성 공"),("栱", "두공 공"),("槓", "지렛대 공"),("贛", "줄 공"),("蛬", "귀뚜라미 공"),("龔", "공손할 공"),("廾", "들다"),]),
("공검면", &[("恭儉面", "지명"),]),
("공근면", &[("公根面", "지명"),]),
("공단동", &[("工團洞", "지명"),]),
("공덕동", &[("孔德洞", "지명"),]),
("공덕면", &[("孔德面", "지명"),]),
("공도읍", &[("孔道邑", "지명"),]),
("공릉동", &[("孔陵洞", "지명"),]),
("공산면", &[("公山面", "지명"),]),
("공성면", &[("功城面", "지명"),]),
("공액공화국", &[("公額共和國", "콩고 공화국"),]),
("공액민주공화국", &[("公額民主共和國", "콩고 민주 공화국"),]),
("공음면", &[("孔音面", "지명"),]),
("공주시", &[("公州市", "지명"),]),
("공촌동", &[("公村洞", "지명"),]),
("공평동", &[("公平洞", "지명"),("公坪洞", "지명"),("孔坪洞", "지명"),]),
("공항동", &[("空港洞", "지명"),]),
("공화동", &[("公和洞", "지명"),]),
("곶", &[("串", "땅이름 곶"),]),
("과", &[("果", "실과 과, 과실 과"),("過", "지날 과"),("科", "과정 과, 과거 과"),("課", "매길 과, 시험할 과"),("寡", "적을 과"),("誇", "자랑할 과"),("瓜", "오이 과, 외 과"),("戈", "창 과"),("菓", "과일 과, 과자 과"),("顆", "낟알 과, 알갱이 과"),("跨", "타넘을 과"),("鍋", "노구솥 과"),("裹", "쌀 과"),("夸", "자랑할 과"),("窠", "보금자리 과"),("夥", "많을 과"),("媧", "사람 이름 과"),("胯", "사타구니 과"),("撾", "칠 과"),("侉", "자랑할 과"),("踝", "복사뼈 과"),("銙", "대구 과"),("蝌", "올챙이 과"),("騍", "암말 과"),("堝", "도가니 과"),("猓", "긴 꼬리 원숭이 과"),("稞", "보리 과"),]),
("과교동", &[("科橋洞", "지명"),]),
("과림동", &[("果林洞", "지명"),]),
("과마라", &[("科摩羅", "코모로"),]),
("과역면", &[("過驛面", "지명"),]),
("과원동", &[("果院洞", "지명"),]),
("과위도", &[("科威都", "쿠웨이트"),]),
("과위특", &[("科威特", "쿠웨이트"),]),
("과전동", &[("果田洞", "지명"),]),
("과천동", &[("果川洞", "지명"),]),
("과천시", &[("果川市", "지명"),]),
("과해동", &[("果海洞", "지명"),]),
("곽", &[("郭", "성곽 곽"),("廓", "둘레 곽, 클 곽"),("槨", "덧널 곽, 궤 곽"),("藿", "콩잎 곽"),("霍", "빠를 곽"),("癨", "곽란 곽"),("鞹", "무두질한 가죽 곽"),("椁", "관 곽"),]),
("관", &[("官", "벼슬 관"),("觀", "볼 관"),("關", "빗장 관"),("館", "객사 관"),("管", "피리 관, 대통 관"),("冠", "갓 관"),("寬", "너그러울 관"),("貫", "꿸 관"),("慣", "버릇 관, 익숙할 관"),("款", "정성 관"),("灌", "물 댈 관"),("串", "곶"),("莞", "골풀 관"),("琯", "옥피리 관, 옥저 관"),("棺", "널 관"),("瓘", "옥 이름 관, 구슬 관"),("罐", "두레박 관, 물동이 관"),("菅", "골풀 관, 왕골 관"),("顴", "광대뼈 관"),("盥", "대야 관"),("祼", "강신제 관"),("錧", "비녀장 관"),("綰", "얽을 관"),("丱", "쌍상투 관"),("鸛", "황새 관"),("筦", "피리 관"),("窾", "빌 관"),("爟", "봉화 관"),("雚", "황새 관"),("髖", "허리뼈 관"),("鑵", "두레박 관"),("涫", "끓을 관"),("輨", "줏대 관"),]),
("관고동", &[("官庫洞", "지명"),]),
("관교동", &[("官校洞", "지명"),]),
("관동", &[("官洞", "지명"),]),
("관문동", &[("官門洞", "지명"),("館門洞", "지명"),]),
("관산동", &[("官山洞", "지명"),]),
("관산읍", &[("冠山邑", "지명"),]),
("관설동", &[("觀雪洞", "지명"),]),
("관수동", &[("觀水洞", "지명"),]),
("관악구", &[("冠岳區", "지명"),]),
("관양동", &[("冠陽洞", "지명"),]),
("관음동", &[("觀音洞", "지명"),]),
("관인면", &[("官仁面", "지명"),]),
("관저동", &[("關雎洞", "지명"),]),
("관정동", &[("官丁洞", "지명"),]),
("관철동", &[("貫鐵洞", "지명"),]),
("관촉동", &[("灌燭洞", "지명"),]),
("관촌면", &[("館村面", "지명"),]),
("관평동", &[("官坪洞", "지명"),]),
("관훈동", &[("寬勳洞", "지명"),]),
("괄", &[("括", "묶을 괄, 헤아릴 괄"),("檜", "전나무 괄, 나라이름 괄"),("刮", "깍을 괄, 긁는 괄"),("适", "빠를 괄"),("恝", "걱정 없을 괄, 깜짝 괄"),("聒", "떠들석할 괄"),("栝", "노송나무 괄"),("筈", "하눌타리 괄"),("髺", "머리 묶을 괄"),("佸", "힘 쓸 괄"),("鴰", "재두루미 괄"),]),
("광", &[("光", "빛 광"),("廣", "넓을 광"),("狂", "미질 광, 미칠 광"),("鑛", "쇳돌 광, 쇳덩이 광"),("匡", "바룰 광, 바를 광"),("曠", "밝을 광, 빌 광"),("壙", "광 광, 텅빈 광"),("胱", "오줌통 광, 방광 광"),("筐", "광주리 광"),("洸", "물 용솟음할 광, 물솟을 광"),("侊", "성한 모양 광, 클 광"),("珖", "옥피리 광"),("炚", "햇빚 뜨거울 광, 밝을 광"),("絖", "솜 광"),("誑", "속일 광"),("纊", "솜 광"),("恇", "겁낼 광"),("獷", "사나울 광"),("磺", "쇳돌 광"),("桄", "광랑나무 광"),("茪", "초결명 광"),("框", "문테 광"),("爌", "불 빛 환할 광"),("誆", "속일 광"),]),
("광남동", &[("廣南洞", "지명"),]),
("광덕면", &[("廣德面", "지명"),]),
("광도면", &[("光道面", "지명"),]),
("광동", &[("光洞", "지명"),]),
("광명동", &[("光明洞", "지명"),]),
("광명시", &[("光明市", "지명"),]),
("광무동", &[("光武洞", "지명"),]),
("광복동", &[("光復洞", "지명"),]),
("광산구", &[("光山區", "지명"),]),
("광산동", &[("光山洞", "지명"),]),
("광석동", &[("廣石洞", "지명"),]),
("광석면", &[("光石面", "지명"),]),
("광시면", &[("光時面", "지명"),]),
("광안동", &[("廣安洞", "지명"),]),
("광암동", &[("廣岩洞", "지명"),]),
("광양시", &[("光陽市", "지명"),]),
("광양읍", &[("光陽邑", "지명"),]),
("광영동", &[("廣英洞", "지명"),]),
("광의면", &[("光義面", "지명"),]),
("광장동", &[("廣壯洞", "지명"),]),
("광적면", &[("廣積面", "지명"),]),
("광정동", &[("光亭洞", "지명"),]),
("광주광역시", &[("光州廣域市", "지명"),]),
("광주시", &[("廣州市", "지명"),]),
("광진구", &[("廣津區", "지명"),]),
("광천동", &[("光川洞", "지명"),]),
("광천읍", &[("廣川邑", "지명"),]),
("광치동", &[("廣峙洞", "지명"),]),
("광탄면", &[("廣灘面", "지명"),]),
("광평동", &[("廣坪洞", "지명"),]),
("광혜원면", &[("廣惠院面", "지명"),]),
("광화동", &[("光化洞", "지명"),]),
("광활면", &[("廣活面", "지명"),]),
("광희동", &[("光熙洞", "지명"),]),
("괘", &[("掛", "걸 괘"),("卦", "걸 괘, 점괘 괘"),("罫", "줄 괘, 줄칠 괘"),("挂", "그림족자 괘"),("詿", "그르칠 괘"),("罣", "걸 괘"),("咼", "입 비뚤어질 괘"),]),
("괘법동", &[("掛法洞", "지명"),]),
("괴", &[("怪", "기이할 괴"),("愧", "부끄러워할 괴, 부끄러울 괴"),("壞", "무너질 괴"),("塊", "흙덩이 괴, 흙덩어리 괴"),("槐", "홰나무 괴, 느티나무 괴"),("傀", "클 괴, 괴이할 괴"),("乖", "어그러질 괴, 어긋날 괴"),("魁", "으뜸 괴, 괴수 괴"),("拐", "속일 괴"),("媿", "창피줄 괴"),("恠", "怪의 俗字"),("瑰", "슬이름 괴"),("蒯", "황모 괴"),("廥", "여물광 괴"),("襘", "띠매듭 괴"),("璝", "옥돌 괴"),]),
("괴곡동", &[("槐谷洞", "지명"),]),
("괴동", &[("槐洞", "지명"),]),
("괴란동", &[("槐蘭洞", "지명"),]),
("괴산군", &[("槐山郡", "지명"),]),
("괴산읍", &[("槐山邑", "지명"),]),
("괴안동", &[("槐安洞", "지명"),]),
("괴연동", &[("槐淵洞", "지명"),]),
("괴전동", &[("槐田洞", "지명"),]),
("괴정동", &[("槐亭洞", "지명"),]),
("괵", &[("馘", "벨 괵"),]),
("굉", &[("宏", "클 굉, 넓을 굉"),("肱", "팔뚝 굉"),("轟", "울릴 굉, 수레몰아가는 소리 굉"),("紘", "갓끈 굉"),("閎", "마을문 굉"),("觥", "뿔잔 굉"),("訇", "큰 소리 굉"),("浤", "용솟음할 굉"),]),
("교", &[("校", "학교 교"),("交", "사귈 교"),("敎", "가르침 교, 가르칠 교"),("橋", "다리 교"),("巧", "공교할 교, 교묘할 교"),("較", "견줄 교, 비교할 교"),("郊", "성 밖 교, 들 교"),("矯", "바로잡을 교"),("膠", "아교 교"),("絞", "목맬 교"),("僑", "높을 교, 붙어살 교"),("嬌", "아리따울 교"),("攪", "어지러울 교"),("驕", "교만할 교"),("喬", "높을 교"),("轎", "가마 교"),("狡", "교활할 교, 간교할 교"),("皎", "달빛 교, 달밝을 교"),("蛟", "교룡 교, 도룡뇽 교"),("咬", "새소리 교, 새지저귀는 소리 교"),("嶠", "뾰족하게 높을 교, 산길험할 교"),("翹", "꼬리 긴 깃털 교, 우뚝우뚝솟은 모양 교"),("鮫", "상어 교"),("蕎", "메밀 교"),("餃", "경단 교"),("榷", "외나무 다리 교"),("嘐", "닭 울 교"),("嚙", "깨물 교"),("磽", "메마른 땅 교"),("姣", "예쁠 교"),("佼", "예쁠 교"),("撟", "들 교"),("噭", "부르짖을 교"),("憍", "교만할 교"),("晈", "달 밝을 교"),("嘄", "부르짖을 교"),("暞", "밝을 교"),]),
("교남동", &[("橋南洞", "지명"),]),
("교동", &[("校洞", "지명"),("交洞", "지명"),("喬洞", "지명"),]),
("교동면", &[("喬洞面", "지명"),]),
("교량동", &[("橋良洞", "지명"),]),
("교문동", &[("校門洞", "지명"),]),
("교방동", &[("校坊洞", "지명"),]),
("교북동", &[("橋北洞", "지명"),]),
("교산동", &[("校山洞", "지명"),]),
("교암동", &[("校岩洞", "지명"),]),
("교원동", &[("校原洞", "지명"),]),
("교촌동", &[("校村洞", "지명"),]),
("교하읍", &[("交河邑", "지명"),]),
("교현동", &[("校峴洞", "지명"),]),
("구", &[("九", "아홉 구"),("口", "입 구"),("求", "찾을 구, 구할 구"),("句", "글귀절 구"),("救", "구원할 구"),("究", "궁리할 구"),("久", "오랠 구"),("舊", "옛 구"),("具", "갖출 구"),("苟", "진실로 구, 풀 구"),("俱", "함께 구"),("區", "감출 구, 지경 구"),("丘", "언덕 구"),("拘", "잡을 구"),("球", "옥경쇠 구, 구슬 구"),("構", "집세울 구"),("懼", "두려워할 구"),("驅", "몰 구"),("狗", "개 구"),("龜", "나라 이름 구, 거북 구"),("邱", "언덕 구"),("歐", "토할 구"),("鳩", "비둘기 구"),("購", "살(구입할) 구"),("鷗", "갈매기 구"),("玖", "옥 다음가는 돌 구, 옥돌 구"),("寇", "도둑 구, 불한당 구"),("仇", "짝 구, 원수 구"),("矩", "곡척 구"),("溝", "개천 구"),("舅", "외삼촌 구"),("衢", "네거리 구, 갈림길 구"),("軀", "몸 구"),("鉤", "갈고랑쇠 구, 갈구리 구"),("廐", "마구간 구"),("柩", "관 구"),("灸", "지질 구, 구울 구"),("謳", "읊조릴 구, 노래 구"),("垢", "때 구, 더러울 구, 먼지 구"),("駒", "망아지 구"),("嘔", "토할 구, 게워내는 구"),("臼", "절구 구"),("嶇", "산험준할 구"),("毆", "때릴 구, 구박할 구"),("枸", "구기자 구, 굽을 구"),("咎", "허물 구"),("耉", "늙을 구, 늙은이 구"),("勾", "글귀절 구"),("毬", "제기 구"),("坵", "丘의 俗字, 언덕 구"),("瞿", "놀라서 볼 구, 놀라서 보는 구"),("逑", "짝 구"),("絿", "급박할 구, 급할 구"),("柾", "관 구, 널 구"),("銶", "끌 구"),("搆", "얽어맬 구"),("扣", "두드릴 구"),("裘", "갓옷 구"),("詬", "꾸짖을 구"),("疚", "오랜 병 구"),("遘", "만날 구"),("媾", "겹사돈 구"),("屨", "삼으로 짠 신 구"),("嫗", "할미 구"),("劬", "수고로울 구"),("捄", "흙파올릴 구"),("駈", "驅와 同字"),("甌", "사발 구"),("摳", "치마걷어들 구"),("窶", "가난하여 예절없을 구"),("彀", "활 잔뜩 당길 구"),("颶", "사방풍 구"),("漚", "물거품 구"),("韭", "부추 구"),("鸜", "구관조 구"),("傴", "구부릴 구"),("榘", "곡척 구"),("糗", "마른밥가루 구"),("蚯", "지렁이 구"),("癯", "여윌 구"),("韝", "깍지 구"),("姤", "만날 구"),("匶", "柩의 古字"),("璆", "옥경쇠 구"),("釦", "그릇에 금테 두를 구"),("鷇", "새 새끼 구"),("俅", "공손할 구"),("佝", "꼽추 구"),("岣", "산이름 구"),("昫", "해돋아 따뜻할 구"),("篝", "불덮개 구"),("胊", "포(얇게 저미어서 말린 고기) 구"),("坸", "垢와 同字"),("冓", "재목 어긋매겨 쌓을 구"),("厹", "세모창 구"),("叴", "소리 높일 구"),("戵", "창 구"),("痀", "곱사등이 구"),("窛", "노략질할 구"),("蒟", "구장 구"),("韮", "韭와 同字"),("鬮", "제비뽑을 구"),("廏", "마구간"),]),
("구기동", &[("舊基洞", "지명"),]),
("구도동", &[("九到洞", "지명"),]),
("구동", &[("龜洞", "지명"),]),
("구랑동", &[("九浪洞", "지명"),]),
("구례군", &[("求禮郡", "지명"),]),
("구례읍", &[("求禮邑", "지명"),]),
("구로구", &[("九老區", "지명"),]),
("구로동", &[("九老洞", "지명"),]),
("구룡동", &[("九龍洞", "지명"),]),
("구룡면", &[("九龍面", "지명"),]),
("구룡포읍", &[("九龍浦邑", "지명"),]),
("구류이", &[("具琉耳", "그루지야"),]),
("구리시", &[("九里市", "지명"),]),
("구림면", &[("龜林面", "지명"),]),
("구마", &[("玖馬", "쿠바"),]),
("구만면", &[("九萬面", "지명"),]),
("구미동", &[("九美洞", "지명"),]),
("구미시", &[("龜尾市", "지명"),]),
("구산동", &[("九山洞", "지명"),("龜山洞", "지명"),]),
("구산면", &[("龜山面", "지명"),]),
("구서동", &[("久瑞洞", "지명"),]),
("구성동", &[("九星洞", "지명"),("九城洞", "지명"),]),
("구성면", &[("龜城面", "지명"),]),
("구성읍", &[("駒城邑", "지명"),]),
("구세주국", &[("救世主國", "엘살바도르"),]),
("구소동", &[("九沼洞", "지명"),]),
("구수동", &[("舊水洞", "지명"),]),
("구암동", &[("九岩洞", "지명"),("龜岩洞", "지명"),("鳩岩洞", "지명"),]),
("구완동", &[("舊完洞", "지명"),]),
("구운동", &[("區雲洞", "지명"),]),
("구월동", &[("九月洞", "지명"),]),
("구유동", &[("舊柳洞", "지명"),]),
("구의동", &[("九宜洞", "지명"),]),
("구이면", &[("九耳面", "지명"),]),
("구정동", &[("九政洞", "지명"),]),
("구정면", &[("邱井面", "지명"),]),
("구좌읍", &[("舊左邑", "지명"),]),
("구지면", &[("求智面", "지명"),]),
("구천", &[("龜川洞", "지명"),]),
("구천면", &[("龜川面", "지명"),]),
("구파발동", &[("舊把撥洞", "지명"),]),
("구평동", &[("舊平洞", "지명"),("九坪洞", "지명"),]),
("구포동", &[("九苞洞", "지명"),("龜浦洞", "지명"),]),
("구항면", &[("龜項面", "지명"),]),
("구호동", &[("九湖洞", "지명"),]),
("구황동", &[("九黃洞", "지명"),]),
("국", &[("國", "나라 국"),("局", "부분 국, 판 국"),("菊", "국화 국"),("鞠", "기를 국"),("鞫", "문초받을"),("麴", "누룩 국"),("匊", "움켜 뜰 국"),("跼", "구부릴 국"),("掬", "두 손으로 움킬 국"),("麯", "麴과 同字"),("囗", "둘러쌀"),]),
("국동", &[("菊洞", "지명"),]),
("국우동", &[("國優洞", "지명"),]),
("군", &[("軍", "군사 군"),("君", "임금 군"),("郡", "고을 군"),("群", "무리 군"),("窘", "군색할 군, 급할 군"),("裙", "치마 군"),("捃", "주울 군"),("皸", "얼어터질 군"),("桾", "고욤나무 군"),]),
("군남면", &[("郡南面", "지명"),]),
("군내면", &[("郡內面", "지명"),]),
("군동면", &[("郡東面", "지명"),]),
("군문동", &[("軍門洞", "지명"),]),
("군북면", &[("郡北面", "지명"),]),
("군산시", &[("群山市", "지명"),]),
("군서면", &[("郡西面", "지명"),]),
("군외면", &[("郡外面", "지명"),]),
("군위군", &[("軍威郡", "지명"),]),
("군위읍", &[("軍威邑", "지명"),]),
("군자동", &[("君子洞", "지명"),]),
("군포동", &[("軍浦洞", "지명"),]),
("군포시", &[("軍浦市", "지명"),]),
("굴", &[("屈", "굽을 굴"),("窟", "구멍 굴"),("掘", "팔 굴"),("堀", "굴뚝 굴"),("崛", "산 높을 굴"),("詘", "굽을 굴"),("倔", "딱딱할 굴"),("淈", "흐릴 굴"),]),
("궁", &[("弓", "활 궁"),("宮", "굴궐 궁, 궁궐 궁"),("窮", "다할 궁"),("躬", "몸 궁"),("穹", "높을 궁"),("芎", "궁궁이 궁"),("躳", "躬의 本字"),]),
("궁내동", &[("宮內洞", "지명"),]),
("궁동", &[("弓洞", "지명"),("宮洞", "지명"),]),
("궁유면", &[("宮柳面", "지명"),]),
("궁정동", &[("宮井洞", "지명"),]),
("궁지동", &[("宮旨洞", "지명"),]),
("궁촌동", &[("宮村洞", "지명"),]),
("권", &[("權", "권세 권"),("卷", "굽을 권, 책 권"),("勸", "권할 권"),("券", "엄쪽(어음을 쪼갠 한 쪽) 권, 문서 권"),("拳", "주먹 권"),("圈", "둥글 권"),("眷", "돌아볼 권"),("倦", "게으를 권"),("捲", "거둘 권, 주먹쥘 권"),("淃", "물돌아 흐를 권, 물도는 모양 권"),("惓", "삼갈 권"),("綣", "정다울 권"),("睠", "眷과 同字"),("蜷", "움추러질 권"),("棬", "휘어만든 나무그릇 권"),("勌", "倦과 同字"),]),
("권곡동", &[("權谷洞", "지명"),]),
("권농동", &[("勸農洞", "지명"),]),
("권선구", &[("勸善區", "지명"),]),
("권선동", &[("勸善洞", "지명"),]),
("궐", &[("厥", "그 궐"),("闕", "대궐 궐"),("蹶", "우물벌레 궐, 쓰러질 궐"),("蕨", "고사리 궐"),("獗", "도둑 일어날 궐, 뛰놀 궐"),("亅", "갈고리"),]),
("궐동", &[("闕洞", "지명"),]),
("궤", &[("軌", "수레바퀴 사이 궤, 바퀴굴데 궤"),("蹶", "급히걸을 궤"),("潰", "흩어질 궤, 무너뜨릴 궤"),("机", "느티나무 궤, 책상 궤"),("詭", "속일 궤, 간사할 궤"),("櫃", "상자 궤, 궤짝 궤"),("饋", "먹일 궤"),("几", "안석 궤"),("跪", "끓어앉을 궤"),("匱", "갑 궤"),("樻", "가마테나무 궤"),("簋", "대제기 궤"),("餽", "饋와 同字"),("憒", "심란할 궤"),("繢", "톱끝 궤"),("闠", "저자문 궤"),("佹", "포갤 궤"),("氿", "물가 궤"),("麂", "큰고라니 궤"),]),
("귀", &[("貴", "높을 귀, 귀할 귀"),("句", "글귀 귀"),("歸", "돌아올 귀"),("鬼", "귀신 귀"),("龜", "거북 귀"),("晷", "시각 귀, 해그림자 귀"),]),
("귀곡동", &[("貴谷洞", "지명"),]),
("귀래면", &[("貴來面", "지명"),]),
("귀산동", &[("貴山洞", "지명"),("龜山洞", "지명"),]),
("귀운동", &[("歸雲洞", "지명"),]),
("귀인동", &[("貴仁洞", "지명"),]),
("귀현동", &[("貴峴洞", "지명"),]),
("규", &[("規", "그림쇠 규, 법 규"),("奎", "별 규"),("圭", "서옥 규"),("糾", "삼합노 규, 살필 규"),("叫", "부를 규, 부르짖을 규"),("揆", "헤아릴 규"),("珪", "圭와 同字, 서옥 규"),("閨", "색시 규, 안방 규"),("窺", "엿볼 규"),("葵", "해바라기 규, 아욱 규"),("逵", "구거리 규, 큰길 규"),("硅", "유리만드는 흙 규, 규소 규"),("竅", "구멍 규, 엿볼 규"),("赳", "헌걸찰 규, 위엄스러울 규"),("槻", "물푸레나무 규"),("虬", "虯와 同字"),("跬", "한발자국 규"),("睽", "어그러질 규"),("虯", "뿔없는 용 규"),("闚", "갸웃이 볼 규"),("樛", "나무가지 휘어질 규"),("糺", "거둘 규"),("楏", "호미자루 규"),("刲", "찌를 규"),("嬀", "성 규"),("暌", "해질 규"),("頍", "고깔비녀 규"),("馗", "아홉거리 규"),("邽", "고을이름 규"),("嫢", "가는 허리 규"),]),
("규아나", &[("圭亞那", "가이아나"),]),
("규암면", &[("窺岩面", "지명"),]),
("균", &[("均", "고를 균"),("菌", "버섯 균"),("龜", "(피부가)틀 균, 거북 균"),("鈞", "서른 근 균"),("筠", "대껍질 균, 속빈 대 균"),("勻", "고를 균"),("畇", "밭개간할 균"),("囷", "둥근곳집 균"),("麏", "고라니 균"),]),
("귤", &[("橘", "귤나무 귤"),]),
("귤현동", &[("橘峴洞", "지명"),]),
("극", &[("極", "가운데 극, 지극할 극"),("克", "이길 극"),("劇", "심할 극"),("隙", "틈 극"),("棘", "가시나무 극"),("戟", "갈래진 창 극"),("剋", "깍일 극, 이길 극"),("亟", "빠를 극"),("屐", "나막신 극"),("郄", "隙과 同字"),("尅", "剋과 同字"),]),
("근", &[("近", "가까울 근"),("根", "뿌리 근"),("勤", "부지런할 근"),("謹", "삼갈 근"),("斤", "근 근"),("僅", "겨우 근"),("筋", "힘줄 근"),("饉", "주릴 근, 푸성귀흉년드는 근"),("瑾", "붉은옥 근"),("槿", "무궁화 근"),("覲", "뵈울"),("懃", "은근할 근"),("芹", "미나리 근"),("菫", "오랑캐 꽃 근, 쓴나물 근"),("劤", "힘많을 근, 힘셀 근"),("跟", "발두꿈치 근"),("靳", "아낄 근"),("卺", "합환주잔 근"),("厪", "적을 근"),("觔", "筋과 同字"),("墐", "진흙 근"),("巹", "받들 근"),("釿", "대패 근"),("廑", "작은집 근"),("漌", "맑을 근"),]),
("근남면", &[("近南面", "지명"),]),
("근덕면", &[("近德面", "지명"),]),
("근북면", &[("近北面", "지명"),]),
("근산동", &[("近山洞", "지명"),]),
("근화동", &[("槿花洞", "지명"),]),
("근흥면", &[("近興面", "지명"),]),
("글", &[("契", "부족 이름 글, 계약할 글"),]),
("금", &[("金", "성 금, 쇠 금"),("今", "이제 금"),("禁", "금할 금"),("錦", "비단 금"),("禽", "날짐승 금, 새 금"),("琴", "거문고 금"),("襟", "옷깃 금, 옷섶 금"),("衾", "이불 금"),("擒", "사로잡을 금"),("衿", "옷깃 금, 옷고름 금"),("芩", "풀 이름 금, 금풀 금"),("檎", "능금나무 금"),("昑", "밝을 금"),("妗", "외숙모 금, 싱글벙글 금"),("噤", "입 다물 금"),("嶔", "높고 험할 금"),("笒", "첨대 금"),("唫", "입 다물 금"),("黅", "누른 빛 금"),]),
("금가면", &[("金加面", "지명"),]),
("금강동", &[("金江洞", "지명"),("琴江洞", "지명"),]),
("금계동", &[("錦溪洞", "지명"),]),
("금고동", &[("今古洞", "지명"),]),
("금곡동", &[("金谷洞", "지명"),]),
("금곡면", &[("金谷面", "지명"),]),
("금과면", &[("金果面", "지명"),]),
("금광동", &[("金光洞", "지명"),("錦光洞", "지명"),]),
("금광면", &[("金光面", "지명"),]),
("금구면", &[("金溝面", "지명"),]),
("금남로", &[("錦南路", "지명"),]),
("금남면", &[("金南面", "지명"),("錦南面", "지명"),]),
("금능동", &[("金陵洞", "지명"),]),
("금당면", &[("金塘面", "지명"),]),
("금동", &[("錦洞", "지명"),]),
("금로동", &[("金老洞", "지명"),]),
("금릉동", &[("金陵洞", "지명"),]),
("금마면", &[("金馬面", "지명"),]),
("금붕동", &[("琴朋洞", "지명"),]),
("금사동", &[("錦絲洞", "지명"),]),
("금사면", &[("金沙面", "지명"),]),
("금산군", &[("錦山郡", "지명"),]),
("금산동", &[("金山洞", "지명"),("錦山洞", "지명"),]),
("금산면", &[("金山面", "지명"),("錦山面", "지명"),("琴山面", "지명"),]),
("금산읍", &[("錦山邑", "지명"),]),
("금상동", &[("今上洞", "지명"),]),
("금서면", &[("今西面", "지명"),]),
("금석동", &[("金石洞", "지명"),]),
("금성동", &[("金城洞", "지명"),("錦城洞", "지명"),]),
("금성면", &[("金星面", "지명"),("金城面", "지명"),("錦城面", "지명"),]),
("금수면", &[("金水面", "지명"),]),
("금암동", &[("金岩洞", "지명"),("錦岩洞", "지명"),]),
("금오동", &[("金梧洞", "지명"),]),
("금왕읍", &[("金旺邑", "지명"),]),
("금이동", &[("錦李洞", "지명"),]),
("금일읍", &[("金日邑", "지명"),]),
("금전동", &[("金田洞", "지명"),]),
("금정구", &[("金井區", "지명"),]),
("금정동", &[("衿井洞", "지명"),]),
("금정면", &[("金井面", "지명"),]),
("금지면", &[("金池面", "지명"),]),
("금천구", &[("衿川區", "지명"),]),
("금천동", &[("金川洞", "지명"),]),
("금천면", &[("金川面", "지명"),("錦川面", "지명"),]),
("금촌동", &[("金村洞", "지명"),]),
("금탄동", &[("金灘洞", "지명"),]),
("금토동", &[("金土洞", "지명"),]),
("금학동", &[("金鶴洞", "지명"),("錦鶴洞", "지명"),]),
("금호동", &[("金湖洞", "지명"),("琴湖洞", "지명"),]),
("금호읍", &[("琴湖邑", "지명"),]),
("금화동", &[("錦和洞", "지명"),]),
("금흥동", &[("錦興洞", "지명"),]),
("급", &[("給", "넉넉할 급, 줄 급"),("急", "급할 급"),("及", "미칠 급"),("級", "등급 급"),("汲", "길을 급, 물길을 급"),("扱", "미칠 급, 취급할 급"),("伋", "속일 급, 생각할 급"),("岌", "높을 급"),("皀", "고소할 급"),("笈", "책상자 급"),("礏", "산 높은 모양 급"),("圾", "위태할 급"),("芨", "말오줌나무 급"),]),
("긍", &[("肯", "옳이 여길 긍, 즐기어할 긍"),("兢", "삼갈 긍, 조심할 긍"),("矜", "불쌍히 여길 긍, 자랑할 긍"),("亘", "뻗칠"),("亙", "뻗칠 긍"),("殑", "까무라칠 긍"),]),
("긍니아", &[("肯尼亜", "케냐"),]),
("기", &[("己", "자기 기, 몸 기"),("記", "기록할 기"),("氣", "기운 기"),("技", "재주 기"),("起", "일어날 기"),("期", "기약할 기"),("基", "터 기"),("其", "그 기"),("旣", "이미 기"),("幾", "기미 기, 몇 기"),("豈", "어찌 기, 일찍 기"),("器", "그릇 기"),("奇", "기이할 기"),("機", "틀 기, 베틀 기"),("旗", "기 기"),("紀", "벼리 기"),("棄", "버릴 기"),("忌", "꺼릴 기"),("企", "꾀할 기, 계획할 기"),("欺", "속일 기"),("飢", "주릴 기"),("祈", "빌 기, 기도할 기"),("乞", "줄 기"),("騎", "말탈 기"),("寄", "부칠 기, 붙여살 기"),("畿", "경기 기"),("冀", "바랄 기"),("箕", "키 기"),("耆", "늙은이 기"),("岐", "갈림길 기, 높을 기"),("沂", "물 이름 기"),("驥", "천리마 기"),("琦", "옥 이름 기"),("麒", "기린 기"),("璣", "구슬 기, 작은구슬 기"),("琪", "옥 기, 옥이름 기"),("騏", "털총이 기, 천리마 기"),("淇", "강 이름 기, 물이름 기"),("汽", "김 기, 물끓는김 기"),("譏", "나무랄 기"),("妓", "기생 기"),("羈", "굴레 기, 말 굴레 기"),("嗜", "즐길 기"),("綺", "비단 기, 무늬놓은 비단 기"),("杞", "나무 이름 기, 구기자 기"),("畸", "뙈기 밭 기, 기이할 기"),("朞", "돌 기"),("肌", "살 기"),("棋", "바둑 기"),("伎", "재주 기"),("崎", "험할 기, 산길험할 기"),("枳", "해할 기, 사타구니 기"),("圻", "경기 기, 지경 기"),("饑", "주릴 기, 흉년들 기"),("祇", "토지의 신 기, 편안할 기"),("夔", "조심할 기, 외발짐승 기"),("祁", "성할 기, 성하게 기"),("磯", "물가 기, 물속자갈 기"),("祺", "복 기, 길할 기"),("碁", "棋와 同字, 바둑 기"),("錡", "솥 기, 세발가마 기"),("玘", "패옥 기"),("璂", "피변 꾸미개 기, 고깔꾸미개 기"),("埼", "崎와 同字, 언덕머리 기"),("覬", "바랄 기"),("耭", "갈 기, 밭갈 기"),("錤", "호미 기"),("歧", "岐와 同字"),("弃", "棄의 古字"),("曁", "및 기"),("旂", "기 기"),("頎", "헌걸찰 기"),("墍", "맥질할 기"),("棊", "棋와 同字"),("鬐", "갈기 기"),("蟣", "서캐 기"),("跂", "육발 기"),("剞", "새김칼 기"),("掎", "끌 기"),("蘄", "풀 이름 기"),("攲", "기울기 기"),("芰", "세발 마름 기"),("綦", "연두빛 비단 기"),("忮", "해칠 기"),("屺", "민둥산 기"),("愭", "공손할 기"),("芪", "단너삼 기"),("炁", "기운 기"),("羇", "나그네 기"),("覉", "구속할 기, 말 굴레 기"),("僛", "취하여 춤추는 모양 기"),("庋", "시렁 기"),("禨", "조짐 기"),("肵", "적대 기"),("虁", "夔와 同字"),("暣", "볕기운 기"),("綥", "비단 쑥색 기"),("蜝", "방계 기"),("鰭", "지느러미 기"),("气", "기운"),]),
("기계면", &[("杞溪面", "지명"),]),
("기내아", &[("銀名", "기니"),]),
("기내아미수", &[("幾内亞美須", "기니비사우"),]),
("기리파사", &[("基里巴斯", "키리바시"),]),
("기린면", &[("麒麟面", "지명"),]),
("기북면", &[("杞北面", "지명"),]),
("기산동", &[("岐山洞", "지명"),]),
("기산면", &[("基山面", "지명"),("麒山面", "지명"),]),
("기성면", &[("箕城面", "지명"),]),
("기장군", &[("機張郡", "지명"),]),
("기장읍", &[("機張邑", "지명"),]),
("기흥읍", &[("器興邑", "지명"),]),
("긴", &[("緊", "굳게 얽힐 긴, 요긴할 긴"),]),
("길", &[("吉", "길할 길"),("拮", "일할 길, 열심히일할 길"),("佶", "건장할 길, 바를 길"),("桔", "도라지 길"),("姞", "성 길"),("蛣", "장구벌레 길"),]),
("길곡면", &[("吉谷面", "지명"),]),
("길동", &[("吉洞", "지명"),]),
("길무지", &[("吉武地", "지부티"),]),
("길상면", &[("吉祥面", "지명"),]),
("길안면", &[("吉安面", "지명"),]),
("길음동", &[("吉音洞", "지명"),]),
("김", &[("金", "사람의 성 김, 쇠 김"),]),
("김량장동", &[("金良場洞", "지명"),]),
("김제시", &[("金堤市", "지명"),]),
("김천시", &[("金泉市", "지명"),]),
("김포시", &[("金浦市", "지명"),]),
("김해시", &[("金海市", "지명"),]),
("김화읍", &[("金化邑", "지명"),]),
("끽", &[("喫", "마실 끽"),]),
("나", &[("羅", "새 그물 나"),("那", "어찌 나"),("奈", "어찌 나"),("拿", "붙잡을 나"),("裸", "벌거벗을 라, 털 없는 벌레 라, 벌거숭이 나"),("懶", "게으를 나"),("儺", "역귀 쫓을 나, 법도있는 나"),("懦", "나약할 나, 부드러울 나"),("螺", "소라 나"),("拏", "붙잡을 나"),("邏", "돌 나"),("癩", "약물 중독 나"),("蘿", "소나무겨우살이 나"),("喇", "나팔 라, 라마교 라"),("娜", "아리따울 나, 휘청거릴 나"),("挐", "붙잡을 나"),("挪", "옮길 나"),("糯", "찰벼 나"),("梛", "나무 이름 나"),("糥", "糯와 同字"),]),
("나동면", &[("奈洞面", "지명"),]),
("나마", &[("羅馬", "로마 제국"),]),
("나마니", &[("羅馬尼", "루마니아"),]),
("나마니아", &[("羅馬尼亞", "루마니아"),]),
("나산면", &[("羅山面", "지명"),]),
("나선", &[("那禪", "러시아"),]),
("나안동", &[("羅雁洞", "지명"),]),
("나우", &[("羅宇", "라오스"),]),
("나운동", &[("羅雲洞", "지명"),]),
("나위", &[("那威", "노르웨이"),]),
("나주시", &[("羅州市", "지명"),]),
("나포면", &[("羅浦面", "지명"),]),
("낙", &[("落", "떨어질 낙"),("樂", "즐길 낙"),("諾", "대답할 낙, 허락할 낙"),("洛", "강 이름 낙"),("駱", "낙타 낙"),("烙", "지질 낙"),("酪", "타락 낙"),("珞", "구슬 목걸이 낙"),]),
("낙동면", &[("洛東面", "지명"),]),
("낙민동", &[("樂民洞", "지명"),]),
("낙상동", &[("洛上洞", "지명"),]),
("낙서면", &[("洛西面", "지명"),]),
("낙안면", &[("樂安面", "지명"),]),
("낙양동", &[("洛陽洞", "지명"),]),
("낙원", &[("樂園洞", "지명"),]),
("낙원동", &[("樂園洞", "지명"),]),
("낙월면", &[("落月面", "지명"),]),
("낙위", &[("諾威", "노르웨이"),]),
("낙포동", &[("洛浦洞", "지명"),]),
("난", &[("難", "어려울 난"),("暖", "따뜻할 난"),("卵", "알 난"),("亂", "어지러울 난"),("蘭", "난초 난"),("欄", "난간 난"),("爛", "문드러질 난"),("鸞", "난새 난"),("煖", "따뜻할 난, 더울 난"),("赧", "얼굴 붉힐 난"),("煗", "터울 난"),("偄", "언약할 난"),("餪", "풀보기 잔치 난"),]),
("난곡동", &[("蘭谷洞", "지명"),]),
("난봉동", &[("卵鳳洞", "지명"),]),
("날", &[("捺", "누를 날, 도장찍을 날"),("捏", "이길 날, 찍을 날"),("涅", "앙금 흙 날"),]),
("날파이", &[("涅巴爾", "네팔"),]),
("남", &[("南", "남녘 남"),("男", "사내 남"),("濫", "퍼질 남"),("藍", "쪽 남"),("嵐", "남기 남"),("楠", "녹나무 남, 들메나무 남"),("枏", "녹나무 남, 매화나무 남"),("湳", "강 이름 남, 물이름 남"),("襤", "누더기 남"),("喃", "재잘거릴 남"),("柟", "枏의 俗字"),]),
("남가좌동", &[("南加佐洞", "지명"),]),
("남곡동", &[("藍谷洞", "지명"),]),
("남교동", &[("南橋洞", "지명"),]),
("남구", &[("南區", "지명"),]),
("남내동", &[("南內洞", "지명"),]),
("남노송동", &[("南老松洞", "지명"),]),
("남대문로", &[("南大門路", "지명"),]),
("남동", &[("南洞", "지명"),]),
("남동구", &[("南洞區", "지명"),]),
("남면", &[("南面", "지명"),]),
("남목동", &[("南牧洞", "지명"),]),
("남문동", &[("南門洞", "지명"),]),
("남문로", &[("南門路", "지명"),]),
("남방동", &[("南方洞", "지명"),]),
("남부동", &[("南部洞", "지명"),]),
("남부면", &[("南部面", "지명"),]),
("남부민동", &[("南富民洞", "지명"),]),
("남부연합", &[("南部聯合", "아메리카 연합국"),]),
("남북동", &[("南北洞", "지명"),]),
("남비", &[("南非", "남아프리카공화국"),]),
("남빈동", &[("南濱洞", "지명"),]),
("남사랍부", &[("南斯拉夫", "유고슬라비아"),]),
("남사면", &[("南四面", "지명"),]),
("남산동", &[("南山洞", "지명"),]),
("남산면", &[("南山面", "지명"),]),
("남상면", &[("南上面", "지명"),]),
("남선면", &[("南先面", "지명"),]),
("남성동", &[("南城洞", "지명"),]),
("남성로", &[("南城路", "지명"),]),
("남수", &[("南水洞", "지명"),]),
("남아공", &[("南阿共", "남아프리카공화국"),]),
("남아불리가", &[("南阿弗利加", "남아프리카공화국"),]),
("남양동", &[("南陽洞", "지명"),]),
("남양면", &[("南陽面", "지명"),]),
("남양주시", &[("南楊州市", "지명"),]),
("남영동", &[("南營洞", "지명"),]),
("남외동", &[("南外洞", "지명"),]),
("남원시", &[("南原市", "지명"),]),
("남원읍", &[("南元邑", "지명"),]),
("남이면", &[("南二面", "지명"),]),
("남일동", &[("南一洞", "지명"),]),
("남일면", &[("南一面", "지명"),]),
("남장동", &[("南長洞", "지명"),]),
("남적동", &[("南積洞", "지명"),]),
("남정동", &[("南井洞", "지명"),("南亭洞", "지명"),]),
("남정면", &[("南亭面", "지명"),]),
("남제주군", &[("南濟州郡", "지명"),]),
("남종면", &[("南終面", "지명"),]),
("남주동", &[("南州洞", "지명"),]),
("남중동", &[("南中洞", "지명"),]),
("남지동", &[("南支洞", "지명"),]),
("남지읍", &[("南旨邑", "지명"),]),
("남창", &[("南昌洞", "지명"),]),
("남창동", &[("南倉洞", "지명"),]),
("남천동", &[("南川洞", "지명"),("南泉洞", "지명"),]),
("남천면", &[("南川面", "지명"),]),
("남촌동", &[("南村洞", "지명"),]),
("남통동", &[("南通洞", "지명"),]),
("남평읍", &[("南平邑", "지명"),]),
("남포동", &[("南浦洞", "지명"),]),
("남포면", &[("藍浦面", "지명"),]),
("남하면", &[("南下面", "지명"),]),
("남학동", &[("南學洞", "지명"),]),
("남한", &[("南韓", "대한민국"),]),
("남한국", &[("南韓國", "대한민국"),]),
("남항동", &[("南港洞", "지명"),]),
("남항진동", &[("南項津洞", "지명"),]),
("남해군", &[("南海郡", "지명"),]),
("남해읍", &[("南海邑", "지명"),]),
("남현동", &[("南峴洞", "지명"),]),
("남화동", &[("南化洞", "지명"),]),
("남후면", &[("南後面", "지명"),]),
("납", &[("納", "바칠 납, 들일 납"),("拉", "꺽을 납, 꺾을 납"),("臘", "납향 납"),("蠟", "밀 납"),("衲", "기울 납, 장삼 납"),]),
("납미비아", &[("納米比亞", "나미비아"),]),
("납탈유아", &[("拉脫維亞", "라트비아"),]),
("낭", &[("浪", "물결 낭"),("娘", "아가씨 낭, 젊은계집 낭"),("廊", "복도 낭"),("狼", "이리 낭"),("囊", "주머니 낭"),("朗", "밝을 낭"),("郎", "사나이 낭"),("曩", "접때 낭"),]),
("낭산면", &[("郎山面", "지명"),]),
("낭성면", &[("琅城面", "지명"),]),
("낭월동", &[("朗月洞", "지명"),]),
("내", &[("內", "안 내"),("來", "올 내"),("乃", "이에 내"),("耐", "견딜 내"),("奈", "어찌 내"),("柰", "능금나무 내, 어찌 내"),("迺", "이에 내"),("鼐", "가마솥 내"),("匂", "향내 내"),("嬭", "젖 내"),("奶", "젖 내"),]),
("내가면", &[("內可面", "지명"),]),
("내곡동", &[("內谷洞", "지명"),]),
("내남동", &[("內南洞", "지명"),]),
("내남면", &[("內南面", "지명"),]),
("내당", &[("內唐", "지명"),]),
("내덕동", &[("內德洞", "지명"),]),
("내도동", &[("內都洞", "지명"),]),
("내동", &[("內洞", "지명"),("奈洞", "지명"),]),
("내리동", &[("內里洞", "지명"),]),
("내면", &[("內面", "지명"),]),
("내발산동", &[("內鉢山洞", "지명"),]),
("내방동", &[("內防洞", "지명"),]),
("내북면", &[("內北面", "지명"),]),
("내산동", &[("內山洞", "지명"),]),
("내산면", &[("內山面", "지명"),]),
("내삼미동", &[("內三美洞", "지명"),]),
("내서면", &[("內西面", "지명"),]),
("내서읍", &[("內西邑", "지명"),]),
("내속리면", &[("內俗離面", "지명"),]),
("내손동", &[("內蓀洞", "지명"),]),
("내수동", &[("內需洞", "지명"),]),
("내수읍", &[("內秀邑", "지명"),]),
("내유동", &[("奈遊洞", "지명"),]),
("내이동", &[("內二洞", "지명"),]),
("내일동", &[("內一洞", "지명"),]),
("내자동", &[("內資洞", "지명"),]),
("내장동", &[("內藏洞", "지명"),]),
("내척동", &[("內尺洞", "지명"),]),
("내초도동", &[("內草島洞", "지명"),]),
("내촌면", &[("內村面", "지명"),("乃村面", "지명"),]),
("내탑동", &[("內塔洞", "지명"),]),
("내항동", &[("內項洞", "지명"),]),
("내흥동", &[("內興洞", "지명"),]),
("냉", &[("冷", "차가울 냉, 찰 냉"),]),
("냉림동", &[("冷林洞", "지명"),]),
("냉천동", &[("冷泉洞", "지명"),]),
("녀", &[("女", "계집 녀"),]),
("녁", &[("惄", "마음 졸일 녁"),("疒", "병질"),]),
("년", &[("年", "해 년"),("撚", "비틀 년, 잡을 년"),("秊", "年의 本字, 해 년"),("碾", "맷돌 년"),]),
("녈", &[("涅", "죽을 녈"),]),
("념", &[("念", "생각 념"),("恬", "편안할 념"),("拈", "집을"),("捻", "비틀 념, 찍을 념"),]),
("녕", &[("寧", "편안할 녕"),("寗", "편안할 녕, 차라리 녕"),("佞", "재주 녕"),("濘", "진흙 녕"),("嚀", "정녕할 녕"),("儜", "고달플 녕"),]),
("노", &[("老", "늙을 노, 늙은이 노"),("路", "길 노"),("勞", "수고할 노, 일할 노"),("怒", "성낼 노"),("露", "이슬 노"),("奴", "종 노"),("努", "힘쓸 노"),("盧", "밥그릇 노"),("魯", "미련할 노, 노둔할 노"),("爐", "화로 노, 화초 노"),("駑", "둔할 노, 노둔한 말 노"),("蘆", "갈대 노"),("鷺", "해오라기 노"),("虜", "포로 노"),("擄", "사로잡을 노"),("弩", "쇠뇌(여러 개의 화살이나 돌을 잇따라 쏘게 된 큰 활) 노"),("帑", "처자식 노"),("櫓", "큰 방패 노"),("瑙", "마노 노, 옥돌 노"),("孥", "자식 노"),("呶", "들랠 노"),("猱", "못할 노"),("笯", "새장 노"),("臑", "팔마디 노"),("峱", "산이름 노"),]),
("노고산동", &[("老姑山洞", "지명"),]),
("노곡동", &[("魯谷洞", "지명"),]),
("노곡면", &[("蘆谷面", "지명"),]),
("노과", &[("老撾", "라오스"),]),
("노국", &[("露國", "러시아"),]),
("노대동", &[("老大洞", "지명"),]),
("노동동", &[("路東洞", "지명"),]),
("노동면", &[("蘆東面", "지명"),]),
("노량진동", &[("鷺梁津洞", "지명"),]),
("노로", &[("瑙魯", "나우루"),]),
("노룡동", &[("魯龍洞", "지명"),]),
("노변동", &[("蘆邊洞", "지명"),]),
("노삼보", &[("盧森堡", "룩셈부르크"),]),
("노서동", &[("路西洞", "지명"),]),
("노서아", &[("露西亞", "러시아"),("魯西亞", "러시아"),]),
("노성면", &[("魯城面", "지명"),]),
("노시아", &[("露矢亞", "러시아"),]),
("노안달", &[("路安達", "르완다"),]),
("노안면", &[("老安面", "지명"),]),
("노암동", &[("魯巖洞", "지명"),("鷺岩洞", "지명"),]),
("노오지동", &[("老梧地洞", "지명"),]),
("노온사동", &[("老溫寺洞", "지명"),]),
("노왕달", &[("盧旺達", "르완다"),]),
("노원구", &[("蘆原區", "지명"),]),
("노원동", &[("魯院洞", "지명"),]),
("노유동", &[("老遊洞", "지명"),]),
("노은동", &[("老隱洞", "지명"),]),
("노은면", &[("老隱面", "지명"),]),
("노포동", &[("老圃洞", "지명"),]),
("노하동", &[("鷺下洞", "지명"),]),
("노학동", &[("蘆鶴洞", "지명"),]),
("노형동", &[("老衡洞", "지명"),]),
("노화읍", &[("盧花邑", "지명"),]),
("녹", &[("綠", "초록빛 녹"),("錄", "기록할 녹"),("祿", "행복 녹"),("鹿", "사슴 녹"),("碌", "푸른 빛 녹, 돌모양 녹"),("菉", "조개풀 녹"),]),
("녹번동", &[("碌磻洞", "지명"),]),
("녹산동", &[("菉山洞", "지명"),]),
("녹양동", &[("綠楊洞", "지명"),]),
("녹전동", &[("錄田洞", "지명"),]),
("녹전면", &[("綠轉面", "지명"),]),
("논", &[("論", "말할 논"),]),
("논곡동", &[("論谷洞", "지명"),]),
("논공", &[("論工", "지명"),]),
("논산시", &[("論山市", "지명"),]),
("논현동", &[("論峴洞", "지명"),]),
("농", &[("農", "농사 농"),("弄", "희롱할 농"),("籠", "대그릇 농"),("濃", "짙을 농"),("膿", "고름 농"),("聾", "귀머거리 농"),("壟", "밭두둑 농, 언덕 농"),("穠", "후한 제사 농"),("儂", "나 농"),("醲", "텁텁한 술 농"),("噥", "달게 먹을 농"),]),
("농성동", &[("農城洞", "지명"),]),
("농소동", &[("農所洞", "지명"),]),
("농소면", &[("農所面", "지명"),]),
("농암면", &[("籠岩面", "지명"),]),
("뇌", &[("雷", "우뢰 뇌, 우리 뇌"),("腦", "머리 뇌, 머릿골 뇌"),("惱", "괴로워할 뇌, 번뇌할 뇌"),("賂", "뇌물 뇌, 뇌물줄 뇌"),("牢", "가축우리 뇌"),("磊", "돌이 많이 쌓인 모양 뇌, 돌무더기 뇌"),("餒", "굶길 뇌"),]),
("뇨", &[("溺", "우줌눌 뇨"),("尿", "오줌 뇨"),("鬧", "시끄러울 뇨"),("嫋", "날릴 뇨"),("裊", "끄을 뇨"),("淖", "진흙 뇨"),("鐃", "작은 징 뇨"),("嬲", "샘낼 뇨"),]),
("누", &[("樓", "다락 누"),("漏", "샐 누"),("淚", "눈물 누"),("累", "포갤 누, 묶을 누"),("屢", "(빛이 들어오는)창 누"),("陋", "줍을 누, 좁을 누"),("壘", "진 누"),("縷", "자세할 누, 실 누"),("耨", "김맬 누"),]),
("누문동", &[("樓門洞", "지명"),]),
("누상동", &[("樓上洞", "지명"),]),
("누읍동", &[("樓邑洞", "지명"),]),
("누하동", &[("樓下洞", "지명"),]),
("눈", &[("嫩", "언약할 눈, 연약할 눈"),]),
("눌", &[("訥", "말 더듬거릴 눌, 말을 더듬는 눌"),("吶", "말 더듬을 눌"),("肭", "물개 눌"),]),
("눌도", &[("율도[訥島", "지명"),]),
("눌차동", &[("訥次洞", "지명"),]),
("뉴", &[("紐", "잡색비단 뉴, 단추 뉴"),("杻", "옷 부드러울 뉴, 싸리 뉴"),("忸", "익을 뉴"),("靵", "단추 뉴"),]),
("뉵", &[("衄", "코피 뉵"),]),
("늑", &[("勒", "굴레 늑"),("肋", "갈비대 늑"),]),
("늑도동", &[("勒島洞", "지명"),]),
("늠", &[("凜", "찰 늠"),]),
("능", &[("能", "능할 능"),("陵", "능 능, 큰언덕 능"),("凌", "얼음 능, 능가할 능"),("綾", "무늬 놓은 비단 능"),("菱", "마름 능"),("稜", "모질 능"),]),
("능곡동", &[("陵谷洞", "지명"),]),
("능동", &[("陵洞", "지명"),]),
("능류영", &[("能留英", "노르웨이"),]),
("능서면", &[("陵西面", "지명"),]),
("능성동", &[("能城洞", "지명"),]),
("능주면", &[("綾州面", "지명"),]),
("능포동", &[("菱浦洞", "지명"),]),
("니", &[("泥", "막힐 니, 진흙 니"),("尼", "여승 니, 여자중 니"),("怩", "부끄러워할 니"),("膩", "살찔 니"),("呢", "소근거릴 니"),("柅", "얼레자루 니"),]),
("니객랍과", &[("尼喀拉瓦", "니카라과"),]),
("니객랍와", &[("尼喀拉瓜", "니카라과"),]),
("니박이", &[("尼泊爾", "네팔"),]),
("니일리아", &[("尼日利亞", "나이지리아"),]),
("니일이", &[("尼日爾", "니제르"),]),
("닉", &[("溺", "빠질 닉"),("匿", "숨쉴 닉, 숨을 닉"),]),
("닐", &[("昵", "가깝게 할 닐"),("暱", "칠근할 닐"),]),
("다", &[("多", "많을 다"),("茶", "차풀 다"),("爹", "아비 다"),]),
("다가", &[("多哥", "토고"),]),
("다가동", &[("多可洞", "지명"),("多佳洞", "지명"),]),
("다남동", &[("多男洞", "지명"),]),
("다대동", &[("多大洞", "지명"),]),
("다도면", &[("茶道面", "지명"),]),
("다동", &[("茶洞", "지명"),]),
("다방동", &[("多芳洞", "지명"),]),
("다사읍", &[("多斯邑", "지명"),]),
("다산면", &[("茶山面", "지명"),]),
("다수동", &[("多壽洞", "지명"),]),
("다시면", &[("多侍面", "지명"),]),
("다압면", &[("多鴨面", "지명"),]),
("다운동", &[("茶雲洞", "지명"),]),
("다인면", &[("多仁面", "지명"),]),
("단", &[("單", "홀로 단"),("短", "짧을 단"),("端", "끝 단"),("但", "다만 단"),("丹", "붉을 단"),("斷", "끊을 단"),("段", "층계 단"),("團", "둥글 단"),("壇", "제터 단"),("檀", "향나무 단, 박달나무 단"),("旦", "밝을 단, 아침 단"),("湍", "여울 단"),("鍛", "쇠불릴 단"),("緞", "비단 단"),("簞", "소쿠리 단"),("蛋", "오랑캐 이름 단, 새알 단"),("亶", "믿을 단"),("袒", "웃옷 벗을 단, 옷벗어멜 단"),("彖", "결단할 단, 결단내릴 단"),("鄲", "조나라 서울 단, 땅이름 단"),("坍", "언덕"),("担", "원숭이 같은 짐승 단"),("胆", "침비깨 단"),("椴", "자작나무 단"),("慱", "근심할 단"),("漙", "이슬방울 맺을 단"),("癉", "황달 단"),("蜑", "오랑캐 이름 단"),("耑", "시초 단"),("腶", "약포 단"),]),
("단계동", &[("丹溪洞", "지명"),]),
("단구동", &[("丹邱洞", "지명"),]),
("단대동", &[("丹垈洞", "지명"),]),
("단밀면", &[("丹密面", "지명"),]),
("단봉동", &[("丹鳳洞", "지명"),]),
("단북면", &[("丹北面", "지명"),]),
("단산면", &[("丹山面", "지명"),]),
("단상니아", &[("坦桑尼亞", "탄자니아"),]),
("단성면", &[("丹城面", "지명"),]),
("단양군", &[("丹陽郡", "지명"),]),
("단양읍", &[("丹陽邑", "지명"),]),
("단원구", &[("檀園區", "지명"),]),
("단월동", &[("丹月洞", "지명"),]),
("단월면", &[("丹月面", "지명"),]),
("단장면", &[("丹場面", "지명"),]),
("단촌면", &[("丹村面", "지명"),]),
("달", &[("達", "통달할 달"),("撻", "매질할 달, 빠를 달"),("疸", "황달 달"),("獺", "수달 달"),("澾", "미끄러울"),("怛", "깜짝 놀랄 달"),("闥", "대문 달"),("韃", "칠 달"),("靼", "다룬가죽 달"),("妲", "계집의 이름 달"),]),
("달동", &[("達洞", "지명"),]),
("달방동", &[("達芳洞", "지명"),]),
("달산면", &[("達山面", "지명"),]),
("달서구", &[("達西區", "지명"),]),
("달성군", &[("達城郡", "지명"),]),
("달성동", &[("達城洞", "지명"),]),
("달안동", &[("達安洞", "지명"),]),
("달천동", &[("達川洞", "지명"),]),
("담", &[("談", "말씀 담"),("擔", "질 담"),("淡", "물모양 담, 묽을 담"),("潭", "깊을 담, 못 담"),("膽", "쓸개 담"),("譚", "클 담, 말씀할 담"),("痰", "가래 담"),("澹", "맑을 담, 싱거울 담"),("曇", "날 흐릴 담, 구름낀 담"),("憺", "고요할 담"),("湛", "즐거울 담"),("聃", "노자이름 담, 귀바퀴없는 담"),("覃", "미칠 담, 고요할 담"),("啖", "씹을 담"),("蕁", "말 담, 지모 담"),("坍", "물이 언덕 찰 담"),("錟", "긴 창 담"),("墰", "목긴 술병 담"),("禫", "담제 담"),("啗", "씹을 담"),("毯", "담자리 담"),("郯", "나라이름 담"),("噉", "씹을 담"),("儋", "기운차고 날쌜해집 담"),("薝", "치자나무 담"),("黮", "검을 담"),("壜", "술병 담"),("罎", "壜과 同字"),("黵", "문신할 담"),]),
("담산동", &[("淡山洞", "지명"),]),
("담양군", &[("潭陽郡", "지명"),]),
("담양읍", &[("潭陽邑", "지명"),]),
("답", &[("答", "젖을 답, 대답 답"),("踏", "떨어지는 소리 답, 밟을 답"),("畓", "논 답"),("遝", "가다가설 답, 뒤섞일 답"),("沓", "거듭 답, 물넘칠 답"),]),
("답동", &[("畓洞", "지명"),]),
("답십리동", &[("踏十里洞", "지명"),]),
("당", &[("堂", "집 당"),("當", "마땅할 당"),("唐", "당나라 당"),("黨", "무리 당"),("糖", "엿 당"),("塘", "연못 당"),("撞", "두드릴 당, 칠 당"),("棠", "아가위 당, 사당나무 당"),("螳", "버마 재비 당"),("幢", "기 당"),("戇", "어리석을 당, 놀랄 당"),("倘", "혹시 당"),("儻", "빼어날 당"),("党", "黨의 略字"),("讜", "곧은 말 당"),("搪", "당동할 당"),("璫", "귀고리 당"),("瑭", "옥이름 당"),("瞠", "바로볼 당"),("鐺", "죄인 자물쇠 당"),("襠", "잠방이 당"),("鏜", "북방축소 당"),("溏", "진수렁 당"),("餳", "엿 당"),("檔", "책상 당"),("礑", "밑바닥 당"),("蟷", "사마귀 당"),("餹", "엿 당"),]),
("당감동", &[("堂甘洞", "지명"),]),
("당동", &[("堂洞", "지명"),("當洞", "지명"),]),
("당리동", &[("堂里洞", "지명"),]),
("당북동", &[("當北洞", "지명"),]),
("당사동", &[("堂舍洞", "지명"),]),
("당산동", &[("堂山洞", "지명"),]),
("당수동", &[("堂樹洞", "지명"),]),
("당왕동", &[("堂旺洞", "지명"),]),
("당인동", &[("唐人洞", "지명"),]),
("당저동", &[("塘底洞", "지명"),]),
("당정동", &[("堂井洞", "지명"),]),
("당주동", &[("唐珠洞", "지명"),]),
("당진군", &[("唐津郡", "지명"),]),
("당진읍", &[("唐津邑", "지명"),]),
("당하동", &[("當下洞", "지명"),]),
("대", &[("大", "클 대, 큰 대"),("代", "대신할 대"),("待", "기다릴 대"),("對", "마주볼 대, 대답할 대"),("帶", "띠 대"),("隊", "군대 대, 떼 대"),("貸", "빌릴 대"),("臺", "능 대"),("戴", "받들 대, 머리에일 대"),("垈", "터 대, 집터 대"),("袋", "자루 대, 주머니 대"),("擡", "들 대"),("岱", "태산 대, 산이름 대"),("黛", "눈썹 그릴 대, 새파랄 대"),("玳", "대모(바다거북) 대"),("錞", "창고달 대"),("坮", "들 대, 집대 대"),("懟", "원망할 대"),("碓", "방아 대"),("儓", "하인 대"),("汏", "씻을 대"),("旲", "햇빛 대"),("鐓", "창고달 대"),]),
("대가면", &[("大可面", "지명"),("大家面", "지명"),]),
("대강면", &[("帶江面", "지명"),("大崗面", "지명"),]),
("대곡동", &[("大谷洞", "지명"),]),
("대곡면", &[("大谷面", "지명"),]),
("대곶면", &[("大串面", "지명"),]),
("대광동", &[("大光洞", "지명"),]),
("대교동", &[("大橋洞", "지명"),]),
("대구광역시", &[("大邱廣域市", "지명"),]),
("대구동", &[("大口洞", "지명"),]),
("대구면", &[("大口面", "지명"),]),
("대기동", &[("大基洞", "지명"),]),
("대내동", &[("臺內洞", "지명"),]),
("대대동", &[("代垈洞", "지명"),]),
("대덕구", &[("大德區", "지명"),]),
("대덕면", &[("大德面", "지명"),]),
("대덕읍", &[("大德邑", "지명"),]),
("대도동", &[("大島洞", "지명"),]),
("대동", &[("大洞", "지명"),("垈洞", "지명"),]),
("대동면", &[("大東面", "지명"),("大洞面", "지명"),]),
("대랑동", &[("大郞洞", "지명"),]),
("대룡동", &[("大龍洞", "지명"),]),
("대림동", &[("大林洞", "지명"),]),
("대마면", &[("大馬面", "지명"),]),
("대만", &[("臺灣", "중화민국"),]),
("대명동", &[("大明洞", "지명"),]),
("대방동", &[("大方洞", "지명"),("大芳洞", "지명"),]),
("대별동", &[("大別洞", "지명"),]),
("대병면", &[("大幷面", "지명"),]),
("대보면", &[("大甫面", "지명"),]),
("대봉동", &[("大鳳洞", "지명"),]),
("대부동", &[("大阜東洞", "지명"),("大阜洞", "지명"),]),
("대부북동", &[("大阜北洞", "지명"),]),
("대불렬돈", &[("大不列頓", "잉글랜드"),]),
("대사동", &[("大寺洞", "지명"),]),
("대산동", &[("大山洞", "지명"),]),
("대산면", &[("大山面", "지명"),("代山面", "지명"),]),
("대산읍", &[("大山邑", "지명"),]),
("대서면", &[("大西面", "지명"),]),
("대석동", &[("大石洞", "지명"),]),
("대성동", &[("大成洞", "지명"),("大城洞", "지명"),("大聖洞", "지명"),]),
("대소면", &[("大所面", "지명"),]),
("대송동", &[("大松洞", "지명"),]),
("대송면", &[("大松面", "지명"),]),
("대술면", &[("大述面", "지명"),]),
("대신동", &[("大新洞", "지명"),]),
("대신면", &[("大神面", "지명"),]),
("대안동", &[("大安洞", "지명"),]),
("대야동", &[("大也洞", "지명"),]),
("대야면", &[("大野面", "지명"),]),
("대야미동", &[("大夜味洞", "지명"),]),
("대양동", &[("大陽洞", "지명"),]),
("대양면", &[("大陽面", "지명"),]),
("대연동", &[("大淵洞", "지명"),]),
("대영동", &[("大榮洞", "지명"),]),
("대외동", &[("臺外洞", "지명"),]),
("대원동", &[("大元洞", "지명"),]),
("대월면", &[("大月面", "지명"),]),
("대의동", &[("大義洞", "지명"),]),
("대의면", &[("大義面", "지명"),]),
("대인동", &[("大仁洞", "지명"),]),
("대자동", &[("大慈洞", "지명"),]),
("대잠동", &[("大岑洞", "지명"),]),
("대장동", &[("大壯洞", "지명"),("大莊洞", "지명"),("大庄洞", "지명"),]),
("대저동", &[("大渚洞", "지명"),]),
("대전광역시", &[("大田廣域市", "지명"),]),
("대전동", &[("大田洞", "지명"),]),
("대전면", &[("大田面", "지명"),]),
("대정동", &[("大井洞", "지명"),("大亭洞", "지명"),]),
("대정읍", &[("大靜邑", "지명"),]),
("대조동", &[("大棗洞", "지명"),]),
("대죽동", &[("大竹洞", "지명"),]),
("대지동", &[("大支洞", "지명"),]),
("대지면", &[("大池面", "지명"),]),
("대진동", &[("大津洞", "지명"),]),
("대창동", &[("大昌洞", "지명"),]),
("대창면", &[("大昌面", "지명"),]),
("대천동", &[("大川洞", "지명"),("大泉洞", "지명"),]),
("대청동", &[("大廳洞", "지명"),]),
("대청면", &[("大靑面", "지명"),]),
("대촌동", &[("大村洞", "지명"),]),
("대치동", &[("大峙洞", "지명"),]),
("대치면", &[("大峙面", "지명"),]),
("대평동", &[("大平洞", "지명"),("大坪洞", "지명"),]),
("대평면", &[("大坪面", "지명"),]),
("대포동", &[("大浦洞", "지명"),("大圃洞", "지명"),]),
("대한민국", &[("大韓民國", "대한민국"),]),
("대합면", &[("大合面", "지명"),]),
("대항동", &[("大項洞", "지명"),]),
("대항면", &[("代項面", "지명"),]),
("대현동", &[("大賢洞", "지명"),("大峴洞", "지명"),]),
("대호동", &[("大湖洞", "지명"),]),
("대호지면", &[("大湖芝面", "지명"),]),
("대화동", &[("大化洞", "지명"),("大禾洞", "지명"),]),
("대화면", &[("大和面", "지명"),]),
("대황교동", &[("大皇橋洞", "지명"),]),
("대흥동", &[("大興洞", "지명"),]),
("대흥면", &[("大興面", "지명"),]),
("댁", &[("宅", "집 댁"),]),
("덕", &[("德", "큰 덕"),("悳", "德의 古字, 덕 덕"),]),
("덕곡동", &[("德谷洞", "지명"),]),
("덕곡면", &[("德谷面", "지명"),]),
("덕과면", &[("德果面", "지명"),]),
("덕교동", &[("德橋洞", "지명"),]),
("덕국", &[("德國", "도이칠란트"),]),
("덕기동", &[("德基洞", "지명"),]),
("덕남동", &[("德南洞", "지명"),]),
("덕동", &[("德洞", "지명"),]),
("덕림동", &[("德林洞", "지명"),]),
("덕명동", &[("德明洞", "지명"),]),
("덕산동", &[("德山洞", "지명"),]),
("덕산면", &[("德山面", "지명"),]),
("덕수동", &[("德壽洞", "지명"),]),
("덕암동", &[("德岩洞", "지명"),]),
("덕양구", &[("德陽區", "지명"),]),
("덕월동", &[("德月洞", "지명"),]),
("덕은동", &[("德隱洞", "지명"),]),
("덕의동", &[("德義洞", "지명"),]),
("덕이동", &[("德耳洞", "지명"),]),
("덕일", &[("德逸", "도이칠란트"),]),
("덕적면", &[("德積面", "지명"),]),
("덕정동", &[("德亭洞", "지명"),]),
("덕지동", &[("德池洞", "지명"),]),
("덕지천동", &[("德之川洞", "지명"),]),
("덕진구", &[("德津區", "지명"),]),
("덕진동", &[("德津洞", "지명"),]),
("덕진면", &[("德津面", "지명"),]),
("덕천동", &[("德川洞", "지명"),]),
("덕천면", &[("德川面", "지명"),]),
("덕충동", &[("德忠洞", "지명"),]),
("덕치면", &[("德峙面", "지명"),]),
("덕포동", &[("德浦洞", "지명"),]),
("덕풍동", &[("德豊洞", "지명"),]),
("덕흥동", &[("德興洞", "지명"),]),
("도", &[("刀", "칼 도"),("道", "길 도"),("度", "법도 도"),("圖", "그림 도"),("島", "섬 도"),("都", "도읍 도"),("到", "이를 도"),("徒", "무리 도"),("逃", "달아날 도"),("導", "이끌 도, 인도할 도"),("渡", "건널 도"),("盜", "도둑 도"),("途", "길 도"),("倒", "넘어질 도, 거꾸러질 도"),("桃", "복숭아 나무 도"),("跳", "뛸 도, 미끄러질 도"),("陶", "질 그도 도, 질그릇 도"),("塗", "바를 도, 진흙 도"),("稻", "벼 도"),("挑", "돋을 도, 돋울 도"),("禱", "빌 도"),("悼", "슬퍼할 도, 애도할 도"),("燾", "비칠 도, 덮일 도"),("濤", "물결 도, 큰물결 도"),("蹈", "밟을 도"),("屠", "잡을 도, 죽일 도"),("滔", "물 넘칠 도, 도도히 흐르는 도"),("睹", "볼 도"),("鍍", "도금할 도"),("掉", "흔들 도, 흔들릴 도"),("堵", "담 도"),("搗", "찧을 도"),("萄", "들머루"),("賭", "노름 도, 내기 도"),("淘", "일 도, 물흐를 도"),("覩", "睹와 同字, 볼 도"),("棹", "노 저을 도"),("韜", "활집 도, 감출 도"),("嶋", "섬 도"),("櫂", "상앗대 도, 노 도"),("叨", "탐할 도"),("鼗", "땡땡이 도"),("擣", "찧을 도"),("饕", "탐할 도"),("涂", "길 도"),("闍", "성문 층대 도"),("忉", "근심할 도"),("弢", "활집 도"),("稌", "찰벼 도"),("鞱", "너그러울 도"),("搯", "두드릴 도"),("檮", "그루터기 도"),("慆", "기뻐할 도"),("壔", "작은 성 도"),("掏", "가릴(선택)할 도"),("酴", "두번 빚은 술 도"),("鞀", "소고 도"),("刂", "선칼도방"),]),
("도개면", &[("桃開面", "지명"),]),
("도경동", &[("桃京洞", "지명"),]),
("도계동", &[("道溪洞", "지명"),]),
("도계읍", &[("道溪邑", "지명"),]),
("도고면", &[("道高面", "지명"),]),
("도곡동", &[("道谷洞", "지명"),]),
("도곡면", &[("道谷面", "지명"),]),
("도금동", &[("陶琴洞", "지명"),]),
("도기동", &[("道基洞", "지명"),]),
("도남동", &[("道南洞", "지명"),]),
("도내동", &[("道乃洞", "지명"),]),
("도농동", &[("陶農洞", "지명"),]),
("도당동", &[("陶唐洞", "지명"),]),
("도덕동", &[("道德洞", "지명"),]),
("도덕면", &[("道德面", "지명"),]),
("도도동", &[("道道洞", "지명"),]),
("도동", &[("道洞", "지명"),]),
("도두동", &[("道頭洞", "지명"),]),
("도량동", &[("道良洞", "지명"),]),
("도련동", &[("道連洞", "지명"),]),
("도룡동", &[("道龍洞", "지명"),]),
("도림동", &[("道林洞", "지명"),("桃林洞", "지명"),]),
("도마교동", &[("渡馬橋洞", "지명"),]),
("도마동", &[("桃馬洞", "지명"),]),
("도만동", &[("道萬洞", "지명"),]),
("도문동", &[("道門洞", "지명"),]),
("도봉구", &[("道峰區", "지명"),]),
("도봉동", &[("道峰洞", "지명"),]),
("도산동", &[("道山洞", "지명"),]),
("도산면", &[("道山面", "지명"),("陶山面", "지명"),]),
("도선동", &[("道詵洞", "지명"),]),
("도순동", &[("道順洞", "지명"),]),
("도안동", &[("道安洞", "지명"),]),
("도안면", &[("道安面", "지명"),]),
("도암면", &[("道岩面", "지명"),]),
("도양읍", &[("道陽邑", "지명"),]),
("도염동", &[("都染洞", "지명"),]),
("도와로", &[("圖瓦盧", "투발루"),]),
("도원동", &[("桃原洞", "지명"),("桃園洞", "지명"),("桃源洞", "지명"),]),
("도이동", &[("桃李洞", "지명"),]),
("도일동", &[("道日洞", "지명"),]),
("도장동", &[("都莊洞", "지명"),]),
("도지동", &[("道只洞", "지명"),]),
("도창동", &[("道倉洞", "지명"),]),
("도척면", &[("都尺面", "지명"),]),
("도천동", &[("道泉洞", "지명"),]),
("도천면", &[("都泉面", "지명"),]),
("도초면", &[("都草面", "지명"),]),
("도촌동", &[("島村洞", "지명"),]),
("도통동", &[("道通洞", "지명"),]),
("도평동", &[("都坪洞", "지명"),]),
("도포면", &[("都浦面", "지명"),]),
("도학동", &[("道鶴洞", "지명"),]),
("도호동", &[("道湖洞", "지명"),]),
("도화동", &[("道禾洞", "지명"),("桃花洞", "지명"),]),
("도화면", &[("道化面", "지명"),]),
("독", &[("讀", "읽을 독"),("獨", "홀로 독"),("督", "감독할 독"),("毒", "독 독, 독할 독"),("篤", "도타울 독, 두터울 독"),("瀆", "도랑 독, 개천 독"),("禿", "대머리 독, 벗어진 독"),("牘", "편지 독"),("犢", "송아지 독"),("纛", "깃일산"),("黷", "더러울 독"),("櫝", "함 독"),]),
("독곡동", &[("獨谷洞", "지명"),]),
("독국", &[("獨國", "도이칠란트"),]),
("독산동", &[("禿山洞", "지명"),]),
("독실동", &[("纛室洞", "지명"),]),
("독을", &[("獨乙", "도이칠란트"),]),
("독일", &[("獨逸", "도이칠란트"),]),
("돈", &[("敦", "도타울 돈"),("豚", "돼지 돈"),("頓", "조아릴 돈"),("惇", "두터울 돈, 도타울 돈"),("沌", "기름 덩어리 돈, 혼탁할 돈"),("燉", "불 성할 돈"),("旽", "늘 돋을 돈, 먼동틀 돈"),("暾", "아침해 돈"),("墩", "돈대 돈"),("焞", "귀갑 지지는 불 돈"),("潡", "큰 물 돈"),("弴", "그림 그린 활 돈"),("躉", "거룻배 돈"),]),
("돈아", &[("豚我", "통가"),]),
("돈암동", &[("敦岩洞", "지명"),]),
("돈의동", &[("敦義洞", "지명"),]),
("돌", &[("突", "부딪칠 돌"),("乭", "이름 돌, 사람이름 돌"),("咄", "꾸짖을 돌"),("堗", "굴똑 돌"),]),
("돌니사", &[("突尼斯", "튀니지"),]),
("돌산읍", &[("突山邑", "지명"),]),
("동", &[("同", "같을 동, 한가지 동"),("東", "동녘 동"),("冬", "겨울 동"),("動", "움직일 동"),("洞", "마을 동, 고을 동"),("童", "아이 동"),("銅", "구리 동"),("凍", "얼 동"),("董", "바로잡을 동, 바를 동"),("桐", "오동나무 동"),("棟", "용마루 동, 동자기둥 동"),("憧", "동경할 동, 흐리멍덩할 동"),("疼", "아플 동"),("瞳", "눈동자 동"),("胴", "큰 창자 동"),("仝", "同의 古字, 같을 동"),("潼", "물 이름 동, 물결높을 동"),("錬", "보습날 동"),("僮", "아이 동"),("蕫", "황모 동"),("彤", "붉은 칠 동"),("侗", "무지할 동"),("峒", "산이름 동"),("蝀", "무지개 동"),("涷", "마룻대 동"),("垌", "항아리 동"),("朣", "달 뜰 동"),("橦", "나무이름 동"),("艟", "배 동"),("茼", "쏙갓 동"),("哃", "클말할 동"),("苳", "겨울살이 동"),("鮗", "전어 동"),]),
("동강면", &[("東江面", "지명"),("洞江面", "지명"),]),
("동계면", &[("東界面", "지명"),]),
("동광동", &[("東光洞", "지명"),]),
("동교동", &[("東橋洞", "지명"),]),
("동구", &[("東區", "지명"),]),
("동구동", &[("東九洞", "지명"),]),
("동금동", &[("東錦洞", "지명"),]),
("동내동", &[("東內洞", "지명"),]),
("동내면", &[("東內面", "지명"),]),
("동대동", &[("東垈洞", "지명"),]),
("동대문구", &[("東大門區", "지명"),]),
("동대신동", &[("東大新洞", "지명"),]),
("동동", &[("東洞", "지명"),]),
("동두천동", &[("東豆川洞", "지명"),]),
("동두천시", &[("東豆川市", "지명"),]),
("동래구", &[("東萊區", "지명"),]),
("동량면", &[("東良面", "지명"),]),
("동로면", &[("東魯面", "지명"),]),
("동림동", &[("東林洞", "지명"),]),
("동막동", &[("東幕洞", "지명"),]),
("동면", &[("東面", "지명"),]),
("동명동", &[("東明洞", "지명"),]),
("동명면", &[("東明面", "지명"),]),
("동문동", &[("東門洞", "지명"),]),
("동방동", &[("東方洞", "지명"),]),
("동변동", &[("東邊洞", "지명"),]),
("동복면", &[("同福面", "지명"),]),
("동본동", &[("東本洞", "지명"),]),
("동부동", &[("東部洞", "지명"),]),
("동부면", &[("東部面", "지명"),]),
("동빈동", &[("東濱洞", "지명"),]),
("동빙고동", &[("東氷庫洞", "지명"),]),
("동삭동", &[("東朔洞", "지명"),]),
("동산동", &[("東山洞", "지명"),("銅山洞", "지명"),]),
("동산면", &[("東山面", "지명"),]),
("동삼동", &[("東三洞", "지명"),]),
("동상동", &[("東上洞", "지명"),]),
("동상면", &[("東上面", "지명"),]),
("동서학동", &[("東棲鶴洞", "지명"),]),
("동선동", &[("東仙洞", "지명"),]),
("동성동", &[("東城洞", "지명"),]),
("동성로", &[("東城路", "지명"),]),
("동소문동", &[("東小門洞", "지명"),]),
("동송읍", &[("東松邑", "지명"),]),
("동수동", &[("東水洞", "지명"),]),
("동숭동", &[("東崇洞", "지명"),]),
("동안구", &[("東安區", "지명"),]),
("동양동", &[("東陽洞", "지명"),]),
("동완산동", &[("東完山洞", "지명"),]),
("동외동", &[("東外洞", "지명"),]),
("동원동", &[("東遠洞", "지명"),]),
("동읍", &[("東邑", "지명"),]),
("동이면", &[("東二面", "지명"),]),
("동인", &[("東仁", "지명"),]),
("동일동", &[("東一洞", "지명"),]),
("동일면", &[("東日面", "지명"),]),
("동자동", &[("東子洞", "지명"),]),
("동작구", &[("銅雀區", "지명"),]),
("동작동", &[("銅雀洞", "지명"),]),
("동적목아", &[("東的木兒", "동티모르"),]),
("동점동", &[("銅店洞", "지명"),]),
("동정동", &[("東井洞", "지명"),]),
("동제문", &[("東帝汶", "동티모르"),]),
("동진면", &[("東津面", "지명"),]),
("동천동", &[("東川洞", "지명"),]),
("동촌동", &[("東村洞", "지명"),]),
("동춘동", &[("東春洞", "지명"),]),
("동충동", &[("東忠洞", "지명"),]),
("동탄면", &[("東灘面", "지명"),]),
("동해면", &[("東海面", "지명"),]),
("동해시", &[("東海市", "지명"),]),
("동향면", &[("銅鄕面", "지명"),]),
("동현동", &[("東峴洞", "지명"),]),
("동호동", &[("東湖洞", "지명"),]),
("동홍동", &[("東烘洞", "지명"),]),
("동화면", &[("東化面", "지명"),]),
("동회동", &[("桐淮洞", "지명"),]),
("동흥남동", &[("東興南洞", "지명"),]),
("두", &[("頭", "머리 두"),("讀", "구절 두, 읽을 두"),("斗", "말 두"),("豆", "콩 두"),("杜", "막을 두"),("兜", "투구 두, 둘러쌀 두"),("痘", "마마 두"),("竇", "구멍 두"),("逗", "머무를 두"),("荳", "콩 두"),("枓", "두공 두, 주두 두"),("斁", "섞을 두"),("蠹", "좀 두"),("肚", "밥통 두"),("陡", "절벽 두"),("蚪", "올챙이 두"),("抖", "퍼주거릴 두"),("脰", "목 두"),("亠", "의미없는 토"),("鬥", "싸움"),]),
("두곡동", &[("斗谷洞", "지명"),]),
("두구동", &[("杜邱洞", "지명"),]),
("두대동", &[("斗大洞", "지명"),]),
("두동", &[("頭洞", "지명"),]),
("두동면", &[("斗東面", "지명"),]),
("두류동", &[("頭流洞", "지명"),]),
("두마면", &[("豆磨面", "지명"),]),
("두모동", &[("杜母洞", "지명"),]),
("두산동", &[("斗山洞", "지명"),]),
("두서면", &[("斗西面", "지명"),]),
("두암동", &[("斗岩洞", "지명"),]),
("두왕동", &[("斗旺洞", "지명"),]),
("두원면", &[("豆原面", "지명"),]),
("두월동", &[("斗月洞", "지명"),]),
("두정동", &[("斗井洞", "지명"),("斗亭洞", "지명"),]),
("두척동", &[("斗尺洞", "지명"),]),
("두촌면", &[("斗村面", "지명"),]),
("두학동", &[("頭鶴洞", "지명"),]),
("두호동", &[("斗湖洞", "지명"),]),
("둔", &[("鈍", "무딜 둔, 둔할 둔"),("屯", "진칠 둔"),("遁", "달아날 둔"),("臀", "볼기 둔"),("芚", "채소 이름 둔, 나무싹 둔"),("遯", "달아날 둔, 숨을 둔"),("窀", "광중 둔"),("迍", "머뭇거릴 둔"),]),
("둔곡동", &[("屯谷洞", "지명"),]),
("둔내면", &[("屯內面", "지명"),]),
("둔대동", &[("屯垈洞", "지명"),]),
("둔덕동", &[("屯德洞", "지명"),]),
("둔덕면", &[("屯德面", "지명"),]),
("둔산동", &[("屯山洞", "지명"),]),
("둔율동", &[("屯栗洞", "지명"),]),
("둔전동", &[("屯田洞", "지명"),]),
("둔촌동", &[("遁村洞", "지명"),]),
("둔포면", &[("屯浦面", "지명"),]),
("둘", &[("乧", "음역자 둘"),]),
("득", &[("得", "얻을 득"),]),
("득량동", &[("得良洞", "지명"),]),
("득량면", &[("得粮面", "지명"),]),
("득산동", &[("得山洞", "지명"),]),
("등", &[("等", "가지런할 등, 무리 등"),("登", "오를 등"),("燈", "등잔 등"),("騰", "오를 등"),("藤", "등나무 등"),("鄧", "나라 이름 등, 등나라 등"),("嶝", "고개 등, 비탈 등"),("謄", "베낄 등"),("橙", "등자나무 등, 궤 등"),("滕", "물 솟을 등"),("鐙", "등자 등"),("灯", "燈의 略字"),("磴", "돌 비탈길 등, 돌다리 등"),("縢", "봉할 등"),("螣", "등사 등"),("墱", "자드락길 등"),("凳", "걸상 등"),("籐", "대 기구 등"),]),
("등봉동", &[("登鳳洞", "지명"),]),
("등임동", &[("登任洞", "지명"),]),
("등촌동", &[("登村洞", "지명"),]),
("등화동", &[("登華洞", "지명"),]),
("라", &[("羅", "새그물 라"),("裸", "벌거벗을 라, 벌거숭이 라"),("懶", "게으를 라"),("螺", "소라 라"),("拏", "붙잡을 라"),("邏", "순행할 라, 돌 라"),("癩", "약물 중독 라"),("蘿", "무 라, 소나무겨우살이 라"),("喇", "나팔"),("騾", "노새 라"),("囉", "소리 읽힐 라"),("鑼", "징 라"),("瘰", "연주창 라"),("臝", "벌거벗을 라"),("倮", "알몸 라"),("曪", "날 흐릴 라"),("驘", "옹 솥 라"),]),
("락", &[("落", "떨어질 락"),("樂", "즐거울 락, 즐길 락"),("諾", "대답할 락, 허락할 락"),("絡", "헌솜 락, 연락할 락"),("洛", "강이름 락"),("駱", "낙타 락"),("烙", "지질 락"),("酪", "진한 유즙 락, 타락 락"),("珞", "구슬 목걸이 락"),("犖", "얼룩소 락"),]),
("란", &[("丹", "붉을 란"),("卵", "알 란"),("亂", "어지러울 란"),("蘭", "난초 란"),("欄", "난간 란"),("爛", "문드러질 란"),("鸞", "난새 란"),("懶", "게으를 란"),("瀾", "물결 란, 큰물결 란"),("欒", "나무 이름 란, 난나무 란"),("闌", "가막을 란"),("鑾", "방울 란"),("攔", "막을 란"),("襴", "난삼 란"),("嬾", "게으를 란"),("幱", "내리다지 란"),("灓", "적실 란"),]),
("랄", &[("剌", "어그러질 랄"),("辣", "매울 랄"),("喇", "말굽히할 랄"),("埒", "바자울 랄"),("辢", "辣과 同字"),]),
("람", &[("覽", "볼 람"),("濫", "퍼질 람"),("藍", "쪽 람"),("籃", "바구니 람"),("攬", "잡을 람"),("嵐", "남기 람"),("纜", "닻줄 람"),("欖", "감람나무 람"),("擥", "攬과 同字, 잡아다릴 람"),("襤", "누더기 람"),("婪", "탐할 람"),("惏", "떨릴 람"),]),
("랍", &[("拉", "꺽을 랍, 꺾을 랍"),("臘", "납향 랍"),("蠟", "밀 랍"),("鑞", "땜납 랍"),]),
("랑", &[("郞", "사나이 랑, 사내 랑"),("浪", "물결 랑"),("廊", "복도 랑"),("狼", "이리 랑"),("朗", "밝을 랑"),("琅", "옥 이름 랑, 옥같은돌 랑"),("郎", "사나이"),("螂", "蜋과 同字, 버마재비 랑"),("瑯", "고을 이름 랑, 옥같은돌 랑"),("閬", "솟을 대문 랑"),("蜋", "사마귀 랑"),("稂", "강아지 풀 랑"),("榔", "나무 이름 랑"),("硠", "돌 부딪는 소라 랑"),("莨", "수크령 랑"),]),
("래", &[("來", "올 래"),("萊", "명아주 래"),("崍", "산 이름 래"),("徠", "올 래"),("淶", "강 이름 래"),("騋", "큰 말 래"),]),
("랭", &[("冷", "찰 랭"),]),
("략", &[("略", "다스릴 략, 간략할 략"),("掠", "노략질할 략"),("畧", "略과 同字"),]),
("량", &[("兩", "두 량, 둘 량"),("良", "좋을 량, 어질 량"),("量", "헤아릴 량"),("凉", "涼의 俗字, 서늘할 량"),("梁", "푸조나무 량, 들보 량"),("糧", "양식 량, 곡식 량"),("諒", "믿을 량"),("亮", "밝을 량"),("樑", "서늘할 량, 들보 량"),("輛", "수레 량, 수레 한채 량"),("粱", "기장 량"),("倆", "재주 량, 공교할 량"),("粮", "糧과 同字, 양식 량"),("涼", "서늘할 량"),("魎", "도깨비 량"),("踉", "뛸 량"),("椋", "들보 량"),("悢", "슬퍼할 량"),("喨", "소리 맑을 량"),]),
("려", &[("旅", "군사 려, 나그네 려"),("慮", "생각할 려"),("麗", "고울 려"),("勵", "힘쓸 려"),("呂", "음률 려, 풍류 려"),("廬", "오두막집 려, 원두막 려"),("礪", "거친 숫돌 려"),("驪", "가라말 려, 검은 말 려"),("閭", "이문 려"),("戾", "여그러질 려, 어그러질 려"),("黎", "검을 려, 무리 려"),("侶", "짝 려"),("濾", "겨를 려, 씻을 려"),("驢", "나귀 려"),("藜", "나라 이름 려, 아름다운 옥 려"),("儷", "짝 려"),("蠣", "굴 려"),("櫚", "종려나무 려"),("厲", "갈 려"),("臚", "살갗 려"),("癘", "창질 려"),("膂", "등골 뼈 려"),("蠡", "좀먹을 려"),("糲", "현미 려"),("唳", "울 려"),("梠", "평고대 려"),("鑢", "줄 려"),("儢", "맘에 하기 싫을 려"),("邌", "천천히 걸을 려"),]),
("력", &[("力", "힘 력"),("歷", "지낼 력, 지날 력"),("曆", "책력 력"),("瀝", "거를 력, 스밀 력"),("礫", "조약돌 력"),("轢", "삐걱거릴 력, 수레바퀴에 치는 력"),("靂", "벼락 력"),("櫟", "상수리나무 력"),("櫪", "말구유 력"),("酈", "땅 이름 력"),("癧", "연주창 력"),("轣", "갈 력"),]),
("련", &[("連", "잇닿을 련, 연할 련"),("練", "익힐 련"),("鍊", "불릴 련, 쇠불릴 련"),("憐", "불쌍히 여길 련, 가련할 련"),("戀", "사모할 련"),("聯", "잇달 련, 연할 련"),("蓮", "연밥 련, 연꽃 련"),("漣", "물놀이 련, 물놀이칠 련"),("輦", "손수레 련, 당길 련"),("煉", "불릴 련, 쇠불릴 련"),("怜", "연리할 련"),("璉", "호련 련, 종묘제기 련"),("攣", "걸릴 련"),("臠", "저민고기 련"),("孌", "아름다울 련"),("鰱", "연어 련"),("楝", "멀구슬나무 련"),("鏈", "쇠사슬 련"),("湅", "누일 련"),("鰊", "고기 이름 련"),]),
("렬", &[("列", "줄 렬, 벌일 렬"),("烈", "세찰 렬, 매울 렬"),("劣", "못할 렬, 용렬할 렬"),("裂", "찢을 렬"),("冽", "찰 렬, 찬바람 렬"),("洌", "맑을 렬"),("捩", "비틀 렬"),("颲", "사나운 바람 렬"),]),
("렴", &[("廉", "청렴할 렴"),("濂", "내 이름 렴, 엷을 렴"),("斂", "거둘 렴"),("簾", "발 렴"),("殮", "염할 렴"),("瀲", "넘칠 렴"),("奩", "화장 상자 렴"),("磏", "거친 숫돌 렴"),]),
("렵", &[("獵", "사냥 렵, 사냥할 렵"),("鬣", "갈기 렵"),("躐", "밟을 렵"),]),
("령", &[("令", "명령 령, 시킬 령, 하여금 령"),("領", "옷깃 령, 거느릴 령"),("寧", "편안할 령"),("靈", "신령 령"),("嶺", "재 령, 산고개 령"),("零", "조용히 오는 비 령, 떨어질 령"),("鈴", "방울 령"),("玲", "옥이름 령, 금옥소리 령"),("囹", "옥 령, 감옥 령"),("齡", "나이 령"),("逞", "굳셀 령, 통할 령"),("聆", "들을 령"),("怜", "영리할 령"),("伶", "영리할 령, 악공 령, 광대 령"),("翎", "깃 령, 날개 령"),("羚", "영양 령"),("岺", "재 령, 깊은산 령"),("笭", "도꼬마리 령, 작은 통 령"),("另", "나눌 령, 다를 령, 헤어질 령"),("岭", "산 이름 령"),("泠", "깨우칠 령"),("苓", "도꼬마리 령"),("鴒", "할미새 령"),("蛉", "장자리 령"),("欞", "격자창 령"),("呤", "속삭일 령"),("昤", "날 빛 영롱할 령"),("姈", "계집 슬기로울 령"),("秢", "벼 처음 익을 령"),("軨", "사냥 수레 령"),("鹷", "나이 령"),]),
("례", &[("禮", "예도 례"),("例", "법식 례"),("豊", "禮의 古字"),("隷", "隸와 同字, 붙을 례"),("醴", "단술 례"),("澧", "강 이름 례"),("隸", "붙을 례"),("鱧", "가물치 례"),]),
("로", &[("老", "늙은이 로"),("路", "길 로"),("勞", "일할 로"),("怒", "성냉 로, 성낼 로"),("露", "이슬 로"),("盧", "밥그릇 로"),("魯", "노둔할 로"),("爐", "화로 로, 화초 로"),("蘆", "갈대 로"),("鷺", "해오라기 로"),("虜", "포로 로"),("擄", "사로잡을 로"),("撈", "잡을 로, 건져낼 로"),("輅", "수레 로"),("鹵", "소금 로, 개펄 로"),("潞", "강 이름 로, 물이름 로"),("櫓", "방패 로"),("瀘", "강 이름 로"),("鑪", "화로 로"),("鱸", "농어 로"),("壚", "흑토 로"),("艪", "艫와 同字"),("顱", "머리뼈 로"),("艫", "뱃머리 로"),("鸕", "가마우지 로"),("轤", "고패 로"),("玈", "검을 로"),("窂", "우리 로"),("滷", "소금밭 로"),("癆", "종독 로"),("鐪", "부레 로"),("髗", "해골 로"),("耂", "늙을로엄"),]),
("록", &[("綠", "초록빛 록"),("錄", "기록할 록"),("祿", "복 록"),("鹿", "사슴 록"),("麓", "신기슭 록, 산기슭 록"),("碌", "돌 모양 록"),("菉", "조개풀 록"),("淥", "밭을 록"),("漉", "거를 록"),("彔", "나무 깍을 록"),("騄", "말이름 록"),("簏", "대 상자 록"),("轆", "도르래 록"),("圥", "버섯 록"),]),
("론", &[("論", "말할 론"),]),
("롱", &[("弄", "희롱할 롱"),("籠", "대그릇 롱"),("聾", "귀머거리 롱"),("壟", "언덕 롱"),("瓏", "환할"),("朧", "흐릿할 롱, 침침할 롱"),("瀧", "적실"),("隴", "고개 이름 롱"),("礱", "갈 롱"),("曨", "어스레할 롱"),("蘢", "개여뀌 롱"),("儱", "건목칠 롱"),("攏", "누를 롱"),]),
("뢰", &[("雷", "우뢰 뢰, 우리 뢰"),("賴", "힘 입을 뢰"),("賂", "뇌물 줄 뢰"),("儡", "영락할 뢰, 무너질 뢰"),("牢", "우리 뢰"),("磊", "돌무더기 뢰"),("賚", "줄 뢰"),("瀨", "여울 뢰, 물결 뢰"),("罍", "술독 뢰"),("耒", "쟁기 뢰"),("酹", "부을 뢰"),("誄", "뇌사 뢰"),("礧", "바위너설 뢰"),("纇", "실 마디 뢰"),("蕾", "꽃봉오리 뢰"),("礌", "돌 굴러내릴 뢰"),]),
("료", &[("料", "되질할 료, 헤아릴 료"),("了", "마칠 료"),("僚", "동료 료, 동관 료"),("遼", "멀 료"),("療", "병고칠 료"),("聊", "귀 울 료, 애오라지 료"),("寮", "벼슬아쳐 료, 동관 료"),("燎", "화톳불 료, 햇불 료"),("瞭", "밝을 료, 멀리보는 료"),("廖", "공허할 료, 성 료"),("寥", "쓸쓸할 료"),("鬧", "시끄러울"),("蓼", "여뀌 료"),("潦", "큰 비 료"),("醪", "막걸리 료"),("繚", "감길 료"),("膋", "발기름 료"),("撩", "다스릴 료"),("暸", "밝을 료"),("獠", "밤사냥 료"),("鐐", "은 료"),("嘹", "울 료"),("嫽", "외조모 료"),("飂", "높이 부는 바람 료"),("飉", "바람 료"),]),
("룡", &[("龍", "용 룡"),("龒", "龍의 古字"),]),
("루", &[("樓", "다락 루"),("漏", "샐 루"),("淚", "눈물 루"),("累", "묶을 루"),("屢", "창 루"),("陋", "줍을 루, 좁을 루"),("壘", "진 루"),("縷", "실 루"),("婁", "별 이름 루, 어리석은 루"),("鏤", "새길 루, 강철 루"),("褸", "남루할 루"),("蔞", "쑥 루, 물쑥 루"),("瘻", "부스럼 루, 헌곳 루"),("螻", "땅강아지 루"),("僂", "구부릴 루"),("髏", "해굴 루"),("嶁", "봉우리 루"),("慺", "정성스러울 루"),("嘍", "시끄러울 루"),("耬", "씨 뿌리는 기구 루"),]),
("류", &[("流", "흐를 류"),("留", "머무를 류"),("柳", "버들 류"),("類", "무리 류"),("劉", "죽일 류, 성 류"),("謬", "그릇될 류"),("溜", "방울져 떨어질 류, 증류수 류"),("琉", "유리 류, 유리돌 류"),("瘤", "혹 류"),("瑠", "琉와 同字, 구슬이름 류"),("旒", "깃발 류, 깃술 류"),("榴", "석류나무 류"),("硫", "유황 류"),("瀏", "맑을 류"),("纍", "갇힐 류"),("鶹", "올빼미 류"),("縲", "포승 류"),("遛", "머무를 류"),("橊", "榴의 本字"),]),
("륙", &[("六", "여섯 륙"),("陸", "뭍 륙"),("戮", "죽일 륙"),("勠", "협력할 륙"),]),
("륜", &[("倫", "인륜 륜"),("輪", "바퀴 륜, 수레바퀴 륜"),("崙", "산 이름 륜"),("綸", "낚싯줄 륜, 푸른인끈 륜"),("淪", "물놀이 륜, 빠질 륜"),("侖", "둥글 륜, 뭉치 륜"),("掄", "가릴 륜"),]),
("률", &[("律", "법 률"),("率", "헤아릴 률"),("栗", "밤나무 률"),("慄", "두려워할 률, 두려울 률"),("嵂", "가파를 률"),("溧", "강 이름 률"),]),
("륭", &[("隆", "클 륭, 높을 륭"),("癃", "느른할 륭"),("窿", "활꼴 륭"),]),
("륵", &[("勒", "굴레 륵"),("肋", "갈비 륵"),("泐", "돌 갈라질 륵"),]),
("름", &[("凜", "찰 름"),("廩", "곳집 름"),("凛", "찰 름"),("澟", "서늘할 름"),]),
("릉", &[("陵", "큰 언덕 릉"),("楞", "모 릉, 네모질 릉"),("凌", "능가할 릉"),("綾", "비단 릉"),("菱", "蔆과 同字, 마름 릉"),("稜", "모 릉"),("倰", "속일 릉"),("蔆", "마름 릉"),]),
("리", &[("里", "마을 리"),("利", "날카로울 리, 이로울 리"),("理", "다스릴 리, 이치 리"),("異", "다를 리"),("李", "오얏 리"),("吏", "벼슬아치 리, 관리 리"),("離", "떼 놓을 리, 떠날 리"),("履", "신 리, 밟을 리"),("裏", "속 리"),("梨", "태나무 리, 배 리"),("罹", "근심 리, 만날 리"),("裡", "裏와 同字, 옷속 리"),("籬", "울타리 리"),("厘", "釐의 俗字, 티끌 리"),("俚", "속될 리"),("痢", "설사 리, 이질 리"),("悧", "영리할 리, 똑똑할 리"),("羸", "여윌 리, 파리할 리"),("釐", "다스릴 리, 털끝 리"),("狸", "貍와 同字, 이리 리"),("犁", "얼룩소 리"),("璃", "유리 리"),("鯉", "잉어 리"),("唎", "가는 소리 리"),("莉", "말리 리, 사과꽃 리"),("浬", "해리 리, 바다잇수 리"),("漓", "스며들 리"),("莅", "다다를 리"),("离", "산신 리"),("螭", "교륭 리"),("俐", "똑똑할 리"),("嫠", "과부 리"),("魑", "도깨비 리"),("貍", "삵 리"),("邐", "이어질 리"),("涖", "다다를 리"),("哩", "어조사 리"),("蜊", "참조개 리"),("黐", "끈끈이 리"),("剺", "벗길 리"),]),
("린", &[("隣", "鄰의 俗字, 이웃 린"),("麟", "기린 린"),("鱗", "비늘 린"),("吝", "아낄 린, 인색할 린"),("躪", "짓밟을 린, 짖밟을 린"),("燐", "도깨비불 린, 반딧불 린"),("璘", "옥빛 린"),("藺", "골풀 린, 뇌양이 린"),("潾", "맑을 린, 물맑을 린"),("獜", "튼튼할 린"),("鄰", "이웃 린"),("磷", "돌 을 틈물이 흐르는 모양 린"),("粼", "물 맑을 린"),("嶙", "가파를 린"),("驎", "워라말 린"),("轔", "수레 소리 린"),("繗", "이을 린"),("悋", "아낄 린"),("躙", "짓밟을 린"),("鏻", "굳셀 린"),("粦", "도깨비 불 린"),]),
("림", &[("林", "수풀 림"),("臨", "임할 림"),("淋", "물뿌릴 림, 물댈 림"),("琳", "아름다운 옥 림"),("霖", "장마 림"),("痳", "임질 림"),]),
("립", &[("立", "설 립"),("笠", "우리 립, 삿갓 립"),("粒", "알 립, 쌀알 립"),("砬", "돌 소리 립"),("岦", "산 우뚝할 립"),]),
("마", &[("馬", "말 마"),("麻", "삼 마"),("磨", "갈 마"),("摩", "갈 마"),("魔", "마귀 마"),("痲", "저릴 마, 홍역 마"),("瑪", "마노 마, 옥돌이름 마"),("碼", "마노 마, 옥돌 마"),("麽", "잘 마"),("麿", "갈 마"),("劘", "깍을 마"),("媽", "어미 마"),("螞", "말거머리 마"),("蟇", "개구리 마"),]),
("마곡동", &[("麻谷洞", "지명"),]),
("마기돈", &[("馬其頓", "마케도니아"),]),
("마납가", &[("摩納哥", "모나코"),]),
("마달가사가", &[("馬達加斯加", "마다가스카르"),]),
("마달동", &[("麻達洞", "지명"),]),
("마도동", &[("馬島洞", "지명"),]),
("마도면", &[("麻道面", "지명"),]),
("마동", &[("馬洞", "지명"),]),
("마두동", &[("馬頭洞", "지명"),]),
("마락가", &[("摩洛哥", "모로코"),]),
("마랍유", &[("馬拉維", "말라위"),]),
("마래서아", &[("馬来西亞", "말레이시아"),]),
("마량면", &[("馬良面", "지명"),]),
("마령면", &[("馬靈面", "지명"),]),
("마로면", &[("馬老面", "지명"),]),
("마륵동", &[("馬勒洞", "지명"),]),
("마리", &[("馬里", "말리"),("麻里", "말리"),]),
("마리면", &[("馬利面", "지명"),]),
("마빈", &[("馬浜", "바하마"),]),
("마산동", &[("馬山洞", "지명"),]),
("마산면", &[("馬山面", "지명"),]),
("마산시", &[("馬山市", "지명"),]),
("마서면", &[("馬西面", "지명"),]),
("마성면", &[("麻城面", "지명"),]),
("마암면", &[("馬岩面", "지명"),]),
("마이다와", &[("摩爾多瓦", "몰도바"),]),
("마이대부", &[("馬爾代夫", "몰디브"),]),
("마이타", &[("馬耳他", "몰타"),]),
("마이태", &[("馬爾太", "몰타"),]),
("마장동", &[("馬場洞", "지명"),]),
("마장면", &[("麻長面", "지명"),]),
("마전동", &[("麻田洞", "지명"),]),
("마천동", &[("馬川洞", "지명"),]),
("마천면", &[("馬川面", "지명"),]),
("마평동", &[("馬坪洞", "지명"),("麻坪洞", "지명"),]),
("마포구", &[("麻浦區", "지명"),]),
("마포동", &[("麻浦洞", "지명"),]),
("마헐이제도", &[("馬歇爾諸島", "마셜 제도"),]),
("막", &[("莫", "없을 막, 말 막"),("幕", "막 막, 장막 막"),("漠", "사막 막, 아득할 막"),("膜", "막 막, 살속의 가죽 막"),("寞", "쓸쓸할 막"),("邈", "멀 막, 아득할 막"),("鏌", "칼 이름 막"),("瞙", "눈 흐릴 막"),]),
("막계동", &[("莫溪洞", "지명"),]),
("만", &[("萬", "일만 만"),("滿", "찰 만"),("晩", "저물 만, 늦을 만"),("慢", "게으를 만, 거만할 만"),("漫", "질펀할 만, 물질펀한 만"),("蠻", "오랑캐 만"),("灣", "물굽이 만"),("娩", "해산할 만"),("挽", "당길 만"),("蔓", "덩굴 만"),("瞞", "속일 만, 거슴츠레한 만"),("輓", "끌 만, 수레끌 만"),("彎", "굽을 만, 활당길 만"),("饅", "만두 만"),("鰻", "뱀장어 만"),("卍", "만자 만, 범자의만 만"),("万", "일만 만"),("曼", "끌 만, 길 만"),("巒", "뫼 만, 산봉우리 만"),("謾", "속일 만"),("幔", "막 만"),("嫚", "업신여길 만"),("蹣", "비틀거릴 만"),("墁", "흙손 만"),("縵", "무늬 없는 비단 만"),("鏝", "흙손 만"),("鬘", "머리장식 만"),("鏋", "금 만"),]),
("만경읍", &[("萬頃邑", "지명"),]),
("만년동", &[("萬年洞", "지명"),]),
("만덕동", &[("萬德洞", "지명"),]),
("만리동", &[("萬里洞", "지명"),]),
("만산동", &[("蔓山洞", "지명"),]),
("만석동", &[("萬石洞", "지명"),]),
("만성동", &[("萬成洞", "지명"),]),
("만수동", &[("萬壽洞", "지명"),]),
("만안구", &[("萬安區", "지명"),]),
("만우동", &[("晩遇洞", "지명"),]),
("만촌동", &[("晩村洞", "지명"),]),
("만호동", &[("萬戶洞", "지명"),]),
("만흥동", &[("萬興洞", "지명"),]),
("말", &[("末", "끝 말"),("靺", "버선 말, 붉은 끈 말"),("抹", "바랄 말, 바를 말"),("襪", "버선 말"),("沫", "거품 말, 물방울 말"),("唜", "끝"),("茉", "말리 말"),("秣", "꼴 말"),]),
("망", &[("亡", "망할 망"),("望", "바랄 망"),("忘", "잊을 망"),("忙", "바쁠 망"),("妄", "허망할 망, 망령될 망"),("罔", "그물 망, 없을 망"),("茫", "아득할 망"),("網", "그물 망"),("芒", "까끄라기 망, 싹 망"),("莽", "우거질 망, 풀이 우거진 망"),("邙", "산 이름 망, 북망산 망"),("輞", "바퀴테 망"),("惘", "멍할 망"),("魍", "도깨비 망"),("莾", "마디 짧은 대 망"),("蟒", "이무기 망"),("漭", "넓을 망"),("汒", "황급할 망"),("网", "그물"),("罒", "그물"),]),
("망경남동", &[("望京南洞", "지명"),]),
("망경동", &[("望京洞", "지명"),]),
("망경북동", &[("望京北洞", "지명"),]),
("망미동", &[("望美洞", "지명"),]),
("망상동", &[("望祥洞", "지명"),]),
("망성면", &[("望城面", "지명"),]),
("망우동", &[("忘憂洞", "지명"),]),
("망운면", &[("望雲面", "지명"),]),
("망원동", &[("望遠洞", "지명"),]),
("망월동", &[("望月洞", "지명"),]),
("망정동", &[("望亭洞", "지명"),]),
("망제동", &[("望帝洞", "지명"),]),
("망포", &[("網浦洞", "지명"),]),
("매", &[("賣", "팔 매"),("買", "살 매"),("每", "매양 매"),("妹", "누이 매, 손아랫누이 매"),("梅", "매화나무 매"),("媒", "중매 매"),("埋", "묻을 매"),("枚", "줄기 매"),("魅", "도깨비 매"),("昧", "새벽 매, 먼동틀 매"),("寐", "잠잘 매, 잔다 매"),("罵", "욕할 매"),("邁", "갈 매, 멀리갈 매"),("煤", "그을음 매"),("呆", "어리석을 매"),("楳", "梅의 古字"),("眛", "어두울 매"),("莓", "나무딸기 매"),("玫", "매괴 매"),("苺", "딸기 매"),("酶", "술밑 매"),("霉", "매우 매"),]),
("매곡동", &[("梅谷洞", "지명"),]),
("매곡면", &[("梅谷面", "지명"),]),
("매교동", &[("梅橋洞", "지명"),]),
("매로동", &[("梅老洞", "지명"),]),
("매산동", &[("梅山洞", "지명"),]),
("매산로", &[("梅山路", "지명"),]),
("매송면", &[("梅松面", "지명"),]),
("매암동", &[("梅岩洞", "지명"),]),
("매여동", &[("梅餘洞", "지명"),]),
("매월동", &[("每月洞", "지명"),]),
("매전면", &[("梅田面", "지명"),]),
("매천동", &[("梅川洞", "지명"),]),
("매탄", &[("梅灘洞", "지명"),]),
("매포읍", &[("梅浦邑", "지명"),]),
("매향", &[("梅香洞", "지명"),]),
("매호동", &[("梅湖洞", "지명"),]),
("매화동", &[("梅花洞", "지명"),]),
("맥", &[("麥", "보리 맥"),("脈", "맥 맥"),("貊", "북방 종족 맥, 큰곰 맥"),("陌", "두렁 맥, 밭둑길 맥"),("驀", "말탈 맥"),("脉", "脈의 古字"),("貃", "오랑캐 맥"),("貘", "짐승 이름 맥"),]),
("맥금동", &[("陌今洞", "지명"),]),
("맹", &[("孟", "맏 맹"),("盟", "맹세할 맹"),("猛", "사나울 맹"),("盲", "소경 맹, 눈어두울 맹"),("萌", "싹 맹"),("氓", "백성 맹"),]),
("맹가랍국", &[("孟加拉國", "방글라데시"),]),
("맹동면", &[("孟洞面", "지명"),]),
("멱", &[("覓", "찾을 멱, 구할 멱"),("汨", "물이름 멱"),("冪", "덮을 멱"),("糸", "실"),("幎", "덮을 멱"),("冖", "덮다"),]),
("면", &[("面", "낯 면"),("免", "면할 면"),("勉", "힘쓸 면"),("眠", "잠잘 면"),("綿", "이어질 면, 솜 면"),("冕", "면류관 면"),("沔", "물 흐를 면"),("緬", "가는 실 면, 아득할 면"),("眄", "애꾸눈 면, 곁눈질할 면"),("麵", "麪과 同字, 밀가루 면"),("棉", "목화 면"),("俛", "힘쓸 면"),("緜", "햇솜 면"),("麪", "밀가루 면"),("糆", "麪과 同字"),("湎", "빠질 면"),("宀", "움집"),]),
("면목동", &[("面牧洞", "지명"),]),
("면전", &[("緬甸", "미얀마"),]),
("면천면", &[("沔川面", "지명"),]),
("멸", &[("滅", "멸망할 멸, 멸할 멸"),("蔑", "업신여길 멸, 없을 멸"),("衊", "모독할 멸"),("篾", "대 껍질 멸"),]),
("명", &[("明", "밝을 명"),("命", "목숨 명"),("名", "이름 명"),("鳴", "울 명, 새소리 명"),("銘", "새길 명"),("冥", "어두울 명"),("溟", "어두울 명, 바다 명"),("暝", "어두울 명"),("皿", "그릇 명"),("螟", "마디충 명, 며루 명"),("酩", "술 취할 명, 취한 모양 명"),("瞑", "눈 감을 명"),("蓂", "명협 명, 담벽풀 명"),("茗", "차 싹 명, 차의 싹 명"),("椧", "홈 통 명"),("洺", "강 이름 명"),]),
("명곡동", &[("明谷洞", "지명"),]),
("명덕동", &[("明德洞", "지명"),]),
("명도동", &[("明道洞", "지명"),]),
("명동", &[("明洞", "지명"),]),
("명륜동", &[("明倫洞", "지명"),]),
("명법동", &[("明法洞", "지명"),]),
("명산동", &[("明山洞", "지명"),]),
("명서동", &[("明西洞", "지명"),]),
("명석면", &[("鳴石面", "지명"),]),
("명암동", &[("明岩洞", "지명"),]),
("명일동", &[("明逸洞", "지명"),]),
("명장동", &[("鳴藏洞", "지명"),]),
("명정동", &[("明井洞", "지명"),]),
("명주동", &[("溟州洞", "지명"),]),
("명지동", &[("明芝洞", "지명"),("鳴旨洞", "지명"),]),
("명천동", &[("鳴川洞", "지명"),]),
("명촌동", &[("明村洞", "지명"),]),
("명호면", &[("明湖面", "지명"),]),
("명화동", &[("明花洞", "지명"),]),
("몌", &[("袂", "소매 몌, 옷소매 몌"),]),
("모", &[("母", "어미 모"),("毛", "털 모, 터럭 모"),("暮", "저물 모"),("慕", "그리워할 모, 사모할 모"),("募", "모을 모, 뽑을 모"),("模", "법 모"),("某", "아무 모"),("謀", "꾀할 모"),("冒", "가릴 모, 무릅쓸 모"),("侮", "업신여길 모"),("貌", "얼굴 모, 모양 모"),("謨", "꾀 모"),("牟", "소 우는 소리 모, 클 모"),("帽", "모자 모"),("茅", "띠 모"),("矛", "창 모, 세모진창 모"),("耗", "줄 모, 없을 모"),("摸", "찾을 모, 본뜰 모"),("牡", "수컷 모"),("眸", "눈동자 모"),("摹", "베낄 모"),("瑁", "서옥 모, 대모 모"),("芼", "풀 우거질 모, 나물 모"),("姆", "여스승 모"),("糢", "模의 俗字, 모호할 모"),("耄", "늙은이 모"),("侔", "가지런 할 모"),("髦", "다팔머리 모"),("旄", "깃대 장식 모"),("媢", "강새암 할 모"),("蟊", "蝥와 同字"),("嫫", "예쁠 모"),("眊", "눈 흐릴 모"),("皃", "貌와 同字"),("姥", "할미 모"),("蝥", "해충 모"),("粍", "밀리메트로 모"),("鉾", "칼 끝 모"),("恈", "탐할 모"),]),
("모가면", &[("慕加面", "지명"),]),
("모곡동", &[("茅谷洞", "지명"),]),
("모국", &[("暮國", "볼리비아"),]),
("모동면", &[("牟東面", "지명"),]),
("모라동", &[("毛羅洞", "지명"),]),
("모리구사", &[("毛利西亞", "모리셔스"),]),
("모리비아", &[("暮利比亜", "볼리비아"),]),
("모리서아", &[("毛里求斯", "모리셔스"),]),
("모리탑니아", &[("毛里塔尼亞", "모리타니"),]),
("모산동", &[("茅山洞", "지명"),]),
("모삼비급", &[("莫三鼻給", "모잠비크"),]),
("모상비극", &[("莫桑比克", "모잠비크"),]),
("모서면", &[("牟西面", "지명"),]),
("모악동", &[("母岳洞", "지명"),]),
("모암동", &[("帽岩洞", "지명"),]),
("모와아", &[("蒙古", "몽골"),]),
("모전동", &[("茅田洞", "지명"),]),
("모종동", &[("毛宗洞", "지명"),]),
("모진동", &[("毛陳洞", "지명"),]),
("모충동", &[("慕忠洞", "지명"),]),
("모현동", &[("慕縣洞", "지명"),]),
("모현면", &[("慕賢面", "지명"),]),
("목", &[("目", "눈 목"),("木", "나무 목"),("牧", "칠 목, 기를 목"),("睦", "화목할 목"),("穆", "화목할 목, 화할 목"),("沐", "머리감을 목"),("鶩", "집오리 목"),("苜", "거여목 목"),("凩", "찬바람 목"),]),
("목감동", &[("牧甘洞", "지명"),]),
("목내동", &[("木內洞", "지명"),]),
("목달동", &[("木達洞", "지명"),]),
("목동", &[("木洞", "지명"),("牧洞", "지명"),]),
("목면", &[("木面", "지명"),]),
("목벌동", &[("木伐洞", "지명"),]),
("목사동면", &[("木寺洞面", "지명"),]),
("목상동", &[("木上洞", "지명"),("木霜洞", "지명"),]),
("목성동", &[("木城洞", "지명"),]),
("목장동", &[("木場洞", "지명"),]),
("목천동", &[("木川洞", "지명"),]),
("목천읍", &[("木川邑", "지명"),]),
("목포시", &[("木浦市", "지명"),]),
("목행동", &[("牧杏洞", "지명"),]),
("목현동", &[("木峴洞", "지명"),]),
("몰", &[("沒", "가라 앉을 몰, 빠질 몰"),("歿", "죽을 몰"),]),
("몽", &[("夢", "꿈 몽"),("蒙", "입을 몽, 어릴 몽"),("朦", "풍부할 몽, 풍부한 몽"),("矇", "소경 몽"),("濛", "가랑비 올 몽"),("曚", "어두울 몽"),("瞢", "어두울 몽"),("幪", "덮을 몽"),("雺", "안개 몽"),("懞", "어두울 몽"),("艨", "싸움배 몽"),("鸏", "비둘기 몽"),]),
("몽고", &[("莫臥兒蒙古", "몽골"),]),
("몽탄면", &[("夢灘面", "지명"),]),
("묘", &[("卯", "토끼 묘"),("妙", "묘할 묘"),("廟", "사당 묘, 종묘 묘"),("墓", "무덤 묘"),("秒", "까끄라기 묘"),("苗", "모 묘, 싹 묘"),("猫", "고양이 묘"),("昴", "별자리 이름 묘, 별이름 묘"),("描", "그릴 묘"),("渺", "아득할 묘"),("杳", "어두울 묘, 아득할 묘"),("竗", "땅 이름 묘"),("錨", "닻 묘"),("眇", "애꾸눈 묘"),("藐", "작을 묘"),("淼", "물 아득할 묘"),("貓", "猫와 同字"),]),
("묘도동", &[("猫島洞", "지명"),]),
("묘동", &[("廟洞", "지명"),]),
("묘산면", &[("妙山面", "지명"),]),
("무", &[("無", "없을 무"),("武", "굳셀 무, 자만할 무, 군인 무, 호반 무"),("務", "일 무, 힘쓸 무, 권장할 무"),("戊", "다섯째 천간 무, 무성할 무"),("茂", "우거질 무, 무성할 무"),("舞", "춤출 무"),("貿", "바꿀 무, 물건 살 무, 무역할 무"),("霧", "안개 무, 어두울 무"),("誣", "무고할 무, 깔볼 무, 속일 무"),("巫", "무당 무, 산 이름 무"),("毋", "말 무"),("撫", "어루만질 무, 누를 무"),("畝", "밭이랑"),("蕪", "거칠어질 무, 거친풀 무, 황무지 무"),("憮", "어루만질 무, 애무할 무"),("拇", "엄지손가락 무"),("无", "없을 무"),("懋", "힘쓸 무, 노력할 무"),("繆", "묶을 무, 얽을 무, 삼 무"),("鵡", "앵무새 무"),("珷", "옥돌 무, 옥돌이름 무"),("楙", "무성할 무, 아름다울 무, 모과나무 무"),("廡", "집 무, 처마 무, 지붕 무"),("騖", "달릴 무, 질주할 무"),("膴", "포 무, 크게 저민 고기 무"),("儛", "舞와 同字"),("嘸", "분명하지 않을 무, 모호한 모양 무"),]),
("무거동", &[("無去洞", "지명"),]),
("무교동", &[("武橋洞", "지명"),]),
("무량고", &[("武良尻", "브라질"),]),
("무량면", &[("畝良面", "지명"),]),
("무릉동", &[("武陵洞", "지명"),]),
("무송동", &[("茂松洞", "지명"),]),
("무수동", &[("無愁洞", "지명"),]),
("무실동", &[("茂實洞", "지명"),]),
("무안군", &[("務安郡", "지명"),]),
("무안동", &[("務安洞", "지명"),]),
("무안면", &[("武安面", "지명"),]),
("무안읍", &[("務安邑", "지명"),]),
("무양동", &[("武陽洞", "지명"),]),
("무용동", &[("舞龍洞", "지명"),]),
("무을면", &[("無乙面", "지명"),]),
("무의동", &[("舞衣洞", "지명"),]),
("무장면", &[("茂長面", "지명"),]),
("무전동", &[("霧田洞", "지명"),]),
("무정면", &[("武貞面", "지명"),]),
("무주군", &[("茂朱郡", "지명"),]),
("무주읍", &[("茂朱邑", "지명"),]),
("무지동", &[("茂芝洞", "지명"),]),
("무풍면", &[("茂豊面", "지명"),]),
("무학동", &[("舞鶴洞", "지명"),]),
("묵", &[("墨", "먹 묵, 형벌 이름 묵"),("默", "묵묵할 묵, 고요할 묵, 잠잠할 묵"),("嘿", "고요할 묵, 말 아니할 묵"),]),
("묵동", &[("墨洞", "지명"),]),
("묵서가", &[("墨西哥", "멕시코"),]),
("묵정동", &[("墨井洞", "지명"),]),
("묵호동", &[("墨湖洞", "지명"),]),
("문", &[("門", "문 문"),("問", "물을 문, 알릴 문"),("文", "무늬 문, 얼룩 문, 글월 문"),("聞", "들을 문"),("紊", "어지러울 문, 얽힐 문"),("汶", "내 이름 문, 수치 문, 물이름 문"),("紋", "무늬 문, 주름 문"),("蚊", "모기 문"),("吻", "입술 문, 입가 문"),("刎", "목 벨 문, 자를 문, 끊을 문"),("們", "들 문, 무리 문"),("雯", "구름 무늬 문"),("捫", "어루만질 문, 쓰다듬을 문"),("懣", "번거로울 문"),("抆", "닦을 문, 문지를 문"),("悗", "잊어버릴 문"),("炆", "따뜻할 문"),("匁", "몸메 문"),("璊", "붉은 옥 문"),]),
("문경시", &[("聞慶市", "지명"),]),
("문경읍", &[("聞慶邑", "지명"),]),
("문곡동", &[("文曲洞", "지명"),]),
("문광면", &[("文光面", "지명"),]),
("문내동", &[("門內洞", "지명"),]),
("문내면", &[("門內面", "지명"),]),
("문당동", &[("文唐洞", "지명"),]),
("문덕면", &[("文德面", "지명"),]),
("문래", &[("文萊", "브루나이"),]),
("문래동", &[("文來洞", "지명"),]),
("문막읍", &[("文幕邑", "지명"),]),
("문배동", &[("文培洞", "지명"),]),
("문백면", &[("文白面", "지명"),]),
("문봉동", &[("文峰洞", "지명"),]),
("문산면", &[("文山面", "지명"),]),
("문산읍", &[("文山邑", "지명"),("汶山邑", "지명"),]),
("문수동", &[("文水洞", "지명"),]),
("문수면", &[("文殊面", "지명"),]),
("문암동", &[("文岩洞", "지명"),]),
("문외동", &[("門外洞", "지명"),]),
("문원동", &[("文原洞", "지명"),]),
("문의면", &[("文義面", "지명"),]),
("문정동", &[("文井洞", "지명"),("文亭洞", "지명"),]),
("문지동", &[("文旨洞", "지명"),]),
("문창동", &[("文昌洞", "지명"),]),
("문척면", &[("文尺面", "지명"),]),
("문평동", &[("文坪洞", "지명"),]),
("문평면", &[("文平面", "지명"),]),
("문학동", &[("文鶴洞", "지명"),]),
("문현동", &[("門峴洞", "지명"),]),
("문호동", &[("文湖洞", "지명"),]),
("문화동", &[("文化洞", "지명"),]),
("문흥동", &[("文興洞", "지명"),]),
("물", &[("物", "만물 물, 무리 물"),("勿", "말 물, 아닐 물, 깃발 물"),("沕", "아득할 물, 숨길 물, 잠길 물"),]),
("물금읍", &[("勿禁邑", "지명"),]),
("물야면", &[("物野面", "지명"),]),
("물왕동", &[("物旺洞", "지명"),]),
("미", &[("美", "아름다울 미, 맛이 좋을 미"),("米", "쌀 미"),("未", "아닐 미"),("味", "맛 미, 뜻 미"),("尾", "꼬리 미, 등 미"),("微", "작을 미, 자질구레할 미, 가늘 미"),("迷", "미혹할 미, 전념할 미"),("眉", "눈썹 미, 노인 미"),("彌", "두루 미, 널리 미, 그칠 미"),("靡", "쓰러질 미, 쏠릴 미, 흐트러질 미"),("媚", "아첨할 미, 풍치가 아름다울 미, 예쁠 미"),("薇", "고삐 미, 고비 미"),("楣", "문미 미, 처마 미, 인중방 미"),("湄", "물 가 미, 더운 물 미"),("嵋", "산이름 미"),("渼", "물놀이 미, 내 이름 미, 물결무늬 미"),("謎", "수수께끼 미"),("黴", "곰팡이 미, 검을 미, 썪을 미, 기미낄 미"),("梶", "나무 끝 미"),("弥", "彌와 同字"),("弭", "활고자 미, 그칠 미"),("糜", "죽 미, 싸라기 미"),("縻", "고삐 미, 얽어맬 미"),("亹", "힘쓸 미, 문채가 있는 모양 미"),("瀰", "물 넓을 미"),("麋", "큰사슴 미, 부서질 미"),("敉", "어루만질 미"),("媺", "착하고 아름다울 미"),("獼", "원숭이 미"),("娓", "장황할 미, 힘쓸 미"),("蘼", "장미 미, 천궁 미"),("媄", "빛 고울 미"),]),
("미곡", &[("米谷", "지명"),]),
("미국", &[("美國", "아메리카합중국"),("米國", "아메리카합중국"),]),
("미근동", &[("渼芹洞", "지명"),]),
("미대동", &[("米垈洞", "지명"),]),
("미력면", &[("彌力面", "지명"),]),
("미로면", &[("未老面", "지명"),]),
("미룡동", &[("米龍洞", "지명"),]),
("미리견", &[("美利堅", "아메리카합중국"),("米利堅", "아메리카합중국"),("彌利堅", "아메리카합중국"),]),
("미사동", &[("渼沙洞", "지명"),]),
("미산동", &[("米山洞", "지명"),]),
("미산면", &[("嵋山面", "지명"),]),
("미수동", &[("美修洞", "지명"),]),
("미아동", &[("彌阿洞", "지명"),]),
("미암면", &[("美岩面", "지명"),]),
("미양면", &[("薇陽面", "지명"),]),
("미원동", &[("米原洞", "지명"),]),
("미원면", &[("米院面", "지명"),]),
("미음동", &[("美音洞", "지명"),]),
("미장동", &[("米場洞", "지명"),]),
("미조면", &[("彌助面", "지명"),]),
("미천면", &[("美川面", "지명"),]),
("미탄면", &[("美灘面", "지명"),]),
("미평동", &[("美坪洞", "지명"),("米坪洞", "지명"),]),
("미포동", &[("尾浦洞", "지명"),]),
("미호동", &[("渼湖洞", "지명"),]),
("민", &[("民", "백성 민"),("敏", "민첩할 민"),("閔", "위문할 민, 성 민"),("憫", "불쌍히 여길 민"),("悶", "번민할 민"),("旻", "하늘 민, 가을하늘 민"),("旼", "온화할 민"),("珉", "아름다운돌 민, 옥돌 민"),("玟", "옥돌 민"),("愍", "근심할 민, 불쌍한 민"),("泯", "망할 민, 빠질 민"),("岷", "산이름 민"),("緡", "낚시줄 민, 입힐 민"),("黽", "힘쓸 민, 맹꽁이 민"),("閩", "종족이름 민"),("忞", "강인할 민"),("暋", "굳셀 민"),("緍", "낚시줄 민"),("湣", "낚시줄 민"),("忟", "강인할 민"),("罠", "그물 민"),("苠", "속대 민"),("鰵", "대구 민"),]),
("민락동", &[("民樂洞", "지명"),]),
("밀", &[("密", "빽빽할 밀"),("蜜", "꿀 밀"),("謐", "고요할 밀"),("樒", "침향 밀"),("滵", "물 흐르는 모양 밀"),]),
("밀극라니서아연방", &[("密克羅尼西亞聯邦", "미크로네시아 연방"),]),
("밀양시", &[("密陽市", "지명"),]),
("박", &[("朴", "나무껍질 박, 질박할 박"),("迫", "닥칠 박, 핍박할 박"),("博", "넓을 박"),("泊", "머무를 박, 배댈 박"),("拍", "칠 박"),("薄", "숲 박, 엷을 박"),("駁", "얼룩말 박"),("舶", "배 박, 큰배 박"),("剝", "벗길 박, 찢을 박"),("縛", "묶을 박"),("撲", "업어질 박, 부딪칠 박"),("搏", "칠 박, 두드릴 박"),("樸", "통나무 박, 순박할 박"),("珀", "호박 박"),("箔", "발 박"),("粕", "지게미 박"),("膊", "포 박, 어깨 박"),("雹", "누리 박, 우박 박"),("璞", "옥덩어리 박"),("亳", "땅이름 박"),("駮", "짐승이름 박"),("鎛", "종 박"),("欂", "주두 박"),("牔", "박공 박"),("髆", "어깨쭉지 박"),]),
("박달동", &[("博達洞", "지명"),]),
("박월동", &[("博月洞", "지명"),]),
("박자와납", &[("博茨瓦納", "보츠와나"),]),
("박촌동", &[("朴村洞", "지명"),]),
("박호동", &[("博湖洞", "지명"),]),
("반", &[("半", "반 반"),("反", "돌이킬 반"),("飯", "밥 반"),("班", "나눌 반, 벌려설 반"),("般", "옮길 반, 되돌아올 반"),("返", "돌이킬 반, 돌아올 반"),("伴", "짝 반"),("盤", "소반 반"),("叛", "배반할 반"),("頒", "나눌 반, 반포할 반"),("槃", "쟁반 반"),("斑", "얼룩 반, 아롱질 반"),("潘", "뜨물 반, 물이름 반"),("搬", "옮길 반"),("磻", "강이름 반, 반계 반"),("攀", "더위잡을 반, 끌어당길 반"),("畔", "지경 반, 밭두둑 반"),("蟠", "서릴 반, 쥐며느리 반"),("絆", "줄 반, 얽을 반"),("礬", "백반 반"),("拌", "버릴 반"),("泮", "학교 반, 얼음풀릴 반"),("盼", "곁눈질 할 반, 눈자위 반"),("磐", "넓을 반, 반석 반"),("瘢", "흉터 반, 부스럼자국 반"),("胖", "희생 반"),("扳", "끌 반"),("搫", "덜 반"),("頖", "풀릴 반"),("攽", "나눌 반"),("朌", "구실 반"),("仮", "反과 同字"),("媻", "비틀거릴 반"),("肦", "나눌 반"),("螌", "가뢰 반"),]),
("반계동", &[("盤溪洞", "지명"),]),
("반곡동", &[("盤谷洞", "지명"),]),
("반구동", &[("伴鷗洞", "지명"),]),
("반남면", &[("潘南面", "지명"),]),
("반림동", &[("盤林洞", "지명"),]),
("반석동", &[("盤石洞", "지명"),]),
("반송동", &[("盤松洞", "지명"),]),
("반암면", &[("蟠岩面", "지명"),]),
("반여동", &[("盤如洞", "지명"),]),
("반월동", &[("半月洞", "지명"),]),
("반죽동", &[("班竹洞", "지명"),]),
("반지동", &[("盤知洞", "지명"),]),
("반포동", &[("盤浦洞", "지명"),]),
("반포면", &[("反浦面", "지명"),]),
("발", &[("發", "쏠 발, 일어날 발"),("髮", "터럭 발"),("拔", "뺄 발"),("跋", "밟을 발"),("鉢", "바리때 발"),("潑", "뿌릴 발, 활발할 발"),("渤", "바다이름 발"),("撥", "다스릴 발"),("勃", "갑작스러울 발, 발끈할 발"),("魃", "가물 귀신 발"),("醱", "술 괼 발"),("浡", "일어날 발"),("鈸", "방울 발"),("鵓", "집비둘기 발"),("哱", "어지러울 발"),("脖", "배꼽 발"),("癶", "걷다"),]),
("발아리", &[("勃牙利", "불가리아"),]),
("발한동", &[("發翰洞", "지명"),]),
("발화동", &[("發化洞", "지명"),]),
("방", &[("方", "모 방, 방위 방"),("放", "놓을 방"),("防", "둑 방, 막을 방"),("房", "방 방"),("訪", "찾을 방, 찾아볼 방"),("邦", "나라 방"),("妨", "방해할 방, 거리낄 방"),("芳", "꽃다울 방, 향기 방"),("傍", "곁 방"),("倣", "본뜰 방, 본받을 방"),("旁", "두루 방, 넓을 방"),("彷", "거닐 방, 방황할 방"),("紡", "자을 방, 길쌈 방"),("龐", "어지러울 방, 흑백의 잡색 방"),("坊", "동네 방, 고을이름 방"),("榜", "매 방, 게시판 방"),("昉", "마침 방, 밝을 방"),("謗", "헐뜯을 방, 나무랄 방"),("枋", "다목 방, 박달 방"),("幇", "幫과 同字, 도울 방"),("肪", "기름 방, 비계 방"),("尨", "삽살개 방"),("膀", "쌍배 방, 방광 방"),("滂", "비 퍼부을 방, 기름질 방"),("蚌", "방합 방, 금조개 방"),("磅", "돌 떨어지는 소리 방"),("舫", "배 방, 사공 방"),("蒡", "인동 덩굴 방, 우엉 방"),("仿", "헤멜 방"),("牓", "패 방"),("髣", "비슷할 방"),("厖", "클 방"),("魴", "방어 방"),("搒", "배저을 방"),("幫", "도울 방"),("螃", "방게 방"),("徬", "시중들 방"),("旊", "옹기장 방"),("梆", "목어 방"),("舽", "배 방"),("鎊", "깎을 방"),("匚", "상자"),]),
("방동", &[("芳洞", "지명"),]),
("방림동", &[("芳林洞", "지명"),]),
("방림면", &[("芳林面", "지명"),]),
("방배동", &[("方背洞", "지명"),]),
("방산동", &[("芳山洞", "지명"),]),
("방산면", &[("方山面", "지명"),]),
("방서동", &[("方西洞", "지명"),]),
("방어동", &[("方魚洞", "지명"),]),
("방이동", &[("芳荑洞", "지명"),]),
("방촌동", &[("芳村洞", "지명"),]),
("방축동", &[("放築洞", "지명"),("防築洞", "지명"),]),
("방학동", &[("放鶴洞", "지명"),]),
("방현동", &[("芳峴洞", "지명"),]),
("방화동", &[("傍花洞", "지명"),]),
("배", &[("北", "달아날"),("拜", "절 배"),("杯", "잔 배"),("輩", "무리 배"),("背", "등 배"),("配", "아내 배, 짝 배"),("倍", "곱 배, 갑절 배"),("培", "북돋을 배, 북돋울 배"),("排", "밀칠 배, 물리칠 배"),("裵", "성"),("俳", "광대 배"),("賠", "물어줄 배"),("陪", "쌓아올릴 배, 모실 배"),("徘", "노닐 배, 배회할 배"),("胚", "아이 밸 배"),("湃", "물결 이는 모양 배, 물소리 배"),("裴", "옷 치렁치렁할 배, 옷이 치렁치렁한 모양 배"),("盃", "杯의 俗字, 잔 배"),("褙", "속적삼"),("焙", "불에 쬘 배, 말릴 배"),("坏", "언덕 배"),("坯", "坏와 同字"),("琲", "구슬 꿰미 배"),("扒", "뺄 배"),("蓓", "꽃봉오리 배"),]),
("배동", &[("拜洞", "지명"),]),
("배미동", &[("拜未洞", "지명"),]),
("배반동", &[("排盤洞", "지명"),]),
("배방면", &[("排芳面", "지명"),]),
("배알미동", &[("拜謁尾洞", "지명"),]),
("백", &[("百", "일백 백"),("白", "흰 백"),("伯", "맏 백"),("栢", "柏의 俗字, 잣나무 백"),("帛", "비단 백"),("魄", "넋 백"),("柏", "나무 이름 백, 잣나무 백"),("佰", "백사람의어른"),("粨", "힉터메트르 백"),]),
("백곡면", &[("栢谷面", "지명"),]),
("백구면", &[("白鷗面", "지명"),]),
("백노서아", &[("白露西亞", "벨로루시"),]),
("백랄서이", &[("伯剌西爾", "브라질"),]),
("백령면", &[("白翎面", "지명"),]),
("백로", &[("白路", "페루"),("白露", "벨로루시"),]),
("백류", &[("帛琉", "팔라우"),]),
("백리자", &[("伯利玆", "벨리즈"),]),
("백사면", &[("栢沙面", "지명"),]),
("백산동", &[("栢山洞", "지명"),]),
("백산면", &[("白山面", "지명"),]),
("백석동", &[("白石洞", "지명"),]),
("백석읍", &[("白石邑", "지명"),]),
("백수읍", &[("白岫邑", "지명"),]),
("백안동", &[("百安洞", "지명"),]),
("백암면", &[("白岩面", "지명"),]),
("백옥동", &[("白玉洞", "지명"),]),
("백운동", &[("白雲洞", "지명"),]),
("백운면", &[("白雲面", "지명"),]),
("백이의", &[("白耳義", "벨기에"),]),
("백전면", &[("栢田面", "지명"),]),
("백천동", &[("白川洞", "지명"),("栢泉洞", "지명"),]),
("백학동", &[("白鶴洞", "지명"),]),
("백학면", &[("百鶴面", "지명"),]),
("백현동", &[("柏峴洞", "지명"),]),
("번", &[("番", "갈마들 번, 번수 번"),("煩", "괴로워할 번, 번거로울 번"),("繁", "많을 번, 성할 번"),("飜", "뒤칠 번, 날 번"),("磻", "강이름 번"),("蕃", "우거질 번, 불 번"),("藩", "덮을 번, 울타리 번"),("燔", "구울 번"),("幡", "기 번, 수건 번"),("樊", "울 번, 어수선할 번"),("翻", "날 번"),("蘩", "산흰쑥 번"),("繙", "되풀이 풀이할 번"),("膰", "제사 고기 번"),("袢", "속옷 번"),]),
("번동", &[("樊洞", "지명"),]),
("벌", &[("伐", "칠 벌"),("罰", "죄 벌, 벌줄 벌"),("閥", "공훈 벌, 가문 벌"),("筏", "떼 벌"),("橃", "떼 벌"),("罸", "罰과 同字"),]),
("벌곡면", &[("伐谷面", "지명"),]),
("벌교읍", &[("筏橋邑", "지명"),]),
("벌리동", &[("閥里洞", "지명"),]),
("벌음동", &[("伐音洞", "지명"),]),
("범", &[("凡", "무릇 범"),("犯", "범할 범"),("範", "법 범"),("范", "풀 이름 범, 벌 범"),("汎", "뜰 범"),("泛", "뜰 범"),("帆", "돛 범"),("梵", "범어 범, 웅얼거릴 범"),("氾", "넘칠 범, 물넘칠 범"),("颿", "돛 범"),("笵", "법 범"),("訉", "말 많을 범"),]),
("범계동", &[("범溪洞", "지명"),]),
("범물동", &[("凡勿洞", "지명"),]),
("범박동", &[("範朴洞", "지명"),]),
("범방동", &[("凡方洞", "지명"),]),
("범서읍", &[("凡西邑", "지명"),]),
("범어동", &[("泛魚洞", "지명"),]),
("범일동", &[("凡一洞", "지명"),]),
("범전동", &[("凡田洞", "지명"),]),
("범천동", &[("凡川洞", "지명"),]),
("범체강", &[("梵蒂岡", "바티칸"),]),
("법", &[("法", "법 법"),("琺", "법랑 법, 유약 법"),]),
("법곡동", &[("法谷洞", "지명"),]),
("법곶동", &[("法串洞", "지명"),]),
("법국", &[("法國", "프랑스"),]),
("법동", &[("法洞", "지명"),]),
("법란서", &[("法蘭西", "프랑스"),]),
("법랑서", &[("法郎西", "프랑스"),]),
("법상동", &[("法尙洞", "지명"),]),
("법성면", &[("法聖面", "지명"),]),
("법수면", &[("法守面", "지명"),]),
("법원읍", &[("法院邑", "지명"),]),
("법전면", &[("法田面", "지명"),]),
("법환동", &[("法還洞", "지명"),]),
("법흥동", &[("法興洞", "지명"),]),
("벽", &[("壁", "벽 벽"),("碧", "푸를 벽"),("僻", "후미질 벽"),("闢", "열 벽"),("璧", "동근 옥 벽, 둥근옥 벽"),("癖", "적취 벽, 버릇 벽"),("劈", "쪼갤 벽"),("擘", "엄지손가락 벽, 나눌 벽"),("霹", "벼락 벽"),("蘗", "황경나무 벽"),("檗", "황벽나무 벽, 황백나무 벽"),("辟", "임금 벽"),("擗", "가슴칠 벽"),("甓", "벽돌 벽"),("襞", "주름 벽"),("疈", "가를 벽"),("鷿", "농병아리 벽"),("鼊", "거북 벽"),]),
("벽제동", &[("碧蹄洞", "지명"),]),
("벽진동", &[("碧津洞", "지명"),]),
("벽진면", &[("碧珍面", "지명"),]),
("변", &[("便", "똥오줌 변, 문득 변"),("變", "변할 변"),("邊", "가 변"),("辯", "말잘할 변"),("辨", "분별할 변"),("卞", "조급할 변, 성 변"),("弁", "고깔 변"),("騈", "나란히 할 변"),("籩", "제기 이름 변"),("抃", "손뼉칠 변"),("忭", "기뻐할 변"),("駢", "騈의 俗字"),("腁", "살갗 틀 변"),("骿", "통갈비 변"),("鴘", "매 변"),("釆", "분별하다"),]),
("변동", &[("邊洞", "지명"),]),
("변류출각", &[("邊瑠出角", "카보베르데"),]),
("변산면", &[("邊山面", "지명"),]),
("별", &[("別", "나눌 별, 분별 별"),("瞥", "언뜻 볼 별, 눈을 깜짝하는 별"),("鱉", "鼈과 同字, 자라 별"),("鼈", "자라 별"),("鷩", "금계 별"),("彆", "활 뒤틀릴 별"),("丿", "삐치다"),]),
("별내면", &[("別內面", "지명"),]),
("별량면", &[("別良面", "지명"),]),
("별양동", &[("別陽洞", "지명"),]),
("병", &[("兵", "군사 병"),("病", "병 병, 병들 병"),("丙", "남녘 병"),("竝", "아우를 병"),("屛", "병풍 병"),("秉", "잡을 병"),("炳", "밝을 병"),("柄", "자루 병"),("倂", "아우를 병, 나란할 병"),("昺", "昞과 同字, 밝을 병"),("昞", "밝을 병"),("甁", "병 병"),("餠", "떡 병, 밀가루떡 병"),("幷", "아우를"),("騈", "나란히 할 병, 두말이 한멍에 멘 병"),("輧", "거마 소리 병"),("棅", "柄과 同字, 자루 병"),("並", "竝과 同字"),("迸", "달아날 병"),("駢", "騈의 俗字"),("缾", "두레박 병"),("塀", "담 병"),("絣", "무늬없는 비단 병, 이을 병, 먹줄 튀길 병"),("鉼", "판금 병"),("鋲", "넓은 못 병, 징 병"),]),
("병곡면", &[("柄谷面", "지명"),("甁谷面", "지명"),]),
("병방동", &[("兵房洞", "지명"),]),
("병산동", &[("柄山洞", "지명"),]),
("병성동", &[("屛城洞", "지명"),]),
("병영동", &[("兵營洞", "지명"),]),
("병영면", &[("兵營面", "지명"),]),
("병천면", &[("竝川面", "지명"),]),
("보", &[("步", "걸을 보, 걸음 보"),("保", "지킬 보, 도울 보"),("報", "갚을 보"),("寶", "보배 보"),("補", "기울 보, 도울 보"),("普", "널리 보, 넓을 보"),("譜", "계보 보, 족보 보"),("輔", "덧방나무 보, 도울 보"),("甫", "클 보"),("堡", "작은 성 보"),("潽", "물이름"),("菩", "보살 보, 보리나무 보"),("洑", "보 보, 보마기 보"),("褓", "포대기 보"),("珤", "寶의 古字, 보배 보"),("湺", "보"),("簠", "제기 이름 보"),("俌", "도울 보"),("黼", "수 보"),("葆", "풀 더부룩할 보"),("鴇", "능에 보"),("盙", "簠의 本字"),]),
("보개면", &[("寶蓋面", "지명"),]),
("보광동", &[("寶光洞", "지명"),("普光洞", "지명"),]),
("보길면", &[("甫吉面", "지명"),]),
("보령시", &[("保寧市", "지명"),]),
("보로서", &[("普魯西", "프로이센"),]),
("보리비옥", &[("保里備屋", "볼리비아"),]),
("보목동", &[("甫木洞", "지명"),]),
("보문동", &[("普門洞", "지명"),]),
("보문면", &[("普門面", "지명"),]),
("보산동", &[("保山洞", "지명"),("寶山洞", "지명"),]),
("보성군", &[("寶城郡", "지명"),]),
("보성읍", &[("寶城邑", "지명"),]),
("보수동", &[("寶水洞", "지명"),]),
("보안면", &[("保安面", "지명"),]),
("보은군", &[("報恩郡", "지명"),]),
("보은읍", &[("報恩邑", "지명"),]),
("보절면", &[("寶節面", "지명"),]),
("복", &[("福", "복 복"),("服", "옷 복, 입을 복"),("復", "돌아올 복"),("伏", "엎드릴 복"),("卜", "점 복, 점칠 복"),("腹", "배 복"),("覆", "뒤집힐 복, 도리어 복"),("複", "겹옷 복"),("馥", "향기 복"),("僕", "종 복, 시중꾼 복"),("撲", "닦을 복"),("輻", "바퀴살 복"),("匐", "길 복, 엉금엉금길 복"),("鰒", "전복 복"),("宓", "성 복, 편안할 복"),("茯", "복령 복"),("蔔", "무우 복, 치자꽃 복"),("輹", "복토 복, 바퀴통 복"),("扑", "칠 복"),("幞", "건 복"),("濮", "강 이름 복"),("鵩", "새 이름 복"),("蝮", "살무사 복"),("墣", "흙덩이 복"),("蝠", "박쥐 복"),("箙", "전동 복"),("菔", "무 복"),("攴", "치다"),("攵", "치다"),]),
("복내면", &[("福內面", "지명"),]),
("복대동", &[("福臺洞", "지명"),]),
("복룡동", &[("伏龍洞", "지명"),]),
("복만동", &[("福滿洞", "지명"),]),
("복산동", &[("福山洞", "지명"),]),
("복수동", &[("福守洞", "지명"),]),
("복수면", &[("福壽面", "지명"),]),
("복정동", &[("福井洞", "지명"),]),
("복죽동", &[("福竹洞", "지명"),]),
("복천동", &[("福泉洞", "지명"),]),
("복현동", &[("伏賢洞", "지명"),]),
("복흥면", &[("福興面", "지명"),]),
("본", &[("本", "밑 본, 근본 본"),]),
("본덕동", &[("本德洞", "지명"),]),
("본동", &[("本洞", "지명"),]),
("본리동", &[("本里洞", "지명"),]),
("본성동", &[("本城洞", "지명"),]),
("본오동", &[("本五洞", "지명"),]),
("본촌동", &[("本村洞", "지명"),]),
("볼", &[("乶", "땅이름"),]),
("봉", &[("奉", "받들 봉"),("逢", "만날 봉"),("封", "봉할 봉"),("鳳", "봉새 봉"),("峯", "봉우리 봉, 산봉우리 봉"),("蜂", "벌 봉"),("蓬", "쑥 봉"),("俸", "녹 봉"),("縫", "꿰맬 봉"),("捧", "받들 봉"),("鋒", "칼끝 봉, 칼날 봉"),("烽", "봉화 봉"),("棒", "몽둥이 봉"),("峰", "峯과 同字, 봉우리 봉"),("熢", "연기 자욱할 봉, 불기운 봉"),("琫", "칼집 장식 봉, 칼집장식옥 봉"),("丰", "예쁠 봉"),("綘", "縫과 同字"),("篷", "뜸 봉"),("夆", "끌 봉"),("菶", "풀 무성할 봉"),("鴌", "鳳의 古字"),]),
("봉강동", &[("鳳崗洞", "지명"),]),
("봉강면", &[("鳳崗面", "지명"),]),
("봉개동", &[("奉蓋洞", "지명"),]),
("봉계동", &[("鳳溪洞", "지명"),]),
("봉곡동", &[("逢谷洞", "지명"),("鳳谷洞", "지명"),]),
("봉남", &[("鳳南", "지명"),]),
("봉남동", &[("鳳南洞", "지명"),]),
("봉남면", &[("鳳南面", "지명"),]),
("봉담읍", &[("峰潭邑", "지명"),]),
("봉덕동", &[("鳳德洞", "지명"),]),
("봉동", &[("鳳洞", "지명"),]),
("봉동읍", &[("鳳東邑", "지명"),]),
("봉래동", &[("蓬萊洞", "지명"),]),
("봉래면", &[("蓬萊面", "지명"),]),
("봉림동", &[("鳳林洞", "지명"),]),
("봉명동", &[("鳳鳴洞", "지명"),]),
("봉무동", &[("鳳舞洞", "지명"),]),
("봉방동", &[("鳳方洞", "지명"),]),
("봉산동", &[("鳳山洞", "지명"),]),
("봉산면", &[("鳳山面", "지명"),]),
("봉선동", &[("鳳仙洞", "지명"),]),
("봉성면", &[("鳳城面", "지명"),]),
("봉수면", &[("鳳樹面", "지명"),]),
("봉암동", &[("鳳岩洞", "지명"),]),
("봉양면", &[("鳳陽面", "지명"),]),
("봉양읍", &[("鳳陽邑", "지명"),]),
("봉원동", &[("奉元洞", "지명"),]),
("봉의동", &[("鳳儀洞", "지명"),]),
("봉익동", &[("鳳翼洞", "지명"),]),
("봉정동", &[("鳳亭洞", "지명"),]),
("봉천동", &[("奉天洞", "지명"),]),
("봉평동", &[("鳳平洞", "지명"),]),
("봉평면", &[("蓬坪面", "지명"),]),
("봉현면", &[("鳳峴面", "지명"),]),
("봉화군", &[("奉化郡", "지명"),]),
("봉화읍", &[("奉化邑", "지명"),]),
("봉황동", &[("鳳凰洞", "지명"),]),
("봉황면", &[("鳳凰面", "지명"),]),
("부", &[("父", "아비 부"),("不", "아닐 부"),("夫", "지아비 부"),("部", "거느릴 부, 나눌 부"),("富", "가멸 부, 부자 부"),("復", "다시 부, 돌아올 부"),("否", "아닐 부"),("婦", "며느리 부"),("浮", "뜰 부"),("扶", "도울 부, 붙들 부"),("府", "곳집 부, 마을 부"),("副", "버금 부"),("付", "줄 부, 부탁할 부"),("負", "질 부, 짐질 부"),("賦", "구실 부"),("培", "무덤 부"),("赴", "나아갈 부, 달릴 부"),("附", "붙을 부, 의탁할 부"),("簿", "장부 부, 문서 부"),("符", "부신 부, 병부 부"),("腐", "썩을 부"),("釜", "가마 부"),("傅", "스승 부"),("敷", "펼 부, 베풀 부"),("訃", "부고 부, 통부 부"),("阜", "언덕 부"),("膚", "살갗 부, 피부 부"),("俯", "구푸릴 부, 구부릴 부"),("賻", "부의 부"),("斧", "도끼 부"),("剖", "쪼갤 부"),("芙", "부용 부, 연꽃 부"),("駙", "곁마 부, 가까울 부"),("腑", "장부 부"),("埠", "선창 부, 부두 부"),("咐", "분부할 부"),("孵", "알 깔 부"),("孚", "미쁠 부, 믿을 부"),("溥", "펼 부, 클 부"),("鳧", "오리 부, 물오리 부"),("缶", "장군 부"),("莩", "풀 이름 부, 갈대청 부"),("趺", "책상다리할 부, 도사리어 앉을 부"),("艀", "작은 배 부"),("仆", "엎드릴 부"),("祔", "합사할 부"),("俘", "사로잡을 부"),("鈇", "도끼 부"),("拊", "어루만질 부"),("裒", "모을 부"),("桴", "마룻대 부"),("蔀", "빈지문 부"),("榑", "부상 부"),("掊", "그러모을 부"),("苻", "귀목풀 부"),("鮒", "붕어 부"),("蜉", "하루살이 부"),("頫", "머리 숙일 부"),("抔", "움킬 부"),("涪", "물거품 부"),("麩", "밀기울 부"),("玞", "옥돌 부"),("跗", "발등 부"),("罘", "그물 부"),("蚨", "파랑강충이 부"),("筟", "대청 부"),("胕", "장부 부"),("罦", "그물 부"),("芣", "질경이 부"),("媍", "婦와 同字"),("阝", "우부방"),]),
("부개동", &[("富開洞", "지명"),]),
("부계면", &[("缶溪面", "지명"),]),
("부곡동", &[("夫谷洞", "지명"),("富谷洞", "지명"),("釜谷洞", "지명"),]),
("부곡면", &[("釜谷面", "지명"),]),
("부귀면", &[("富貴面", "지명"),]),
("부남면", &[("富南面", "지명"),("府南面", "지명"),]),
("부단", &[("不丹", "부탄"),]),
("부대동", &[("富垈洞", "지명"),]),
("부덕동", &[("富德洞", "지명"),]),
("부동", &[("釜洞", "지명"),]),
("부동면", &[("府東面", "지명"),]),
("부량면", &[("扶梁面", "지명"),]),
("부론면", &[("富論面", "지명"),]),
("부리면", &[("富利面", "지명"),]),
("부림동", &[("富林洞", "지명"),]),
("부림면", &[("富林面", "지명"),]),
("부민동", &[("富民洞", "지명"),]),
("부발읍", &[("夫鉢邑", "지명"),]),
("부북면", &[("府北面", "지명"),]),
("부사동", &[("芙沙洞", "지명"),]),
("부산광역시", &[("釜山廣域市", "지명"),]),
("부산동", &[("釜山洞", "지명"),]),
("부산면", &[("夫山面", "지명"),]),
("부산진구", &[("釜山鎭區", "지명"),]),
("부석면", &[("浮石面", "지명"),]),
("부송동", &[("富松洞", "지명"),]),
("부수동", &[("芙水洞", "지명"),]),
("부안군", &[("扶安郡", "지명"),]),
("부안면", &[("富安面", "지명"),]),
("부안읍", &[("扶安邑", "지명"),]),
("부암동", &[("付岩洞", "지명"),("釜岩洞", "지명"),]),
("부여군", &[("扶餘郡", "지명"),]),
("부여읍", &[("扶餘邑", "지명"),]),
("부용동", &[("芙蓉洞", "지명"),]),
("부용면", &[("芙蓉面", "지명"),]),
("부원동", &[("府院洞", "지명"),("釜院洞", "지명"),]),
("부적면", &[("夫赤面", "지명"),]),
("부전동", &[("夫田洞", "지명"),("釜田洞", "지명"),]),
("부창동", &[("富倉洞", "지명"),]),
("부천시", &[("富川市", "지명"),]),
("부평구", &[("富平區", "지명"),]),
("부평동", &[("富平洞", "지명"),]),
("부항면", &[("釜項面", "지명"),]),
("부흥동", &[("復興洞", "지명"),]),
("북", &[("北", "북녘 북, 달아날 북"),]),
("북가좌동", &[("北加佐洞", "지명"),]),
("북교동", &[("北橋洞", "지명"),]),
("북구", &[("北區", "지명"),]),
("북군동", &[("北軍洞", "지명"),]),
("북내동", &[("北內洞", "지명"),]),
("북내면", &[("北內面", "지명"),]),
("북도면", &[("北島面", "지명"),]),
("북동", &[("北洞", "지명"),]),
("북면", &[("北面", "지명"),]),
("북문동", &[("北門洞", "지명"),]),
("북문로", &[("北門路", "지명"),]),
("북방면", &[("北方面", "지명"),]),
("북변동", &[("北邊洞", "지명"),]),
("북부동", &[("北部洞", "지명"),]),
("북산동", &[("北山洞", "지명"),]),
("북산면", &[("北山面", "지명"),]),
("북삼동", &[("北三洞", "지명"),]),
("북삼면", &[("北三面", "지명"),]),
("북상면", &[("北上面", "지명"),]),
("북성동", &[("北城洞", "지명"),]),
("북성로", &[("北城路", "지명"),]),
("북수동", &[("北水洞", "지명"),]),
("북신동", &[("北新洞", "지명"),]),
("북아현동", &[("北阿峴洞", "지명"),]),
("북안면", &[("北安面", "지명"),]),
("북양동", &[("北陽洞", "지명"),]),
("북이면", &[("北二面", "지명"),]),
("북일면", &[("北一面", "지명"),("北日面", "지명"),]),
("북정동", &[("北亭洞", "지명"),]),
("북제주군", &[("北濟州郡", "지명"),]),
("북창동", &[("北倉洞", "지명"),]),
("북천면", &[("北川面", "지명"),]),
("북평동", &[("北坪洞", "지명"),]),
("북평면", &[("北平面", "지명"),("北坪面", "지명"),]),
("북하면", &[("北下面", "지명"),]),
("북한", &[("北韓", "조선민주주의인민공화국"),]),
("북한국", &[("北韓國", "조선민주주의인민공화국"),]),
("북한동", &[("北漢洞", "지명"),]),
("북항동", &[("北港洞", "지명"),]),
("북후면", &[("北後面", "지명"),]),
("분", &[("分", "나눌 분"),("憤", "결낼 분, 분할 분"),("奮", "떨칠 분, 성낼 분"),("粉", "가루 분"),("紛", "어지러워질 분, 어지러울 분"),("奔", "달릴 분, 달아날 분"),("墳", "무덤 분"),("頒", "큰 머리 분"),("芬", "향기로울 분"),("焚", "불사를 분"),("盆", "동이 분"),("忿", "성낼 분, 분할 분"),("糞", "똥 분"),("噴", "뿜을 분, 뿜어낼 분"),("雰", "안개 분"),("扮", "꾸밀 분, 잡을 분"),("吩", "뿜을 분"),("賁", "클 분"),("汾", "클 분, 물이름 분"),("昐", "햇빛"),("体", "용렬할 분"),("氛", "기운 분"),("棼", "마룻대 분"),("坌", "먼지 분"),("犇", "달아날 분"),("濆", "뿜을 분"),("蕡", "들깨 분"),("枌", "나무 이름 분"),("畚", "삼태기 분"),("朌", "頒과 同字"),("湓", "용솟음할 분"),("轒", "병거 분"),("帉", "걸레 분, 행주 분"),("砏", "큰 소리 분"),("笨", "거칠 분"),("肦", "머리 클 분"),("膹", "고기 삶은 국 분"),("黺", "옷에 오색 수 놓을 분"),("鼢", "두더지 분"),]),
("분당구", &[("盆塘區", "지명"),]),
("분당동", &[("盆塘洞", "지명"),]),
("분란", &[("芬蘭", "핀란드"),]),
("분란토", &[("芬蘭土", "핀란드"),]),
("분평동", &[("紛坪洞", "지명"),]),
("불", &[("不", "아닐 불"),("佛", "부처 불"),("拂", "떨 불, 떨칠 불"),("弗", "아닐 불, 말 불"),("彿", "비슷할 불"),("黻", "수 불"),("紱", "인끈 불"),("髴", "비슷할 불"),("祓", "푸닥거리할 불"),("茀", "풀 우거질 불"),("岪", "산길 불"),("艴", "발끈할 불"),("韍", "폐슬 불"),]),
("불갑면", &[("佛甲面", "지명"),]),
("불광동", &[("佛光洞", "지명"),]),
("불국", &[("佛國", "프랑스"),]),
("불당동", &[("佛堂洞", "지명"),]),
("불란서", &[("佛蘭西", "프랑스"),]),
("불로동", &[("不老洞", "지명"),]),
("불모산동", &[("佛母山洞", "지명"),]),
("불암동", &[("佛岩洞", "지명"),]),
("불은면", &[("佛恩面", "지명"),]),
("불정동", &[("拂井洞", "지명"),]),
("불정면", &[("佛頂面", "지명"),]),
("붕", &[("朋", "벗 붕"),("崩", "무너질 붕, 산무너질 붕"),("鵬", "대붕새 붕"),("棚", "시렁 붕, 사다리 붕"),("硼", "붕산 붕, 약이름 붕"),("繃", "묶을 붕"),]),
("비", &[("非", "아닐 비"),("鼻", "코 비"),("悲", "슬플 비"),("備", "깆출 비, 갖출 비"),("比", "견줄 비"),("飛", "날 비"),("秘", "숨길 비, 비밀할 비"),("費", "쓸 비, 허비할 비"),("妃", "왕비 비"),("卑", "낮을 비"),("碑", "돌기둥 비, 비석 비"),("肥", "살찔 비"),("批", "칠 비, 비평할 비"),("婢", "여자종 비, 여종 비"),("匪", "대상자 비"),("丕", "클 비, 으뜸 비"),("毖", "삼갈 비"),("泌", "샘물 흐르는 모양 비, 졸졸흐르는 모양 비"),("毘", "毗와 同字, 밝을 비"),("鄙", "다라울 비, 더러울 비"),("扉", "문짝 비, 사립문 비"),("譬", "비유할 비"),("庇", "덮을 비"),("臂", "팔 비"),("裨", "도울 비"),("沸", "끓을 비"),("憊", "고달플 비"),("緋", "붉은 빛 비, 붉은 비단 비"),("脾", "지라 비, 비위 비"),("誹", "헐뜯을 비, 그르다할 비"),("痺", "암메추라기 비, 새이름 비"),("蜚", "바퀴 비, 풍뎅이 비"),("琵", "비파 비"),("匕", "비수 비"),("砒", "비상 비"),("翡", "물총새 비, 비취새 비"),("秕", "쭉정이 비"),("毗", "도울 비, 밝을 비"),("菲", "엷을 비, 나물이름 비"),("斐", "오락가락할 비, 아롱질 비"),("粃", "쭉정이 비"),("榧", "비자나무 비"),("枇", "비파나무 비, 참빗 비"),("妣", "죽은 어미 비"),("俾", "더할 비"),("祕", "귀신 비, 비밀 비"),("閟", "문 닫을 비"),("霏", "눈 펄펄 내릴 비"),("轡", "고삐 비"),("圮", "무너질 비"),("沘", "강 이름 비"),("騑", "곁마 비"),("羆", "큰 곰 비"),("髀", "넓적다리 비"),("棐", "도지개 비"),("睥", "흘겨볼 비"),("痞", "뱃속 결릴 비"),("鼙", "마상북 비"),("邳", "클 비"),("紕", "가선 비"),("貔", "비휴 비"),("贔", "힘쓸 비"),("悱", "표현 못할 비"),("椑", "술통 비"),("腓", "장딴지 비"),("陴", "성가퀴 비"),("仳", "떠날 비"),("芘", "풀 이름 비"),("淝", "강 이름 비"),("篦", "빗치개 비"),("芾", "작은 모양 비"),("濞", "물 소리 비"),("蚍", "왕개미 비"),("狒", "비비 비"),("剕", "발 벨 비"),("埤", "더할 비"),("萆", "비해 비"),("鞴", "풀무 비"),("痹", "저릴 비"),("屁", "방귀 비"),("淠", "강 이름 비"),("狉", "삵의 새끼 비"),("蓖", "아주까리 비"),("郫", "고을 이름 비"),("騛", "빠른 말 비"),]),
("비금면", &[("飛禽面", "지명"),]),
("비래동", &[("比來洞", "지명"),]),
("비력빈", &[("非力彬", "필리핀"),]),
("비로", &[("秘露", "페루"),("秘魯", "페루"),]),
("비룡동", &[("飛龍洞", "지명"),]),
("비립빈", &[("非立賓", "필리핀"),]),
("비봉동", &[("飛鳳洞", "지명"),]),
("비봉면", &[("飛鳳面", "지명"),]),
("비산동", &[("飛山洞", "지명"),]),
("비아동", &[("飛鴉洞", "지명"),]),
("비안면", &[("比安面", "지명"),]),
("비율빈", &[("比律賓", "필리핀"),]),
("비응도동", &[("飛鷹島洞", "지명"),]),
("비인면", &[("庇仁面", "지명"),]),
("비전동", &[("碑前洞", "지명"),]),
("비제", &[("斐濟", "피지"),]),
("비천동", &[("飛川洞", "지명"),]),
("비하동", &[("飛下洞", "지명"),]),
("빈", &[("貧", "가난할 빈"),("賓", "손 빈"),("頻", "자주 빈"),("彬", "빛날 빈"),("嬪", "아내 빈, 귀녀 빈"),("殯", "염할 빈"),("濱", "물가 빈"),("嚬", "찡그릴 빈"),("瀕", "물가 빈"),("牝", "암컷 빈"),("斌", "빛날 빈, 문채날 빈"),("浜", "물가 빈, 갯고랑 빈"),("玭", "구슬 이름 빈"),("檳", "빈랑나무 빈"),("鬢", "살쩍 빈"),("擯", "물리칠 빈"),("儐", "인도할 빈"),("蘋", "네가래 빈"),("邠", "나라 이름 빈"),("顰", "찡그릴 빈"),("繽", "어지러울 빈"),("豳", "나라 이름 빈"),("霦", "옥 광채 빈"),("鑌", "강철 빈"),("鬂", "鬢의 俗字"),("矉", "찡그릴 빈"),("臏", "종지뼈 빈"),]),
("빙", &[("氷", "얼음 빙"),("聘", "찾아가다 빙, 청할 빙"),("憑", "기대다 빙, 의지할 빙"),("騁", "달리다 빙, 달릴 빙"),("冰", "氷의 本字"),("凭", "기대다 빙"),("娉", "장가들다 빙"),("凴", "凭과 同字"),("冫", "얼음"),]),
("빙도", &[("氷島", "아이슬란드"),]),
("빙주", &[("氷州", "아이슬란드"),]),
("사", &[("四", "넉 사, 넷 사"),("事", "일 사"),("食", "밥 먹일 사"),("士", "선비 사, 벼슬 사"),("死", "죽을 사"),("思", "생각할 사"),("使", "하여금 사"),("史", "역사 사, 사기 사"),("私", "사사 사"),("寺", "절 사"),("師", "스승 사"),("仕", "벼슬할 사"),("絲", "실 사"),("舍", "집 사"),("謝", "사례할 사"),("巳", "여섯째 지지 사, 뱀 사"),("射", "궁술 사, 쏠 사"),("司", "맡을 사"),("辭", "말 사, 말씀 사"),("似", "같을 사"),("賜", "줄 사"),("社", "토지의 신 사, 모일 사"),("斯", "이 사"),("祀", "제사 사"),("査", "사실할 사, 캐물을 사"),("沙", "모래 사"),("詞", "말씀 사"),("寫", "베낄 사"),("捨", "버릴 사"),("邪", "간사할 사"),("詐", "속일 사"),("斜", "비낄 사, 비뚤어질 사"),("蛇", "뱀 사"),("赦", "용서할 사"),("祠", "사당 사, 봄제사 사"),("泗", "물 이름 사"),("獅", "사자 사"),("飼", "먹일 사"),("唆", "부추길 사, 가르칠 사"),("嗣", "이을 사, 대이을 사"),("徙", "옮길 사"),("紗", "깁 사"),("些", "적을 사"),("奢", "사치할 사"),("瀉", "토할 사, 쏟을 사"),("娑", "춤출 사, 춤추는모양 사"),("麝", "사향노루 사"),("肆", "방자할 사"),("俟", "기다릴 사"),("乍", "잠깐 사"),("伺", "엿볼 사"),("蓑", "도롱이 사"),("砂", "모래 사"),("莎", "향부자 사, 귀뚜라미 사"),("駟", "사마 사"),("裟", "가사 사"),("梭", "북 사"),("篩", "체 사, 왕대 사"),("柶", "수저 사, 숟가락 사"),("渣", "찌끼 사"),("僿", "잘게 부슬 사, 정성없는 사"),("竢", "기다릴 사"),("蜡", "납향 사"),("糸", "가는 실 사"),("笥", "상자 사"),("榭", "정자 사"),("姒", "동서 사"),("卸", "풀 사"),("楂", "떼 사"),("駛", "달릴 사"),("剚", "찌를 사"),("咋", "잠간 사"),("汜", "지류 사"),("傞", "취하여 춤추는 모양 사"),("覗", "엿볼 사"),("鯊", "문절망둑 사"),("痧", "쥐통 사"),("魦", "鯊와 同字"),("鰤", "새우 사"),("厶", "사사"),]),
("사간동", &[("司諫洞", "지명"),]),
("사곡동", &[("沙谷洞", "지명"),]),
("사곡면", &[("寺谷面", "지명"),("舍谷面", "지명"),]),
("사근동", &[("沙斤洞", "지명"),]),
("사남면", &[("泗南面", "지명"),]),
("사내면", &[("史內面", "지명"),]),
("사노동", &[("四老洞", "지명"),]),
("사농동", &[("司農洞", "지명"),]),
("사당동", &[("舍堂洞", "지명"),]),
("사동", &[("四洞", "지명"),("巳洞", "지명"),("社洞", "지명"),("沙洞", "지명"),]),
("사등동", &[("沙登洞", "지명"),]),
("사등면", &[("沙等面", "지명"),]),
("사락벌극", &[("斯洛伐克", "슬로바키아"),]),
("사량면", &[("蛇梁面", "지명"),]),
("사리면", &[("沙梨面", "지명"),]),
("사리현동", &[("沙里峴洞", "지명"),]),
("사림동", &[("沙林洞", "지명"),]),
("사매면", &[("巳梅面", "지명"),]),
("사벌면", &[("沙伐面", "지명"),]),
("사복동", &[("司福洞", "지명"),]),
("사봉면", &[("寺奉面", "지명"),]),
("사북면", &[("史北面", "지명"),]),
("사북읍", &[("舍北邑", "지명"),]),
("사사동", &[("沙士洞", "지명"),]),
("사상구", &[("沙上區", "지명"),]),
("사성", &[("沙城", "지명"),]),
("사송동", &[("沙松洞", "지명"),]),
("사수", &[("泗水", "지명"),]),
("사우동", &[("沙隅洞", "지명"),]),
("사월동", &[("沙月洞", "지명"),]),
("사위사란", &[("斯威士蘭", "스와질랜드"),]),
("사음동", &[("沙音洞", "지명"),]),
("사일동", &[("射一洞", "지명"),]),
("사자산", &[("獅子山", "시에라리온"),]),
("사정동", &[("沙正洞", "지명"),("士亭洞", "지명"),("沙亭洞", "지명"),]),
("사지아랄비아", &[("沙地亞剌比亞", "사우디아라비아"),]),
("사직동", &[("史直洞", "지명"),("社稷洞", "지명"),]),
("사창동", &[("司倉洞", "지명"),]),
("사천동", &[("斜川洞", "지명"),]),
("사천면", &[("沙川面", "지명"),]),
("사천시", &[("泗川市", "지명"),]),
("사천읍", &[("泗川邑", "지명"),]),
("사파동", &[("沙巴洞", "지명"),]),
("사파정동", &[("沙巴丁洞", "지명"),]),
("사하구", &[("沙下區", "지명"),]),
("사호동", &[("沙湖洞", "지명"),]),
("사화동", &[("沙和洞", "지명"),]),
("삭", &[("數", "자주 삭"),("削", "깎을 삭, 깍을 삭"),("索", "동아줄 삭"),("朔", "초하루 삭"),("鑠", "녹일 삭"),("槊", "창 삭"),("爍", "빛날 삭"),("蒴", "말오줌대 삭"),]),
("산", &[("山", "뫼 산"),("産", "낳을 산"),("散", "흩을 산, 흩어질 산"),("算", "셀 산, 셈놓을 산"),("酸", "초 산, 초.실 산"),("傘", "우산 산"),("刪", "깎을 산, 깍을 산"),("珊", "산호 산"),("疝", "산증 산, 산중 산"),("霰", "싸라기눈 산, 싸락눈 산"),("蒜", "달래 산"),("汕", "오구 산, 통발 산"),("繖", "일산 산"),("訕", "헐뜯을 산"),("潸", "눈물흐를 산"),("狻", "사자 산"),("鏟", "대패 산"),("澘", "潸의 略字"),("剷", "깎을 산"),("橵", "산자 산"),("姍", "헐뜯을 산"),("孿", "쌍둥이 산"),("閊", "비색할 산"),]),
("산격동", &[("山格洞", "지명"),]),
("산곡동", &[("山谷洞", "지명"),]),
("산남동", &[("山南洞", "지명"),]),
("산내면", &[("山內面", "지명"),]),
("산동면", &[("山東面", "지명"),]),
("산림동", &[("山林洞", "지명"),]),
("산막동", &[("山幕洞", "지명"),]),
("산미아", &[("山美亞", "잠비아"),]),
("산본동", &[("山本洞", "지명"),]),
("산북동", &[("山北洞", "지명"),]),
("산북면", &[("山北面", "지명"),]),
("산서면", &[("山西面", "지명"),]),
("산성동", &[("山城洞", "지명"),]),
("산성면", &[("山城面", "지명"),]),
("산수동", &[("山水洞", "지명"),]),
("산양면", &[("山陽面", "지명"),]),
("산양읍", &[("山陽邑", "지명"),]),
("산외면", &[("山外面", "지명"),]),
("산월동", &[("山月洞", "지명"),]),
("산이면", &[("山二面", "지명"),]),
("산인면", &[("山仁面", "지명"),]),
("산정동", &[("山亭洞", "지명"),]),
("산직동", &[("山直洞", "지명"),]),
("산척면", &[("山尺面", "지명"),]),
("산천동", &[("山泉洞", "지명"),]),
("산청군", &[("山淸郡", "지명"),]),
("산청읍", &[("山淸邑", "지명"),]),
("산포면", &[("山浦面", "지명"),]),
("산하동", &[("山下洞", "지명"),]),
("산현동", &[("山峴洞", "지명"),]),
("산호동", &[("山湖洞", "지명"),]),
("산황동", &[("山黃洞", "지명"),]),
("살", &[("殺", "죽일 살"),("蔡", "내칠 살"),("薩", "보살 살"),("撒", "뿌릴 살"),("煞", "죽일 살"),("乷", "음역자 살"),]),
("살마아", &[("薩摩亞", "사모아"),]),
("살미면", &[("乷味面", "지명"),]),
("살이와다", &[("薩爾瓦多", "엘살바도르"),]),
("삼", &[("三", "석 삼"),("參", "석 삼"),("蔘", "인삼 삼"),("森", "나무빽빽할 삼"),("滲", "샐"),("渗", "거를"),("衫", "적삼 삼, 옷 삼"),("芟", "벨 삼, 풀벨 삼"),("杉", "삼나무 삼"),("毿", "털긴 삼"),("糝", "나물죽 삼"),("鬖", "헝클어질 삼"),("釤", "낫 삼"),("彡", "터럭"),]),
("삼가동", &[("三街洞", "지명"),]),
("삼가면", &[("三嘉面", "지명"),]),
("삼각동", &[("三角洞", "지명"),]),
("삼거동", &[("三巨洞", "지명"),]),
("삼계동", &[("三溪洞", "지명"),]),
("삼계면", &[("三溪面", "지명"),("森溪面", "지명"),]),
("삼괴동", &[("三槐洞", "지명"),]),
("삼기면", &[("三箕面", "지명"),("三岐面", "지명"),]),
("삼남동", &[("三南洞", "지명"),]),
("삼남면", &[("三南面", "지명"),]),
("삼덕동", &[("三德洞", "지명"),]),
("삼도동", &[("三道洞", "지명"),("三都洞", "지명"),("三徒洞", "지명"),]),
("삼동", &[("三洞", "지명"),]),
("삼동동", &[("三東洞", "지명"),]),
("삼동면", &[("三同面", "지명"),("三東面", "지명"),]),
("삼락동", &[("三樂洞", "지명"),]),
("삼랑진읍", &[("三浪津邑", "지명"),]),
("삼례읍", &[("參禮邑", "지명"),]),
("삼문동", &[("三門洞", "지명"),]),
("삼방동", &[("三芳洞", "지명"),]),
("삼북동", &[("三北洞", "지명"),]),
("삼산동", &[("三山洞", "지명"),]),
("삼산면", &[("三山面", "지명"),]),
("삼서면", &[("森西面", "지명"),]),
("삼선동", &[("三仙洞", "지명"),]),
("삼성동", &[("三成洞", "지명"),("三省洞", "지명"),]),
("삼성면", &[("三成面", "지명"),]),
("삼송동", &[("三松洞", "지명"),]),
("삼승면", &[("三升面", "지명"),]),
("삼양동", &[("三陽洞", "지명"),]),
("삼영동", &[("三榮洞", "지명"),]),
("삼용동", &[("三龍洞", "지명"),]),
("삼장면", &[("三壯面", "지명"),]),
("삼전동", &[("三田洞", "지명"),]),
("삼정동", &[("三丁洞", "지명"),("三政洞", "지명"),("三井洞", "지명"),]),
("삼정자동", &[("三丁子洞", "지명"),]),
("삼죽면", &[("三竹面", "지명"),]),
("삼척시", &[("三陟市", "지명"),]),
("삼천동", &[("三川洞", "지명"),]),
("삼청동", &[("三淸洞", "지명"),]),
("삼패동", &[("三牌洞", "지명"),]),
("삼평동", &[("三坪洞", "지명"),]),
("삼풍동", &[("三豊洞", "지명"),]),
("삼학동", &[("三鶴洞", "지명"),]),
("삼향면", &[("三鄕面", "지명"),]),
("삼호면", &[("三湖面", "지명"),]),
("삼화동", &[("三和洞", "지명"),]),
("삽", &[("揷", "꽂을 삽"),("澁", "떫을 삽, 깔깔할 삽"),("颯", "바람소리 삽"),("鈒", "창 삽, 새길 삽"),("歃", "마실 삽"),("翣", "운삽 삽"),("鍤", "가래 삽"),("卅", "서른 삽"),("霎", "가랑비 삽"),("霅", "비올 삽"),("唼", "쪼아먹을 삽"),]),
("삽교읍", &[("揷橋邑", "지명"),]),
("상", &[("上", "위 상"),("相", "서로 상"),("想", "생각할 상"),("常", "항상 상"),("賞", "상줄 상"),("商", "헤아릴 상, 장사 상"),("尙", "오히려 상"),("喪", "죽을 상, 상사 상"),("傷", "상처 상, 상할 상"),("霜", "서리 상"),("狀", "형상 상"),("嘗", "맛볼 상"),("詳", "자세할 상"),("祥", "상서로울 상"),("象", "코끼리 상"),("床", "牀의 俗字, 평상 상"),("桑", "뽕나무 상"),("像", "형상 상"),("償", "갚을 상"),("裳", "치마 상"),("庠", "학교 상, 우나라태학 상"),("箱", "상자 상"),("爽", "시원할 상"),("觴", "잔 상"),("翔", "빙빙돌아날 상"),("孀", "과부 상"),("廂", "행랑 상"),("湘", "강이름 상, 물이름 상"),("牀", "평상 상"),("橡", "상수리나무 상, 도토리 상"),("峠", "고개 상"),("甞", "맛볼 상"),("殤", "일찍죽을 상"),("顙", "이마 상"),("徜", "노닐 상"),("緗", "담황색 상"),("晌", "정오 상"),("塽", "높고밝은땅 상"),("鎟", "방울소리 상"),("鬺", "삶을 상"),]),
("상개동", &[("上開洞", "지명"),]),
("상계동", &[("上溪洞", "지명"),]),
("상관면", &[("上關面", "지명"),]),
("상광교동", &[("上光敎洞", "지명"),]),
("상남동", &[("上南洞", "지명"),]),
("상남면", &[("上南面", "지명"),]),
("상당구", &[("上黨區", "지명"),]),
("상대동", &[("上大洞", "지명"),("上垈洞", "지명"),]),
("상대원동", &[("上大院洞", "지명"),]),
("상덕동", &[("尙德洞", "지명"),]),
("상도동", &[("上道洞", "지명"),("上島洞", "지명"),]),
("상동", &[("上洞", "지명"),]),
("상동면", &[("上東面", "지명"),]),
("상동읍", &[("上東邑", "지명"),]),
("상락동", &[("常樂洞", "지명"),]),
("상록구", &[("常綠區", "지명"),]),
("상리동", &[("上里洞", "지명"),]),
("상리면", &[("上里面", "지명"),]),
("상림동", &[("上林洞", "지명"),]),
("상망동", &[("上望洞", "지명"),]),
("상매동", &[("上梅洞", "지명"),]),
("상면", &[("上面", "지명"),]),
("상모동", &[("上毛洞", "지명"),]),
("상모면", &[("上芼面", "지명"),]),
("상방동", &[("上方洞", "지명"),]),
("상복동", &[("上福洞", "지명"),]),
("상봉동", &[("上鳳洞", "지명"),]),
("상봉동동", &[("上鳳東洞", "지명"),]),
("상봉서동", &[("上鳳西洞", "지명"),]),
("상봉암동", &[("上鳳岩洞", "지명"),]),
("상북면", &[("上北面", "지명"),]),
("상사면", &[("上沙面", "지명"),]),
("상사미동", &[("上士美洞", "지명"),]),
("상사창동", &[("上司倉洞", "지명"),]),
("상산곡동", &[("上山谷洞", "지명"),]),
("상서", &[("上西", "지명"),]),
("상서동", &[("上書洞", "지명"),]),
("상서면", &[("上西面", "지명"),]),
("상소동", &[("上所洞", "지명"),]),
("상수동", &[("上水洞", "지명"),]),
("상신동", &[("上新洞", "지명"),]),
("상아동", &[("上阿洞", "지명"),]),
("상아해안", &[("象牙海岸", "코트디부아르"),]),
("상안동", &[("常安洞", "지명"),]),
("상암동", &[("上岩洞", "지명"),]),
("상야동", &[("上野洞", "지명"),]),
("상예동", &[("上猊洞", "지명"),]),
("상왕동", &[("上旺洞", "지명"),]),
("상왕십리", &[("上往十里", "지명"),]),
("상운면", &[("詳雲面", "지명"),]),
("상원동", &[("上元洞", "지명"),]),
("상월곡동", &[("上月谷洞", "지명"),]),
("상월면", &[("上月面", "지명"),]),
("상인동", &[("上仁洞", "지명"),]),
("상일동", &[("上一洞", "지명"),]),
("상장동", &[("上長洞", "지명"),]),
("상적동", &[("上笛洞", "지명"),]),
("상전면", &[("上田面", "지명"),]),
("상주면", &[("尙州面", "지명"),]),
("상주시", &[("尙州市", "지명"),]),
("상줄동", &[("上茁洞", "지명"),]),
("상촌면", &[("上村面", "지명"),]),
("상패동", &[("上牌洞", "지명"),]),
("상평동", &[("上平洞", "지명"),("上坪洞", "지명"),]),
("상하면", &[("上下面", "지명"),]),
("상현동", &[("上峴洞", "지명"),]),
("상효동", &[("上孝洞", "지명"),]),
("새", &[("塞", "변방 새, 변망 새"),("璽", "도장 새, 옥새 새"),("賽", "굿할 새, 국할 새"),("鰓", "뿔심 새"),]),
("새병아", &[("塞丙牙", "세네갈"),]),
("새설이", &[("塞舌爾", "세이셸"),]),
("새이유흑산", &[("塞爾維黒山", "세르비아 몬테네그로"),]),
("새포로사", &[("塞浦路斯", "키프로스"),]),
("색", &[("色", "빛 색"),("塞", "막힐 색, 변망 색"),("索", "찾을 색, 동아줄 색"),("嗇", "아낄 색, 인색할 색"),("薔", "아낄 색"),("穡", "거둘 색"),("愬", "놀랍고두려울 색"),("槭", "나뭇잎 떨어져 앙상할 색"),("濇", "껄끄러울 색"),("瀒", "濇의 俗字"),]),
("색달동", &[("穡達洞", "지명"),]),
("색장동", &[("色長洞", "지명"),]),
("생", &[("生", "날 생"),("省", "덜 생, 살필 생"),("牲", "희생 생"),("甥", "생질 생, 사위 생"),("笙", "생황 생"),("眚", "눈에백태낄 생"),("鉎", "녹 생"),]),
("생곡동", &[("生谷洞", "지명"),]),
("생극면", &[("笙極面", "지명"),]),
("생림면", &[("生林面", "지명"),]),
("생목동", &[("生木洞", "지명"),]),
("생비량면", &[("生比良面", "지명"),]),
("생연동", &[("生淵洞", "지명"),]),
("생용동", &[("生龍洞", "지명"),]),
("생일면", &[("生日面", "지명"),]),
("생초면", &[("生草面", "지명"),]),
("서", &[("西", "서녘 서"),("書", "쓸 서, 글 서"),("序", "차례 서"),("暑", "더울 서"),("庶", "여러 서, 뭇 서"),("徐", "천천할 서"),("署", "관청 서, 마을 서"),("恕", "용서할 서"),("緖", "실마리 서"),("誓", "맹세할 서"),("敍", "차례 서, 베풀 서"),("逝", "갈 서"),("瑞", "상서 서"),("舒", "펼 서"),("曙", "새벽 서"),("棲", "살 서, 쉴 서"),("胥", "서로 서"),("黍", "기장 서"),("鼠", "쥐 서"),("犀", "무소 서, 뿔난소 서"),("薯", "참마 서, 감자 서"),("嶼", "섬 서"),("抒", "풀 서, 끄어낼 서"),("壻", "사위 서"),("栖", "깃들일 서, 깃드릴 서"),("筮", "점대 서, 산가지 서"),("鋤", "호미 서"),("絮", "솜 서, 헌솜 서"),("墅", "농막 서"),("捿", "깃들일 서, 깃드릴 서"),("婿", "사위 서"),("紓", "느슨할 서"),("噬", "씹을 서"),("鉏", "호미 서"),("湑", "거를 서"),("澨", "물가 서"),("芧", "상수리 서"),("揟", "나무이름 서"),("耡", "구실이름 서"),]),
("서계동", &[("西界洞", "지명"),]),
("서곡동", &[("西谷洞", "지명"),("書谷洞", "지명"),]),
("서교동", &[("西橋洞", "지명"),]),
("서구", &[("西區", "지명"),]),
("서귀동", &[("西歸洞", "지명"),]),
("서귀포시", &[("西歸浦市", "지명"),]),
("서금동", &[("西錦洞", "지명"),]),
("서내동", &[("西內洞", "지명"),]),
("서노서아", &[("西露西亞", "벨로루시"),]),
("서노송동", &[("西老松洞", "지명"),]),
("서대문구", &[("西大門區", "지명"),]),
("서대신동", &[("西大新洞", "지명"),]),
("서도면", &[("西島面", "지명"),]),
("서동", &[("西洞", "지명"),("書洞", "지명"),]),
("서둔동", &[("西屯洞", "지명"),]),
("서랑동", &[("西廊洞", "지명"),]),
("서리아", &[("叙利亞", "시리아"),]),
("서린동", &[("瑞麟洞", "지명"),]),
("서면", &[("西面", "지명"),]),
("서문동", &[("西門洞", "지명"),]),
("서문로", &[("西門路", "지명"),]),
("서반아", &[("西班牙", "에스파냐"),]),
("서변동", &[("西邊洞", "지명"),]),
("서봉동", &[("西峰洞", "지명"),]),
("서부동", &[("西部洞", "지명"),]),
("서부면", &[("西部面", "지명"),]),
("서빙고동", &[("西氷庫洞", "지명"),]),
("서사", &[("瑞士", "스위스"),]),
("서산동", &[("西山洞", "지명"),("瑞山洞", "지명"),]),
("서산시", &[("瑞山市", "지명"),]),
("서삼면", &[("西三面", "지명"),]),
("서상동", &[("西上洞", "지명"),]),
("서상면", &[("西上面", "지명"),]),
("서생면", &[("西生面", "지명"),]),
("서서", &[("瑞西", "스위스"),]),
("서서학동", &[("西棲鶴洞", "지명"),]),
("서석동", &[("瑞石洞", "지명"),]),
("서석면", &[("瑞石面", "지명"),]),
("서성동", &[("西城洞", "지명"),]),
("서소문동", &[("西小門洞", "지명"),]),
("서수면", &[("瑞穗面", "지명"),]),
("서신동", &[("西新洞", "지명"),]),
("서신면", &[("西新面", "지명"),]),
("서악동", &[("西岳洞", "지명"),]),
("서암동", &[("西菴洞", "지명"),]),
("서야동", &[("西也洞", "지명"),]),
("서완산동", &[("西完山洞", "지명"),]),
("서운동", &[("瑞雲洞", "지명"),]),
("서운면", &[("瑞雲面", "지명"),]),
("서울특별시", &[("서울特別市", "지명"),]),
("서원면", &[("書院面", "지명"),]),
("서인동", &[("西仁洞", "지명"),]),
("서전", &[("瑞典", "스웨덴"),]),
("서정동", &[("西井洞", "지명"),("西亭洞", "지명"),]),
("서종면", &[("西宗面", "지명"),]),
("서중동", &[("西中洞", "지명"),]),
("서창동", &[("西昌洞", "지명"),("西倉洞", "지명"),]),
("서천군", &[("舒川郡", "지명"),]),
("서천읍", &[("舒川邑", "지명"),]),
("서초구", &[("瑞草區", "지명"),]),
("서초동", &[("瑞草洞", "지명"),]),
("서촌동", &[("西村洞", "지명"),]),
("서탄면", &[("西炭面", "지명"),]),
("서포면", &[("西浦面", "지명"),]),
("서하면", &[("西下面", "지명"),]),
("서현동", &[("書峴洞", "지명"),]),
("서호", &[("西湖", "지명"),]),
("서호동", &[("西好洞", "지명"),("西湖洞", "지명"),]),
("서호면", &[("西湖面", "지명"),]),
("서홍동", &[("西烘洞", "지명"),]),
("서화면", &[("瑞和面", "지명"),]),
("서후면", &[("西後面", "지명"),]),
("서흥남동", &[("西興南洞", "지명"),]),
("석", &[("石", "돌 석"),("夕", "저녁 석"),("席", "자리 석"),("昔", "옛 석"),("惜", "아낄 석"),("釋", "풀 석"),("析", "가를 석, 쪼갤 석"),("錫", "주석 석"),("奭", "클 석"),("碩", "클 석"),("晳", "밝을 석, 분석할 석"),("潟", "개펄 석"),("汐", "조수 석, 저녁조수 석"),("淅", "쌀일 석"),("蓆", "자리 석, 클 석"),("腊", "포 석"),("舃", "신 석"),("蜥", "도마뱀 석"),("鉐", "놋쇠 석"),("晰", "밝을 석"),("矽", "석비레 석"),("鼫", "석서 석"),]),
("석곡동", &[("石谷洞", "지명"),]),
("석곡면", &[("石谷面", "지명"),]),
("석관동", &[("石串洞", "지명"),]),
("석교동", &[("石橋洞", "지명"),]),
("석구동", &[("石九洞", "지명"),]),
("석남동", &[("石南洞", "지명"),]),
("석대동", &[("石坮洞", "지명"),]),
("석동", &[("石洞", "지명"),]),
("석란", &[("錫蘭", "스리랑카"),]),
("석림동", &[("石林洞", "지명"),]),
("석문면", &[("石門面", "지명"),]),
("석보면", &[("石保面", "지명"),]),
("석봉동", &[("石峰洞", "지명"),]),
("석사동", &[("碩士洞", "지명"),]),
("석성면", &[("石城面", "지명"),]),
("석소동", &[("石所洞", "지명"),]),
("석수동", &[("石水洞", "지명"),]),
("석암동", &[("石岩洞", "지명"),]),
("석왕동", &[("石旺洞", "지명"),]),
("석운", &[("石雲", "지명"),]),
("석장동", &[("石長洞", "지명"),]),
("석적면", &[("石積面", "지명"),]),
("석전동", &[("石田洞", "지명"),]),
("석정동", &[("石井洞", "지명"),("石亭洞", "지명"),]),
("석촌동", &[("石村洞", "지명"),]),
("석탄동", &[("石灘洞", "지명"),]),
("석포면", &[("石浦面", "지명"),]),
("석현동", &[("石峴洞", "지명"),]),
("선", &[("先", "먼저 선"),("仙", "신선 선"),("善", "착할 선"),("單", "고을이름 선"),("線", "실 선, 기울 선"),("船", "배 선"),("選", "가릴 선"),("鮮", "고울 선"),("洗", "조촐할 선, 율이름 선"),("宣", "베풀 선"),("旋", "돌 선"),("禪", "봉선 선, 전위할 선"),("膳", "반찬 선"),("繕", "기울 선"),("扇", "사립문 선, 부채 선"),("煽", "부칠 선, 부추킬 선"),("璿", "아름다운옥 선"),("璇", "아름다운옥 선, 구슬 선"),("瑄", "도리옥 선, 둥근옥 선"),("癬", "옴 선, 버짐 선"),("腺", "샘 선, 멍울 선"),("亘", "구할 선"),("羨", "부러워할 선, 부끄러워할 선"),("銑", "끌 선, 윤택할금 선"),("蟬", "매미 선"),("詵", "많을 선, 말전할 선"),("饍", "膳과 同字, 반찬 선"),("嬋", "고울 선"),("霰", "싸락눈 선, 별 선"),("僊", "춤출 선"),("蘚", "이끼 선"),("跣", "맨발 선, 발벗을 선"),("鐥", "복자 선"),("渲", "바림 선, 물적실 선"),("琁", "옥 선, 구슬 선"),("敾", "글잘쓸 선"),("尠", "적을 선"),("譔", "가르칠 선"),("綫", "線과 同字"),("鏇", "갈이틀 선"),("騸", "불깔 선"),("愃", "쾌할 선"),("墡", "백토 선"),("筅", "솔 선"),("鱻", "생선 선"),("嫙", "예쁠 선"),("尟", "尠과 同字"),("屳", "날 선"),("歚", "고을 선"),("譱", "善의 古字"),("鱓", "두렁허리 선"),]),
("선감동", &[("仙甘洞", "지명"),]),
("선교동", &[("仙橋洞", "지명"),]),
("선구동", &[("仙龜洞", "지명"),]),
("선기동", &[("善基洞", "지명"),]),
("선남면", &[("船南面", "지명"),]),
("선동", &[("仙洞", "지명"),("船洞", "지명"),]),
("선린동", &[("善隣洞", "지명"),]),
("선부동", &[("仙府洞", "지명"),]),
("선산읍", &[("善山邑", "지명"),]),
("선암동", &[("仙岩洞", "지명"),]),
("선양동", &[("先陽洞", "지명"),]),
("선원동", &[("仙源洞", "지명"),]),
("선원면", &[("仙源面", "지명"),]),
("선유동", &[("仙遊洞", "지명"),]),
("선장면", &[("仙掌面", "지명"),]),
("선주지동", &[("仙住池洞", "지명"),]),
("선학동", &[("仙鶴洞", "지명"),]),
("선화동", &[("仙花洞", "지명"),("宣化洞", "지명"),]),
("설", &[("雪", "눈 설"),("說", "말씀 설"),("設", "베풀 설"),("舌", "혀 설"),("泄", "샐 설, 발설할 설"),("薛", "맑은대쑥 설, 풀이름 설"),("卨", "사람이름 설"),("屑", "가루 설, 구차할 설"),("洩", "샐 설, 물이샐 설"),("渫", "칠 설, 더러울 설"),("褻", "더러울 설, 평복 설"),("楔", "문설주 설, 기둥 설"),("齧", "물 설, 씹을 설"),("偰", "맑을 설"),("揲", "셀 설"),("爇", "불사를 설"),("紲", "고삐 설"),("媟", "깔볼 설"),("碟", "가죽다룰 설"),("暬", "설만할 설"),]),
("설문동", &[("雪門洞", "지명"),]),
("설성면", &[("雪星面", "지명"),]),
("설악동", &[("雪岳洞", "지명"),]),
("설악면", &[("雪岳面", "지명"),]),
("설천면", &[("雪川面", "지명"),]),
("섬", &[("暹", "해돋을 섬, 햇살오를 섬"),("纖", "가늘 섬"),("蟾", "두꺼비 섬"),("陝", "고을이름 섬"),("殲", "다죽일 섬, 멸할 섬"),("閃", "번쩍할 섬, 피할 섬"),("贍", "넉넉할 섬, 도울 섬"),("剡", "날카로울"),("憸", "간사할 섬"),("摻", "섬섬할 섬"),("銛", "가래 섬"),("譫", "헛소리 섬"),("睒", "번개빛 섬"),("韱", "산부추 섬"),("孅", "가늘 섬"),]),
("섭", &[("葉", "고을이름 섭, 성 섭"),("涉", "물 건널 섭, 지나칠 섭, 돌아다닐 섭"),("攝", "몰아 잡을 섭, 끌 섭, 단정하게 할 섭, 겸할 섭, 거둘 섭, 기록할 섭, 항복할 섭"),("燮", "불에 익힐 섭, 불꽃 섭, 조화로울 섭"),("躡", "밟을 섭, 신 신을 섭, 오를 섭"),("懾", "무서울 섭, 두려울 섭"),("囁", "말하려다 멈출 섭, 중얼거릴 섭, 입 다물 섭"),("聶", "소곤거릴 섭, 낄 섭, 성씨 섭"),("鑷", "쪽집게 섭"),("灄", "흠치르르할 섭, 물이름 섭, 떼 섭"),("顳", "귀밑 뼈 섭"),]),
("성", &[("成", "이룰 성, 거듭 성, 마칠 성, 화목할 성"),("星", "별 성, 희뜩희뜩할 성, 세월 성, 성시 성"),("省", "살필 성"),("性", "성품 성, 마음 성, 바탕 성, 색욕 성"),("姓", "일가 성, 아이 낳을 성, 백성 성"),("城", "보루 성, 재 성, 서울 성"),("誠", "미쁠 성, 공경할 성, 살필 성, 진실 성, 정성 성"),("聖", "성인 성, 착할 성, 통할 성, 지극할 성"),("聲", "소리 성, 풍류 성, 명예 성"),("盛", "담을 성, 이룰 성, 정제할 성, 많을 성, 성할 성"),("晟", "밝을 성, 햇살 퍼질 성"),("醒", "술 깰 성, 꿈 깰 성, 깨달을 성"),("宬", "사고 성, 도서실 성, 창고 성, 사기창고 성"),("惺", "깨달을 성, 똑똑할 성, 조용할 성"),("腥", "비린내 성, 더러울 성, 날고기 성, 냄새 성"),("珹", "옥이름"),("猩", "성성이 성"),("筬", "바디 성, 대나무이름 성"),("騂", "붉은 소 성, 누른말 성, 활 물쩡물쩡할 성"),]),
("성거읍", &[("聖居邑", "지명"),]),
("성건동", &[("城乾洞", "지명"),]),
("성곡동", &[("城谷洞", "지명"),]),
("성기차화니비사", &[("聖基茨和尼維斯", "세인트 키츠 네비스"),]),
("성남동", &[("城南洞", "지명"),]),
("성남면", &[("城南面", "지명"),]),
("성남시", &[("城南市", "지명"),]),
("성내동", &[("城內洞", "지명"),]),
("성내면", &[("星內面", "지명"),]),
("성당동", &[("聖堂洞", "지명"),]),
("성당면", &[("聖堂面", "지명"),]),
("성덕동", &[("聖德洞", "지명"),]),
("성덕면", &[("聖德面", "지명"),]),
("성동", &[("城洞", "지명"),]),
("성동구", &[("城東區", "지명"),]),
("성동동", &[("城東洞", "지명"),]),
("성동면", &[("城東面", "지명"),]),
("성등미불림자부", &[("聖登米不林刺部", "상토메 프린시페"),]),
("성로서아", &[("聖盧西亞", "세인트 루시아"),]),
("성마력낙", &[("聖馬利諾", "산마리노"),]),
("성마리낙", &[("聖馬力諾", "산마리노"),]),
("성복동", &[("星福洞", "지명"),]),
("성북구", &[("城北區", "지명"),]),
("성북동", &[("城北洞", "지명"),]),
("성사동", &[("星沙洞", "지명"),]),
("성산동", &[("城山洞", "지명"),]),
("성산면", &[("星山面", "지명"),("城山面", "지명"),("聖山面", "지명"),]),
("성산읍", &[("城山邑", "지명"),]),
("성서동", &[("城西洞", "지명"),]),
("성석동", &[("星石洞", "지명"),]),
("성성동", &[("聖城洞", "지명"),]),
("성송면", &[("星松面", "지명"),]),
("성수동", &[("聖水洞", "지명"),]),
("성수면", &[("聖壽面", "지명"),]),
("성안동", &[("聖安洞", "지명"),]),
("성암동", &[("城岩洞", "지명"),]),
("성연면", &[("聖淵面", "지명"),]),
("성전면", &[("城田面", "지명"),]),
("성정동", &[("星井洞", "지명"),]),
("성주군", &[("星州郡", "지명"),]),
("성주동", &[("聖住洞", "지명"),]),
("성주면", &[("聖住面", "지명"),]),
("성주읍", &[("星州邑", "지명"),]),
("성포동", &[("聲浦洞", "지명"),]),
("성하동", &[("城下洞", "지명"),]),
("성항", &[("星港", "싱가포르"),]),
("성호동", &[("城湖洞", "지명"),]),
("성화동", &[("聖化洞", "지명"),]),
("성환읍", &[("成歡邑", "지명"),]),
("성황동", &[("城隍洞", "지명"),]),
("세", &[("世", "세상 세, 평생 세, 백년 세, 인간 세"),("說", "달랠 세, 쉴 세, 말씀 세"),("歲", "해 세, 곡식 익을 세, 돐 세, 풍년 세"),("細", "가늘 세, 작을 세, 좀놈 세"),("洗", "씻을 세, 세수 그릇 세"),("勢", "권세 세, 위엄 세, 불알 세, 기회 세"),("稅", "구실 세, 거둘 세, 놓을 세, 쉴 세, 세금 세"),("貰", "빌릴 세, 세 바칠 세, 세낼 세"),("笹", "가는 대 세"),("洒", "씻을 세, 설치할 세"),("繐", "가늘고 성긴 베 세"),("蛻", "매미 허물 세"),("帨", "차는 수건 세, 손수건 세"),]),
("세곡동", &[("細谷洞", "지명"),]),
("세교동", &[("細橋洞", "지명"),]),
("세도면", &[("世道面", "지명"),]),
("세동", &[("細洞", "지명"),]),
("세류동", &[("細柳洞", "지명"),]),
("세식도동", &[("歲篒島洞", "지명"),]),
("세종로", &[("世宗路", "지명"),]),
("세지면", &[("細枝面", "지명"),]),
("세천동", &[("細川洞", "지명"),]),
("세하동", &[("細荷洞", "지명"),]),
("소", &[("小", "작을 소, 좁을 소, 적을 소, 어릴 소, 적게 여길 소"),("少", "적을 소, 조금 소, 멸시할 소, 잠깐 소, 젊을 소"),("所", "바 소, 곳 소, 쯤 소, 가질 소, 얼마 소"),("笑", "웃음 소"),("消", "다할 소, 꺼질 소, 풀릴 소, 해어질 소, 사라질 소"),("素", "흴 소, 생초 소, 빌 소, 바탕 소, 원래 소"),("召", "부를 소, 청할 소, 과부 소"),("昭", "소명할 소, 소목 소, 태평세월 소, 밝을 소"),("訴", "하소연할 소, 송사할 소"),("掃", "쓸 소, 상투 소"),("蘇", "차조기 소, 나무할 소, 까무러칠 소, 깨어날 소, 성씨 소"),("燒", "불 붙을 소, 들불 소, 불 놓을 소, 불사를 소"),("騷", "근심스러울 소, 흔들릴 소, 급할 소, 처량할 소, 소동할 소"),("疎", "성길 소, 드물 소"),("蔬", "나물 소"),("巢", "새집 소, 집 지을 소, 새 보금자리 소, 적진 망보는 높을 수레 소, 도둑굴 소, 큰 피리 소, 채소이름 소"),("紹", "이을 소, 얽을 소, 소개할 소"),("邵", "땅이름 소, 성씨 소"),("沼", "못 소, 늪 소"),("蕭", "쑥 소, 쓸쓸할 소, 말 우는 소리 소, 바람소리 소"),("宵", "밤 소, 작을 소, 벌레이름 소"),("逍", "노닐 소, 거닐 소"),("簫", "퉁소 소, 활고지 소"),("搔", "긁을 소, 휘저을 소, 분분할 소"),("遡", "거스를 소, 맞이할 소, 하소연할 소"),("梳", "얼레빗 소, 머리빗을 소"),("塑", "허수아비 소"),("甦", "깨어날 소, 숨 쉴 소"),("瘙", "옴 소, 종기 소"),("疏", "뚫릴 소, 나눌 소, 멀 소, 추할 소, 드물 소, 성길 소"),("嘯", "휘파람 소, 세게 뿜을 소, 읊을 소"),("銷", "녹을 소, 사라질 소, 녹일 소"),("韶", "아름다울 소, 이을 소, 순의 풍류 소, 봄 소"),("瀟", "물 맑을 소, 비바람 몰아칠 소, 강이름 소, 비바람치는 모양 소"),("炤", "밝을 소"),("溯", "거슬러 올라갈 소"),("篠", "가는 대 소, 조릿대 소"),("踈", "疎의 譌字"),("艘", "배 소"),("霄", "하늘 소, 진눈깨비 소"),("泝", "거슬러 올라갈 소, 흘러갈 소"),("埽", "쓸 소, 그릴 소, 언덕 소"),("翛", "날개치는 소리 소, 모지라질 소"),("愬", "고할 소, 참소할 소, 알릴 소"),("酥", "타락죽 소"),("繅", "고치 실 뽑을 소"),("卲", "높을 소, 성씨 소"),("蛸", "거미알 소, 연가시 알집 소"),("俏", "거문고 뒤치는 소리 소"),("捎", "덜 소, 흔들거릴 소, 추릴 소, 버릴 소"),("魈", "산도깨비 소"),("佋", "소개할 소, 사신 소, 댓수의 차례 소"),("嗉", "멀떠구니 소"),("筱", "가는 대 소"),("塐", "塑와 同字"),("樔", "풀막 소, 너스레 소"),("膆", "살찔 소, 멀떠구니 소"),("鮹", "문어 소, 낙지 소"),("鰺", "비린내 소의 譌字"),]),
("소격동", &[("昭格洞", "지명"),]),
("소계동", &[("召界洞", "지명"),]),
("소공동", &[("小公洞", "지명"),]),
("소남", &[("昭南", "싱가포르"),]),
("소단", &[("蘇丹", "수단"),]),
("소답동", &[("召畓洞", "지명"),]),
("소도동", &[("所道洞", "지명"),]),
("소라면", &[("召羅面", "지명"),]),
("소라문제도", &[("所羅門諸島", "솔로몬 제도"),]),
("소련", &[("蘇聯", "소비에트 연방"),]),
("소룡동", &[("少龍洞", "지명"),]),
("소리남", &[("蘇里南", "수리남"),]),
("소마리아", &[("蘇摩利亞", "소말리아"),]),
("소보면", &[("召保面", "지명"),]),
("소사구", &[("素砂區", "지명"),]),
("소사동", &[("素沙洞", "지명"),("素砂洞", "지명"),]),
("소사본동", &[("素砂本洞", "지명"),]),
("소성면", &[("所聲面", "지명"),]),
("소수면", &[("沼壽面", "지명"),]),
("소안면", &[("所安面", "지명"),]),
("소양로", &[("昭陽路", "지명"),]),
("소양면", &[("所陽面", "지명"),]),
("소원면", &[("所遠面", "지명"),]),
("소이면", &[("蘇伊面", "지명"),]),
("소정면", &[("小井面", "지명"),]),
("소제동", &[("蘇堤洞", "지명"),]),
("소천면", &[("小川面", "지명"),]),
("소초면", &[("所草面", "지명"),]),
("소촌동", &[("素村洞", "지명"),]),
("소태동", &[("所台洞", "지명"),]),
("소태면", &[("蘇台面", "지명"),]),
("소하동", &[("所下洞", "지명"),]),
("소학동", &[("巢鶴洞", "지명"),]),
("소호동", &[("所好洞", "지명"),("蘇湖洞", "지명"),]),
("소흘읍", &[("蘇屹邑", "지명"),]),
("속", &[("速", "빠를 속, 부를 속, 더러울 속, 사슴 발자취 속"),("俗", "익을 속, 버릇 속, 풍속 속, 세상 속"),("續", "이을 속"),("束", "묶을 속, 단나무 속, 약속할 속, 비단 다섯끝 속"),("屬", "무리 속, 좇을 속, 붙이 속, 거느릴 속, 붙일 속"),("粟", "좁쌀 속, 겉곡식 속, 조 속"),("贖", "속바칠 속, 무역할 속"),("涑", "빨"),("謖", "일어날"),("遬", "공손할 속, 줄어들 속"),]),
("속달", &[("速達", "지명"),]),
("속천동", &[("束川洞", "지명"),]),
("속초시", &[("束草市", "지명"),]),
("손", &[("孫", "손자 손, 움 돋을 손, 순할 손, 피할 손"),("損", "덜 손, 잃을 손, 피곤할 손, 삼갈 손, 상할 손, 괘 이름 손"),("遜", "순할 손, 겸손할 손, 도망할 손, 사양할 손"),("巽", "사양할 손, 낮은체 할 손, 부드러울 손, 괘 이름 손, 동과 남의 사이방향 손"),("飡", "飱과 同字, 삼킬 손"),("蓀", "난초"),("飧", "저녁밥 손, 물에 만 밥 손"),("飱", "飧의 俗字"),]),
("손곡동", &[("蓀谷洞", "지명"),]),
("손불면", &[("孫佛面", "지명"),]),
("손양면", &[("巽陽面", "지명"),]),
("솔", &[("率", "거느릴 솔, 좇을 솔, 쓸 솔, 대강 솔, 공경할 솔, 뱀 이름 솔, 헤아릴 솔"),("蟀", "귀뚜라미 솔"),("窣", "느릿느릿 걸을 솔, 우지직거릴 솔, 구멍으로 나올 솔"),]),
("송", &[("送", "보낼 송, 가질 송, 활쏘기 능통할 송, 줄 송"),("松", "소나무 송, 향풀 송, 땅이름 송, 솔 송"),("訟", "송사할 송, 시비할 송, 꾸짖을 송, 괘 이름 송"),("誦", "풍유할 송, 읽을 송, 말할 송, 원망할 송, 욀 송"),("頌", "기릴 송, 칭송할 송, 찬양하는 노래 송"),("宋", "송나라 송, 성씨 송"),("悚", "두려울 송, 송구할 송, 두려워할 송"),("淞", "강이름 송"),("竦", "공경할 송, 두려울 송, 높일 송, 솟을 송"),("柗", "松과 同字"),("鬆", "터럭 더부룩할 송"),]),
("송강동", &[("松江洞", "지명"),]),
("송광면", &[("松光面", "지명"),]),
("송내동", &[("松內洞", "지명"),]),
("송대동", &[("松大洞", "지명"),]),
("송도동", &[("松島洞", "지명"),]),
("송동면", &[("松洞面", "지명"),]),
("송라면", &[("松羅面", "지명"),]),
("송림동", &[("松林洞", "지명"),]),
("송산동", &[("松山洞", "지명"),]),
("송산면", &[("松山面", "지명"),]),
("송악면", &[("松岳面", "지명"),]),
("송암동", &[("松岩洞", "지명"),]),
("송월동", &[("松月洞", "지명"),]),
("송절동", &[("松節洞", "지명"),]),
("송정동", &[("松亭洞", "지명"),("松汀洞", "지명"),]),
("송죽동", &[("松竹洞", "지명"),]),
("송지면", &[("松旨面", "지명"),]),
("송창동", &[("松昌洞", "지명"),]),
("송천동", &[("松川洞", "지명"),]),
("송촌동", &[("松村洞", "지명"),("宋村洞", "지명"),]),
("송치동", &[("松峙洞", "지명"),]),
("송파구", &[("松坡區", "지명"),]),
("송파동", &[("松坡洞", "지명"),]),
("송포동", &[("松圃洞", "지명"),]),
("송풍동", &[("松豊洞", "지명"),]),
("송하동", &[("松荷洞", "지명"),]),
("송학동", &[("松鶴洞", "지명"),]),
("송학면", &[("松鶴面", "지명"),]),
("송해면", &[("松海面", "지명"),]),
("송현동", &[("松峴洞", "지명"),]),
("솨", &[("惢", "의심낼 솨"),]),
("쇄", &[("殺", "내릴 쇄, 감할 쇄, 빠를 쇄, 죽일 쇄"),("刷", "긁을 쇄, 고칠 쇄, 빗을 쇄, 문지를 쇄, 인쇄할 쇄"),("鎖", "자물쇠 쇄, 쇠사슬 쇄, 가둘 쇄, 항쇄 쇄, 자물쇄 쇄"),("灑", "뿌릴 쇄, 깜짝 놀랄 쇄"),("碎", "부술 쇄, 잘 쇄"),("瑣", "옥가루 쇄, 가늘 쇄, 좀스러울 쇄, 대궐문 아로새길 쇄"),]),
("쇄운동", &[("灑雲洞", "지명"),]),
("쇠", &[("衰", "쇠할 쇠, 모손할 쇠, 약할 쇠"),("釗", "쇠"),("夊", "천천히걷다"),]),
("수", &[("水", "물 수, 고를 수"),("手", "손 수, 잡을 수, 칠 수"),("數", "헤아릴 수, 수죄할 수, 몇 수, 이치 수, 자주 수"),("守", "지킬 수, 보살필 수, 원님 수, 기다릴 수"),("首", "머리 수, 먼저 수, 비롯할 수, 임금 수, 향할 수, 자백할 수"),("樹", "나무 수, 막을 수, 세울 수, 심을 수"),("受", "이을 수, 얻을 수, 담을 수, 받을 수"),("授", "줄 수, 부칠 수"),("收", "모을 수, 거둘 수, 잡을 수, 수레바퀴 수"),("雖", "비록 수, 벌레이름 수"),("修", "닦을 수, 옳게할 수, 정리할 수, 꾸밀 수"),("壽", "목숨 수, 장수할 수, 나이 수, 축복할 수"),("須", "수염 수, 기다릴 수, 모름지기 수"),("誰", "누구 수, 무엇 수"),("秀", "빼어날 수, 이삭 수, 벼 패일 수, 아름다울 수"),("愁", "근심 수, 염려할 수, 탄식할 수"),("遂", "사무칠 수, 나아갈 수, 이룰 수, 마침내 수"),("隨", "따를 수, 괘 이름 수, 나라이름 수, 맡길 수"),("囚", "가둘 수, 갇힐 수, 묶일 수"),("殊", "죽을 수, 베일 수, 끊어질 수, 지나갈 수, 다를 수"),("輸", "떨어뜨릴 수, 쏟을 수, 보낼 수, 짐바리 수"),("需", "음식 수, 머뭇거릴 수, 기다릴 수, 찾을 수, 괘 이름 수"),("獸", "짐승 수"),("垂", "드리울 수, 변방 수, 거의 수, 남길 수"),("帥", "주장할 수, 장수 수"),("洙", "물가 수, 물읾 수"),("睡", "졸음 수, 잠 수"),("搜", "찾을 수, 더듬을 수, 화살 빨리 가는 소리 수, 어지러울 수"),("隋", "수나라 수"),("髓", "뼛속 기름 수, 마음속 수, 뼈골 수"),("銖", "저울눈 수"),("蒐", "꼭두서니 수, 모을 수, 숨을 수, 찾을 수"),("酬", "술 권할 수, 갚을 수"),("羞", "부끄러울 수, 음식 수, 부끄러워할 수"),("繡", "수놓을 수, 성씨 수"),("粹", "정할 수, 순수할 수"),("袖", "소매 수"),("瘦", "파리할 수, 가늘 수"),("讐", "讎와 同字, 원수 수"),("竪", "세울 수, 서있을 수, 더벅머리 수"),("狩", "겨울사냥 수, 순행할 수"),("嫂", "형수 수"),("穗", "이삭 수, 벼이삭 수"),("脩", "포 수, 길 수, 마를 수, 닦을 수"),("戍", "수자리 수, 막을 수, 집 수"),("綏", "편안할 수, 수레고삐 수, 물러갈 수, 여우모양 수"),("藪", "큰 늪 수, 덤불 수, 똬리 수"),("綬", "인끈 수"),("邃", "깊숙할 수"),("鬚", "턱수염 수, 아랫수염 수"),("岫", "바위구멍 수, 바위굴 수"),("燧", "봉화 수, 불 수, 나무 문질러 불낼 수"),("隧", "무덤길 수, 구멍 수, 길 수"),("嗽", "기침할 수, 입가실 수"),("漱", "양치질할 수, 빨래할 수"),("琇", "귀막이 수, 옥돌 수, 귀고리 수"),("峀", "岫와 同字, 바위굴 수"),("茱", "수유 수"),("璲", "서옥 수, 패옥 수"),("蓚", "기쁠"),("銹", "동록 수, 녹슬 수"),("叟", "어른 수, 쌀 씻는 소리 수"),("讎", "짝 수, 원수 수, 대거리할 수, 비교할 수, 갚을 수"),("售", "팔 수, 갚을 수"),("豎", "세울 수, 내시 수, 더벅머리 수"),("睟", "똑바로 볼 수, 윤택할 수"),("陲", "변방 수, 위태할 수"),("祟", "빌미 수"),("瞍", "소경 수, 장님 수, 판수 수"),("颼", "바람소리 수"),("殳", "치다"),("廋", "숨길 수"),("溲", "오줌 수, 반족할 수, 적실 수"),("膄", "파리할 수"),("脺", "얼굴 윤택할 수, 머리덜미 수"),("籔", "조리 수, 곡식 세는 단위 휘 수, 또아리 수"),("膸", "髓와 同字"),("饈", "드릴 수, 반찬 수"),("氵", "삼수변"),("氺", "아래물"),]),
("수강동", &[("壽康洞", "지명"),]),
("수곡동", &[("水谷洞", "지명"),("秀谷洞", "지명"),]),
("수곡면", &[("水谷面", "지명"),]),
("수기동", &[("須奇洞", "지명"),]),
("수남동", &[("水南洞", "지명"),]),
("수내", &[("藪內", "지명"),]),
("수도동", &[("水島洞", "지명"),]),
("수동", &[("壽洞", "지명"),]),
("수동면", &[("水東面", "지명"),("水洞面", "지명"),]),
("수륜면", &[("修倫面", "지명"),]),
("수리동", &[("修理洞", "지명"),]),
("수북면", &[("水北面", "지명"),]),
("수비면", &[("首比面", "지명"),]),
("수산동", &[("壽山洞", "지명"),]),
("수산면", &[("水山面", "지명"),]),
("수상동", &[("水上洞", "지명"),]),
("수색동", &[("水色洞", "지명"),]),
("수서동", &[("水西洞", "지명"),]),
("수석동", &[("水石洞", "지명"),("壽石洞", "지명"),]),
("수성구", &[("壽城區", "지명"),]),
("수성동", &[("水城洞", "지명"),("壽城洞", "지명"),]),
("수송동", &[("壽松洞", "지명"),("秀松洞", "지명"),]),
("수신면", &[("修身面", "지명"),]),
("수안동", &[("壽安洞", "지명"),]),
("수암동", &[("秀巖洞", "지명"),]),
("수영구", &[("水營區", "지명"),]),
("수영동", &[("水營洞", "지명"),]),
("수완동", &[("水莞洞", "지명"),]),
("수원시", &[("水原市", "지명"),]),
("수유동", &[("水踰洞", "지명"),]),
("수의동", &[("守儀洞", "지명"),]),
("수점동", &[("水店洞", "지명"),]),
("수정구", &[("壽井區", "지명"),]),
("수정동", &[("水晶洞", "지명"),]),
("수주면", &[("水周面", "지명"),]),
("수지면", &[("水旨面", "지명"),]),
("수진동", &[("壽進洞", "지명"),]),
("수창동", &[("壽昌洞", "지명"),]),
("수청동", &[("水淸洞", "지명"),]),
("수택동", &[("水澤洞", "지명"),]),
("수평동", &[("水坪洞", "지명"),]),
("수표동", &[("水標洞", "지명"),]),
("수하동", &[("水下洞", "지명"),]),
("수한면", &[("水汗面", "지명"),]),
("수화동", &[("水花洞", "지명"),]),
("숙", &[("宿", "잘 숙, 지킬 숙, 머물 숙"),("叔", "아재비 숙, 주울 숙, 어릴 숙, 끝 숙"),("淑", "맑을 숙, 착할 숙, 사모할 숙"),("孰", "누구 숙, 어느 숙, 살필 숙, 익을 숙"),("熟", "익힐 숙, 삶을 숙, 풍년들 숙, 익을 숙"),("肅", "공손할 숙, 공경할 숙, 경계할 숙, 엄숙할 숙"),("夙", "이를 숙, 이미 숙, 빠를 숙, 일찍 일어날 숙"),("菽", "콩"),("塾", "사랑방 숙, 기숙사 숙, 서당 숙"),("璹", "옥그릇"),("潚", "빠를"),("琡", "옥이름"),("倏", "잠간 숙, 홀연 숙, 개의 빨리 달리는 모양 숙"),("俶", "비롯할 숙, 처음 숙, 지을 숙"),("橚", "길고 꼿꼿할 숙"),("儵", "잿빛 숙, 남해 임금 숙, 독화당할 숙, 갑자기 숙"),("鷫", "숙상새 숙"),("驌", "좋은말 숙, 숙상말 숙"),("婌", "궁녀 벼슬이름 숙"),]),
("숙천동", &[("淑泉洞", "지명"),]),
("순", &[("順", "좇을 순, 부드러울 순, 차례 순, 성씨 순, 순할 순"),("純", "실 순, 순수할 순, 온전할 순, 부드러울 순, 순전할 순"),("脣", "입술 순"),("巡", "돌 순, 순행할 순, 두루 순"),("循", "좇을 순, 의지할 순, 돌 순, 차례 순, 돌아다닐 순"),("旬", "열흘 순, 두루할 순, 고를 순, 가득할 순, 요사스런 별 순"),("殉", "죽은 사람을 따라 죽을 순, 구할 순, 좇을 순"),("瞬", "눈 깜작일 순, 잠깐 순, 눈을 깜짝이는 순"),("舜", "순임금 순, 무궁화 순"),("淳", "맑을 순, 순박할 순"),("珣", "옥그릇 순, 옥 이름 순"),("盾", "방패 순, 벼슬이름 순"),("洵", "웅덩이물 순, 소리없이 눈물흘릴 순, 믿을 순"),("筍", "죽순 순, 대싹 순"),("醇", "전국술 순, 두터울 순, 삼갈 순, 순수할 순"),("馴", "길들일 순, 착할 순, 길드릴 순"),("荀", "풀 이름 순, 성씨 순, 순풀 순"),("詢", "꾀할 순, 물을 순, 믿을 순"),("諄", "거듭 일러줄 순, 지극할 순, 정성스러울 순"),("徇", "조리 돌릴 순, 따라 죽을 순, 빠를 순, 부릴 순"),("恂", "진실할 순, 믿을 순, 온공스러울 순"),("蓴", "순나물 순, 순마룰 순"),("楯", "난간 순, 방패 순, 뺄 순, 상여 순"),("錞", "사발종 순"),("蕣", "무궁화 순"),("栒", "경쇠걸이 순, 순나무 순"),("橓", "무궁화나무 순"),("肫", "광대뼈 순, 정성스러울 순"),("鶉", "메추라기 순, 옷 해질 순"),("紃", "신에 실선 두를 순, 실 띠 순, 법 순, 좇을 순"),("狥", "徇의 俗字"),("鬊", "머리 풀어헤칠 순"),("眴", "눈짓할 순"),("侚", "좇을 순, 빠를 순, 조리 돌릴 순"),("盹", "눈 감을 순, 졸 순"),]),
("순동", &[("蓴洞", "지명"),]),
("순성면", &[("順城面", "지명"),]),
("순창군", &[("淳昌郡", "지명"),]),
("순창읍", &[("淳昌邑", "지명"),]),
("순천시", &[("順天市", "지명"),]),
("순화동", &[("巡和洞", "지명"),]),
("순흥면", &[("順興面", "지명"),]),
("술", &[("戌", "개 술, 열한째 지지 술, 때려 부술 술"),("述", "이을 술, 좇을 술, 조회할 술, 밝힐 술, 지을 술"),("術", "재주 술, 심술부릴 술, 술법 술"),("鉥", "돗바늘 술, 인도할 술, 큰바늘 술"),]),
("숭", &[("崇", "높을 숭, 공경할 숭, 마칠 숭, 산이름 숭"),("嵩", "높을 숭, 산이름 숭"),("崧", "산 불끈 솟을 숭, 산 웅장할 숭, 산이름 숭"),("菘", "배추 숭"),]),
("숭의동", &[("崇義洞", "지명"),]),
("숭인동", &[("崇仁洞", "지명"),]),
("쉬", &[("倅", "버금 쉬, 아직 벼슬자리에 오르지 않은 아들 쉬, 원님 쉬"),("晬", "돐 쉬, 첫 생일 쉬"),("淬", "칼 담글 쉬, 물들일 쉬, 범할 쉬"),("焠", "물들일 쉬, 칼날 물에 담글 쉬, 지질 쉬, 태울 쉬"),]),
("슬", &[("瑟", "비파 슬, 거문고 슬, 깨끗한체할 슬, 바람소리 슬"),("膝", "무릎 슬, 종지뼈 슬, 치슬말 슬"),("蝨", "이 슬"),("虱", "蝨과 同字"),]),
("습", &[("習", "익힐 습, 거듭 습"),("拾", "주울 습, 거둘 습, 팔찌 습, 벼슬이름 습"),("襲", "옷 덧입을 습, 벼슬 대물릴 습, 반복할 습, 합할 습, 염습할 습, 엄습할 습"),("濕", "젖을 습, 소 귀 벌룩거릴 습, 근심 습"),("褶", "슬갑 습"),("隰", "진펄 습"),("熠", "환할 습, 선명할 습, 반딧불 반짝거릴 습"),]),
("승", &[("勝", "이길 승, 경치가 좋을 승, 가질 승"),("承", "받들 승, 이을 승, 도울 승, 차례 승"),("乘", "오를 승, 곱할 승, 셈하는 단위 승, 같은 물건 네 개 승, 탈 승"),("僧", "중 승"),("昇", "해 돋을 승, 풍년들 승, 오를 승"),("升", "되 승, 오를 승, 피륙의 짜인 날을 세는 단위 새 승, 괘 이름 승"),("繩", "노끈 승, 법 승, 다스릴 승, 이을 승"),("丞", "이을 승, 도울 승, 벼슬의 이름 승, 향상할 승"),("陞", "오를 승, 올릴 승"),("蠅", "파리 승"),("鬙", "터럭 더부룩할 승"),]),
("승주읍", &[("昇州邑", "지명"),]),
("승촌동", &[("昇村洞", "지명"),]),
("시", &[("時", "때 시, 끼니 시, 이 시, 엿볼 시, 가끔 시"),("始", "비로소 시, 처음 시, 시작할 시, 별이름 시"),("示", "보일 시, 바칠 시, 가르칠 시"),("市", "저자 시, 흥정할 시, 집 많은 동리 시"),("寺", "내관 시"),("視", "볼 시, 견줄 시, 본받을 시, 대접 시"),("詩", "귀글 시, 풍류가락 시, 받들 시, 글귀 시"),("試", "시험할 시, 더듬을 시, 비교할 시"),("是", "이 시, 바를 시, 곧을 시"),("施", "베풀 시, 쓸 시, 더할 시, 안팎 곱사등이 시, 버릴 시, 줄 시, 은혜 시, 공로 시"),("侍", "모실 시, 가까울 시, 좇을 시"),("矢", "살 시, 소리살 시, 곧을 시, 베풀 시, 똥 시, 화살 시"),("柴", "섶 시, 불 땔 나무 시, 시제지낼 시"),("屍", "주검 시, 송장 시, 시체 시"),("諡", "행장 시, 시호 시"),("弑", "윗사람 죽일 시"),("匙", "숟가락 시, 열쇠 시"),("猜", "의심낼 시, 시기할 시, 두려워할 시, 사나울 시"),("豺", "승냥이 시, 늑대 시"),("媤", "시집 시"),("柿", "감나무"),("尸", "시동 시, 주검 시, 시체 시"),("恃", "믿을 시, 의지할 시, 어머니 시"),("蓍", "뺑대쑥 시, 시초 시, 뺑때쑥 시"),("豕", "돼지 시, 돝 시"),("翅", "날개 시, 깃 시, 뿐 시"),("屎", "똥 시, 변 시"),("嘶", "말 울 시, 목 쉴 시, 울부짖을 시, 말이우는 시"),("蒔", "소회향 시, 모종낼 시"),("昰", "是와 同字"),("枾", "柹의 本字, 감 시"),("啻", "뿐 시, 쯤 시"),("厮", "부릴 시, 마부 시, 나눌 시"),("緦", "보름새베 시, 시마복 시, 석달복 시"),("澌", "물 잦을 시, 다할 시"),("廝", "부릴 시, 천할 시, 마부 시"),("柹", "감 시"),("偲", "간절히 책망할 시, 살피고 힘쓸 시, 굳셀 시"),("禔", "복 시, 편안할 시"),("諟", "이 시, 살필 시, 다스릴 시"),("兕", "외뿔난 소 시"),("豉", "메주 시, 콩자반 시"),("塒", "홰 시"),("顋", "뺨 시, 볼 시"),("枲", "수삼 시, 도꼬마리 시"),("諰", "눈 휘둥글할 시, 곧은말 시"),("釃", "술 거를 시"),("鍉", "숟가락 시, 열쇠 시"),]),
("시기동", &[("市其洞", "지명"),]),
("시동", &[("是洞", "지명"),("矢洞", "지명"),]),
("시래동", &[("時來洞", "지명"),]),
("시례동", &[("時禮洞", "지명"),]),
("시미동", &[("侍美洞", "지명"),]),
("시장북로", &[("市場北路", "지명"),]),
("시전동", &[("枾田洞", "지명"),]),
("시종면", &[("始終面", "지명"),]),
("시지동", &[("時至洞", "지명"),]),
("시천동", &[("始川洞", "지명"),]),
("시천면", &[("矢川面", "지명"),]),
("시초면", &[("時草面", "지명"),]),
("시흥", &[("始興", "지명"),]),
("시흥동", &[("始興洞", "지명"),]),
("시흥시", &[("始興市", "지명"),]),
("식", &[("食", "밥 식, 먹을 식, 씹을 식, 제 식, 헛말할 식"),("式", "법 식, 쓸 식, 제도 식, 수레 앞 가로막대 식"),("植", "심을 식, 세울 식, 초목 식"),("識", "알 식"),("息", "숨쉴 식, 그칠 식, 자식 식, 기를 식"),("飾", "꾸밀 식, 문채날 식, 분 바를 식"),("湜", "물 맑을 식, 엄숙할 식"),("殖", "날 식, 심을 식, 성할 식, 불릴 식"),("軾", "수레앞 가로막이 나무 식, 수레 안에서 절할 식"),("蝕", "벌레먹을 식, 일식 식, 월식 식, 좀먹을 식"),("拭", "닦을 식, 다듬을 식, 씻을 식"),("熄", "불 꺼질 식, 없어질 식, 마칠 식"),("寔", "이 식, 참 식, 뿐 식"),("埴", "찰진흙 식, 흙 이길 식, 더듬어 걸을 식"),("篒", "대밥통"),("栻", "점판 식"),("媳", "며느리 식"),]),
("식만동", &[("食滿洞", "지명"),]),
("식사동", &[("食寺洞", "지명"),]),
("식정동", &[("植亭洞", "지명"),]),
("신", &[("身", "몸 신, 아이 밸 신, 몸소 신"),("信", "믿을 신, 밝힐 신, 맏길 신, 이틀 밤을 잘 신, 사신 신"),("莘洞", "지명"),("臣", "신하 신, 두려울 신"),("新", "새 신, 처음 신, 고울 신"),("神", "천신 신, 영검할 신, 신명 신, 정신 신, 귀신 신"),("申", "펼 신, 기지개켤 신, 거듭 신, 아홉째 지지 신, 원숭이 신"),("辰", "날 신"),("辛", "매울 신, 고생 신, 여덟째 천간 신"),("愼", "삼갈 신, 정성스러울 신, 고요할 신"),("伸", "펼 신, 다스릴 신, 기지개 신"),("晨", "샛별 신, 아침을 아뢸 신, 새벽 신"),("紳", "큰 띠 신, 벼슬아치 신"),("訊", "물을 신, 다스릴 신, 죄 조사할 신, 알릴 신, 꾸짖을 신"),("迅", "빠를 신, 억셀 신"),("腎", "콩팥 신, 불알 신, 자지 신"),("燼", "깜부기불 신, 불똥 신, 재난의 뒤 신"),("宸", "집 신, 처마 신, 대궐 신"),("薪", "섶 신, 땔나무 신, 월급 신, 성씨 신"),("呻", "읊조릴 신, 끙끙거릴 신"),("蜃", "큰 조개 신, 이무기 신, 술잔 신"),("娠", "아이밸 신, 마부 신, 임신할 신"),("藎", "갈골 신, 나아갈 신, 남을 신"),("莘", "약 이름 신, 많은 모양 신, 나라이름 신"),("侁", "떼지어 갈 신, 여럿이 행함 신"),("矧", "하물며 신, 잇속 드러날 신"),("贐", "노자 신, 노수 신"),("哂", "빙그레 웃을 신, 비웃을 신"),("汛", "물뿌릴 신"),("頣", "눈들고 볼 신"),("脤", "사직제 지낸 고기 신"),("駪", "말 우물거릴 신, 빨리 걸을 신"),("噺", "이야기 신"),("囟", "숨구멍 신, 정수리 신"),("姺", "나라이름 신"),]),
("신가동", &[("新佳洞", "지명"),]),
("신가파", &[("新加坡", "싱가포르"),("新嘉坡", "싱가포르"),]),
("신건지동", &[("新乾芝洞", "지명"),]),
("신계동", &[("新契洞", "지명"),]),
("신곡동", &[("新谷洞", "지명"),]),
("신공덕동", &[("新孔德洞", "지명"),]),
("신관동", &[("新官洞", "지명"),("新觀洞", "지명"),]),
("신광면", &[("新光面", "지명"),]),
("신교동", &[("新校洞", "지명"),("新橋洞", "지명"),]),
("신기동", &[("新基洞", "지명"),("新機洞", "지명"),]),
("신기면", &[("新基面", "지명"),]),
("신길동", &[("新吉洞", "지명"),]),
("신남동", &[("新南洞", "지명"),]),
("신내동", &[("新內洞", "지명"),]),
("신니면", &[("新尼面", "지명"),]),
("신당동", &[("新堂洞", "지명"),("新塘洞", "지명"),]),
("신대동", &[("新垈洞", "지명"),]),
("신대방동", &[("新大方洞", "지명"),]),
("신덕동", &[("新德洞", "지명"),]),
("신덕면", &[("新德面", "지명"),]),
("신도림동", &[("新道林洞", "지명"),]),
("신동", &[("新洞", "지명"),("神洞", "지명"),]),
("신동면", &[("新東面", "지명"),]),
("신동읍", &[("新東邑", "지명"),]),
("신둔면", &[("新屯面", "지명"),]),
("신등면", &[("新等面", "지명"),]),
("신령면", &[("新寧面", "지명"),]),
("신룡동", &[("新龍洞", "지명"),]),
("신림동", &[("新林洞", "지명"),("神林洞", "지명"),]),
("신림면", &[("新林面", "지명"),]),
("신매", &[("新梅", "지명"),]),
("신명동", &[("新明洞", "지명"),]),
("신모산동", &[("新茅山洞", "지명"),]),
("신무동", &[("新武洞", "지명"),]),
("신문로", &[("新門路", "지명"),]),
("신방동", &[("新芳洞", "지명"),]),
("신백동", &[("新百洞", "지명"),]),
("신벽동", &[("新碧洞", "지명"),]),
("신봉동", &[("新鳳洞", "지명"),("新峰洞", "지명"),]),
("신부동", &[("新富洞", "지명"),]),
("신북면", &[("新北面", "지명"),]),
("신북읍", &[("新北邑", "지명"),]),
("신사동", &[("新寺洞", "지명"),("新沙洞", "지명"),]),
("신상동", &[("新上洞", "지명"),]),
("신생동", &[("新生洞", "지명"),]),
("신서동", &[("新西洞", "지명"),]),
("신서란", &[("新西蘭土", "뉴질랜드"),]),
("신서란토", &[("新西蘭", "뉴질랜드"),]),
("신서면", &[("新西面", "지명"),]),
("신석동", &[("申石洞", "지명"),]),
("신선동", &[("新仙洞", "지명"),]),
("신설동", &[("新說洞", "지명"),]),
("신성동", &[("新城洞", "지명"),]),
("신세동", &[("新世洞", "지명"),]),
("신수동", &[("新水洞", "지명"),("新樹洞", "지명"),]),
("신안군", &[("新安郡", "지명"),]),
("신안동", &[("新安洞", "지명"),]),
("신안면", &[("新安面", "지명"),]),
("신암동", &[("新岩洞", "지명"),]),
("신암면", &[("新岩面", "지명"),]),
("신양면", &[("新陽面", "지명"),]),
("신영동", &[("新榮洞", "지명"),("新營洞", "지명"),]),
("신외동", &[("新外洞", "지명"),]),
("신용동", &[("臣龍洞", "지명"),("新龍洞", "지명"),]),
("신원동", &[("新院洞", "지명"),]),
("신원면", &[("神院面", "지명"),]),
("신월동", &[("新月洞", "지명"),]),
("신음동", &[("新音洞", "지명"),]),
("신의면", &[("新衣面", "지명"),]),
("신인동", &[("信仁洞", "지명"),]),
("신일동", &[("新日洞", "지명"),]),
("신장동", &[("新長洞", "지명"),("新場洞", "지명"),("新壯洞", "지명"),]),
("신전동", &[("薪田洞", "지명"),]),
("신전면", &[("薪田面", "지명"),]),
("신정동", &[("新正洞", "지명"),("新井洞", "지명"),("新亭洞", "지명"),]),
("신지면", &[("薪智面", "지명"),]),
("신창동", &[("新昌洞", "지명"),("新倉洞", "지명"),]),
("신창면", &[("新昌面", "지명"),]),
("신천동", &[("信川洞", "지명"),("新川洞", "지명"),("新泉洞", "지명"),]),
("신촌", &[("新村", "지명"),]),
("신촌동", &[("新村洞", "지명"),]),
("신탄진동", &[("新灘津洞", "지명"),]),
("신태인읍", &[("新泰仁邑", "지명"),]),
("신파위", &[("津巴布韋", "짐바브웨"),]),
("신평동", &[("新平洞", "지명"),("新坪洞", "지명"),("薪坪洞", "지명"),]),
("신평면", &[("新平面", "지명"),]),
("신포동", &[("新浦洞", "지명"),]),
("신풍동", &[("新豊洞", "지명"),]),
("신풍면", &[("新豊面", "지명"),]),
("신하동", &[("新下洞", "지명"),]),
("신현동", &[("新峴洞", "지명"),]),
("신현읍", &[("新縣邑", "지명"),]),
("신호동", &[("新湖洞", "지명"),]),
("신효동", &[("新孝洞", "지명"),]),
("신흑동", &[("新黑洞", "지명"),]),
("신흥", &[("新興", "지명"),]),
("신흥동", &[("新興洞", "지명"),]),
("실", &[("室", "집 실, 아내 실, 방 실"),("失", "잃을 실, 그르칠 실"),("實", "열매 실"),("悉", "모두 실, 알 실"),("蟋", "귀뚜라미 실"),]),
("실안동", &[("實安洞", "지명"),]),
("실옥동", &[("實玉洞", "지명"),]),
("실촌읍", &[("實村邑", "지명"),]),
("심", &[("心", "마음 심"),("甚", "심할 심, 무엇 심"),("深", "깊을 심"),("沈", "성 심, 가라앉을 심"),("尋", "찾을 심"),("審", "살필 심"),("瀋", "즙낼"),("沁", "스며들 심, 물이름 심"),("諶", "참 심, 믿을 심"),("芯", "등심초 심"),("沉", "沈과 同字"),("潯", "물가 심"),("燖", "삶을 심"),("葚", "뽕나무 열매 심"),("鐔", "칼날 아래 코등이 심"),("鱏", "칼철갑상어 심"),("忄", "심방변"),]),
("심곡", &[("深谷", "지명"),]),
("심곡동", &[("深谷洞", "지명"),]),
("심곡본동", &[("深谷本洞", "지명"),]),
("심원면", &[("心元面", "지명"),]),
("심천면", &[("深川面", "지명"),]),
("십", &[("十", "열 십, 전부 십"),("拾", "十의 갖은자, 주울 십"),("什", "열 사람 십"),("辻", "네거리 십"),]),
("십정동", &[("十井洞", "지명"),]),
("쌍", &[("雙", "짝 쌍"),]),
("쌍계동", &[("雙溪洞", "지명"),]),
("쌍교동", &[("雙橋洞", "지명"),]),
("쌍령동", &[("雙嶺洞", "지명"),]),
("쌍림동", &[("雙林洞", "지명"),]),
("쌍림면", &[("雙林面", "지명"),]),
("쌍문동", &[("雙門洞", "지명"),]),
("쌍백면", &[("雙栢面", "지명"),]),
("쌍신동", &[("雙新洞", "지명"),]),
("쌍암동", &[("雙岩洞", "지명"),]),
("쌍용동", &[("雙龍洞", "지명"),]),
("쌍책면", &[("雙冊面", "지명"),]),
("쌍촌동", &[("雙村洞", "지명"),]),
("쌍치면", &[("雙置面", "지명"),]),
("씨", &[("氏", "성 씨"),]),
("아", &[("兒", "아이 아"),("我", "자기 아, 나 아"),("雅", "아담할 아"),("亞", "버금 아"),("餓", "주릴 아, 굶을 아"),("芽", "싹 아"),("牙", "어금니 아, 대장 기 아"),("阿", "언덕 아, 아름다울 아, 알랑거릴 아"),("衙", "마을 아"),("俄", "갑자기 아"),("訝", "맞아들일 아, 의심할 아"),("啞", "벙어리 아, 놀랄 아"),("鴉", "갈가마귀 아, 검을 아"),("峨", "산 높을 아"),("娥", "예쁠 아"),("鵝", "거위 아"),("莪", "지칭개 아, 새발쑥 아"),("蛾", "누에나방 아, 누에나비 아"),("迓", "마중할 아"),("疴", "앓을 아"),("哦", "놀람의 어조사 아"),("婀", "娿와 同字"),("丫", "가장귀 아"),("峩", "峨와 同字"),("娿", "아리따울 아"),("砑", "갈 아"),("笌", "대싹 아"),("錏", "투구의 목가림 아"),("鵞", "鵝와 同字"),("覀", "덮다"),]),
("아국", &[("俄國", "러시아"),]),
("아동동", &[("衙洞洞", "지명"),]),
("아라동", &[("我羅洞", "지명"),]),
("아라사", &[("俄羅斯", "러시아"),]),
("아란타", &[("阿蘭陀", "네덜란드"),]),
("아랄비아수장국연방", &[("亞剌比亞首長國聯邦", "아랍에미리트연방"),]),
("아류세리옥", &[("阿留世里屋", "알제리"),]),
("아만", &[("阿曼", "오만"),]),
("아매가", &[("牙買加", "자메이카"),]),
("아묵리가", &[("亞墨利加", "아메리카합중국"),]),
("아미니아", &[("亞美尼亞", "아르메니아"),]),
("아미동", &[("峨嵋洞", "지명"),]),
("아미리가", &[("亞米利加", "아메리카합중국"),]),
("아부한", &[("阿富汗", "아프가니스탄"),]),
("아부한사단", &[("阿富汗斯坦", "아프가니스탄"),]),
("아산면", &[("雅山面", "지명"),]),
("아산시", &[("牙山市", "지명"),]),
("아새배강", &[("阿塞拜疆", "아제르바이잔"),]),
("아양동", &[("鵝陽洞", "지명"),("娥洋洞", "지명"),]),
("아영면", &[("阿英面", "지명"),]),
("아이급", &[("阿爾及", "알제리"),]),
("아이연정", &[("亜爾然丁", "아르헨티나"),]),
("아이파니아", &[("阿爾巴尼亜", "알바니아"),]),
("아주동", &[("鵝州洞", "지명"),]),
("아지동", &[("阿芝洞", "지명"),]),
("아천동", &[("峨川洞", "지명"),]),
("아포읍", &[("牙浦邑", "지명"),]),
("아현동", &[("阿峴洞", "지명"),]),
("악", &[("樂", "풍류 악, 즐길 악"),("惡", "나쁠 악, 악할 악"),("岳", "큰 산 악"),("握", "잡을 악, 손아귀 악, 움켜질 악"),("愕", "놀랄 악, 억지부릴 악"),("堊", "흰 흙 악"),("顎", "턱 악, 턱뼈 악"),("嶽", "높은 산 악, 큰산 악"),("幄", "장막 악"),("渥", "두터울 악, 비젖을 악"),("鰐", "악어 악"),("鄂", "나라이름 악, 고을이름 악"),("鍔", "칼날끝 악"),("齷", "악착할 악, 악착같을 악"),("萼", "꽃받침 악"),("諤", "직언할 악"),("鶚", "물수리 악"),("咢", "놀랄 악"),("喔", "닭 우는 소리 악, 아첨해 웃는 소리 악"),("噩", "놀랄 악"),("卾", "윗턱 악"),("腭", "잇몸 악"),("偓", "거리낄 악"),("覨", "오래 볼 악"),("齶", "잇몸 악"),]),
("악양면", &[("岳陽面", "지명"),]),
("안", &[("安", "편안할 안, 어찌 안"),("案", "책상 안, 생각할 안"),("眼", "눈 안"),("顔", "顏과 同字, 얼굴 안"),("岸", "물가 언덕 안"),("雁", "鴈과 同字, 기러기 안"),("鞍", "안장 안"),("按", "살필 안, 어루만질 안"),("晏", "늦을 안, 편안할 안"),("鮟", "아귀 안, 천징어 안"),("鴈", "기러기 안"),("犴", "들개 안"),("贋", "가짜 안"),("桉", "案과 同字"),]),
("안가랍", &[("安哥拉", "앙골라"),]),
("안강읍", &[("安康邑", "지명"),]),
("안계면", &[("安溪面", "지명"),]),
("안곡동", &[("安谷洞", "지명"),]),
("안골동", &[("安骨洞", "지명"),]),
("안국동", &[("安國洞", "지명"),]),
("안기동", &[("安奇洞", "지명"),]),
("안남면", &[("安南面", "지명"),]),
("안내면", &[("安內面", "지명"),]),
("안내서랍", &[("委內瑞拉", "베네수엘라"),]),
("안덕면", &[("安德面", "지명"),]),
("안도이", &[("安道爾", "안도라"),]),
("안동", &[("安洞", "지명"),]),
("안동시", &[("安東市", "지명"),]),
("안락동", &[("安樂洞", "지명"),]),
("안량면", &[("安良面", "지명"),]),
("안림동", &[("安林洞", "지명"),]),
("안막동", &[("安幕洞", "지명"),]),
("안면읍", &[("安眠邑", "지명"),]),
("안민동", &[("安民洞", "지명"),]),
("안사면", &[("安寺面", "지명"),]),
("안산동", &[("安山洞", "지명"),("案山洞", "지명"),]),
("안산시", &[("安山市", "지명"),]),
("안서동", &[("安棲洞", "지명"),]),
("안석동", &[("安石洞", "지명"),]),
("안성면", &[("安城面", "지명"),]),
("안성시", &[("安城市", "지명"),]),
("안암동", &[("安岩洞", "지명"),]),
("안양동", &[("安養洞", "지명"),]),
("안양시", &[("安養市", "지명"),]),
("안영동", &[("安永洞", "지명"),]),
("안의면", &[("安義面", "지명"),]),
("안정면", &[("安定面", "지명"),]),
("안제과파포달", &[("安提瓜巴布達", "앤티가 바부다"),]),
("안좌면", &[("安佐面", "지명"),]),
("안중읍", &[("安仲邑", "지명"),]),
("안창동", &[("安倉洞", "지명"),]),
("안천면", &[("顔川面", "지명"),]),
("안청동", &[("安淸洞", "지명"),]),
("안평면", &[("安平面", "지명"),]),
("안풍동", &[("安豊洞", "지명"),]),
("안현동", &[("雁峴洞", "지명"),("鞍峴洞", "지명"),]),
("안흥동", &[("安興洞", "지명"),]),
("안흥면", &[("安興面", "지명"),]),
("알", &[("謁", "아뢸 알, 뵈올 알"),("閼", "막을"),("軋", "수레 삐걱거릴 알, 빼앗을 알"),("斡", "돌릴 알, 주선할 알"),("遏", "막을 알"),("訐", "들추어 낼 알"),("戞", "창 알"),("頞", "콧마루 알"),("揠", "뽑을 알"),("鴶", "뻐꾸기 알"),("嘎", "새소리 알"),("穵", "구멍 알"),("歹", "부서진뼈"),]),
("암", &[("暗", "어두울 암, 몰래 암, 어리석을 암"),("巖", "바위 암, 험할 암"),("癌", "종양 암"),("庵", "초막 암, 암자 암"),("闇", "어두울 암, 어리석을 암, 망루 암"),("岩", "巖의 俗字, 바위 암"),("菴", "암자 암, 쑥 암"),("唵", "머금을"),("諳", "욀 암"),("黯", "어두울 암"),("嵓", "바위 암, 가파를 암"),("馣", "향기로울 암"),("晻", "어두울 암"),("媕", "머뭇거릴 암"),("啽", "잠꼬대 암"),("腤", "고기 삶을 암"),("葊", "풀이름 암"),("蓭", "암자 암"),]),
("암객랄", &[("諳喀剌", "앙골라"),]),
("암곡동", &[("暗谷洞", "지명"),]),
("암남동", &[("岩南洞", "지명"),]),
("암사동", &[("岩寺洞", "지명"),]),
("암천면", &[("唵川面", "지명"),]),
("암태면", &[("岩泰面", "지명"),]),
("압", &[("壓", "누를 압"),("押", "수결 둘 압, 누를 압"),("鴨", "오리 압, 집오리 압"),("狎", "친근할 압, 업신여길 압, 익힐 압"),]),
("압구정동", &[("狎鷗亭洞", "지명"),]),
("압량면", &[("押梁面", "지명"),]),
("압촌동", &[("鴨村洞", "지명"),]),
("압해면", &[("押海面", "지명"),]),
("앙", &[("仰", "우러를 앙, 우러러볼 앙"),("殃", "재앙 앙"),("央", "가운데 앙"),("怏", "원망할 앙"),("昻", "오를 앙, 밝을 앙"),("鴦", "암원앙새 앙"),("秧", "모 앙"),("盎", "동이 앙"),("鞅", "가슴걸이 앙, 소고삐 앙"),("泱", "끝없을 앙"),("卬", "자기 앙"),("坱", "티끌 앙"),("昂", "밝을,높을"),]),
("앙성면", &[("仰城面", "지명"),]),
("애", &[("愛", "사랑 애"),("哀", "슬플 애, 가여울 애"),("涯", "물가 애"),("碍", "礙의 俗字, 그칠 애"),("埃", "티끌 애, 속세 애, 먼지 애"),("艾", "쑥 애"),("喝", "목 쉴 애"),("崖", "낭떠러지 애"),("隘", "좁을 애"),("靄", "아지랭이 애, 아지랑이 애"),("曖", "희미할 애, 흐릴 애"),("厓", "언덕 애, 물가 애"),("礙", "막을 애"),("藹", "화기로울 애"),("欸", "한숨쉴 애"),("騃", "어리석을 애, 말달릴 애"),("睚", "눈흘길 애"),("皚", "흴 애"),("瞹", "흐릿할 애"),("挨", "밀칠 애"),("僾", "어렴풋할 애"),("薆", "숨겨질 애"),("靉", "구름낄 애"),("捱", "막을 애"),("獃", "어리석을 애"),("磑", "맷돌 애"),("娭", "계집종 애"),("唉", "대답하는 소리 애"),("啀", "물어뜯을 애"),("噯", "트림할 애"),("崕", "崖와 同字"),("漄", "물가 애"),]),
("애급", &[("埃及", "이집트"),]),
("애란", &[("愛蘭", "아일랜드"),]),
("애란토", &[("愛蘭土", "아일랜드"),]),
("애륜", &[("愛倫", "아일랜드"),]),
("애사란", &[("愛斯蘭", "아이슬란드"),]),
("애새아비아", &[("埃塞俄比亜", "에티오피아"),]),
("애월읍", &[("涯月邑", "지명"),]),
("애이란", &[("愛爾蘭", "아일랜드"),]),
("애입다", &[("阨入多", "이집트"),]),
("애제백", &[("哀提伯", "에티오피아"),]),
("액", &[("額", "이마 액, 수량 액"),("厄", "재앙 액"),("液", "즙 액, 진액 액"),("腋", "겨드랑이 액"),("扼", "움켜쥘 액, 움겨질 액"),("縊", "목 맬 액"),("掖", "겨드랑이에 낄 액"),("阨", "막힐 액"),("搤", "움켜쥘 액"),("戹", "좁을 액"),("呝", "울 액"),]),
("액과다", &[("厄瓜多", "에콰도르"),]),
("액립특리아", &[("厄立特里亞", "에리트레아"),]),
("앵", &[("鶯", "꾀꼬리 앵"),("櫻", "앵두나무 앵"),("鸚", "앵무새 앵"),("罌", "술병 앵"),("嚶", "새 소리 앵"),("鷪", "꾀꼬리 앵"),("罃", "술병 앵"),("嫈", "예쁠 앵"),]),
("앵곡동", &[("鶯谷洞", "지명"),]),
("야", &[("夜", "밤 야"),("野", "들판 야"),("也", "단정의 어조사 야"),("若", "땅이름 야, 지혜(범어의 음역) 야, 반야 야"),("耶", "의문의 어조야 야, 아비 야, 어조사 야"),("惹", "끌릴 야, 어지러울 야, 이끌 야"),("倻", "땅이름 야"),("椰", "야자나무 야"),("爺", "아비 야, 노인 야, 노인존칭 야"),("冶", "단련할 야, 대장장이 야, 쇠불릴 야"),("揶", "희롱할 야"),("埜", "들판 야"),]),
("야로면", &[("冶爐面", "지명"),]),
("야문", &[("也門", "예멘"),]),
("야사동", &[("也史洞", "지명"),]),
("야음동", &[("也音洞", "지명"),]),
("야탑", &[("野塔", "지명"),]),
("야흥동", &[("也興洞", "지명"),]),
("약", &[("弱", "약할 약, 어릴 약"),("藥", "약 약, 약할 약"),("約", "대략 약, 맹세할 약, 간소할 약, 맺을 약, 기약할 약"),("若", "같을 약, 자네 약, 만약 약, 반야 약"),("略", "간략할 약, 노략질할 약, 잔꾀 약"),("躍", "뛸 약"),("掠", "노략질할 약"),("葯", "꽃밥 약, 부들풀싹 약"),("蒻", "구약나물 약, 부들속 약"),("鑰", "자물쇠 약"),("籥", "피리 약, 잠글 약"),("禴", "종묘의 여름제사 약"),("爚", "스러질 약"),("篛", "죽순 약"),("鰯", "멸치 약, 정어리 약"),("龠", "피리 약"),("鶸", "댓닭 약, 투계 약"),]),
("약단", &[("約旦", "요르단"),]),
("약대동", &[("若大洞", "지명"),]),
("약목면", &[("若木面", "지명"),]),
("약사동", &[("藥司洞", "지명"),("藥泗洞", "지명"),]),
("약산면", &[("藥山面", "지명"),]),
("양", &[("羊", "양 양"),("兩", "두 량, 둘 양"),("陽", "볕 양, 드러낼 양, 시월 양, 거짓 양"),("洋", "큰 바다 양, 넘칠 양"),("良", "어질 량, 좋을 량, 남편 량"),("養", "기를 양, 다스릴 양, 봉양할 양"),("量", "헤아릴 량, 용량 량"),("讓", "사양할 양"),("揚", "드높일 양, 칭찬할 양, 들날릴 양"),("凉", "서늘할 량"),("梁", "들보 량, 다리 량"),("樣", "모양 양, 모범 양, 본보기 양"),("糧", "양식 량, 곡식 양"),("楊", "갯버들 양"),("壤", "흙 양, 풍년들 양, 기름진흙 양"),("諒", "헤아릴 량, 믿을 양"),("亮", "밝을 량, 임금의 상중 량"),("襄", "오를 양, 장사지낼 양, 도울 양"),("孃", "계집아이 양, 아씨 양"),("瘍", "머리헐 양, 종기 양"),("攘", "물리칠 양, 빼앗을 양, 밀칠 양"),("釀", "술 빚을 양"),("恙", "근심 양"),("禳", "푸닥거리할 양, 기도할 양"),("痒", "가려울 양, 옴 양"),("佯", "거짓 양, 어정거릴 양, 속일 양"),("暘", "해 돋을 양, 해돋이 양"),("穰", "풍년들 양, 볏짚 양"),("瀁", "물결 일렁일 양, 내이름 양"),("敭", "오를 양, 칭찬할 양"),("煬", "구울 양, 녹일 양"),("癢", "가려울 양"),("驤", "날뛰는 말 양"),("漾", "물결 출렁거릴 양"),("颺", "날릴 양, 높일 양"),("徉", "배회할 양"),("鑲", "거푸집 속 양"),("瀼", "이슬 많은 모양 양, 강이름 양"),("烊", "구울 양, 녹일 양"),("眻", "눈 아름다울 양"),("蘘", "양하 양"),("輰", "상여수레 양"),]),
("양감면", &[("楊甘面", "지명"),]),
("양강면", &[("陽江面", "지명"),]),
("양고동", &[("良苽洞", "지명"),]),
("양곡동", &[("梁谷洞", "지명"),]),
("양구군", &[("楊口郡", "지명"),]),
("양구읍", &[("楊口邑", "지명"),]),
("양남면", &[("陽南面", "지명"),]),
("양대동", &[("良垈洞", "지명"),]),
("양덕동", &[("陽德洞", "지명"),("良德洞", "지명"),]),
("양도면", &[("良道面", "지명"),]),
("양동", &[("陽洞", "지명"),("良洞", "지명"),]),
("양동면", &[("楊東面", "지명"),]),
("양림동", &[("楊林洞", "지명"),]),
("양보면", &[("良甫面", "지명"),]),
("양북면", &[("陽北面", "지명"),]),
("양사면", &[("兩寺面", "지명"),]),
("양산동", &[("陽山洞", "지명"),("良山洞", "지명"),("楊山洞", "지명"),]),
("양산면", &[("陽山面", "지명"),]),
("양산시", &[("梁山市", "지명"),]),
("양상동", &[("楊上洞", "지명"),]),
("양서면", &[("楊西面", "지명"),]),
("양성면", &[("陽城面", "지명"),]),
("양양군", &[("襄陽郡", "지명"),]),
("양양읍", &[("襄陽邑", "지명"),]),
("양재동", &[("良才洞", "지명"),]),
("양전동", &[("良田洞", "지명"),]),
("양정동", &[("養正洞", "지명"),("楊亭洞", "지명"),]),
("양주군", &[("楊州郡", "지명"),]),
("양주읍", &[("楊州邑", "지명"),]),
("양지", &[("陽地", "지명"),]),
("양지면", &[("陽智面", "지명"),]),
("양천구", &[("陽川區", "지명"),]),
("양천동", &[("陽川洞", "지명"),]),
("양촌동", &[("良村洞", "지명"),("梁村洞", "지명"),]),
("양촌면", &[("陽村面", "지명"),]),
("양평군", &[("楊平郡", "지명"),]),
("양평동", &[("楊坪洞", "지명"),]),
("양평읍", &[("楊平邑", "지명"),]),
("양호동", &[("陽湖洞", "지명"),]),
("양화동", &[("楊花洞", "지명"),]),
("양화면", &[("良花面", "지명"),]),
("어", &[("魚", "물고기 어"),("語", "말씀 어"),("漁", "물고기 잡을 어"),("於", "방향의 어조사 어, 대신할 어"),("御", "거느릴 어, 모실 어"),("禦", "막을 어, 그칠 어"),("圄", "가둘 어, 옥 어"),("瘀", "어혈질 어"),("馭", "말 부릴 어"),("齬", "이 어긋날 어"),("圉", "마부 어, 변방 어"),("飫", "먹기 싫을 어, 배부를 어"),("敔", "금할 어, 풍류그칠 어"),("淤", "앙금 어, 진흙 어"),]),
("어곡동", &[("魚谷洞", "지명"),]),
("어남동", &[("於南洞", "지명"),]),
("어달동", &[("於達洞", "지명"),]),
("어룡동", &[("魚龍洞", "지명"),]),
("어모면", &[("禦侮面", "지명"),]),
("어물동", &[("於勿洞", "지명"),]),
("어방동", &[("漁防洞", "지명"),]),
("어상천면", &[("魚上川面", "지명"),]),
("어양동", &[("於陽洞", "지명"),]),
("어은동", &[("魚隱洞", "지명"),]),
("어현동", &[("漁峴洞", "지명"),]),
("억", &[("億", "억 억, 편안할 억, 이바지할 억, 헤아릴 억, 인민 억"),("憶", "생각 억, 기억할 억"),("抑", "누를 억, 억울할 억"),("臆", "가슴 억, 가득할 억"),("檍", "참죽나무 억, 박달나무 억, 싸리나무 억"),("繶", "땋은 노 억"),]),
("언", &[("言", "말씀 언, 자기 언, 우뚝할 언"),("焉", "어찌 언, 의심쩍을 언, 어조사 언"),("彦", "彥과 同字, 선비 언"),("諺", "상말 언"),("堰", "방죽 언"),("偃", "자빠질 언, 누울 언"),("讞", "죄 의논할 언"),("嫣", "생긋생긋 웃을 언"),("鄢", "땅이름 언"),("鼴", "두더쥐 언, 소 같은 큰 쥐 언"),("匽", "숨길 언, 길 곁 언, 한데 뒷간 언"),("鼹", "鼴과 同字"),("傿", "鄢과 同字"),]),
("언양읍", &[("彦陽邑", "지명"),]),
("언하동", &[("彦河洞", "지명"),]),
("얼", &[("蘖", "그루터기 얼, 싹 얼"),("孼", "첩자식 얼, 요물 얼, 첩의자식 얼"),("臬", "법 얼, 문지방 얼, 과녁 얼"),]),
("엄", &[("嚴", "굳셀 엄, 공경할 엄, 엄할 엄"),("掩", "거둘 엄, 가릴 엄"),("奄", "문득 엄, 가릴 엄, 그칠 엄, 오랠 엄, 문뜩 엄"),("儼", "공경할 엄, 머리쳐들 엄"),("俺", "자기 엄, 클 엄"),("淹", "담글 엄, 오래머물 엄"),("广", "바윗집 엄"),("閹", "고자 엄, 내시 엄"),("崦", "해 지는 산 이름 엄"),("罨", "그물 엄"),("曮", "해 다니는 길 엄"),("醃", "절일 엄, 김치 엄"),("厂", "언덕"),]),
("엄궁동", &[("嚴弓洞", "지명"),]),
("엄다면", &[("嚴多面", "지명"),]),
("엄정면", &[("嚴政面", "지명"),]),
("업", &[("業", "일 업, 위태할 업, 씩씩할 업, 벌써 업, 공경할 업"),("嶪", "산이 높고 웅장할 업, 산높은모양 업"),("鄴", "땅이름 업, 성씨 업"),("嶫", "嶪과 同字"),]),
("업성동", &[("業成洞", "지명"),]),
("에", &[("恚", "성낼 에, 원망할 에"),("曀", "음산할 에, 가리울 에"),]),
("엔", &[("円", "일본화폐단위"),]),
("여", &[("女", "계집 녀, 시집보낼 녀"),("如", "같을 여, 만약 여, 어떠할 여, 이를 여"),("餘", "남을 여, 나라이름 여"),("與", "너울너울할 여, 더불어 여, 같을 여, 미칠 여"),("余", "자기 여, 남을 여, 나 여"),("汝", "물 이름 여, 물에 젖을 여, 너 여"),("旅", "나그네 려, 베풀 려"),("予", "자기 여, 나 여"),("麗", "고울 려, 빛날 려, 베풀 려"),("輿", "수레바탕 여, 짐질 여"),("勵", "힘쓸 려, 가다듬을 려"),("呂", "풍류 려, 등골뼈 려, 성씨 려"),("廬", "초가 려, 움막 려, 원두막 여"),("礪", "돌 단단할 려, 숫돌 여"),("驪", "가라말 려, 나라이름 려, 산이름 려, 검은 말 여"),("閭", "마을 려, 이문 여"),("黎", "무리 려, 동틀 려"),("濾", "씻을 려, 맑을 려"),("歟", "그런가할 어조사 여"),("轝", "輿와 同字, 가마 여"),("茹", "띠 뿌리 여, 받을 여, 헤아릴 여"),("璵", "보배옥 여"),("艅", "나룻배 여, 나뭇배 여"),("礖", "여돌 여, 섞인돌 여"),("舁", "마주들 여"),]),
("여남동", &[("汝南洞", "지명"),]),
("여산면", &[("礪山面", "지명"),]),
("여서동", &[("麗西洞", "지명"),]),
("여수동", &[("麗水洞", "지명"),]),
("여수시", &[("麗水市", "지명"),]),
("여월동", &[("如月洞", "지명"),]),
("여의도동", &[("汝矣島洞", "지명"),]),
("여의동", &[("如意洞", "지명"),]),
("여좌동", &[("余佐洞", "지명"),]),
("여주군", &[("驪州郡", "지명"),]),
("여주읍", &[("驪州邑", "지명"),]),
("여천동", &[("餘川洞", "지명"),("麗川洞", "지명"),("呂川洞", "지명"),]),
("여파눈", &[("黎巴嫩", "레바논"),]),
("여항면", &[("艅航面", "지명"),]),
("역", &[("力", "힘 력, 부지런할 력"),("亦", "또 역, 모두 역"),("易", "바꿀 역"),("逆", "거스를 역"),("歷", "지낼 력, 겪을 력, 지날 역"),("役", "부릴 역, 국경 지킬 역"),("驛", "잇닿을 역, 쌀 뾰족뾰족할 역, 역말집 역"),("譯", "통변할 역, 번역할 역"),("曆", "셀 력, 세월 력, 책력 역"),("域", "경계 역, 범위 역, 지경 역"),("疫", "염병 역"),("繹", "삭일 역, 베풀 역, 실 끝 찾을 역"),("轢", "수레바퀴에 치일 력, 서로 부닥칠 력, 수레바퀴에 치는 역"),("嶧", "연달아 있는 산 역"),("懌", "기꺼울 역"),("閾", "문지방 역"),("淢", "빨리 흐를 역"),]),
("역곡동", &[("驛谷洞", "지명"),]),
("역동", &[("驛洞", "지명"),]),
("역북동", &[("驛北洞", "지명"),]),
("역삼동", &[("驛三洞", "지명"),]),
("역촌동", &[("驛村洞", "지명"),]),
("연", &[("年", "해 년, 나이 년, 나아갈 년"),("然", "불사를 연, 그러할 연, 허락할 연, 그러나 연, 그럴 연"),("連", "이을 련, 끌릴 련, 연할 연"),("煙", "연기 연"),("練", "이길 련, 익힐 련, 겪을 련"),("硏", "연마할 연, 갈 연"),("鍊", "불린 쇠 련, 단련할 련, 쇠불릴 연"),("宴", "잔치할 연, 편안할 연"),("延", "미칠 연, 닿을 연"),("緣", "인연 연, 서두를 연"),("演", "펼칠 연, 긴 물줄기 연, 통할 연, 윤택할 연, 넓힐 연"),("憐", "불쌍할 련, 사랑할 련, 가련할 연"),("戀", "생각할 련, 사모할 련"),("聯", "잇닿을 련, 관계할 련, 연할 연"),("蓮", "연밥 련, 연꽃 련"),("燃", "불사를 연, 연등절 연, 불탈 연"),("軟", "부드러울 연, 연할 연"),("淵", "못 연, 깊을 연, 북소리 둥둥할 연, 모래톱 연"),("燕", "제비 연, 편안할 연, 잔치 연, 나라이름 연"),("沿", "물 따라 내려갈 연, 좇을 연"),("鉛", "납 연, 분 연"),("衍", "성할 연, 넓을 연, 물이 넘칠 연, 상자 연, 아름다울 연, 흐를 연"),("捐", "버릴 연, 병들어 죽을 연"),("硯", "벼루 연, 돌 연"),("漣", "물 놀이칠 련, 눈물 줄줄 흘릴 련"),("姸", "고을 연, 사랑스러울 연, 고울 연"),("筵", "대자리 연"),("輦", "당길 련, 궁중의 길 련"),("椽", "서까래 연"),("鳶", "솔개 연"),("撚", "잡을 년, 닦을 년, 밟을 년, 손 끝으로 비빌 년"),("煉", "쇠 불릴 련, 반죽할 련"),("烟", "煙과 同字, 연기 연"),("涓", "물방울 떨어질 연, 조촐할 연"),("璉", "종묘 제기 련"),("沇", "물 졸졸 흐를 연, 물흐르는모양 연"),("娟", "어여쁠 연, 춤추는 모양 연"),("涎", "침 연, 물 졸졸 흐를 연"),("堧", "빈 땅 연, 변두리땅 연"),("嚥", "침 삼킬 연, 목구멍 연"),("挻", "당길 연, 달아날 연, 손바닥으로 칠 연"),("秊", "年의 本字, 해 연"),("縯", "길 연, 늘일 연"),("讌", "잔치 연, 모여 말할 연"),("臙", "목구멍 연, 연지 연"),("莚", "만연할 연, 풀 이름 연"),("掾", "아전 연, 기인할 연"),("悁", "분할 연, 근심할 연"),("兗", "고을이름 연, 믿을 연, 단정할 연"),("埏", "땅 가장자리 연"),("渷", "물 이름 연"),("鷰", "제비 연, 씨름 연"),("嬿", "아름다울 연"),("囦", "물 깊을 연"),("曣", "더울 연, 청명할 연"),("櫞", "연나무 연"),("蜵", "우렁찰 연, 벌레 이름 연"),]),
("연건동", &[("蓮建洞", "지명"),]),
("연경동", &[("硏經洞", "지명"),]),
("연곡면", &[("連谷面", "지명"),]),
("연기군", &[("燕岐郡", "지명"),]),
("연남동", &[("延南洞", "지명"),]),
("연덕동", &[("淵德洞", "지명"),]),
("연도동", &[("椽島洞", "지명"),]),
("연동", &[("蓮洞", "지명"),]),
("연등동", &[("蓮燈洞", "지명"),]),
("연마", &[("璉馬", "덴마크"),]),
("연무동", &[("鍊武洞", "지명"),]),
("연무읍", &[("鍊武邑", "지명"),]),
("연산동", &[("連山洞", "지명"),("蓮山洞", "지명"),]),
("연산면", &[("連山面", "지명"),]),
("연수구", &[("延壽區", "지명"),]),
("연수동", &[("連守洞", "지명"),("延壽洞", "지명"),]),
("연암동", &[("蓮岩洞", "지명"),]),
("연원동", &[("蓮院洞", "지명"),]),
("연일읍", &[("延日邑", "지명"),]),
("연정", &[("蓮井", "지명"),]),
("연제구", &[("蓮堤區", "지명"),]),
("연제동", &[("蓮堤洞", "지명"),]),
("연지동", &[("蓮智洞", "지명"),("蓮池洞", "지명"),]),
("연천군", &[("漣川郡", "지명"),]),
("연천읍", &[("漣川邑", "지명"),]),
("연초면", &[("延草面", "지명"),]),
("연축동", &[("蓮丑洞", "지명"),]),
("연평면", &[("延坪面", "지명"),]),
("연풍면", &[("延豊面", "지명"),]),
("연향동", &[("蓮香洞", "지명"),]),
("연호동", &[("蓮湖洞", "지명"),]),
("연희동", &[("連喜洞", "지명"),("延禧洞", "지명"),]),
("열", &[("說", "기꺼울 열, 말씀 열"),("熱", "뜨거울 열, 쏠릴 열, 더울 열"),("列", "벌릴 렬, 무리에 들어갈 렬, 항렬 렬, 베풀 렬, 벌일 열"),("悅", "즐거울 열, 복종할 열, 성씨 열, 기뻐할 열"),("烈", "불 활활 붙을 렬, 빛날 렬, 업적 렬, 아름다울 렬, 사나울 렬, 매울 열"),("劣", "용렬할 렬, 못날 렬, 어릴 렬, 서툴 렬"),("裂", "찢어질 렬, 비단 자투리 렬, 찢을 열"),("閱", "겪을 열, 군대 점호할 열, 용납할 열, 볼 열"),("咽", "목 멜 열, 막힐 열"),("涅", "극락갈"),("噎", "목 멜 열"),]),
("열지돈사등", &[("列支敦士登", "리히텐슈타인"),]),
("염", &[("念", "생각할 념, 읽을 념, 스물 념, 대단히 짧은시각 념"),("炎", "불꽃 염, 임금의 호 염"),("鹽", "소금 염, 절일 염, 후렴 염"),("染", "꼭두서니 염, 물들일 염"),("廉", "맑을 렴, 조촐할 렴, 청렴할 렴, 살필 렴"),("厭", "넉넉할 염, 아름다울 염, 게으를 염, 만족할 염, 미워할 염, 편안할 염"),("閻", "마을 염, 항간 염, 저승 염, 마을안의 문 염"),("焰", "불당길"),("簾", "발 렴"),("艶", "고울 염, 얼굴 탐스러울 염"),("殮", "염할 염"),("苒", "풀 우거질 염, 덧없을 염, 풀 우거진 모양 염"),("髥", "구레나룻 염"),("琰", "아름다운 옥 염, 비취옥 염"),("捻", "손가락으로 찍을 념"),("塩", "鹽의 俗字"),("冉", "가는 털 늘어질 염, 남생이 등 언저리 염, 침노할 염"),("灎", "灩의 俗字"),("饜", "싫을 염, 물릴 염"),("魘", "잠꼬대할 염"),("灩", "물 그득할 염, 물결 출렁거릴 염"),("黶", "검은 사마귀 염"),("扊", "문 빗장 염"),("檿", "산뽕나무 염"),("懕", "편안할 염"),]),
("염곡동", &[("廉谷洞", "지명"),]),
("염리동", &[("鹽里洞", "지명"),]),
("염산면", &[("鹽山面", "지명"),]),
("염창동", &[("鹽倉洞", "지명"),]),
("염치읍", &[("鹽峙邑", "지명"),]),
("염포동", &[("鹽浦洞", "지명"),]),
("엽", &[("葉", "잎 엽, 세대 엽, 성씨 엽"),("獵", "사냥할 렵, 진동할 렵, 어긋날 렵, 바람소리 렵"),("燁", "불 이글글할 엽, 번쩍번쩍할 엽, 번쩍거릴 엽"),("曄", "빛날 엽, 번개 번쩍거릴 엽"),("爗", "불 이글글할 엽, 번쩍번쩍할 엽"),("熀", "불빛 이글이글할 녑"),("靨", "웃는 볼 옴쏙 들어갈 엽, 얼굴의 검은 사마귀 엽"),("曅", "曄과 同字"),]),
("영", &[("榮洞", "지명"),("永", "길 영, 오랠 영"),("英", "꽃부리 영, 영웅 영, 구름 뭉게뭉게 일어날 영, 아름다울 영"),("令", "하여금 령, 시킬 령, 가령 령, 개 목소리 령, 벼슬이름 령"),("領", "옷깃 령, 고개 령, 거느릴 령, 받을 령"),("榮", "영화로울 영, 오동나무 영, 추녀 영, 꽃다울 영"),("迎", "맞을 영"),("營", "지을 영, 헤아릴 영, 다스릴 영, 진 영"),("寧", "편안할 녕, 차라리 녕, 어찌 녕"),("靈", "신령 령, 혼백 령, 좋을 령"),("嶺", "고개 령, 봉우리 령, 산고개 영"),("影", "그림자 영, 형상 영"),("詠", "읊을 영"),("映", "비칠 영, 빛날 영"),("泳", "헤엄칠 영"),("零", "부서질 령, 비뚝비뚝 떨어질 령, 셈 나머지 령"),("盈", "가득할 영, 넘칠 영, 물 흐를 영, 찰 영"),("塋", "무덤 영, 산소 영"),("鈴", "방울 령"),("瑛", "옥빛 영, 수정 영, 옥광채 영"),("玲", "옥소리 쟁그렁거릴 령, 아롱아롱할 령, 정교할 령, 금옥소리 영"),("囹", "감옥 령"),("暎", "비칠 영"),("穎", "이삭 영, 송곳 끝 영, 빼어날 영"),("纓", "갓끈 영, 말 가슴걸이 영, 얽힐 영"),("瑩", "귀막이 옥 영, 밝을 영"),("聆", "들을 령, 깨달을 령"),("怜", "영리할 령"),("楹", "기둥 영, 하관들 영"),("瀛", "큰 바다 영, 신선 사는 산 영"),("潁", "물 이름 영, 성씨 영, 강이름 영"),("嶸", "산 높을 영, 산이험한 영"),("霙", "눈꽃 영, 구름 피어오를 영"),("獰", "영악할"),("濚", "물 돌아나갈 영, 물도는 모양 영"),("渶", "물 맑을 영"),("瀯", "물소리 영, 물 돌아나갈 영, 물웅덩이 영"),("羚", "영양 령, 큰 뿔 양 령"),("煐", "빛날 영"),("瓔", "옥돌 영, 구슬 목걸이 영"),("鍈", "방울소리 영"),("嬰", "어릴 영, 더할 영, 머리치장할 영, 물요괴 영, 갓난아이 영"),("咏", "노래할 영, 읊을 영"),("贏", "이문 남길 영, 멜 영, 자랄 영"),("縈", "얽힐 영, 맬 영"),("嬴", "성씨 영, 풀어낼 영, 가득할 영, 아름다울 영"),("郢", "땅이름 영"),("癭", "목 혹 영"),("韺", "풍류이름 영"),("浧", "잠길 영, 앙금 영"),("濴", "물 졸졸 흐를 영"),("碤", "물 속 돌 영"),("蠑", "도마뱀 영"),]),
("영격란", &[("英格蘭", "잉글랜드"),]),
("영광군", &[("靈光郡", "지명"),]),
("영광읍", &[("靈光邑", "지명"),]),
("영국", &[("英國", "잉글랜드"),]),
("영길리", &[("英吉利", "잉글랜드"),]),
("영남동", &[("嶺南洞", "지명"),]),
("영남면", &[("永南面", "지명"),]),
("영덕군", &[("盈德郡", "지명"),]),
("영덕읍", &[("盈德邑", "지명"),]),
("영도구", &[("影島區", "지명"),]),
("영동", &[("榮洞", "지명"),]),
("영동군", &[("永同郡", "지명"),]),
("영동읍", &[("永同邑", "지명"),]),
("영등동", &[("永登洞", "지명"),]),
("영등포구", &[("永登浦區", "지명"),]),
("영등포동", &[("永登浦洞", "지명"),]),
("영랑동", &[("永郞洞", "지명"),]),
("영북면", &[("永北面", "지명"),]),
("영산동", &[("榮山洞", "지명"),]),
("영산면", &[("靈山面", "지명"),]),
("영선동", &[("瀛仙洞", "지명"),]),
("영성동", &[("寧城洞", "지명"),]),
("영순면", &[("永順面", "지명"),]),
("영신동", &[("永新洞", "지명"),]),
("영암군", &[("靈岩郡", "지명"),]),
("영암읍", &[("靈岩邑", "지명"),]),
("영양군", &[("英陽郡", "지명"),]),
("영양읍", &[("英陽邑", "지명"),]),
("영오면", &[("永吾面", "지명"),]),
("영운동", &[("永雲洞", "지명"),]),
("영원면", &[("永元面", "지명"),]),
("영월군", &[("寧越郡", "지명"),]),
("영월읍", &[("寧越邑", "지명"),]),
("영인면", &[("靈仁面", "지명"),]),
("영주동", &[("榮州洞", "지명"),("瀛州洞", "지명"),]),
("영주시", &[("榮州市", "지명"),]),
("영중면", &[("永中面", "지명"),]),
("영천동", &[("榮川洞", "지명"),("靈泉洞", "지명"),]),
("영천시", &[("永川市", "지명"),]),
("영춘면", &[("永春面", "지명"),]),
("영통", &[("靈通", "지명"),]),
("영파동", &[("暎波洞", "지명"),]),
("영평동", &[("寧坪洞", "지명"),]),
("영해동", &[("榮海洞", "지명"),]),
("영해면", &[("寧海面", "지명"),]),
("영현면", &[("永縣面", "지명"),]),
("영화동", &[("永和洞", "지명"),("迎華洞", "지명"),]),
("영흥면", &[("靈興面", "지명"),]),
("예", &[("禮", "예도 례, 인사 례"),("例", "본보기 례, 견줄 례, 대부분 례, 법식 예"),("藝", "재주 예, 글 예, 가늠할 예, 극진할 예, 심을 예"),("豫", "기쁠 예, 편안할 예, 미리 예"),("譽", "칭찬할 예, 이름날 예, 즐길 예, 기릴 예"),("銳", "날카로울 예, 까끄라기 예"),("預", "미리 예, 참여할 예"),("睿", "슬기로울 예, 밝을 예, 통할 예"),("泄", "내칠 예, 날개 훨훨칠 예, 흩을 예"),("醴", "단술 례, 고을이름 례"),("濊", "흐릴 예, 물 넘칠 예, 물넘치는 모양 예"),("芮", "풀 뾰족뾰족할 예, 물가 예, 방패끈 예, 나라이름 예, 성씨 예"),("詣", "이를 예, 나아갈 예, 학문 통달할 예"),("曳", "끌 예, 당길 예, 천천히 할 예"),("裔", "옷 뒷자락 예, 변방 예, 후손 예"),("穢", "더러울 예, 거칠 예"),("洩", "퍼질 예, 날개 훨훨칠 예"),("刈", "풀 벨 예, 죽일 예"),("乂", "풀 벨 예, 다스릴 예"),("倪", "어릴 예, 도울 예, 끝 예"),("霓", "암무지개 예"),("猊", "사자 예"),("汭", "물 이름 예, 물 굽이 예"),("蘂", "蕊와 同字, 꽃술 예"),("叡", "밝을 예, 임금 예, 어질 예"),("隸", "종 례, 노비 례, 검열할 례"),("翳", "어조사 예, 깃 일산 예, 가려 숨길 예, 새이름 예"),("繄", "검푸른 비단 예, 탄식하는 소리 예"),("蕊", "꽃술 예, 꽃 예"),("鯢", "암고래 예"),("獩", "민족이름 예"),("枘", "자루 예"),("拽", "당길 예"),("蜺", "말매미 예, 암무지개 예"),("薉", "더러울 예"),("鷖", "갈매기 예, 봉황 예"),("蕋", "蕊의 俗字"),("蚋", "모기 예"),("囈", "잠꼬대할 예, 헛소리할 예"),("瞖", "눈에 백태 낄 예"),("麑", "아기사슴 예, 사자 예"),("嫛", "유순할 예, 갓난아이 예"),("掜", "부칠 예, 비길 예, 잡을 예, 당길 예"),("苅", "벨 예, 자를 예"),]),
("예곡동", &[("禮谷洞", "지명"),]),
("예관동", &[("藝館洞", "지명"),]),
("예산군", &[("禮山郡", "지명"),]),
("예산읍", &[("禮山邑", "지명"),]),
("예소호", &[("礼素戸", "레소토"),]),
("예안면", &[("禮安面", "지명"),]),
("예장동", &[("藝場洞", "지명"),]),
("예지동", &[("禮智洞", "지명"),]),
("예천군", &[("醴泉郡", "지명"),]),
("예천동", &[("禮川洞", "지명"),]),
("예천읍", &[("醴泉邑", "지명"),]),
("오", &[("五", "다섯 오"),("午", "낮 오, 남쪽 오, 말 오"),("惡", "미워할 오, 부끄러울 오, 악할 오"),("吾", "자기 오, 아들 오, 나 오"),("誤", "그릇할 오"),("烏", "까마귀 오, 검을 오, 어찌 오, 탄식할 오"),("悟", "깨우칠 오, 깨달을 오"),("吳", "오나라 오, 큰소리 지를 오, 성씨 오"),("嗚", "탄식할 오"),("汚", "더러울 오, 웅덩이 오"),("娛", "즐거울 오"),("傲", "업신여길 오, 즐길 오, 거만할 오"),("奧", "속 오, 비밀 오, 깊을 오"),("梧", "머귀나무 오, 버틸 오, 오동나무 오"),("墺", "방 구들 오, 물가 언덕 오, 뭍 오"),("伍", "五의 갖은자, 다섯 사람 오, 무리 오"),("寤", "잠 깨어날 오, 깨달을 오, 잠깰 오"),("懊", "원망할 오, 번뇌할 오, 사랑할 오"),("澳", "깊을 오, 물 이름 오"),("鰲", "큰 자라 오"),("鼇", "매우 큰 자라 오"),("晤", "밝을 오, 만날 오"),("敖", "희롱할 오, 거만할 오, 오만할 오"),("塢", "산 언덕 오, 마을 오"),("熬", "볶을 오, 애 끓는 소리 오"),("獒", "사나운 개 오, 호박개 오"),("筽", "버들 고리 오"),("蜈", "지네 오"),("俉", "맞이할 오"),("旿", "밝을 오, 대낮 오"),("忤", "거스릴 오, 미워할 오"),("嗷", "여럿이 걱정할 오"),("媪", "할미 오, 땅귀신 오"),("汙", "汚와 同字"),("遨", "노닐 오"),("鏖", "무찌를 오, 구리동이 오"),("襖", "도포 오"),("驁", "준마 오, 깔볼 오"),("窹", "아궁이 오"),("迕", "만날 오, 어길 오"),("鼯", "날다람쥐 오"),("聱", "못 들은채 할 오, 말 더듬거릴 오"),("唔", "글 읽는 소리 오"),("慠", "거만할 오"),("謷", "중얼거릴 오, 거만할 오"),("隩", "감출 오, 물가 언덕 오"),("捂", "부닥칠 오, 거스릴 오"),("鏊", "번철 오"),("仵", "짝 오, 같을 오"),("俣", "갈래질 오"),("圬", "흙손 오"),("噁", "성낼 오"),("嫯", "업신여길 오"),("茣", "차조기 오"),]),
("오가면", &[("吾可面", "지명"),]),
("오곡골", &[("油谷洞", "지명"),]),
("오곡동", &[("五谷洞", "지명"),("梧谷洞", "지명"),]),
("오곡면", &[("梧谷面", "지명"),]),
("오극란", &[("烏克蘭", "우크라이나"),]),
("오금동", &[("五禁洞", "지명"),("梧琴洞", "지명"),]),
("오남", &[("梧南", "지명"),]),
("오남동", &[("吾南洞", "지명"),]),
("오대동", &[("午臺洞", "지명"),]),
("오동", &[("梧洞", "지명"),]),
("오동동", &[("午東洞", "지명"),("梧東洞", "지명"),]),
("오등동", &[("梧登洞", "지명"),]),
("오라동", &[("吾羅洞", "지명"),]),
("오량동", &[("五良洞", "지명"),]),
("오려차", &[("吳呂茶", "크로아티아"),]),
("오룡동", &[("五龍洞", "지명"),]),
("오류동", &[("五柳洞", "지명"),("梧柳洞", "지명"),]),
("오륜동", &[("五倫洞", "지명"),("五輪洞", "지명"),]),
("오림동", &[("五林洞", "지명"),]),
("오목천동", &[("梧木川洞", "지명"),]),
("오미동", &[("五味洞", "지명"),]),
("오부면", &[("梧釜面", "지명"),]),
("오분동", &[("梧紛洞", "지명"),]),
("오사동", &[("五士洞", "지명"),]),
("오산동", &[("烏山洞", "지명"),]),
("오산면", &[("五山面", "지명"),("梧山面", "지명"),]),
("오산시", &[("烏山市", "지명"),]),
("오선동", &[("鰲仙洞", "지명"),]),
("오성면", &[("梧城面", "지명"),]),
("오쇠동", &[("五釗洞", "지명"),]),
("오수동", &[("五樹洞", "지명"),]),
("오수면", &[("獒樹面", "지명"),]),
("오야", &[("梧野", "지명"),]),
("오운동", &[("五雲洞", "지명"),]),
("오장동", &[("五壯洞", "지명"),]),
("오전동", &[("五全洞", "지명"),]),
("오정구", &[("梧亭區", "지명"),]),
("오정동", &[("梧井洞", "지명"),("梧亭洞", "지명"),]),
("오지리", &[("墺地利", "오스트리아"),]),
("오창면", &[("梧倉面", "지명"),]),
("오천동", &[("五川洞", "지명"),("五泉洞", "지명"),]),
("오천면", &[("鰲川面", "지명"),]),
("오천읍", &[("烏川邑", "지명"),]),
("오치동", &[("梧峙洞", "지명"),]),
("오태동", &[("吾台洞", "지명"),]),
("오태리", &[("墺太利", "오스트리아"),]),
("오포읍", &[("五浦邑", "지명"),]),
("옥", &[("玉", "구슬 옥, 사랑할 옥, 이룰 옥"),("屋", "집 옥, 지붕 옥, 거북 덮개 옥"),("獄", "감옥 옥"),("沃", "기름질 옥, 부드러울 옥, 손 씻을 옥, 아리따울 옥"),("鈺", "보배 옥"),]),
("옥계동", &[("玉溪洞", "지명"),]),
("옥계면", &[("玉溪面", "지명"),]),
("옥곡동", &[("玉谷洞", "지명"),]),
("옥곡면", &[("玉谷面", "지명"),]),
("옥과면", &[("玉果面", "지명"),]),
("옥교동", &[("玉橋洞", "지명"),]),
("옥구읍", &[("沃溝邑", "지명"),]),
("옥길동", &[("玉吉洞", "지명"),]),
("옥도면", &[("玉島面", "지명"),]),
("옥동", &[("玉洞", "지명"),]),
("옥련동", &[("玉蓮洞", "지명"),]),
("옥룡동", &[("玉龍洞", "지명"),]),
("옥룡면", &[("玉龍面", "지명"),]),
("옥봉남동", &[("玉峰南洞", "지명"),]),
("옥봉북동", &[("玉峰北洞", "지명"),]),
("옥산동", &[("玉山洞", "지명"),]),
("옥산면", &[("玉山面", "지명"),]),
("옥서면", &[("玉西面", "지명"),]),
("옥성면", &[("玉城面", "지명"),]),
("옥수동", &[("玉水洞", "지명"),]),
("옥암동", &[("玉岩洞", "지명"),]),
("옥야동", &[("玉野洞", "지명"),]),
("옥인동", &[("玉仁洞", "지명"),]),
("옥정동", &[("玉井洞", "지명"),]),
("옥종면", &[("玉宗面", "지명"),]),
("옥천군", &[("沃川郡", "지명"),]),
("옥천동", &[("玉川洞", "지명"),("玉泉洞", "지명"),]),
("옥천면", &[("玉泉面", "지명"),]),
("옥천읍", &[("沃川邑", "지명"),]),
("옥포동", &[("玉浦洞", "지명"),]),
("옥포면", &[("玉浦面", "지명"),]),
("온", &[("溫", "따뜻할 온, 부드러울 온"),("穩", "편안할 온, 곡식 걷어 모을 온"),("蘊", "마름 온, 쌓일 온, 쌓을 온"),("縕", "모시 온, 묵은 솜 온"),("瘟", "염병 온, 온역 온"),("瑥", "사람이름 온"),("醞", "술 빚을 온"),("慍", "성낼 온, 병 온"),("氳", "기운 어릴 온, 기운 성할 온"),("韞", "감출 온, 붉은 빛 온"),("昷", "어질 온"),("薀", "마름 온, 쌓일 온"),("轀", "온량차 온"),("饂", "밀 국수 온"),("鰮", "멸치 온"),]),
("온금동", &[("溫錦洞", "지명"),]),
("온산읍", &[("溫山邑", "지명"),]),
("온석동", &[("溫石洞", "지명"),]),
("온수동", &[("溫水洞", "지명"),]),
("온양읍", &[("溫陽邑", "지명"),]),
("온의동", &[("溫衣洞", "지명"),]),
("온정면", &[("溫井面", "지명"),]),
("온천동", &[("溫泉洞", "지명"),]),
("올", &[("兀", "우뚝할 올, 움직이지 않을 올, 오똑할 올"),("膃", "해구 올, 살찔 올"),("嗢", "목 멜 올"),]),
("옹", &[("翁", "늙은이 옹, 새 목털 아래 옹"),("擁", "안을 옹, 품을 옹, 가질 옹"),("雍", "조화로울 옹, 학교 옹, 화할 옹"),("壅", "막을 옹, 북돋울 옹"),("甕", "항아리 옹, 물장군 옹, 독 옹"),("邕", "막힐 옹, 사람이름 옹"),("瓮", "항아리 옹, 독 옹"),("饔", "아침밥 옹"),("癰", "헌곳"),("顒", "우러를 옹"),("喁", "물고기 입 오물거릴 옹"),("蓊", "옹풀 옹, 우거질 옹"),("雝", "조화로울 옹, 학교 옹"),("滃", "구름 피어 오를 옹, 안개 자욱할 옹"),("罋", "甕과 同字"),("禺", "땅 이름 옹"),("廱", "벽옹 옹"),("癕", "등창 옹"),]),
("옹동면", &[("瓮東面", "지명"),]),
("옹진군", &[("甕津郡", "지명"),]),
("와", &[("臥", "누울 와, 쉴 와"),("瓦", "질그릇 와, 기와 와"),("訛", "거짓말 와, 어긋날 와"),("蝸", "달팽이 와"),("渦", "소용돌이 와, 시끄러울 와"),("蛙", "개구리 와"),("窩", "굴 와, 움집 와, 감출 와"),("窪", "도랑 와, 깊을 와, 맑은물 와"),("洼", "물 이름 와"),("哇", "음란한 소리 와, 게울 와"),("譌", "거짓 와, 와전될 와, 요사스런 말 와"),("萵", "상추 와, 부루 와"),("囮", "새 후릴 와"),("枙", "옹이 와"),("窊", "웅덩이 와"),("婐", "정숙할 와, 단정할 와"),("猧", "와개 와"),]),
("와노아도", &[("瓦努阿圖", "바누아투"),]),
("와동", &[("瓦洞", "지명"),]),
("와룡동", &[("臥龍洞", "지명"),]),
("와룡면", &[("臥龍面", "지명"),]),
("와부읍", &[("瓦阜邑", "지명"),]),
("와촌동", &[("瓦村洞", "지명"),]),
("와촌면", &[("瓦村面", "지명"),]),
("완", &[("完", "완전할 완, 끝날 완, 지킬 완"),("緩", "느즈러질 완, 더딜 완"),("莞", "빙그레 웃는 모양 완, 빙그레웃을 완"),("頑", "완고할 완, 완악할 완"),("宛", "어슴푸레할 완, 언덕 위 언덕 완, 굽을 완"),("婉", "순할 완, 예쁠 완, 젊을 완"),("阮", "성씨 완, 관이름 완"),("琓", "구슬"),("玩", "희롱할 완, 보배 완"),("浣", "옷 빨 완, 씻을 완"),("腕", "팔뚝 완"),("翫", "익숙할 완, 싫을 완, 구경할 완, 싫은 완"),("椀", "주발 완, 사발 완"),("琬", "보석 완, 아름다운 옥 완, 서옥 완"),("碗", "그릇 완, 주발 완"),("梡", "네 발 도마 완, 토막나무 완"),("脘", "중완 완"),("豌", "동부 완, 완두 완"),("惋", "한탄할 완, 놀라 탄식할 완"),("岏", "산 뾰족할 완"),("盌", "은 바리 완"),("刓", "깎을 완"),("涴", "물 굽이쳐 흐를 완, 진흙 묻을 완"),("忨", "탐할 완, 사랑할 완"),("垸", "회 섞어 바를 완"),("妧", "좋을 완, 고울 완"),]),
("완도군", &[("莞島郡", "지명"),]),
("완도읍", &[("莞島邑", "지명"),]),
("완산구", &[("完山區", "지명"),]),
("완산동", &[("完山洞", "지명"),]),
("완암동", &[("完岩洞", "지명"),]),
("완월동", &[("玩月洞", "지명"),]),
("완전동", &[("莞田洞", "지명"),]),
("완주군", &[("完州郡", "지명"),]),
("왈", &[("曰", "가로되 왈"),]),
("왕", &[("王", "임금 왕, 할아버지 왕"),("往", "갈 왕, 옛 왕, 이따금 왕"),("旺", "고울 왕, 해무리 왕, 성할 왕, 왕성할 왕"),("汪", "물 출렁출렁할 왕, 연못 왕, 깊고넓을 왕"),("枉", "굽을 왕, 원통할 왕"),("尫", "절름발이 왕, 파리할 왕, 천상바라기 왕"),("迬", "往과 同字"),("瀇", "아득할 왕, 넓을 왕, 고인 물 썪어 냄새날 왕"),("尢", "절름발이"),]),
("왕곡동", &[("旺谷洞", "지명"),]),
("왕곡면", &[("旺谷面", "지명"),]),
("왕궁면", &[("王宮面", "지명"),]),
("왕길동", &[("旺吉洞", "지명"),]),
("왕동", &[("旺洞", "지명"),]),
("왕산면", &[("旺山面", "지명"),]),
("왕암동", &[("旺岩洞", "지명"),]),
("왕정동", &[("王亭洞", "지명"),]),
("왕지동", &[("旺芝洞", "지명"),]),
("왕징면", &[("旺澄面", "지명"),]),
("왜", &[("倭", "나라이름 왜, 일본"),("矮", "난장이 왜"),("娃", "어여쁜 계집 왜, 얼굴 아름다울 왜, 예쁜계집 왜"),("歪", "비뚤"),("媧", "여자이름 왜"),]),
("왜관읍", &[("倭館邑", "지명"),]),
("왜국", &[("倭國", "일본"),]),
("외", &[("外", "바깥 외, 다를 외, 잃을 외, 아버지 외"),("畏", "두려울 외, 겁낼 외"),("猥", "더러울 외, 굽을 외, 섞일 외, 개 새끼 셋 낳을 외, 음란할 외"),("巍", "높을 외, 높고 튼 모양 외"),("嵬", "산 뾰족할 외, 산 울뚝질뚝할 외, 험할 외"),("聵", "배냇귀머거리 외"),("煨", "불에 묻어 구울 외, 그슬릴 외, 사람이름 외"),("隗", "높을 외, 성씨 외"),("磈", "돌 사닥다리 외"),("偎", "사랑할 외, 가물거릴 외"),("崴", "평평치 아니할 외"),("碨", "돌 자갈 땅 외, 바위 옹두라지 외"),("嵔", "산이름 외, 산 높을 외"),("渨", "더러울 외"),]),
("외남동", &[("外南洞", "지명"),]),
("외남면", &[("外南面", "지명"),]),
("외답동", &[("外畓洞", "지명"),]),
("외도동", &[("外都洞", "지명"),]),
("외동", &[("外洞", "지명"),]),
("외동읍", &[("外東邑", "지명"),]),
("외발산동", &[("外鉢山洞", "지명"),]),
("외북동", &[("外北洞", "지명"),]),
("외산면", &[("外山面", "지명"),]),
("외삼동", &[("外三洞", "지명"),]),
("외삼미동", &[("外三美洞", "지명"),]),
("외서면", &[("外西面", "지명"),]),
("외속리면", &[("外俗離面", "지명"),]),
("외평동", &[("外坪洞", "지명"),]),
("외하동", &[("外下洞", "지명"),]),
("요", &[("要", "구할 요, 살필 요, 언약할 요, 허리 요, 기다릴 요, 부를 요, 반드시 요"),("樂", "좋아할 요, 즐길 요"),("料", "말질할 료, 헤아릴 료, 대금 료"),("了", "마칠 료, 깨달을 료"),("謠", "노래 요, 소문 요"),("僚", "벗 료, 어여쁠 료, 동관 요"),("遙", "멀 요, 노닐 요"),("陶", "화락할 요, 순임금의 신하 요"),("搖", "흔들 요, 회오리 바람 요, 별이름 요"),("腰", "허리 요"),("遼", "멀 료, 강이름 료, 나라이름 료"),("堯", "높을 요, 요임금 요"),("妖", "요괴로울 요, 생긋생긋 웃는 모양 요, 요사할 요"),("耀", "빛날 요"),("療", "병 나을 료, 병 고칠 료"),("曜", "해 비칠 요, 요일 요"),("姚", "어여쁠 요, 날랠 요, 멀 요, 예쁠 요"),("尿", "오줌 뇨"),("擾", "길들일 요, 번거로울 요, 길드릴 요"),("撓", "긁을"),("饒", "용서할 요, 배부를 요"),("邀", "맞을 요, 구할 요, 부를 요, 맞이할 요"),("夭", "어여쁠 요, 무성할 요, 재앙 요, 일찍 죽을 요, 뱃속에 든 아이 요, 끊어 죽일 요"),("寮", "동관 료, 관리 료, 중의 집 료"),("僥", "거짓 요, 난장이 요, 요행 요"),("燎", "뜰에 세운 횃불 료, 풀 태울 료, 햇불 요"),("窈", "고요할 요, 깊을 요"),("凹", "오목할 요"),("拗", "고집스러울 요, 꺾을 요"),("窯", "기와가마 요, 오지그릇 요"),("寥", "잠잠할"),("繞", "얽힐 요, 둘릴 요"),("瑤", "아름다운 옥 요, 못 이름 요, 옥돌 요"),("蓼", "병 나을 료, 여뀌 요"),("嶢", "높을 요, 산이높은 요"),("繇", "따를 요, 성할 요"),("橈", "노 요, 돛대 요"),("燿", "비칠 요, 빛날 요"),("蟯", "촌백충 요"),("幺", "작을 요, 어릴 요, 작다 요"),("徭", "부릴 요"),("澆", "걸찰 요, 물 끌어올 요"),("徼", "돌아다닐 요, 순라 요, 변방 요, 구할 요"),("殀", "단명할 요"),("蕘", "나무할 요, 거칠 요"),("遶", "둘릴 요"),("窅", "움펑눈 요, 까마득할 요"),("坳", "凹와 同字"),("鷂", "장끼 요, 새매 요"),("祅", "재앙 요"),("穾", "깊숙할 요, 골방 요"),("墝", "메마른 밭 요, 자갈 땅 요"),("偠", "허리 가늘 요"),("喓", "벌레소리 요"),("嬈", "예쁜체 할 요"),]),
("요기동", &[("堯基洞", "지명"),]),
("요선동", &[("要仙洞", "지명"),]),
("요암동", &[("蓼庵洞", "지명"),]),
("요촌동", &[("堯村洞", "지명"),]),
("욕", &[("欲", "욕심낼 욕, 하고자할 욕"),("浴", "깨끗이할 욕, 못 이름 욕, 목욕할 욕"),("辱", "욕될 욕, 굽힐 욕"),("慾", "욕심낼 욕, 하고자할 욕"),("褥", "요"),("縟", "꾸밀"),("溽", "유월 더위 욕, 무더울 욕"),("蓐", "새싹 욕, 가을 맡은 귀신 욕"),]),
("욕지면", &[("欲知面", "지명"),]),
("용", &[("用", "쓸 용, 재물 용, 통할 용"),("容", "얼굴 용, 감쌀 용, 용서할 용"),("勇", "날랠 용, 용맹할 용"),("龍", "용 룡, 임금 룡"),("庸", "쓸 용, 떳떳할 용, 수고로울 용, 어리석을 용, 물도랑 용"),("踊", "뛸"),("鏞", "큰 쇠북 용"),("茸", "풀 뾰죽뾰죽 날 용, 못생길 용, 녹용 용"),("鎔", "불릴 용, 녹일 용, 거푸집 용"),("傭", "머슴 용, 지을 용, 삯 용"),("溶", "물 질펀히 흐를 용, 녹일 용, 녹을 용"),("瑢", "패옥소리 용"),("熔", "鎔의 俗字, 거푸집 용"),("聳", "솟을 용, 귀먹을 용, 공경할 용"),("湧", "涌의 俗字, 물솟을 용"),("蓉", "연꽃 용, 약 이름 용"),("涌", "물 넘칠 용, 날칠 용, 물솟을 용"),("冗", "宂과 同字, 한산할 용"),("墉", "작은 성 용, 담벽 용, 골목길 용"),("俑", "시체와 함께 매장하는 허수아비 인형 용"),("甬", "물 솟아 오를 용, 골목길 용, 쇠북 꼭지 용, 곡식 셈하는 단위 휘 용"),("慂", "권할 용, 거들어 말할 용"),("榕", "용나무 용, 나무이름 용"),("埇", "골목길 용, 길 돋울 용"),("舂", "방아 찧을 용, 쇠북소리 용, 해가 질 용"),("慵", "게으를 용"),("宂", "번잡할 용, 바쁠 용, 떠돌아 다닐 용"),("踴", "뛸 용"),("憃", "천치 용"),("嵱", "봉우리 쭝굿쭝굿할 용"),("蛹", "번데기 용"),("傛", "혁혁할 용, 몸 굽힐 용"),("槦", "병기 얹는 시렁 용"),]),
("용강동", &[("龍江洞", "지명"),("龍岡洞", "지명"),]),
("용계동", &[("龍溪洞", "지명"),]),
("용곡동", &[("龍谷洞", "지명"),]),
("용관동", &[("龍觀洞", "지명"),]),
("용궁면", &[("龍宮面", "지명"),]),
("용남면", &[("龍南面", "지명"),]),
("용담동", &[("龍潭洞", "지명"),]),
("용담면", &[("龍潭面", "지명"),]),
("용답동", &[("龍踏洞", "지명"),]),
("용당동", &[("龍堂洞", "지명"),("龍塘洞", "지명"),]),
("용덕동", &[("龍德洞", "지명"),]),
("용덕면", &[("龍德面", "지명"),]),
("용동", &[("龍洞", "지명"),]),
("용동면", &[("龍東面", "지명"),]),
("용두동", &[("龍頭洞", "지명"),]),
("용면", &[("龍面", "지명"),]),
("용문동", &[("龍門洞", "지명"),("龍汶洞", "지명"),]),
("용문면", &[("龍門面", "지명"),]),
("용방면", &[("龍方面", "지명"),]),
("용복동", &[("龍福洞", "지명"),]),
("용봉동", &[("龍鳳洞", "지명"),]),
("용산구", &[("龍山區", "지명"),]),
("용산동", &[("龍山洞", "지명"),]),
("용산면", &[("龍山面", "지명"),("蓉山面", "지명"),]),
("용상동", &[("龍上洞", "지명"),]),
("용성면", &[("龍城面", "지명"),]),
("용수동", &[("龍水洞", "지명"),]),
("용안면", &[("龍安面", "지명"),]),
("용암동", &[("龍岩洞", "지명"),]),
("용암면", &[("龍岩面", "지명"),]),
("용연동", &[("龍淵洞", "지명"),]),
("용운동", &[("龍雲洞", "지명"),]),
("용원동", &[("龍院洞", "지명"),]),
("용이동", &[("龍耳洞", "지명"),]),
("용인시", &[("龍仁市", "지명"),]),
("용잠동", &[("龍岑洞", "지명"),]),
("용전동", &[("龍田洞", "지명"),]),
("용정동", &[("龍井洞", "지명"),("龍程洞", "지명"),("龍亭洞", "지명"),]),
("용제동", &[("龍堤洞", "지명"),]),
("용종동", &[("龍宗洞", "지명"),]),
("용주면", &[("龍洲面", "지명"),]),
("용지동", &[("龍池洞", "지명"),]),
("용지면", &[("龍池面", "지명"),]),
("용진면", &[("龍進面", "지명"),]),
("용촌동", &[("龍村洞", "지명"),]),
("용탄동", &[("龍灘洞", "지명"),]),
("용평동", &[("龍平洞", "지명"),]),
("용평면", &[("龍坪面", "지명"),]),
("용해동", &[("龍海洞", "지명"),]),
("용현동", &[("龍峴洞", "지명"),]),
("용현면", &[("龍見面", "지명"),]),
("용호동", &[("龍湖洞", "지명"),("龍虎洞", "지명"),]),
("용화동", &[("龍禾洞", "지명"),]),
("용화면", &[("龍化面", "지명"),]),
("용흥동", &[("龍興洞", "지명"),]),
("우", &[("右", "오른쪽 우, 높일 우, 강할 우, 도울 우"),("牛", "소 우, 별 이름 우"),("雨", "비 우"),("友", "벗 우, 합할 우"),("又", "또 우, 용서할 우"),("宇", "집 우, 처마 기슭 우, 하늘 우"),("于", "갈 우, 여기 우, 만족할 우, 탄식의 어조사 우"),("尤", "가장 우, 더욱 우, 탓할 우"),("憂", "근심 우, 상제될 우, 병 우"),("遇", "만날 우, 대접할 우, 뜻밖에 우"),("愚", "어리석을 우, 어두울 우, 업신여길 우"),("優", "넉넉할 우, 부드러울 우, 나을 우, 결단성 없을 우"),("羽", "깃 우, 오음의 하나 우"),("郵", "역말 우, 지날 우, 우편 우"),("偶", "짝지울 우, 무리 우, 뜻밖에 우"),("佑", "도울 우"),("祐", "도울 우, 다행할 우"),("禹", "하우씨 우, 성씨 우, 느릴 우"),("迂", "굽을 우, 피할 우, 멀 우"),("虞", "염려할 우, 즐거울 우, 갖출 우, 우제 지낼 우"),("寓", "살 우, 부탁할 우, 빙자할 우, 붙어살 우"),("隅", "모퉁이 우, 기슭 우"),("禑", "복"),("雩", "기우제 우, 무지개 우"),("紆", "얽힐 우, 굽을 우"),("瑀", "옥돌 우, 옥다음가는 돌 우"),("盂", "바리 우, 사냥하는 진 우, 밥그릇 우"),("旴", "해 돋을 우, 새벽 우"),("芋", "토란 우"),("藕", "연뿌리 우"),("玗", "옥돌 우, 우기나무 우"),("嵎", "산모퉁이"),("釪", "요령 우, 바리때 우, 풍류그릇 우"),("耦", "쟁기 우, 겨리 우, 짝 맞을 우"),("踽", "타달거릴 우"),("喁", "서로 부를 우"),("竽", "큰 생황 우"),("耰", "고무래 우, 곰방메 우"),("麀", "암사슴 우"),("麌", "숫사슴 우"),("鍝", "귀고리 우"),("吽", "개 싸울 우, 개 짖는 소리 우"),("謣", "망령되게 말할 우"),("齲", "충치 우"),]),
("우강면", &[("牛江面", "지명"),]),
("우곡면", &[("牛谷面", "지명"),]),
("우도면", &[("牛島面", "지명"),]),
("우동", &[("佑洞", "지명"),]),
("우두동", &[("牛頭洞", "지명"),]),
("우류구", &[("宇柳具", "우루과이"),]),
("우만", &[("牛滿", "지명"),]),
("우면동", &[("牛眠洞", "지명"),]),
("우명동", &[("牛鳴洞", "지명"),]),
("우보면", &[("友保面", "지명"),]),
("우산동", &[("牛山洞", "지명"),]),
("우성면", &[("牛城面", "지명"),]),
("우아동", &[("牛牙洞", "지명"),]),
("우안다", &[("宇岸陀", "우간다"),]),
("우암동", &[("牛岩洞", "지명"),]),
("우이동", &[("牛耳洞", "지명"),]),
("우정동", &[("牛亭洞", "지명"),]),
("우정면", &[("雨汀面", "지명"),]),
("우지동", &[("牛池洞", "지명"),("禹池洞", "지명"),]),
("우천면", &[("隅川面", "지명"),]),
("우현동", &[("牛峴洞", "지명"),]),
("욱", &[("旭", "빛날 욱, 햇살 치밀 욱, 교만할 욱"),("郁", "문채날 욱, 자욱할 욱, 향냐날 욱"),("煜", "비칠 욱, 불꽃 욱, 성할 욱, 빛날 욱"),("頊", "머리 굽실거릴 욱, 별이름 욱, 사람이름 욱"),("昱", "햇빛 밝을 욱"),("勖", "힘쓸 욱"),("彧", "빛날 욱, 문채날 욱, 무성할 욱"),("栯", "산앵두 욱"),("稶", "서직 무성할 욱, 서속이 우거진 모양 욱"),("燠", "더울 욱"),]),
("욱수동", &[("旭水洞", "지명"),]),
("운", &[("雲", "구름 운, 팔대손 운, 하늘 운"),("運", "움직일 운, 운수 운, 운전할 운"),("云", "이를 운, 움직일 운, 돌아갈 운"),("韻", "울림 운, 소리 맞을 운, 운 운, 운치 운"),("芸", "향풀 운, 궁궁이 운, 촘촘할 운, 성씨 운, 재주 운"),("暈", "무리 운, 어지러울 운"),("隕", "떨어질 운, 곤란할 운"),("殞", "죽을 운, 떨어질 운"),("耘", "길 맬 운, 김맬 운"),("蕓", "운풀 운, 평지 운, 향내나는 풀 운"),("澐", "큰 물결 운"),("橒", "나무 무늬 운"),("熉", "누른 빛 운"),("紜", "얼크러질 운"),("韵", "韻과 同字"),("惲", "의논할 운, 혼후할 운"),("沄", "물 콸콸 흐를 운, 끓을 운"),("霣", "떨어질 운, 천둥에 비 몰아올 운"),("篔", "왕대나무 운"),]),
("운곡동", &[("雲谷洞", "지명"),]),
("운곡면", &[("雲谷面", "지명"),]),
("운교동", &[("雲校洞", "지명"),]),
("운남동", &[("雲南洞", "지명"),]),
("운남면", &[("雲南面", "지명"),]),
("운니동", &[("雲泥洞", "지명"),]),
("운동동", &[("雲東洞", "지명"),]),
("운림동", &[("雲林洞", "지명"),]),
("운문면", &[("雲門面", "지명"),]),
("운봉읍", &[("雲峯邑", "지명"),]),
("운북동", &[("雲北洞", "지명"),]),
("운산동", &[("雲山洞", "지명"),]),
("운산면", &[("雲山面", "지명"),]),
("운서동", &[("雲西洞", "지명"),]),
("운수동", &[("雲水洞", "지명"),]),
("운수면", &[("雲水面", "지명"),]),
("운안동", &[("雲安洞", "지명"),]),
("운암동", &[("雲岩洞", "지명"),]),
("운암면", &[("雲岩面", "지명"),]),
("운양동", &[("雲陽洞", "지명"),]),
("운연동", &[("雲宴洞", "지명"),]),
("운정동", &[("雲亭洞", "지명"),]),
("운주면", &[("雲州面", "지명"),]),
("운중", &[("雲中", "지명"),]),
("운천동", &[("雲泉洞", "지명"),]),
("운학동", &[("雲鶴洞", "지명"),]),
("운흥동", &[("雲興洞", "지명"),]),
("울", &[("鬱", "향기로운 풀 울, 무성할 울"),("蔚", "고을이름 울"),("亐", "땅이름"),]),
("울릉군", &[("鬱陵郡", "지명"),]),
("울릉읍", &[("鬱陵邑", "지명"),]),
("울산광역시", &[("蔚山廣域市", "지명"),]),
("울주군", &[("蔚州郡", "지명"),]),
("울진군", &[("蔚珍郡", "지명"),]),
("울진읍", &[("蔚珍邑", "지명"),]),
("웅", &[("雄", "수컷 웅, 영웅 웅, 웅장할 웅"),("熊", "곰 웅, 빛날 웅"),]),
("웅남동", &[("熊南洞", "지명"),]),
("웅상읍", &[("熊上邑", "지명"),]),
("웅양면", &[("熊陽面", "지명"),]),
("웅진동", &[("熊津洞", "지명"),]),
("웅천동", &[("熊川洞", "지명"),]),
("웅천읍", &[("熊川邑", "지명"),]),
("웅촌면", &[("熊村面", "지명"),]),
("웅치면", &[("熊峙面", "지명"),]),
("웅포면", &[("熊浦面", "지명"),]),
("원", &[("元", "으뜸 원, 착하고 어질 원, 일 년의 첫 날 원, 임금 원, 백성 원, 하늘 원"),("原", "근본 원, 거듭 원, 언덕 원, 기인할 원, 들판 원"),("遠", "멀 원, 심오할 원"),("園", "동산 원, 능 원, 울타리 원"),("願", "하고자할 원, 바랄 원, 생각할 원, 원할 원"),("圓", "둥글 원, 원만할 원, 화폐의 단위 원"),("怨", "원망할 원, 원수 원, 분낼 원"),("院", "원집 원, 공해 원, 절 원, 학교 원"),("員", "관원 원, 둥글 원"),("源", "근원 원, 샘 원, 계속할 원"),("援", "당길 원, 사다리 원, 구원할 원"),("苑", "나랏동산 원, 큰 바람 원, 나라동산 원"),("瑗", "도리옥 원, 구멍 큰 둥근 옥 원"),("袁", "옷 치렁거릴 원, 성씨 원, 옷긴모양 원"),("媛", "아리따운 여자 원, 여자 벼슬이름 원, 예쁜계집 원"),("寃", "원통할 원, 굽힐 원, 죄 없을 원"),("猿", "원숭이 원, 잔나비 원"),("鴛", "숫원앙새 원, 수원앙새 원"),("阮", "원나라 원, 성씨 원, 관이름 원"),("轅", "진문 원, 멍에 원, 별 이름 원, 멍에채 원"),("垣", "낮은 담 원, 보호하는 사람 원, 별 이름 원"),("爰", "당길 원, 이끌 원, 가로되 원"),("愿", "정성 원, 착할 원, 삼갈 원"),("湲", "물소리 원, 물 졸졸 흐를 원"),("沅", "물 이름 원"),("嫄", "여자이름 원"),("洹", "흐를 원, 물 이름 원"),("冤", "원통할 원, 원한 원"),("鵷", "원추새 원"),("蜿", "굼틀거릴 원"),("黿", "큰 자라 원"),("謜", "천천히 말할 원, 기꺼울 원"),("猨", "猿과 同字"),("杬", "몸 주무를 원, 나무이름 원"),("楥", "떡갈나무 원, 실감개 원, 신골 원"),("芫", "고기 잡는 풀 원, 여뀌 원"),("薗", "園과 同字"),("鋺", "저울 바탕 원"),("騵", "배 희고 갈기 검은 말 원"),]),
("원곡동", &[("元谷洞", "지명"),]),
("원곡면", &[("元谷面", "지명"),]),
("원남동", &[("元南洞", "지명"),("苑南洞", "지명"),]),
("원남면", &[("遠南面", "지명"),]),
("원내동", &[("元內洞", "지명"),]),
("원당동", &[("元堂洞", "지명"),("元當洞", "지명"),("院堂洞", "지명"),]),
("원대동", &[("院垈洞", "지명"),]),
("원덕읍", &[("遠德邑", "지명"),]),
("원동", &[("元洞", "지명"),("園洞", "지명"),("院洞", "지명"),]),
("원동면", &[("院東面", "지명"),]),
("원문동", &[("元文洞", "지명"),]),
("원미구", &[("遠美區", "지명"),]),
("원미동", &[("遠美洞", "지명"),]),
("원북면", &[("遠北面", "지명"),]),
("원산동", &[("元山洞", "지명"),("院山洞", "지명"),]),
("원삼면", &[("遠三面", "지명"),]),
("원서동", &[("苑西洞", "지명"),]),
("원성동", &[("院城洞", "지명"),]),
("원시동", &[("元時洞", "지명"),]),
("원신흥동", &[("院新興洞", "지명"),]),
("원정동", &[("元亭洞", "지명"),]),
("원종동", &[("遠宗洞", "지명"),]),
("원주시", &[("原州市", "지명"),]),
("원지동", &[("院趾洞", "지명"),]),
("원창동", &[("元倉洞", "지명"),]),
("원천", &[("遠川", "지명"),]),
("원천동", &[("遠泉洞", "지명"),]),
("원촌동", &[("院村洞", "지명"),]),
("원평동", &[("元坪洞", "지명"),("院坪洞", "지명"),]),
("원포동", &[("院浦洞", "지명"),]),
("원효로", &[("元曉路", "지명"),]),
("원흥동", &[("元興洞", "지명"),]),
("월", &[("月", "달 월"),("越", "넘을 월, 뛸 월, 월나라 월"),("鉞", "도끼 월"),("粤", "말 내킬 월, 곰곰히 생각할 월, 나라이름 월"),("刖", "발꿈치 자를 월"),]),
("월계동", &[("月溪洞", "지명"),("月桂洞", "지명"),]),
("월곡동", &[("月谷洞", "지명"),]),
("월곶동", &[("月串洞", "지명"),]),
("월곶면", &[("月串面", "지명"),]),
("월남", &[("越南", "베트남"),]),
("월남동", &[("月南洞", "지명"),]),
("월내동", &[("月內洞", "지명"),]),
("월등면", &[("月燈面", "지명"),]),
("월락동", &[("月洛洞", "지명"),]),
("월롱면", &[("月籠面", "지명"),]),
("월림동", &[("月林洞", "지명"),]),
("월명동", &[("月明洞", "지명"),]),
("월미동", &[("月尾洞", "지명"),]),
("월봉동", &[("月鳳洞", "지명"),]),
("월산동", &[("月山洞", "지명"),]),
("월산면", &[("月山面", "지명"),]),
("월성동", &[("月星洞", "지명"),("月城洞", "지명"),]),
("월송동", &[("月松洞", "지명"),]),
("월암동", &[("月岩洞", "지명"),]),
("월야면", &[("月也面", "지명"),]),
("월영동", &[("月影洞", "지명"),]),
("월오동", &[("月午洞", "지명"),]),
("월전동", &[("月田洞", "지명"),]),
("월조별", &[("月祖別", "우즈베키스탄"),]),
("월즉별", &[("月卽別", "우즈베키스탄"),]),
("월출동", &[("月出洞", "지명"),]),
("월평동", &[("月平洞", "지명"),("月坪洞", "지명"),]),
("월포동", &[("月浦洞", "지명"),]),
("월피동", &[("月陂洞", "지명"),]),
("월하동", &[("月下洞", "지명"),]),
("월항면", &[("月恒面", "지명"),]),
("월호평동", &[("月呼坪洞", "지명"),]),
("위", &[("位", "벼슬 위, 임금의 신분 위, 자리 위, 방위 위"),("危", "위태할 위, 무너질 위, 상할 위, 높을 위, 별 이름 위"),("爲", "할 위, 다스릴 위, 하여금 위, 어미원숭이 위, 이룰 위"),("威", "위엄 위, 두려울 위"),("偉", "클 위, 넉넉할 위, 기특할 위"),("謂", "고할 위, 이를 위"),("衛", "衞와 同字, 호위할 위"),("委", "맡길 위, 버릴 위, 맘에 든든할 위, 벼이삭 고개 숙일 위"),("慰", "위로할 위"),("圍", "둘레 위, 에워 쌀 위, 한아람 위, 지킬 위"),("僞", "거짓 위, 속일 위"),("胃", "밥통 위, 별 이름 위, 성씨 위"),("違", "어길 위, 미적거릴 위, 되돌아올 위"),("倭", "순한 모양 위, 빙글 돌아올 위"),("緯", "씨줄 위, 별 오른편으로 돌 위, 경위 위"),("尉", "벼슬이름 위, 눌릴 위"),("魏", "위나라 위, 대궐 위, 우뚝할 위"),("蔚", "제비쑥 위, 초목 우거진 모양 위, 잔무늬 위"),("渭", "물 이름 위, 속 끓일 위"),("韋", "다룬 가죽 위, 훌부들할 위, 군복 위, 성씨 위, 연할 위"),("萎", "마를 위, 풀 이름 위, 쇠약해질 위"),("瑋", "위옥 위, 노리개 위, 옥이름 위"),("葦", "갈대 위, 작은 배 위"),("蝟", "고슴도치 위"),("暐", "햇빛 위, 빛 환할 위, 빛날 위"),("褘", "휘장 위, 아름다울 위"),("蔿", "풀 위, 성씨 위, 고을이름 위"),("諉", "핑계할 위, 버릴 위"),("闈", "대궐안의 문 위"),("衞", "막을 위, 지킬 위, 핏기운 위, 나라이름 위"),("逶", "비틀거릴 위"),("喟", "한숨쉴 위"),("韙", "옳을 위"),("痿", "습병 위, 잘름거릴 위, 음위증 위"),("葳", "초목 성할 위, 위유풀 위"),("煒", "벌그레할 위, 환할 위"),("幃", "향낭 위, 홑휘장 위"),("熨", "다리미 위, 고약 붙일 위"),("韡", "꽃 환히 필 위"),("餧", "먹일 위"),]),
("위도면", &[("蝟島面", "지명"),]),
("위사부도", &[("衛士府都", "이집트"),]),
("위지마랍", &[("危地馬拉", "과테말라"),]),
("위천면", &[("渭川面", "지명"),]),
("유", &[("有", "있을 유, 얻을 유, 과연 유, 또 유"),("流", "흐를 류, 번져나갈 류, 구할 류, 내칠 류, 달아날 류, 무리 류, 귀양보낼 류"),("由", "말미암을 유, 쓸 유, 지날 유"),("油", "기름 유, 구름 피어오를 유, 공손할 유"),("留", "머무를 류, 그칠 류, 오랠 류, 횡사할 류"),("猶", "어미 원숭이 유, 같을 유, 오히려 유"),("柳", "버들 류, 별 이름 류"),("遺", "잃어버릴 유, 남을 유, 끼칠 유"),("遊", "놀 유, 벗 사귈 유"),("酉", "별 유, 열째 지지 유, 나아갈 유, 닭 유"),("唯", "오직 유, 허락할 유"),("幼", "어릴 유, 사랑할 유"),("柔", "부드러울 유, 순할 유, 복종할 유"),("惟", "꾀할 유, 오직 유, 생각할 유"),("類", "같을 류, 나눌 류, 착할 류, 무리 류"),("裕", "넉넉할 유, 너그러울 유"),("悠", "멀 유, 생각할 유, 한가할 유, 근심할 유"),("誘", "꾀일 유, 가르칠 유, 당길 유, 인도할 유"),("乳", "젖 유, 종유석 유, 낳을 유, 젖먹일 유, 기를 유"),("儒", "선비 유, 나장이 유, 유도 유, 광대 유"),("維", "벼리 유, 이을 유, 맺을 유, 오직 유"),("愈", "나을 유, 어질 유, 더욱 유, 병 나을 유"),("幽", "숨을 유, 그윽할 유, 적을 유, 어두울 유, 귀신 유, 저승 유, 깊을 유"),("劉", "이길 류, 죽일 류, 베풀 류, 성씨 류"),("兪", "그럴 유, 대답할 유, 공손할 유, 그러할 유"),("踰", "넘을 유"),("庾", "노적 유, 곡식 셈하는 단위 휘 유"),("楡", "느름나무 유, 서쪽 유"),("紐", "단추 뉴, 맺을 뉴"),("癒", "병 나을 유, 병들 유"),("諭", "고할 유, 비유할 유"),("游", "헤엄칠 유, 노닐 유, 깃발 유"),("宥", "너그러울 유, 죄 사할 유, 도울 유"),("喩", "깨우쳐 줄 유, 알릴 유, 비유할 유, 깨우칠 유"),("溜", "처마물 류, 낙수물 류, 증류수 류"),("諛", "아첨할 유"),("鍮", "놋쇠 유"),("琉", "유리돌 류, 나라이름 류"),("愉", "기뻐할 유, 즐거울 유"),("柚", "유자 유"),("蹂", "밟을 유, 쌀 씻을 유"),("揄", "당길 유, 칭찬할 유, 희롱할 유"),("攸", "곳 유, 휙 달아날 유, 아득할 유, 대롱거릴 유"),("猷", "꾀 유, 그릴 유, 옳을 유, 탄식할 유"),("綏", "깃발 늘어질 유"),("逾", "갈 유, 지날 유"),("濡", "적실 유, 막힐 유, 곱고 윤택할 유"),("孺", "젖먹이 유, 사모할 유, 딸릴 유"),("臾", "잠간 유, 착할 유, 나라이름 유, 활이 뒤로 젖혀질 유, 잠깐 유"),("瑜", "아름다운 옥 유"),("侑", "도울 유, 권할 유, 귀인을 모시고 밥먹을 유"),("硫", "석류황 류, 유황 류"),("杻", "싸리 뉴"),("萸", "수유 유, 약이름 유"),("洧", "물이름 유"),("楢", "부드러운 나무 유, 홰 유"),("釉", "물건 빛날 유"),("籲", "부르짖을 유"),("帷", "휘장 유"),("牖", "엇살창 유, 들창 유, 밝을 유, 인도할 유"),("壝", "토담 유, 단 둘러쌓은 담 유"),("囿", "엔담 유, 고루할 유"),("腴", "아랫배 살찔 유"),("逌", "빙그레할 유"),("莠", "가라지 유, 추할 유"),("糅", "섞일 유, 얽힐 유, 잡곡밥 유"),("揉", "풀 유, 부드럽게 할 유, 희일 유"),("蕕", "냄새나는 풀 유, 유풀 유"),("蕤", "더북할 유"),("窬", "판장문 유"),("黝", "검푸를 유, 검은칠할 유"),("瘐", "죄인 주려 죽을 유"),("窳", "이지러질 유, 약할 유, 짐승이름 유"),("讉", "성낼 유"),("呦", "사슴 우는 소리 유, 새짐승 우는 소리 유"),("鮪", "상어 유"),("褕", "꿩의 깃으로 꾸민 옷 유, 쾌자 유"),("泑", "물빛이 검을 유, 물이름 유"),("冘", "머뭇거릴 유, 갈 유"),("蚴", "굼틀거릴 유"),("蝤", "하루살이 유"),("鼬", "청서 유, 족제비 유"),("斿", "깃발 유, 깃술 유, 면류관술 유"),("瘉", "癒와 同字"),("蚰", "노래기 유, 땅지네 유"),("鞣", "다룬 가죽 유, 마른 가죽 유"),("龥", "부르짖을 유"),("禸", "발자국"),]),
("유가면", &[("瑜伽面", "지명"),]),
("유계동", &[("柳溪洞", "지명"),]),
("유곡동", &[("柳谷洞", "지명"),("裕谷洞", "지명"),("幽谷洞", "지명"),]),
("유곡면", &[("柳谷面", "지명"),]),
("유구읍", &[("維鳩邑", "지명"),]),
("유달동", &[("儒達洞", "지명"),]),
("유동", &[("柳洞", "지명"),]),
("유동면", &[("杻東面", "지명"),]),
("유등면", &[("柳等面", "지명"),]),
("유량동", &[("留糧洞", "지명"),]),
("유록동", &[("柳綠洞", "지명"),]),
("유림면", &[("柳林面", "지명"),]),
("유만전", &[("瑠湾田", "르완다"),]),
("유방동", &[("柳防洞", "지명"),]),
("유산동", &[("由山洞", "지명"),("幼山洞", "지명"),]),
("유성구", &[("儒城區", "지명"),]),
("유어면", &[("遊漁面", "지명"),]),
("유천", &[("流川", "지명"),]),
("유천동", &[("柳川洞", "지명"),("楡川洞", "지명"),]),
("유천면", &[("柳川面", "지명"),]),
("유촌동", &[("柳村洞", "지명"),]),
("유치면", &[("有治面", "지명"),]),
("육", &[("六", "여섯 륙, 나라이름 륙"),("肉", "고기 육, 몸 육, 살 육"),("育", "기를 육, 날 육, 자랄 육"),("陸", "뭍 륙, 길 륙, 어긋날 륙, 뛸 륙, 두터울 륙"),("戮", "죽일 륙, 육시할 륙, 욕할 륙"),("堉", "기름진 땅 육"),("毓", "기를 육, 어릴 육, 많을 육"),("儥", "팔 육, 길 육"),]),
("윤", &[("倫", "인륜 륜, 무리 륜, 조리 륜, 의리 륜, 가릴 륜"),("輪", "바퀴 륜, 땅 길이 륜, 우렁찰 륜, 서릴 륜, 둘레 륜, 수레바퀴 윤"),("尹", "다스릴 윤, 바를 윤, 벼슬이름 윤, 믿을 윤"),("允", "미쁠 윤, 마땅할 윤, 옳게 여길 윤, 좇을 윤, 허락할 윤, 진실로 윤"),("潤", "불을"),("閏", "윤달"),("崙", "곤륜산 륜, 나라이름 륜, 산이름 윤"),("胤", "맏아들 윤, 익힐 윤, 이을 윤"),("鈗", "창 윤"),("淪", "빠질 륜, 물놀이칠 륜, 거느릴 륜"),("贇", "예블"),("勻", "가지런할 윤, 적을 윤"),("奫", "물 깊을 윤, 물이 충충할 윤, 물이 층층한 윤"),("玧", "귀막이 구슬 윤"),]),
("윤직동", &[("閏稷洞", "지명"),]),
("율", &[("律", "법 률, 풍률 률, 지을 률, 저울질할 률"),("率", "헤아릴 률, 과녁 률, 홀 한껏 다릴 률"),("栗", "밤 률, 신주 재목 률, 단단할 률, 무서울 률, 공손할 률"),("慄", "두려울 률, 쭈그릴 률, 슬플 률, 떨 률"),("聿", "마침내 율, 지을 율, 오직 율, 스스로 율, 붓 율, 드디어 율"),("潏", "물 흐를 율"),("矞", "송곳질할 율, 상서구름 율, 궤휼할 율, 귀신이름 율"),]),
("율곡면", &[("栗谷面", "지명"),]),
("율동", &[("栗洞", "지명"),]),
("율면", &[("栗面", "지명"),]),
("율목동", &[("栗木洞", "지명"),]),
("율세동", &[("栗世洞", "지명"),]),
("율암동", &[("栗岩洞", "지명"),]),
("율양동", &[("栗陽洞", "지명"),]),
("율어면", &[("栗於面", "지명"),]),
("율전동", &[("栗田洞", "지명"),]),
("율촌면", &[("栗村面", "지명"),]),
("율하동", &[("栗下洞", "지명"),]),
("율현동", &[("栗峴洞", "지명"),]),
("융", &[("隆", "성할 륭, 높을 륭, 가운데 우뚝할 륭, 괘 이름 륭"),("融", "부드러울 융, 밝을 융, 융통할 융, 불길 위로 오를 융, 귀신이름 융"),("戎", "병장기 융, 싸움수레 융, 클 융, 너 융, 도울 융, 서쪽 오랑캐 융"),("絨", "삶은 실 융, 가는 베 융"),("瀜", "물 깊을 륭, 물깊은 모양 융"),("狨", "원숭이 융"),]),
("은", &[("銀", "은 은, 돈 은"),("恩", "은혜 은, 신세 은, 사랑할 은"),("隱", "숨을 은, 아낄 은, 속걱정할 은, 불쌍히 여길 은, 점칠 은, 의지할 은, 쌓을 은"),("殷", "많을 은, 무리 은, 클 은, 가운데 은, 은나라 은, 융성할 은, 천둥소리 은"),("誾", "화평할 은"),("垠", "언덕 은, 하늘 가장자리 은, 경계 은"),("圻", "언덕 은"),("慇", "은근할 은, 공손할 은, 간절할 은"),("訔", "시비할 은"),("听", "벙긋거릴 은, 들을 은, 입이 큰 모양 은"),("憖", "물을 은, 공근할 은, 힘쓸 은, 서러워할 은"),("嚚", "어리석을 은, 말다툼할 은, 불칙하게 말할 은"),("狺", "뭇 개 짖는 소리 은"),("溵", "물소리 은, 물이름 은"),("檼", "집 마룻대 은, 대공 은"),("癮", "두드러기 은"),("垽", "해감 은, 찌끼 은"),("鄞", "땅이름 은"),("圁", "물이름 은"),("珢", "옥돌 은"),("齗", "잇몸 은, 말다툼할 은, 미워할 은"),("乚", "숨을"),]),
("은계동", &[("銀溪洞", "지명"),]),
("은기동", &[("隱基洞", "지명"),]),
("은명", &[("幾內亞", "기니"),]),
("은산면", &[("恩山面", "지명"),]),
("은진면", &[("恩津面", "지명"),]),
("은척면", &[("銀尺面", "지명"),]),
("은평구", &[("恩平區", "지명"),]),
("은하면", &[("銀河面", "지명"),]),
("은행동", &[("銀行洞", "지명"),("銀杏洞", "지명"),]),
("은현면", &[("隱縣面", "지명"),]),
("을", &[("乙", "새 을, 천간 이름 을, 굽힐 을, 생선의 창자 을, 모모 을"),("鳦", "제비 을"),]),
("을왕동", &[("乙旺洞", "지명"),]),
("을지로", &[("乙支路", "지명"),]),
("음", &[("音", "소리 음, 편지 음, 음악 음"),("飮", "마실 음"),("陰", "음기 음, 부인에게 예 가르칠 음, 몰래 음, 세월 음, 그늘 음"),("吟", "읊을 음, 끙끙거릴 음, 탄식할 음, 턱 끄덕거릴 음, 노래할 음, 말 더듬을 음, 울 음"),("淫", "방탕할 음, 간음할 음, 음란할 음, 넘칠 음, 적실 음, 오랠 음"),("蔭", "덮을 음, 가릴 음, 그늘 음"),("喑", "소리지를 음, 안간힘 쓸 음, 목 쉴 음"),("愔", "조용할 음, 화평할 음"),("霪", "장마 음"),("崟", "멧부리 음, 산 높을 음"),("廕", "덮을 음"),]),
("음봉면", &[("陰峰面", "지명"),]),
("음성군", &[("陰城郡", "지명"),]),
("음성읍", &[("陰城邑", "지명"),]),
("음암면", &[("音岩面", "지명"),]),
("읍", &[("邑", "고을 읍, 답답할 읍"),("泣", "눈물 줄줄 흘릴 읍, 부글부글 끓는 소리 읍, 소리없이울 읍"),("揖", "읍할 읍, 나아갈 읍, 깍지낄 읍, 공손할 읍"),("挹", "잡아당길 읍, 잔질할 읍"),("悒", "답답할 읍, 근심할 읍"),("浥", "젖을 읍, 흠치르르할 읍"),]),
("읍내동", &[("邑內洞", "지명"),]),
("읍상동", &[("邑上洞", "지명"),]),
("읍중동", &[("邑中洞", "지명"),]),
("응", &[("應", "응당 응, 꼭 응, 사랑할 응, 대답할 응, 응할 응"),("凝", "엉길 응, 이룰 응, 열중할 응"),("鷹", "매 응"),("膺", "가슴 응, 친할 응, 당할 응, 응할 응, 받을 응"),]),
("응명동", &[("鷹鳴洞", "지명"),]),
("응봉동", &[("鷹峰洞", "지명"),]),
("응봉면", &[("鷹峰面", "지명"),]),
("응암동", &[("鷹岩洞", "지명"),]),
("의", &[("衣", "옷 의, 입을 의"),("意", "뜻 의, 생각 의, 의리 의, 형세 의"),("義", "옳을 의, 의리 의, 뜻 의"),("依", "의지할 의, 기댈 의, 비슷할 의, 따를 의, 비유할 의, 병풍 의"),("醫", "의원 의, 병 고칠 의"),("矣", "말 그칠 의, 어조사 의"),("議", "말할 의, 의논할 의, 꾀할 의"),("宜", "옳을 의, 마땅할 의, 유순할 의"),("儀", "꼴 의, 모양 의, 법도 의, 좋을 의"),("疑", "의심할 의, 두려워할 의, 그럴듯할 의"),("誼", "옳을 의, 다스릴 의"),("擬", "의논할 의, 헤아릴 의, 흡사할 의, 비길 의"),("毅", "굳셀 의, 발끈 성낼 의"),("椅", "가래나무 의, 교의 의"),("縊", "목 맬 의"),("倚", "기댈 의, 의지할 의, 믿을 의"),("懿", "아름다울 의, 클 의"),("蟻", "왕개미 의, 검을 의, 술구더기 의"),("薏", "연밥 의, 율무 의"),("艤", "배 닿을 의, 배언덕에 댈 의"),("錡", "세발 가마 의, 쇠뇌틀 의, 휘뚝거릴 의"),("猗", "불 깐 개 의, 탄식할 의, 길 의"),("嶷", "산이름 의"),("欹", "아름답다할 의, 거룩하다할 의"),("漪", "물놀이칠 의"),("儗", "서로 못믿을 의, 참람할 의"),("劓", "코 베일 의, 베일 의"),("螘", "목 매어 죽는 벌레 의"),("饐", "밥 쉴 의"),("凒", "눈서리 쌓일 의"),("礒", "바위 의"),("衤", "옷의"),]),
("의당면", &[("儀堂面", "지명"),]),
("의령군", &[("宜寧郡", "지명"),]),
("의령읍", &[("宜寧邑", "지명"),]),
("의림동", &[("義林洞", "지명"),]),
("의성군", &[("義城郡", "지명"),]),
("의성읍", &[("義城邑", "지명"),]),
("의신면", &[("義新面", "지명"),]),
("의왕시", &[("儀旺市", "지명"),]),
("의정부동", &[("議政府洞", "지명"),]),
("의정부시", &[("議政府市", "지명"),]),
("의주로", &[("義州路", "지명"),]),
("의흥면", &[("義興面", "지명"),]),
("이", &[("二", "두 이, 풍신 이, 같을 이, 의심할 이"),("耳", "귀 이, 조자리 이, 말 그칠 이, 여덟대 손자 이"),("里", "마을 리, 근심할 리, 잇수 리"),("利", "날카로울 리, 이로울 리, 탐할 리, 편리할 리, 이자 리"),("理", "다스릴 리, 바를 리, 누늬낼 리, 성품 리, 이치 리, 고칠 리, 나무결 리"),("異", "다를 이, 괴이할 이, 나눌 이"),("以", "써 이, 쓸 이, 까닭 이, 함께 이, 거느릴 이"),("而", "순접의 어조사 이, 너 이, 말이을 이, 이에 이"),("李", "오얏 리, 선비 천거리할 리, 역말 리, 보따리 리"),("已", "이미 이, 그칠 이, 버릴 이, 너무 이"),("移", "옮길 이, 모낼 이, 변할 이"),("易", "쉬울 이, 다스릴 이, 게으를 이, 편할 이, 바꿀 이"),("吏", "아전 리, 관리 리"),("離", "떠날 리, 베풀 리, 지날 리, 아름다울 리, 둘 리, 외손 리"),("履", "가죽신 리, 신을 리, 밟을 리"),("裏", "옷 안 리, 속 리"),("梨", "배 리, 벌레이름 리"),("伊", "저 이, 이 이, 오직 이, 답답할 이, 성씨 이"),("夷", "동쪽 오랑캐 이, 평평할 이, 기꺼울 이, 상할 이, 베풀 이, 괘 이름 이"),("泥", "진흙 니, 물이 더러워질 니, 흙손 니, 술취할 니, 이슬 맺힐 니"),("珥", "귀막이 옥 이, 귀고리 이, 해무리 이, 햇무리 이"),("弛", "늦출 이, 활 부릴 이, 방탕할 이, 해이할 이"),("貳", "二의 갖은자, 버금 이, 의심낼 이, 마음 변할 이, 이별할 이, 두 이"),("怡", "기쁠 이, 즐거울 이, 화할 이"),("罹", "만날 리, 근심할 리, 걸릴 리"),("餌", "미끼 이, 이깝 이, 먹일 이, 흰떡 이"),("裡", "裏의 俗字, 옷속 이"),("痍", "상할 이, 다칠 이, 흠집 이"),("爾", "너 이, 가까울 이, 오직 이"),("痢", "이질 리, 곱똥 리, 설사 리"),("姨", "이모 이, 처이모 이"),("貽", "끼칠 이, 줄 이"),("邇", "가까울 이"),("彛", "彝의 俗字, 떳떳할 이"),("肄", "익힐 이, 수고할 이, 휘추리 이, 곁가지 이"),("苡", "율무 이, 질경이 이"),("飴", "엿 이, 맛 이"),("荑", "흰 비름 이, 베일 이, 벨 이"),("彝", "떳떳할 이, 법 이, 종묘 제기 이, 술통 이"),("迤", "든든할 이"),("訑", "자랑할 이"),("詑", "자랑할 이"),("洟", "콧물 이, 눈물 이, 못이름 이"),("咿", "선웃음칠 이, 책 읽는 소리 이"),("栮", "버섯 이, 느타리 이"),("尔", "爾와 同字"),("隶", "밑 이, 미치다 이"),("鮧", "창자젓 이"),]),
("이곡동", &[("梨谷洞", "지명"),]),
("이금동", &[("梨琴洞", "지명"),]),
("이기동", &[("耳基洞", "지명"),]),
("이도동", &[("二徒洞", "지명"),("梨島洞", "지명"),]),
("이동", &[("二洞", "지명"),("梨洞", "지명"),("泥洞", "지명"),]),
("이동면", &[("二東面", "지명"),]),
("이란", &[("以蘭", "이란"),("伊蘭", "이란"),]),
("이랍구", &[("伊拉久", "이라크"),]),
("이랍극", &[("伊拉克", "이라크"),]),
("이랑", &[("伊朗", "이란"),]),
("이로동", &[("泥老洞", "지명"),]),
("이류면", &[("利柳面", "지명"),]),
("이매", &[("二梅", "지명"),]),
("이목동", &[("梨木洞", "지명"),]),
("이문동", &[("里門洞", "지명"),]),
("이반성면", &[("二班城面", "지명"),]),
("이방면", &[("梨房面", "지명"),]),
("이백면", &[("二百面", "지명"),]),
("이비리아", &[("利比里亞", "라이베리아"),]),
("이비아", &[("利比亞", "리비아"),]),
("이사동", &[("二沙洞", "지명"),]),
("이산면", &[("伊山面", "지명"),]),
("이색렬", &[("伊色列", "이스라엘"),]),
("이서면", &[("二西面", "지명"),("伊西面", "지명"),]),
("이안면", &[("利安面", "지명"),]),
("이양면", &[("梨陽面", "지명"),]),
("이원면", &[("梨原面", "지명"),("伊院面", "지명"),]),
("이월면", &[("梨月面", "지명"),]),
("이의", &[("二儀", "지명"),]),
("이인면", &[("利仁面", "지명"),]),
("이장동", &[("泥場洞", "지명"),]),
("이창동", &[("二倉洞", "지명"),]),
("이천동", &[("梨川洞", "지명"),("泥川洞", "지명"),("梨泉洞", "지명"),]),
("이천시", &[("利川市", "지명"),]),
("이촌동", &[("二村洞", "지명"),]),
("이충동", &[("二忠洞", "지명"),]),
("이태리", &[("以太利", "이탈리아"),("伊太利", "이탈리아"),]),
("이태리아", &[("伊太利亞", "이탈리아"),]),
("이태원동", &[("梨泰院洞", "지명"),]),
("이패동", &[("二牌洞", "지명"),]),
("이평면", &[("梨坪面", "지명"),]),
("이현동", &[("二峴洞", "지명"),("梨峴洞", "지명"),]),
("이호동", &[("梨湖洞", "지명"),]),
("이홀동", &[("耳笏洞", "지명"),]),
("이화동", &[("梨花洞", "지명"),]),
("익", &[("益", "더할 익"),("翼", "날개 익"),("翊", "도울 익"),("溺", "빠질 닉, 약할 닉, 헤어 나오지 못할 닉"),("翌", "다음날 익"),("匿", "숨을 닉, 숨길 닉, 덮어둘 닉, 몰래 붙을 닉, 쌀 닉, 술 담는 그릇 닉"),("謚", "웃을 익, 웃는모양 익"),("瀷", "강이름 익, 스며흐를 익"),("弋", "주살 익, 취할 익, 홰 익, 검을 익, 벼슬이름 익, 오랑캐 익"),("鷁", "익새 익, 돛대 끝 바람개비 익"),("熤", "빛날 익, 사람이름 익"),]),
("익산시", &[("益山市", "지명"),]),
("익선동", &[("益善洞", "지명"),]),
("인", &[("人", "사람 인"),("仁", "어질 인"),("因", "인할 인"),("引", "끌 인, 이끌 인"),("印", "도장 인"),("寅", "세째지지 인, 범 인"),("忍", "참을 인"),("認", "알 인"),("隣", "鄰의 俗字, 이웃 인"),("姻", "혼인 인, 혼인할 인"),("咽", "목구멍 인, 목멜 인"),("麟", "기린 인"),("刃", "칼날 인"),("湮", "잠길 인, 없어질 인"),("鱗", "비늘 인"),("吝", "아낄 인, 인색할 인"),("燐", "도깨비불 인, 반딧불 인"),("蚓", "지렁이 인"),("靭", "韌과 同字, 질긴 고기 인"),("璘", "옥빛 인"),("茵", "자리 인, 사철쑥 인"),("絪", "기운 인, 수삼 인"),("靷", "가슴걸이 인"),("藺", "골풀 인, 뇌양이 인"),("堙", "막을 인"),("仞", "길 인"),("禋", "제사지낼 인"),("夤", "조심할 인"),("氤", "기운성할 인"),("裀", "요 인"),("婣", "姻과 同字"),("洇", "湮과 同字"),("扨", "그러하나 인"),("籾", "벼 인"),("芢", "씨 인"),("儿", "어진사람"),("亻", "사람인변"),("廴", "길게걷다"),]),
("인계", &[("仁溪", "지명"),]),
("인계면", &[("仁溪面", "지명"),]),
("인교동", &[("仁橋洞", "지명"),]),
("인니", &[("印尼", "인도네시아"),]),
("인덕동", &[("仁德洞", "지명"),]),
("인도", &[("印度", "인디아"),]),
("인도니서아", &[("印度尼西亞", "인도네시아"),]),
("인동", &[("仁洞", "지명"),]),
("인봉동", &[("仁鳳洞", "지명"),]),
("인사동", &[("仁寺洞", "지명"),]),
("인왕동", &[("仁旺洞", "지명"),]),
("인월동", &[("仁月洞", "지명"),]),
("인월면", &[("引月面", "지명"),]),
("인의동", &[("仁義洞", "지명"),]),
("인제군", &[("麟蹄郡", "지명"),]),
("인제동", &[("隣蹄洞", "지명"),]),
("인제읍", &[("麟蹄邑", "지명"),]),
("인주면", &[("仁州面", "지명"),]),
("인지동", &[("仁智洞", "지명"),]),
("인지면", &[("仁旨面", "지명"),]),
("인창동", &[("仁昌洞", "지명"),]),
("인천광역시", &[("仁川廣域市", "지명"),]),
("인평동", &[("仁平洞", "지명"),("人坪洞", "지명"),]),
("인현동", &[("仁峴洞", "지명"),]),
("인화동", &[("仁和洞", "지명"),]),
("인후동", &[("麟後洞", "지명"),]),
("일", &[("一", "한 일"),("日", "날 일"),("逸", "달아날 일, 편안할 일"),("壹", "한 일, 하나 일"),("鎰", "중량 일, 스물넉냥쭝 일"),("佾", "춤 일, 줄춤 일"),("溢", "넘칠 일"),("佚", "편안할 일, 편할 일"),("馹", "역말 일, 역마 일"),("軼", "앞지를 일"),("泆", "끊을 일"),]),
("일곡동", &[("日谷洞", "지명"),]),
("일광면", &[("日光面", "지명"),]),
("일도동", &[("一徒洞", "지명"),]),
("일동", &[("一洞", "지명"),]),
("일동면", &[("一東面", "지명"),]),
("일로읍", &[("一老邑", "지명"),]),
("일반성면", &[("一班城面", "지명"),]),
("일본", &[("日本", "일본"),]),
("일산구", &[("一山區", "지명"),]),
("일산동", &[("一山洞", "지명"),("日山洞", "지명"),]),
("일신동", &[("日新洞", "지명"),]),
("일운면", &[("一運面", "지명"),]),
("일원동", &[("逸院洞", "지명"),]),
("일월동", &[("日月洞", "지명"),]),
("일월면", &[("日月面", "지명"),]),
("일죽면", &[("一竹面", "지명"),]),
("일직동", &[("日直洞", "지명"),]),
("일직면", &[("一直面", "지명"),]),
("일패동", &[("一牌洞", "지명"),]),
("임", &[("林", "수풀 림, 더북더북 날 림"),("壬", "아홉째천간 임"),("任", "맡길 임, 맡을 임"),("臨", "임할 림, 군림할 림, 여럿이 울 림, 굽힐 림"),("賃", "품팔이 임, 빌릴 임"),("姙", "妊과 同字, 아이밸 임"),("淋", "지적지적할 림, 축일 림, 번지르르할 림, 물댈 임"),("稔", "곡식익을 임"),("荏", "들깨 임, 콩 임"),("恁", "생각할 임, 믿을 임"),("妊", "아이밸 임"),("衽", "옷깃 임"),("飪", "익힐 임"),("絍", "짤 임, 길쌈할 임"),("銋", "젖을 임"),]),
("임계면", &[("臨溪面", "지명"),]),
("임고면", &[("臨皐面", "지명"),]),
("임곡동", &[("林谷洞", "지명"),]),
("임당동", &[("林堂洞", "지명"),("林唐洞", "지명"),]),
("임동", &[("林洞", "지명"),]),
("임동면", &[("臨東面", "지명"),]),
("임상동", &[("林相洞", "지명"),]),
("임수동", &[("臨洙洞", "지명"),]),
("임실군", &[("任實郡", "지명"),]),
("임실읍", &[("任實邑", "지명"),]),
("임암동", &[("林岩洞", "지명"),]),
("임은동", &[("林隱洞", "지명"),]),
("임자면", &[("荏子面", "지명"),]),
("임천면", &[("林川面", "지명"),]),
("임피면", &[("臨陂面", "지명"),]),
("임하면", &[("臨河面", "지명"),]),
("임학동", &[("林鶴洞", "지명"),]),
("임회면", &[("臨淮面", "지명"),]),
("입", &[("入", "들 입"),("立", "설 입"),("笠", "우리 입, 삿갓 입"),("粒", "알 입, 쌀알 입"),("卄", "스물 입"),("廿", "스물 입"),]),
("입도완", &[("立陶宛", "리투아니아"),]),
("입면", &[("立面", "지명"),]),
("입북동", &[("笠北洞", "지명"),]),
("입석동", &[("立石洞", "지명"),]),
("입암동", &[("笠岩洞", "지명"),]),
("입암면", &[("立岩面", "지명"),("笠岩面", "지명"),]),
("입장면", &[("笠場面", "지명"),]),
("입정동", &[("笠井洞", "지명"),]),
("잉", &[("剩", "남을 잉"),("孕", "아이밸 잉"),("仍", "인할 잉, 이전의 잉"),("芿", "새풀싹 잉"),("媵", "보낼 잉"),]),
("자", &[("子", "아들 자"),("自", "스스로 자"),("者", "놈 자"),("字", "글자 자"),("姉", "姊의 俗字, 손윗누이 자"),("慈", "사랑할 자"),("資", "재물 자"),("姿", "맵시 자"),("玆", "이 자"),("紫", "자주빛 자, 검붉을 자"),("恣", "방자할 자"),("刺", "찌를 자"),("滋", "불을 자"),("疵", "흠 자, 죽은깨 자"),("雌", "암컷 자"),("磁", "자석 자"),("炙", "고기구을 자, 고기구이 자"),("諮", "물을 자, 꾀 자"),("藉", "깔개 자"),("煮", "삶을 자, 지질 자"),("仔", "자세할 자"),("蔗", "사탕수수 자"),("瓷", "오지그릇 자"),("咨", "물을 자, 원망할 자"),("孜", "힘쓸 자, 부지런할 자"),("茨", "가시나무 자, 납가새 자"),("茲", "무성할 자"),("貲", "재물 자"),("眦", "眥와 同字"),("孶", "부지런할 자"),("訾", "헐뜯을 자"),("赭", "붉은흙 자"),("粢", "피 자"),("髭", "코밑수염 자"),("觜", "털뿔 자"),("泚", "맑을 자"),("柘", "산뽕나무 자"),("耔", "복돋을 자"),("鷓", "자고 자"),("眥", "흘길 자"),("鶿", "가마우지 자"),("牸", "암컷 자"),("胾", "고깃점 자"),("呰", "주차할 자"),("鎡", "호미 자"),("莿", "풀가시 자"),("鮓", "젓 자"),("嬨", "계집성품너그러고순할 자"),("孖", "쌍둥이 자"),("茈", "지치 자"),("頿", "코밑수염 자"),]),
("자곡동", &[("紫谷洞", "지명"),]),
("자동", &[("子洞", "지명"),]),
("자산동", &[("玆山洞", "지명"),]),
("자양동", &[("紫陽洞", "지명"),]),
("자양면", &[("紫陽面", "지명"),]),
("자운동", &[("自雲洞", "지명"),]),
("자원동", &[("紫元洞", "지명"),]),
("자월면", &[("紫月面", "지명"),]),
("자은동", &[("自隱洞", "지명"),]),
("자은면", &[("慈恩面", "지명"),]),
("자인면", &[("慈仁面", "지명"),]),
("자일동", &[("自逸洞", "지명"),]),
("자작동", &[("紫作洞", "지명"),]),
("작", &[("作", "지을 작"),("昨", "어제 작"),("爵", "벼슬 작"),("酌", "따를 작, 참작할 작"),("杓", "구기 작"),("灼", "사를 작, 구을 작"),("雀", "참새 작"),("鵲", "까치 작"),("綽", "너그러울 작"),("勺", "구기 작, 잔질할 작"),("嚼", "씹을 작"),("芍", "작약 작"),("醋", "술잔을 돌릴 작"),("炸", "터질 작, 기름에 지질 작"),("斫", "벨 작, 쪼갤 작"),("酢", "초 작"),("怍", "부끄러울 작"),("焯", "밝을 작"),("碏", "삼갈 작"),("柞", "나무이름 작"),("岝", "산 높을 작"),("汋", "삶을 작"),("犳", "아롱 짐승 작"),("斱", "쪼갤 작"),]),
("작동", &[("鵲洞", "지명"),]),
("작산동", &[("鵲山洞", "지명"),]),
("작전동", &[("鵲田洞", "지명"),]),
("작천면", &[("鵲川面", "지명"),]),
("잔", &[("殘", "해칠 잔, 나머지 잔"),("盞", "작은 술잔 잔"),("棧", "잔교 잔, 사다리 잔"),("孱", "잔약할 잔"),("潺", "물이 줄줄 흐르는 모양 잔, 물졸졸흐르는 모양 잔"),("戔", "쌓일 잔"),("剗", "깍을 잔"),("驏", "안장 얹지 않은 말 잔"),]),
("잠", &[("潛", "잠길 잠"),("暫", "잠시 잠"),("蠶", "누에 잠"),("箴", "바늘 잠, 경계할 잠"),("簪", "비녀 잠"),("岑", "봉우리 잠, 높을 잠"),("潜", "潛의 俗字"),("蚕", "누에 잠"),("涔", "괸물 잠"),("濳", "潛의 俗字"),]),
("잠실동", &[("蠶室洞", "지명"),]),
("잠원동", &[("蠶院洞", "지명"),]),
("잠홍동", &[("潛紅洞", "지명"),]),
("잡", &[("雜", "섞일 잡, 잡될 잡"),("襍", "雜의 本字"),("磼", "산 높을 잡"),("卡", "관 잡"),("囃", "장단 잡을 잡"),("眨", "눈 깜작일 잡"),]),
("장", &[("長", "길 장"),("場", "마당 장"),("將", "장차 장, 장수 장"),("章", "문채 장, 글 장"),("壯", "씩씩할 장, 장할 장"),("狀", "모양 형상 장"),("張", "베풀 장"),("掌", "손바닥 장"),("丈", "어른 장, 길 장"),("腸", "창자 장"),("帳", "휘장 장막 장"),("障", "막을 장, 막힐 장"),("獎", "권면할"),("葬", "장사 지낼 장"),("藏", "감출 장"),("莊", "엄할 장, 씩씩할 장"),("墻", "牆과 同字, 담 장"),("裝", "차려 입을 장, 행장 장"),("粧", "단장할 장"),("臟", "오장 장"),("匠", "장인 장, 바치 장"),("庄", "장중할 장, 농막 장"),("璋", "끝의 반을 깎아 뾰족하게 한 홀 장, 서옥 장"),("蔣", "줄 장, 과장풀 장"),("樟", "녹나무 장, 노나무 장"),("杖", "지팡이 장"),("仗", "병장기 장, 의지할 장"),("獐", "노루 장"),("醬", "장 장, 간장 장"),("漿", "미음 장, 초 장"),("檣", "돛대 장"),("薔", "물여뀌 장, 장미꽃 장"),("奬", "도울 장, 클 장"),("臧", "착할 장, 거둘 장"),("贓", "장물 장"),("牆", "담 장"),("欌", "장농 장, 장롱 장"),("暲", "햇발이 돋아올 장, 밝을 장"),("装", "裝의 俗字"),("戕", "죽일 장"),("瘴", "장기 장"),("嶂", "높고 가파른 산 장"),("鏘", "금옥 소리 장"),("糚", "妝과 同字"),("漳", "강이름 장"),("萇", "나무 이름 장"),("奘", "클 장"),("賬", "치부책 장"),("麞", "노루 장"),("牂", "암양 장"),("妝", "꾸밀 장"),("嬙", "궁녀 장"),("廧", "담 장"),("鄣", "나라이름 장"),("傽", "놀랄 장"),("羘", "수양 장"),("餦", "산자 장"),("爿", "나무조각"),]),
("장계면", &[("長溪面", "지명"),]),
("장곡동", &[("長谷洞", "지명"),]),
("장곡면", &[("長谷面", "지명"),]),
("장관동", &[("壯觀洞", "지명"),]),
("장교동", &[("長橋洞", "지명"),]),
("장군동", &[("將軍洞", "지명"),]),
("장기동", &[("長基洞", "지명"),("場基洞", "지명"),]),
("장기면", &[("長岐面", "지명"),("長　面", "지명"),]),
("장남면", &[("長南面", "지명"),]),
("장단면", &[("長湍面", "지명"),]),
("장당동", &[("獐堂洞", "지명"),]),
("장대동", &[("場垈洞", "지명"),("將臺洞", "지명"),]),
("장덕동", &[("長德洞", "지명"),]),
("장동", &[("長洞", "지명"),("壯洞", "지명"),("獐洞", "지명"),]),
("장동면", &[("長東面", "지명"),]),
("장등동", &[("長燈洞", "지명"),]),
("장락동", &[("長樂洞", "지명"),]),
("장록동", &[("長錄洞", "지명"),]),
("장림동", &[("長林洞", "지명"),]),
("장마면", &[("丈麻面", "지명"),]),
("장명동", &[("長明洞", "지명"),]),
("장목면", &[("長木面", "지명"),]),
("장미동", &[("藏米洞", "지명"),]),
("장사동", &[("長沙洞", "지명"),("章沙洞", "지명"),]),
("장산면", &[("長山面", "지명"),]),
("장상동", &[("章上洞", "지명"),]),
("장생포동", &[("長生浦洞", "지명"),]),
("장성군", &[("長城郡", "지명"),]),
("장성남면", &[("長城南面", "지명"),]),
("장성동", &[("長省洞", "지명"),("長城洞", "지명"),]),
("장성읍", &[("長城邑", "지명"),]),
("장수군", &[("長水郡", "지명"),]),
("장수동", &[("長水洞", "지명"),("長壽洞", "지명"),]),
("장수면", &[("長壽面", "지명"),]),
("장수읍", &[("長水邑", "지명"),]),
("장승포동", &[("長承浦洞", "지명"),]),
("장안구", &[("長安區", "지명"),]),
("장안동", &[("長安洞", "지명"),("壯安洞", "지명"),]),
("장안면", &[("長安面", "지명"),]),
("장안읍", &[("長安邑", "지명"),]),
("장암동", &[("長岩洞", "지명"),("壯岩洞", "지명"),]),
("장암면", &[("場岩面", "지명"),]),
("장연면", &[("長延面", "지명"),]),
("장위동", &[("長位洞", "지명"),]),
("장유면", &[("長有面", "지명"),]),
("장재동", &[("長在洞", "지명"),("藏財洞", "지명"),]),
("장전동", &[("獐田洞", "지명"),("長箭洞", "지명"),]),
("장존동", &[("長存洞", "지명"),]),
("장지동", &[("長旨洞", "지명"),("長芝洞", "지명"),("墻枝洞", "지명"),]),
("장척동", &[("長尺洞", "지명"),]),
("장천동", &[("將川洞", "지명"),("長泉洞", "지명"),]),
("장천면", &[("長川面", "지명"),]),
("장충동", &[("奬忠洞", "지명"),]),
("장평면", &[("長平面", "지명"),("長坪面", "지명"),]),
("장하동", &[("章下洞", "지명"),]),
("장항동", &[("獐項洞", "지명"),]),
("장항읍", &[("長項邑", "지명"),]),
("장현동", &[("長峴洞", "지명"),("蔣峴洞", "지명"),]),
("장호원읍", &[("長湖院邑", "지명"),]),
("장화동", &[("長華洞", "지명"),]),
("장흥군", &[("長興郡", "지명"),]),
("장흥동", &[("長興洞", "지명"),]),
("장흥면", &[("長興面", "지명"),]),
("장흥읍", &[("長興邑", "지명"),]),
("재", &[("在", "있을 재, 살 재, 살필 재, 곳 재"),("才", "재주 재, 능할 재, 현인 재, 바탕 재"),("材", "재목 재, 늘미 재, 성품 재, 재주 재"),("再", "두 번 재, 거듭 재"),("財", "재물 재, 뇌물 재, 보배 재"),("哉", "비로소 재, 답다 재, 그런가 재, 어조사 재"),("栽", "심을 재"),("載", "실을 재, 이길 재, 비롯할 재, 가득할 재"),("災", "재앙 재, 천벌 재, 횡액 재"),("裁", "마름질할 재, 헤아릴 재, 결단할 재, 옷마를 재"),("宰", "주관할 재, 다스릴 재, 재상 재, 으뜸 재, 삶을 재"),("滓", "앙금 재, 찌끼 재"),("齋", "재계할 재, 집 재"),("梓", "가래나무 재, 목수 재, 우러러 볼 재, 고향 재, 노나무 재"),("縡", "일 재, 실을 재"),("渽", "맑을 재"),("齎", "탄식할 재, 쌀 재, 가질 재"),("灾", "災와 同字"),("纔", "겨우 재, 비롯할 재"),]),
("재궁동", &[("齋宮洞", "지명"),]),
("재동", &[("齋洞", "지명"),]),
("재득", &[("在得", "차드"),]),
("재산면", &[("才山面", "지명"),]),
("재송동", &[("栽松洞", "지명"),]),
("쟁", &[("爭", "다툴 쟁, 다스릴 쟁, 분별할 쟁"),("錚", "쇳소리 쟁그렁거릴 쟁, 징 쟁"),("諍", "간할 쟁"),("箏", "쟁 쟁, 풍경 쟁"),("崢", "가파를 쟁, 산 높을 쟁"),("鎗", "금석소리 쟁, 창 쟁, 총 쟁"),("瞠", "똑바로 볼 쟁"),("琤", "옥소리 쟁"),("猙", "밉살스럴 쟁, 짐승이름 쟁"),]),
("저", &[("低", "낮을 저, 값 쌀 저, 소리 약할 저, 숙일 저, 머뭇거릴 저"),("貯", "쌓을 저, 감출 저, 둘 저"),("著", "나타날 저, 널리 알려질 저, 글 지을 저, 옹저 저"),("底", "밑 저, 그칠 저"),("抵", "밀칠 저, 당할 저, 막을 저, 다달을 저, 씨름할 저"),("沮", "그칠 저, 막을 저, 무너질 저, 공갈할 저, 물이 번질 저, 나라이름 저"),("躇", "머뭇거릴 저"),("猪", "豬의 俗字, 돼지 저"),("邸", "사처 저, 주막 저, 홀바탕 저, 병풍 저, 집 저"),("咀", "씹을 저, 깨달을 저, 먹을 저"),("箸", "젓가락 저"),("詛", "저주할"),("狙", "원숭이 저, 엿볼 저, 살필 저"),("苧", "모시 저"),("儲", "쌓을 저, 버금 저, 용납할 저"),("楮", "닥나무 저, 종이돈 저, 감매나무 저"),("佇", "오래 설 저, 기다릴 저, 잠깐 머물 저, 우두커니설 저"),("這", "맞을 저, 이것 저, 여기 저"),("渚", "물가 저, 물 갈라질 저"),("紵", "모시 저"),("杵", "공이 저, 방망이 저, 혜성 저, 망치 저"),("疽", "등창 저"),("雎", "저구 저, 증경이 저, 원앙 저"),("樗", "가죽나무 저"),("菹", "김치 저, 푸서리 저"),("姐", "맏누이 저, 아가씨 저, 교만할 저"),("觝", "찌를 저, 받을 저, 씨름 저"),("藷", "마 저, 감자 저"),("齟", "이 어긋날 저"),("詆", "꾸짖을 저, 알소할 저, 비방할 저"),("氐", "낮을 저, 오랑캐 이름 저, 이를 저, 근본 저, 별이름 저"),("宁", "조회 받는 곳 저, 멈출 저"),("柢", "뿌리 저"),("瀦", "물 괼 저, 못 저, 웅덩이 저"),("苴", "암삼 저, 꾸러미 저, 대지팡이 저, 신바닥 저"),("杼", "북 저, 도토리 저"),("袛", "속적삼 저"),("潴", "瀦와 同字"),("牴", "찌를 저, 대강 저, 씨름 저, 당할 저"),("蛆", "구더기 저, 지네 저"),("羝", "숫양 저"),("褚", "주머니 저, 쌓을 저, 옷에 솜 둘 저"),("豬", "돼지 저, 물이 괼 저, 못이름 저"),("罝", "짐승 그물 저"),("岨", "돌산에 흙 덮일 저"),("陼", "모래섬 저, 둔덕 저, 언덕 저"),]),
("저동", &[("苧洞", "지명"),]),
("저전동", &[("楮田洞", "지명"),]),
("적", &[("赤", "붉을 적, 금치 적"),("的", "과녁 적, 꼭 그러할 적, 밝을 적"),("敵", "대적할 적, 원수 적, 무리 적, 막을 적"),("適", "맞갖을 적, 편안할 적, 깨달을 적, 시집갈 적, 좇을 적, 주장할 적, 마침 적"),("賊", "도적 적, 해칠 적, 도둑 적"),("積", "포갤 적, 모을 적, 넓이 적, 부피 적, 쌓을 적"),("籍", "문서 적, 왁자할 적, 호적 적, 압수할 적, 임금이 가는 밭 적"),("跡", "자취 적"),("績", "길쌈 적, 공 적, 이룰 적, 이을 적"),("摘", "딸 적, 돋구어낼 적, 움직일 적"),("寂", "고요할 적, 쓸쓸할 적"),("滴", "물방울 적, 물 댈 적"),("蹟", "행적 적, 자취 적, 사적 적"),("笛", "피리 적, 날라리 적"),("炙", "고기구이 적, 김 쏘일 적, 냄새 퍼질 적"),("迹", "발자국 적, 자취 적, 뒤따를 적"),("嫡", "정실 적, 맏아들 적"),("藉", "어수선할 적, 확자할 적, 임금이 가는 밭 적"),("謫", "귀양갈 적, 꾸짖을 적"),("狄", "북방 오랑캐 적, 꿩 그린 옷 적, 멀 적"),("吊", "슬퍼할"),("迪", "나아갈 적, 순할 적, 열어줄 적"),("勣", "공적 적, 사업 적"),("翟", "꿩의 깃 적, 황후의 옷 적"),("鏑", "화살촉 적"),("荻", "갈대 적, 쑥 적"),("糴", "쌀 사들일 적, 빠를 적"),("逖", "멀 적"),("覿", "볼 적"),("磧", "돌무더기 적, 모래벌 적"),("樀", "추녀 적, 도토마리 적, 방망이 적"),("菂", "연밥 적"),("馰", "별배기 적, 소태성 적"),]),
("적각동", &[("赤角洞", "지명"),]),
("적노동", &[("積老洞", "지명"),]),
("적도기내아", &[("赤道幾内亞", "적도 기니"),]),
("적량동", &[("積良洞", "지명"),]),
("적량면", &[("赤良面", "지명"),]),
("적상면", &[("赤裳面", "지명"),]),
("적서동", &[("赤西洞", "지명"),]),
("적선동", &[("積善洞", "지명"),]),
("적성면", &[("赤城面", "지명"),("積城面", "지명"),]),
("적중면", &[("赤中面", "지명"),]),
("적현동", &[("赤峴洞", "지명"),]),
("전", &[("田", "밭 전, 사냥할 전, 논 전"),("前", "앞 전, 옛 전, 인도할 전"),("全", "온전할 전, 갖출 전"),("電", "번개 전, 전기 전"),("戰", "싸움 전, 경쟁할 전"),("展", "펼칠 전, 열릴 전, 살필 전"),("傳", "전할 전, 펼 전, 이을 전, 주막 전, 책 전"),("典", "책 전, 법 전, 맡을 전, 도덕 전"),("錢", "돈 전, 가래 전"),("專", "오로지 전, 전일할 전"),("轉", "구를 전, 변할 전, 굴릴 전"),("殿", "대궐 전"),("顚", "이마 전, 엎드러질 전"),("甸", "경기 전"),("悛", "고칠 전, 차례 전"),("奠", "정할 전"),("箭", "화살 전, 약이름 전"),("銓", "사람 가릴 전, 저울질할 전"),("箋", "기록할 전, 글 전"),("塡", "메일 전, 북소리 전, 순종할 전, 병들 전, 막힐 전"),("餞", "전별잔치 전, 보낼 전"),("篆", "문체이름 전, 전자 전"),("纏", "둘릴 전, 묶을 전, 얽을 전"),("剪", "가위 전"),("煎", "달일 전, 불에 말릴 전, 다릴 전"),("廛", "전방 전, 터전 전"),("氈", "단자리 전, 전방석 전"),("輾", "돌아 누울 전"),("顫", "사지 떨릴 전, 머리 비뚤이 전"),("澱", "찌끼 전, 물 고일 전"),("癲", "미칠 전, 지랄병 전"),("栓", "말뚝 전, 나무못 전"),("鐫", "새길 전"),("詮", "평론할 전, 갖출 전"),("佺", "신선이름"),("佃", "밭 맬 전, 머슴꾼 전, 사냥할 전, 밭갈 전"),("鈿", "비녀 전, 보배로 꾸민 그릇 전"),("琠", "옥이름"),("筌", "통발 전"),("塼", "벽돌 전"),("畑", "화전 전, 밭 전"),("靦", "무안할 전, 물끄러미 볼 전"),("牋", "글 전, 표 전, 문체이름 전"),("畋", "사냥할 전"),("腆", "두터울 전, 지극할 전, 많이 차려놓을 전"),("顓", "어리석을 전, 오로지 전"),("翦", "베어 없앨 전, 멸할 전"),("瑱", "귀막이옥 전, 옥이름 전"),("痊", "병 나을 전"),("湔", "빨 전, 씻을 전, 물 번질 전"),("旃", "기 전, 말 그칠 전"),("躔", "햇길 전, 별자리 전"),("巓", "산 꼭대기 전"),("羶", "노린내날 전"),("荃", "향풀 전, 전풀 전"),("磚", "벽돌 전, 기와 전"),("鸇", "구진매 전"),("吮", "빨 전"),("甎", "벽돌 전, 기와 전"),("邅", "머뭇거릴 전"),("囀", "새 지저귈 전, 후렴 전"),("飦", "범벅 전, 된죽 전"),("澶", "물이름 전"),("揃", "가를 전, 자를 전, 가지런히 할 전"),("栴", "향나무 전"),("屇", "구멍 전"),("餰", "된죽 전"),("鱣", "전어 전"),("錪", "솥 전, 쇠 전"),("畠", "밭 전"),("籛", "성씨 전"),("膞", "썰 전, 질그릇 만드는 틀 전"),("輇", "달 전, 잴 전"),("嫥", "아름다울 전"),("癜", "어루러기 전"),("鄽", "가게 전"),("靛", "푸른 대 전"),("鬋", "수염 깎을 전, 귀밑 털 드릴 전"),]),
("전곡읍", &[("全谷邑", "지명"),]),
("전농동", &[("典農洞", "지명"),]),
("전동", &[("前洞", "지명"),("錢洞", "지명"),("殿洞", "지명"),]),
("전동면", &[("全東面", "지명"),]),
("전라남도", &[("全羅南道", "지명"),]),
("전라북도", &[("全羅北道", "지명"),]),
("전미동", &[("全美洞", "지명"),]),
("전민동", &[("田民洞", "지명"),]),
("전의면", &[("全義面", "지명"),]),
("전주시", &[("全州市", "지명"),]),
("전포동", &[("田浦洞", "지명"),]),
("전하동", &[("田下洞", "지명"),]),
("절", &[("節", "마디 절, 절개 절, 대마디 절"),("絶", "絕과 同字, 끊을 절"),("切", "끊을 절, 저밀 절, 정성스럴 절, 급할 절, 진맥할 절"),("折", "꺾을 절, 자를 절, 휘일 절, 알맞을 절"),("竊", "좀도둑 절, 얕을 절"),("截", "끊을 절, 말 잘할 절"),("浙", "쌀 씻을 절, 물이름 절"),("癤", "멍울 절, 부스럼 절"),("窃", "竊의 俗字"),("晢", "밝을 절, 비칠 절"),("岊", "산 모퉁이 우뚝 내밀 절"),("卩", "병부"),]),
("점", &[("店", "가게 점, 주막 점"),("點", "더러울 점, 뭉갤 점, 검은 점 점"),("占", "점칠 점, 날씨 볼 점, 점령할 점"),("漸", "번질 점, 물 흘러 들어갈 점, 점점 점, 차차 점"),("粘", "붙일 점, 끈끈할 점"),("霑", "젖을 점, 비 지정거릴 점"),("点", "點의 略字, 검은 점 점"),("岾", "고개 점, 절이름 점"),("鮎", "메기 점"),("玷", "옥의 티 점, 흠각 점"),("佔", "엿볼 점, 숙일 점"),("簟", "삿자리 점, 대 이름 점"),("苫", "이엉 점, 거적자리 점, 글씨 흘려 쓸 점"),("墊", "빠질 점, 축축할 점"),("黏", "붙일 점, 풀 점"),("颭", "펄렁거릴 점"),("蔪", "풀 벨 점, 보리 팰 점"),]),
("점곡면", &[("點谷面", "지명"),]),
("점동면", &[("占東面", "지명"),]),
("점량동", &[("占梁洞", "지명"),]),
("점암면", &[("占岩面", "지명"),]),
("점촌동", &[("店村洞", "지명"),]),
("접", &[("接", "사귈 접, 잇닿을 접, 대접할 접"),("蝶", "들나비 접"),("渫", "물결 출렁출렁할 접"),("摺", "접을 접, 패할 접"),("楪", "널평상 접"),("鰈", "가자미 접, 넙치 접"),("慴", "두려울 접, 겁낼 접"),("蹀", "저벅저벅 걸을 접"),("跕", "미끄러질 접"),("椄", "나무 접붙일 접, 형벌틀 접, 문설주 접"),("蜨", "나비 접"),]),
("정", &[("正", "바를 정, 과녁 정, 남쪽으로 난 창 정, 어른 정, 분별할 정"),("定", "정할 정, 편안할 정, 고요할 정"),("丁", "장정 정, 네째 천간 정, 고무래 정"),("政", "정사 정, 바르게 할 정, 조세 정"),("情", "뜻 정, 마음속 정"),("庭", "뜰 정, 곧을 정"),("停", "머무를 정, 늦어질 정"),("精", "정교할 정, 세밀할 정, 정할 정, 성실할 정, 신령 정, 정기 정"),("靜", "고요할 정, 조용할 정, 쉴 정, 편안할 정"),("貞", "곧을 정, 굳을 정"),("井", "우물 정, 단정할 정, 괘 이름 정, 천정 정, 저자 정"),("淨", "맑을 정, 조촐할 정"),("頂", "이마 정, 꼭대기 정, 관 꼭대기 치장하는 장식 정"),("廷", "조정 정, 바를 정, 곧을 정"),("征", "칠 정, 갈 정"),("程", "법 정, 한정 정, 과정 정, 품수 정, 헤아릴 정, 길 정"),("亭", "정자 정, 여관 정, 고를 정"),("整", "가지런할 정, 정돈할 정"),("鄭", "나라이름 정, 성씨 정, 정나라 정"),("訂", "바로잡을 정, 의논할 정"),("晶", "수정 정, 맑을 정, 빛날 정"),("呈", "보일 정, 드러낼 정"),("鼎", "솥 정, 바야흐로 정, 새로울 정"),("旌", "장목기 정, 표시할 정, 표할 정"),("挺", "빼어날 정, 너그러울 정, 향초이름 정, 뺄 정"),("禎", "상서로울 정"),("偵", "엿볼 정, 정탐할 정, 물을 정"),("汀", "물가 정, 수렁 정"),("楨", "담틀 마구리대 정, 단단한 나무 정, 쥐똥나무 정"),("艇", "거룻배 정, 작은 배 정"),("珽", "옥 이름 정, 뺄 정"),("靖", "다스릴 정, 편안할 정, 생각할 정"),("釘", "창 정, 못 정"),("幀", "그림족자 정"),("錠", "촛대 정, 덩이 정"),("碇", "닻돌 정, 배 멈출 정"),("穽", "구덩이 정, 함정 정"),("町", "밭 두덕 정, 정보 정, 시가 정, 밭지경 정"),("酊", "비틀거릴 정, 술취한 모양 정"),("睛", "눈 검은자위 정, 눈동자 정"),("炡", "데칠 정, 불 번쩍거릴 정"),("霆", "벼락 정, 번개 정"),("渟", "물 고일 정, 도랑 정, 물가 정"),("淀", "배댈"),("晸", "해돋는모양"),("綎", "띠술 정, 인끈 정"),("鉦", "징 정"),("瀞", "맑을 정, 정결할 정"),("玎", "옥소리 정"),("諪", "고를"),("檉", "능수버들 정, 수양버들 정"),("姃", "계집단정할"),("柾", "나무결 바를 정, 나무바를 정"),("湞", "물이름 정"),("鋌", "화살촉 정, 달음박질할 정, 쇳덩이 정"),("証", "간할 정"),("筳", "대쪽 정"),("靚", "단장할 정, 밝을 정"),("酲", "술병 정, 술 깰 정"),("梃", "외줄기 정, 막대 정, 꼿꼿할 정"),("怔", "황겁할 정, 가슴 두근두근할 정"),("叮", "단단히 부탁할 정, 정성스러울 정"),("棖", "문설주 정, 막대 정"),("莛", "풀 줄거리 정, 들보 정"),("婷", "아리따울 정, 쌀쌀할 정"),("珵", "노리개 정, 패옥 정"),("疔", "헌데 정"),("桯", "서안 정, 걸상 정"),("佂", "두려워할 정"),("掟", "둘러칠 정"),("遉", "순라군 정, 염탐할 정"),]),
("정곡면", &[("正谷面", "지명"),]),
("정관면", &[("鼎冠面", "지명"),]),
("정남면", &[("正南面", "지명"),]),
("정동", &[("貞洞", "지명"),]),
("정동면", &[("正東面", "지명"),]),
("정량동", &[("貞梁洞", "지명"),]),
("정릉동", &[("貞陵洞", "지명"),]),
("정림동", &[("正林洞", "지명"),]),
("정말", &[("丁抹", "덴마크"),]),
("정미면", &[("貞美面", "지명"),]),
("정방동", &[("正方洞", "지명"),]),
("정봉동", &[("丁峰洞", "지명"),]),
("정북동", &[("井北洞", "지명"),]),
("정산면", &[("定山面", "지명"),]),
("정상동", &[("井上洞", "지명"),("亭上洞", "지명"),("汀上洞", "지명"),]),
("정생동", &[("政生洞", "지명"),]),
("정선군", &[("旌善郡", "지명"),]),
("정선읍", &[("旌善邑", "지명"),]),
("정안면", &[("正安面", "지명"),]),
("정왕동", &[("正往洞", "지명"),]),
("정우면", &[("淨雨面", "지명"),]),
("정읍시", &[("井邑市", "지명"),]),
("정자", &[("亭子", "지명"),]),
("정자동", &[("亭子洞", "지명"),]),
("정족동", &[("鼎足洞", "지명"),]),
("정천면", &[("程川面", "지명"),]),
("정촌면", &[("井村面", "지명"),]),
("정평동", &[("正坪洞", "지명"),]),
("정하동", &[("井下洞", "지명"),("亭下洞", "지명"),("汀下洞", "지명"),]),
("제", &[("弟", "아우 제"),("第", "집 제, 차례 제"),("題", "이마 제, 제목 제"),("諸", "모든 제, 모두 제"),("祭", "제사 제"),("除", "섬돌 제, 덜 제"),("帝", "임금 제"),("製", "만들 제, 지을 제"),("制", "억제할 제, 제도 제"),("濟", "나루 제, 건널 제"),("提", "끌 제, 들 제"),("際", "사이 제, 모을 제"),("齊", "가지런할 제"),("堤", "둑 제, 방축 제"),("劑", "약 지을 제"),("悌", "공경할 제"),("蹄", "굽 제"),("梯", "사다리 제"),("啼", "울 제, 새지저귀는 소리 제"),("霽", "갤 제, 비갤 제"),("臍", "배꼽 제"),("薺", "냉이 제"),("醍", "맑은 술 제"),("荑", "띠싹 제"),("儕", "동배 제"),("躋", "오를 제"),("擠", "물리칠 제"),("隄", "堤와 同字"),("娣", "여동생 제"),("禔", "복 제"),("睇", "흘끗 볼 제"),("稊", "강아지풀 제"),("瑅", "제당 제"),("鯷", "메기 제"),("緹", "붉은 비단 제"),("踶", "찰 제"),("猘", "미친개 제"),("蹏", "蹄와 同字"),("韲", "양념할 제"),("鍗", "큰 가마 제"),("鮧", "복 제"),]),
("제기동", &[("祭基洞", "지명"),]),
("제덕동", &[("齊德洞", "지명"),]),
("제원면", &[("濟原面", "지명"),]),
("제월동", &[("堤月洞", "지명"),]),
("제주도", &[("濟州道", "지명"),]),
("제주시", &[("濟州市", "지명"),]),
("제천시", &[("堤川市", "지명"),]),
("제황산동", &[("帝皇山洞", "지명"),]),
("조", &[("朝", "아침 조"),("祖", "조상 조, 할아버지 조"),("助", "도울 조"),("鳥", "새 조"),("調", "고를 조"),("造", "지을 조"),("早", "새벽 조, 이를 조"),("兆", "조짐 조"),("條", "가지 조, 조목 조"),("照", "비출 조, 비칠 조"),("操", "잡을 조"),("租", "구실 조, 부세 조"),("弔", "위문할 조, 조상할 조"),("潮", "조수 조"),("組", "끈 조, 짤 조"),("跳", "뛸 조"),("趙", "조나라 조"),("曺", "성 조"),("祚", "복 조"),("燥", "마를 조, 불에말릴 조"),("措", "둘 조"),("遭", "만날 조"),("釣", "낚시 조"),("彫", "새길 조"),("曹", "무리 조"),("詔", "고할 조, 조서 조"),("阻", "험할 조, 막힐 조"),("粗", "거칠 조, 간략할 조"),("漕", "배로 실어 나를 조, 배로실어올 조"),("凋", "시들 조"),("稠", "빽빽할 조, 조밀할 조"),("藻", "조류 조, 글 조"),("肇", "비롯할 조, 비로소 조"),("嘲", "조롱할 조, 희롱할 조"),("爪", "손톱 조"),("眺", "바라볼 조, 멀리볼 조"),("躁", "떠들 조, 움직일 조"),("棗", "대추나무 조"),("糟", "지게미 조"),("繰", "야청 통견 조, 아청통견 조"),("雕", "독수리 조"),("俎", "도마 조"),("炤", "照와 同字"),("窕", "정숙할 조, 안존할 조"),("蚤", "벼룩 조"),("槽", "구유 조, 마구 조"),("晁", "朝의 古字, 아침 조"),("璪", "면루관 드림 옥 조, 면류관드림옥 조"),("噪", "떠들썩할 조"),("皁", "하인 조"),("祧", "조묘 조"),("徂", "갈 조"),("胙", "복 조"),("糶", "쌀 내어 팔 조"),("竈", "부엌 조"),("厝", "措와 同字"),("刁", "바라 조"),("譟", "시끄러울 조"),("鵰", "수리 조"),("澡", "씻을 조"),("蜩", "매미 조"),("殂", "죽을 조"),("鼂", "朝와 同字"),("臊", "누릴 조"),("嘈", "지껄일 조"),("佻", "방정맞을 조"),("蔦", "담쟁이 조"),("銚", "쟁개비 조"),("糙", "매조미쌀 조"),("找", "채울 조"),("誂", "꾈 조"),("傮", "마칠 조"),("嬥", "날씬할 조"),("懆", "근심할 조"),("笊", "조리 조"),("絩", "견직물 날실 수 조"),("艚", "거룻배 조"),("鈟", "낚시 조"),("鋽", "불리지 않은 쇠 조"),("鯛", "도미 조"),("爫", "손톱조"),]),
("조곡동", &[("稠谷洞", "지명"),]),
("조교동", &[("早橋洞", "지명"),]),
("조남동", &[("鳥南洞", "지명"),]),
("조도면", &[("鳥島面", "지명"),]),
("조례동", &[("照禮洞", "지명"),]),
("조리읍", &[("條里邑", "지명"),]),
("조마면", &[("助馬面", "지명"),]),
("조비동", &[("鳥飛洞", "지명"),]),
("조산동", &[("造山洞", "지명"),]),
("조선", &[("朝鮮", "조선민주주의인민공화국"),]),
("조선민주주의인민공화국", &[("朝鮮民主主義人民共和國", "조선민주주의인민공화국"),]),
("조성면", &[("鳥城面", "지명"),]),
("조안", &[("鳥安", "지명"),]),
("조암동", &[("槽岩洞", "지명"),]),
("조야동", &[("助也洞", "지명"),]),
("조양동", &[("朝陽洞", "지명"),]),
("조영동", &[("造永洞", "지명"),]),
("조와동", &[("助臥洞", "지명"),]),
("조원동", &[("棗園洞", "지명"),]),
("조천읍", &[("朝天邑", "지명"),]),
("조촌동", &[("助村洞", "지명"),]),
("조치원읍", &[("鳥致院邑", "지명"),]),
("조탄동", &[("助呑洞", "지명"),]),
("족", &[("足", "발 족"),("族", "겨레 족"),("簇", "모일 족, 가는대 족"),("鏃", "화살촉 족"),("瘯", "피부병 이름 족"),]),
("존", &[("存", "있을 존"),("尊", "존귀할 존, 높을 존"),("拵", "꽂을 존"),]),
("졸", &[("卒", "군사 졸"),("拙", "서툴 졸, 졸할 졸"),("猝", "갑자기 졸"),]),
("종", &[("終", "끝낼 종, 마칠 종"),("宗", "마루 종"),("種", "씨 종, 종류 종"),("從", "좇을 종"),("鐘", "쇠북 종"),("縱", "늘어질 종, 세로 종"),("腫", "부스럼 종"),("琮", "옥홀 종, 서옥이름 종"),("綜", "모을 종"),("踵", "발꿈치 종"),("踪", "자취 종"),("慫", "권할 종, 놀랄 종"),("鍾", "술병 종, 술잔 종"),("淙", "물 소리 종"),("悰", "즐길 종, 즐거울 종"),("棕", "종려나무 종"),("倧", "상고 신인 종, 옛적신인 종"),("蹤", "자취 종"),("瘇", "수종 종"),("螽", "누리 종"),("椶", "棕과 同字"),("粽", "주악 종"),("伀", "두려워할 종"),("慒", "생각할 종"),("柊", "방망이 종"),("樅", "전나무 종"),("瑽", "패옥소리 종"),]),
("종로", &[("鐘路", "지명"),]),
("종로구", &[("鍾路區", "지명"),]),
("종민동", &[("宗民洞", "지명"),]),
("종암동", &[("鍾岩洞", "지명"),]),
("종천면", &[("鍾川面", "지명"),]),
("종화동", &[("鍾和洞", "지명"),]),
("좌", &[("左", "왼 좌, 왼쪽 좌"),("坐", "앉을 좌"),("佐", "도울 좌"),("座", "자리 좌"),("挫", "꺽을 좌, 꺾을 좌"),("髽", "북상투 좌"),("剉", "꺽을 좌"),("莝", "여물 좌"),("痤", "뾰루지 좌"),("屮", "왼손"),]),
("좌동", &[("佐洞", "지명"),]),
("좌룡동", &[("佐龍洞", "지명"),]),
("좌부동", &[("左部洞", "지명"),]),
("좌천동", &[("佐川洞", "지명"),]),
("죄", &[("罪", "허물 죄"),]),
("주", &[("主", "주인 주"),("住", "살 주, 머무를 주"),("走", "달릴 주"),("注", "물댈 주"),("晝", "낮 주"),("朱", "붉을 주"),("宙", "집 주"),("酒", "술 주"),("州", "고을 주"),("周", "두루 주"),("舟", "배 주"),("柱", "기둥 주"),("洲", "섬 주, 물가 주"),("珠", "구슬 주, 진주 주"),("株", "그루 주"),("奏", "아뢸 주"),("鑄", "쇠 부어 만들 주, 쇠불릴 주"),("駐", "머무를 주, 말머무를 주"),("疇", "밭두둑 주"),("週", "돌 주, 주일 주"),("躊", "머뭇거릴 주, 주저할 주"),("誅", "벨 주"),("註", "주낼 주"),("紬", "명주 주"),("做", "지을 주, 만들 주"),("稠", "빽빽할 주"),("廚", "부엌 주"),("紂", "껑거리끈 주, 말고삐 주"),("嗾", "시킬"),("呪", "빌 주, 저주 주"),("輳", "모일 주, 몰려들 주"),("胄", "후사 주, 투구 주"),("籌", "투호 살 주, 셈대 주"),("湊", "모일 주, 물모일 주"),("綢", "얽힐 주, 빽빽할 주"),("澍", "단비 주"),("炷", "심지 주"),("蛛", "거미 주"),("姝", "예쁠 주"),("酎", "세 번 빚은 술 주"),("侏", "난쟁이 주, 난장이 주"),("霔", "장마 주"),("肘", "팔꿈치 주"),("儔", "무리 주"),("拄", "떠받칠 주"),("裯", "홑이불 주"),("遒", "다가설 주"),("賙", "진휼할 주"),("輈", "끌채 주"),("侜", "속일 주"),("幬", "휘장 주"),("腠", "살결 주"),("霌", "운우 모양 주"),("硃", "주사 주"),("蔟", "태주 주"),("尌", "세울 주"),("籒", "주문 주"),("蛀", "나무좀 주"),("詋", "呪와 同字"),("丟", "갈 주"),("趎", "사람이름 주"),("鉒", "쇳돌 주"),("鼄", "거미 주"),("妵", "예쁠, 사람 이름"),("丶", "불똥"),]),
("주교동", &[("舟橋洞", "지명"),]),
("주교면", &[("舟橋面", "지명"),]),
("주덕읍", &[("周德邑", "지명"),]),
("주례동", &[("周禮洞", "지명"),]),
("주문진읍", &[("注文津邑", "지명"),]),
("주미동", &[("舟尾洞", "지명"),]),
("주산동", &[("注山洞", "지명"),]),
("주산면", &[("舟山面", "지명"),("珠山面", "지명"),]),
("주삼동", &[("珠三洞", "지명"),]),
("주상면", &[("主尙面", "지명"),]),
("주생면", &[("周生面", "지명"),]),
("주성동", &[("酒城洞", "지명"),("鑄城洞", "지명"),]),
("주안동", &[("朱安洞", "지명"),]),
("주암동", &[("注岩洞", "지명"),]),
("주암면", &[("住巖面", "지명"),]),
("주약동", &[("株藥洞", "지명"),]),
("주엽동", &[("注葉洞", "지명"),]),
("주월동", &[("珠月洞", "지명"),]),
("주자동", &[("鑄字洞", "지명"),]),
("주전동", &[("朱田洞", "지명"),]),
("주천면", &[("朱川面", "지명"),("酒泉面", "지명"),]),
("주촌동", &[("舟村洞", "지명"),]),
("주촌면", &[("酒村面", "지명"),]),
("주포면", &[("周浦面", "지명"),]),
("주현동", &[("珠峴洞", "지명"),]),
("죽", &[("竹", "대 죽"),("粥", "죽 죽, 미음 죽"),]),
("죽곡동", &[("竹谷洞", "지명"),]),
("죽곡면", &[("竹谷面", "지명"),]),
("죽교동", &[("竹橋洞", "지명"),]),
("죽도동", &[("竹島洞", "지명"),]),
("죽동", &[("竹洞", "지명"),]),
("죽동동", &[("竹同洞", "지명"),]),
("죽림동", &[("竹林洞", "지명"),]),
("죽백동", &[("竹柏洞", "지명"),]),
("죽변면", &[("竹邊面", "지명"),]),
("죽산면", &[("竹山面", "지명"),]),
("죽성동", &[("竹城洞", "지명"),]),
("죽왕면", &[("竹王面", "지명"),]),
("죽율동", &[("竹栗洞", "지명"),]),
("죽장면", &[("竹長面", "지명"),]),
("죽전동", &[("竹田洞", "지명"),]),
("죽정동", &[("竹亭洞", "지명"),]),
("죽항동", &[("竹巷洞", "지명"),]),
("죽헌동", &[("竹軒洞", "지명"),]),
("준", &[("準", "수준기 준, 법 준"),("俊", "준걸 준"),("遵", "좇을 준"),("准", "승인할 준, 법 준"),("浚", "깊을 준"),("峻", "높을 준"),("駿", "준마 준"),("埈", "가파를 준, 높을 준"),("濬", "칠 준, 깊을 준"),("晙", "밝을 준"),("樽", "술그릇 준, 술단지 준"),("竣", "마칠 준, 일마칠 준"),("蠢", "꿈틀거릴 준, 꿈실거리는 준"),("儁", "雋·俊과 同字, 영특할 준"),("雋", "새살찔"),("畯", "俊과 同字, 농부 준"),("逡", "뒷걸음칠 준, 물러갈 준"),("寯", "모일 준"),("焌", "굽을 준, 불땔 준"),("罇", "樽·尊과 同字"),("蹲", "걸터앉을 준"),("隼", "새매 준"),("餕", "대궁 준"),("撙", "누를 준"),("惷", "어수선할 준"),("綧", "피륙의 폭의 넓이 준"),("噂", "수군거릴 준"),("踆", "그칠 준"),("皴", "주름 준"),("埻", "과녘 준"),("墫", "樽·罇과 同字"),("鐏", "창고달 준"),("鱒", "송어 준"),("鵔", "금계 준"),]),
("줄", &[("茁", "풀 처음 나는 모양 줄, 싹 줄"),("乼", "줄 줄"),]),
("줄포면", &[("茁浦面", "지명"),]),
("중", &[("中", "가운데 중"),("重", "무거울 중"),("衆", "무리 중"),("仲", "버금 중"),("眾", "衆의 本字"),]),
("중계동", &[("中溪洞", "지명"),]),
("중곡동", &[("中谷洞", "지명"),]),
("중구", &[("中區", "지명"),]),
("중국", &[("中國", "중화인민공화국"),]),
("중군동", &[("中軍洞", "지명"),]),
("중노송동", &[("中老松洞", "지명"),]),
("중대", &[("中大", "지명"),]),
("중대동", &[("中垈洞", "지명"),]),
("중덕동", &[("中德洞", "지명"),]),
("중도동", &[("中島洞", "지명"),]),
("중동", &[("中洞", "지명"),("仲洞", "지명"),]),
("중동면", &[("中東面", "지명"),]),
("중랑구", &[("中浪區", "지명"),]),
("중리동", &[("中里洞", "지명"),]),
("중림동", &[("中林洞", "지명"),]),
("중면", &[("中面", "지명"),]),
("중문동", &[("中文洞", "지명"),]),
("중방동", &[("中方洞", "지명"),]),
("중부동", &[("中部洞", "지명"),]),
("중부면", &[("中部面", "지명"),]),
("중산동", &[("中山洞", "지명"),]),
("중성동", &[("中城洞", "지명"),]),
("중안동", &[("中安洞", "지명"),]),
("중앙", &[("中央", "지명"),]),
("중앙동", &[("中央洞", "지명"),]),
("중앙로", &[("中央路", "지명"),]),
("중앙아불리가", &[("中央阿弗利加", "중앙아프리카 공화국"),]),
("중원구", &[("中院區", "지명"),]),
("중인동", &[("中仁洞", "지명"),]),
("중촌동", &[("中村洞", "지명"),]),
("중평동", &[("中坪洞", "지명"),]),
("중학동", &[("中學洞", "지명"),]),
("중화동", &[("中和洞", "지명"),]),
("중화산동", &[("中華山洞", "지명"),]),
("중흥동", &[("中興洞", "지명"),]),
("즉", &[("卽", "곧 즉"),("即", "卽의 俗字"),]),
("즐", &[("櫛", "빗 즐"),("騭", "수말 즐"),("喞", "두런거릴 즐"),]),
("즙", &[("汁", "즙 즙, 진액 즙"),("葺", "기울 즙, 지붕일 즙"),("楫", "노 즙, 돛대 즙"),("檝", "楫과 同字"),("蕺", "삼백초 즙"),]),
("증", &[("曾", "일찍 증"),("增", "불을 증, 더할 증"),("證", "증거 증, 보증할 증"),("贈", "보낼 증, 줄 증"),("症", "증세 증, 병증세 증"),("憎", "미워할 증"),("蒸", "찔 증"),("拯", "건질 증"),("烝", "김 오를 증"),("甑", "시루 증"),("繒", "비단 증"),("嶒", "산 높고 험할 증"),("矰", "주살 증"),("罾", "어망 증"),]),
("증도면", &[("曾島面", "지명"),]),
("증산동", &[("甑山洞", "지명"),("繒山洞", "지명"),]),
("증산면", &[("甑山面", "지명"),]),
("증일동", &[("曾日洞", "지명"),]),
("증평읍", &[("曾坪邑", "지명"),]),
("증포동", &[("增浦洞", "지명"),]),
("지", &[("地", "땅 지"),("知", "알 지"),("至", "이를 지"),("志", "뜻 지"),("之", "갈 지"),("止", "발 지, 그칠 지"),("紙", "종이 지"),("持", "가질 지"),("指", "손가락 지"),("識", "표할 지, 알 지"),("支", "가를 지, 지탱할 지"),("只", "다만 지"),("枝", "가지 지"),("智", "슬기 지, 지혜 지"),("池", "못 지"),("誌", "기록할 지"),("遲", "늦을 지, 더딜 지"),("旨", "맛있을 지, 뜻 지"),("址", "터 지"),("芝", "지초 지"),("脂", "기름 지, 비계 지"),("肢", "사지 지, 팔다리 지"),("祉", "복 지"),("咫", "길이 지, 여덟치 지"),("摯", "잡을 지, 쥘 지"),("枳", "탱자나무 지"),("祗", "공경할 지"),("趾", "발 지"),("祇", "마침 지"),("砥", "숫돌 지"),("贄", "폐백 지, 패백 지"),("漬", "담글 지, 물거품 지"),("沚", "물가 지, 모래톱 지"),("芷", "구리때 지, 백지 지"),("蜘", "거미 지"),("墀", "계단 위의 공지 지"),("秪", "벼 처음 익을 지"),("躓", "넘어질 지"),("舐", "핥을 지"),("踟", "머뭇거릴 지"),("篪", "저 이름 지"),("鷙", "맹금 지"),("榰", "주춧돌 지"),("坻", "모래섬 지"),("扺", "손바닥 지"),("軹", "굴대 머리 지"),("泜", "강 이름 지"),("阯", "터 지"),("痣", "사마귀 지"),("鮨", "젓갈 지"),]),
("지가동", &[("池柯洞", "지명"),]),
("지곡동", &[("紙谷洞", "지명"),("芝谷洞", "지명"),]),
("지곡면", &[("地谷面", "지명"),("池谷面", "지명"),]),
("지곶동", &[("紙串洞", "지명"),]),
("지귀동", &[("知歸洞", "지명"),]),
("지금동", &[("芝錦洞", "지명"),]),
("지나", &[("支那", "중화인민공화국"),("脂那", "중화인민공화국"),]),
("지내동", &[("池內洞", "지명"),]),
("지뉴동", &[("紙杻洞", "지명"),]),
("지도읍", &[("智島邑", "지명"),]),
("지동동", &[("池東洞", "지명"),]),
("지례면", &[("知禮面", "지명"),]),
("지리", &[("知里", "칠레"),("智里", "칠레"),("智利", "칠레"),]),
("지묘동", &[("智妙洞", "지명"),]),
("지변동", &[("池邊洞", "지명"),]),
("지보면", &[("知保面", "지명"),]),
("지북동", &[("池北洞", "지명"),]),
("지사동", &[("智士洞", "지명"),]),
("지사면", &[("只沙面", "지명"),]),
("지산동", &[("池山洞", "지명"),("芝山洞", "지명"),]),
("지산면", &[("智山面", "지명"),]),
("지석동", &[("支石洞", "지명"),]),
("지수면", &[("智水面", "지명"),]),
("지야동", &[("芝野洞", "지명"),]),
("지영동", &[("芝英洞", "지명"),]),
("지저동", &[("枝底洞", "지명"),]),
("지정동", &[("地正洞", "지명"),("池亭洞", "지명"),]),
("지정면", &[("芝正面", "지명"),]),
("지제동", &[("芝制洞", "지명"),]),
("지제면", &[("砥堤面", "지명"),]),
("지족동", &[("智足洞", "지명"),]),
("지좌동", &[("智佐洞", "지명"),]),
("지죽동", &[("芝竹洞", "지명"),]),
("지천동", &[("智川洞", "지명"),]),
("지천면", &[("枝川面", "지명"),]),
("지평동", &[("芝坪洞", "지명"),]),
("지품면", &[("知品面", "지명"),]),
("지행", &[("紙杏", "지명"),]),
("지현동", &[("之峴洞", "지명"),]),
("지흥동", &[("智興洞", "지명"),]),
("직", &[("直", "곧을 직"),("職", "벼슬 직, 직분 직"),("織", "짤 직"),("稷", "기장 직, 메기장 직"),("稙", "올벼 직"),("禝", "사람 이름 직"),]),
("직동", &[("直洞", "지명"),("稷洞", "지명"),]),
("직산읍", &[("稷山邑", "지명"),]),
("진", &[("眞", "참 진"),("進", "나아갈 진"),("盡", "다할 진"),("辰", "다섯째지지 진, 날 진"),("陳", "늘어놓을 진, 묵을 진"),("振", "떨칠 진"),("震", "벼락 진, 진동할 진"),("陣", "줄 진, 진칠 진"),("珍", "보배 진"),("鎭", "누를 진, 진압할 진"),("晉", "進과 同字, 나아갈 진"),("塵", "띠끌 진, 티끌 진"),("津", "나루 진"),("秦", "벼 이름 진, 진나라 진"),("診", "볼 진, 진맥할 진"),("嗔", "성낼 진, 꾸짖을 진"),("疹", "홍역 진, 마마 진"),("賑", "구휼할 진, 넉넉할 진"),("晋", "晉의 俗字, 나아갈 진"),("軫", "수레 뒤턱 나무 진, 구를 진"),("唇", "놀랄 진"),("搢", "꽂을 진"),("臻", "이를 진"),("殄", "끊어질 진, 다할 진"),("縉", "搢과 同字, 분홍빛 진"),("榛", "개암나무 진"),("袗", "홑옷 진, 고운 옷 진"),("瑨", "아름다운 돌 진, 옥돌 진"),("畛", "두렁길 진, 밭갈피 진"),("璡", "옥돌 진"),("縝", "삼실 진, 맺을 진"),("瞋", "부릅뜰 진, 눈부릅뜰 진"),("溱", "많을 진, 성할 진"),("桭", "평고대 진, 대청 진"),("蔯", "더워지기 진, 사철쑥 진"),("趁", "좇을 진"),("儘", "盡과 同字"),("稹", "떨기로 날 진"),("蓁", "우거질 진"),("珒", "옥 이름 진"),("鬒", "숱 많을 진"),("侲", "동자 진"),("鉁", "보배 진"),("螴", "설렐 진"),]),
("진건읍", &[("眞乾邑", "지명"),]),
("진곡동", &[("眞谷洞", "지명"),]),
("진관내동", &[("津寬內洞", "지명"),]),
("진관외동", &[("津寬外洞", "지명"),]),
("진교면", &[("辰橋面", "지명"),]),
("진단", &[("眞旦", "중화인민공화국"),("震旦", "중화인민공화국"),]),
("진도군", &[("珍島郡", "지명"),]),
("진도읍", &[("珍島邑", "지명"),]),
("진동면", &[("鎭東面", "지명"),("津東面", "지명"),]),
("진량읍", &[("珍良邑", "지명"),]),
("진례면", &[("進禮面", "지명"),]),
("진리동", &[("陳里洞", "지명"),]),
("진보면", &[("珍寶面", "지명"),]),
("진봉면", &[("進鳳面", "지명"),]),
("진부면", &[("珍富面", "지명"),]),
("진북동", &[("鎭北洞", "지명"),]),
("진북면", &[("鎭北面", "지명"),]),
("진산동", &[("辰山洞", "지명"),]),
("진산면", &[("珍山面", "지명"),]),
("진상면", &[("津上面", "지명"),]),
("진서면", &[("鎭西面", "지명"),("津西面", "지명"),]),
("진성면", &[("晉城面", "지명"),]),
("진안군", &[("鎭安郡", "지명"),]),
("진안읍", &[("鎭安邑", "지명"),]),
("진영읍", &[("進永邑", "지명"),]),
("진원면", &[("珍原面", "지명"),]),
("진월동", &[("眞月洞", "지명"),]),
("진월면", &[("津月面", "지명"),]),
("진위면", &[("振威面", "지명"),]),
("진인동", &[("眞仁洞", "지명"),]),
("진장", &[("津張", "투발루"),]),
("진장동", &[("珍庄洞", "지명"),]),
("진전면", &[("鎭田面", "지명"),]),
("진접", &[("榛接", "지명"),]),
("진주시", &[("晉州市", "지명"),]),
("진천군", &[("鎭川郡", "지명"),]),
("진천동", &[("辰泉洞", "지명"),]),
("진천읍", &[("鎭川邑", "지명"),]),
("진파포위", &[("辛巴威", "짐바브웨"),]),
("진평동", &[("眞坪洞", "지명"),]),
("진포동", &[("津浦洞", "지명"),]),
("진해시", &[("鎭海市", "지명"),]),
("진현동", &[("進峴洞", "지명"),]),
("질", &[("質", "바탕 질"),("疾", "병 질"),("秩", "차례 질"),("姪", "조카 질"),("迭", "갈마들 질, 침노할 질"),("跌", "넘어질 질, 달아날 질"),("窒", "막을 질"),("叱", "꾸짖을 질"),("嫉", "미워할 질, 질투할 질"),("帙", "책갑 질"),("佚", "흐릴 질"),("桎", "차꼬 질, 조카 질"),("膣", "새살 날 질, 음도 질"),("侄", "어리석을 질, 굳을 질"),("蛭", "거머리 질"),("瓆", "사람 이름 질"),("絰", "질 질"),("垤", "개밋둑 질"),("郅", "고을 이름 질"),("鑕", "모루 질"),("蒺", "납가새 질"),]),
("짐", &[("朕", "나 짐"),("斟", "술 따를 짐, 짐작할 짐"),("鴆", "짐새 짐"),]),
("집", &[("集", "모일 집, 모을 집"),("執", "잡을 집"),("輯", "모을 집"),("什", "세간 집, 열사람 집"),("緝", "낳을 집, 길쌈 집"),("潗", "샘솟을 집, 물끓을 집"),("鏶", "판금 집, 쇳조각 집"),("戢", "그칠 집"),("咠", "참소할 집"),]),
("집현면", &[("集賢面", "지명"),]),
("징", &[("徵", "부를 징"),("懲", "혼날 징, 징계할 징"),("澄", "맑을 징"),("澂", "澄과 同字"),("瀓", "맑을 징"),("瞪", "바로 볼 징"),("癥", "적취 징"),]),
("차", &[("車", "수레 차"),("次", "버금 차"),("此", "이 차"),("且", "또 차"),("借", "빌 차, 빌릴 차"),("差", "어긋날 차, 어길 차"),("茶", "차 차"),("叉", "깍지낄 차, 두갈래 차"),("遮", "막을 차, 가릴 차"),("嗟", "탄식할 차, 슬플 차"),("蹉", "넘어질 차, 지날 차"),("箚", "차자 차, 글 차"),("嵯", "우뚝 솟을 차, 험할 차"),("釵", "비녀 차"),("磋", "윤낼 차, 갈 차"),("侘", "실의할 차, 자랑할 차"),("槎", "뗏목 차"),("瑳", "깨끗할 차"),("佽", "도울 차"),("奓", "오만할 차"),("硨", "조개 이름 차"),("岔", "갈림길 차"),("偖", "찢을 차"),("徣", "빌릴 차"),]),
("차도", &[("茶都", "차드"),]),
("차룡동", &[("車龍洞", "지명"),]),
("차암동", &[("車岩洞", "지명"),]),
("차황면", &[("車黃面", "지명"),]),
("착", &[("着", "붙을 착, 부딪칠 착"),("著", "분명할 착"),("捉", "잡을 착"),("錯", "섞일 착"),("躇", "머뭇거릴 착"),("搾", "짤 착"),("鑿", "뚫을 착"),("窄", "좁을 착, 끼일 착"),("齪", "악착할 착, 악착같을 착"),("斲", "깎을 착"),("戳", "창으로 찌를 착"),("擉", "찌를 착"),("辵", "쉬엄쉬엄가다"),("辶", "책받침"),]),
("찬", &[("贊", "도울 찬"),("讚", "기릴 찬, 칭찬할 찬"),("餐", "먹을 찬, 삼킬 찬"),("瓚", "제기 찬, 옥그릇 찬"),("燦", "빛날 찬, 찬란할 찬"),("鑽", "끌 찬, 뚫을 찬"),("璨", "빛날 찬"),("撰", "지을 찬, 글지을 찬"),("饌", "반찬 찬"),("纂", "모을 찬"),("簒", "빼앗을 찬"),("竄", "숨을 찬, 숨길 찬"),("纘", "이을 찬"),("粲", "정미 찬, 정한 쌀밥 찬"),("澯", "맑을 찬"),("攢", "모일 찬"),("爨", "불땔 찬"),("欑", "모일 찬"),("巑", "높이 솟을 찬"),("趲", "놀라 흩어질 찬"),("儧", "모일 찬"),("儹", "모을 찬"),("劗", "끊을 찬"),]),
("찰", &[("察", "살필 찰"),("刹", "절 찰"),("札", "패 찰, 편지 찰"),("擦", "뿌릴 찰, 문지를 찰"),("紮", "감을 찰, 묶을 찰"),("扎", "뺄 찰"),("拶", "핍박할 찰"),]),
("참", &[("參", "간여할 참, 석 참"),("慘", "참혹할 참, 슬플 참"),("慙", "부끄러울 참"),("斬", "벨 참"),("站", "우두커니 설 참, 역마을 참"),("讒", "참소할 참, 간악할 참"),("僭", "참람할 참, 거짓 참"),("讖", "참서 참, 비결 참"),("塹", "구덩이 참"),("懺", "뉘우칠 참"),("叅", "의논할 참"),("慚", "부끄러울 참"),("驂", "곁마 참"),("譖", "참소할 참"),("黲", "검푸르죽죽할 참"),("巉", "가파를 참"),("嶄", "높을 참"),("槧", "판 참"),("鑱", "보습 참"),("憯", "슬퍼할 참"),("攙", "찌를 참"),("饞", "탐할 참"),("欃", "살별 참"),("儳", "어긋날 참"),("毚", "토끼 참"),("鏨", "끌 참"),]),
("창", &[("唱", "노래 창, 노래부를 창"),("窓", "창 창"),("昌", "창성할 창"),("倉", "곳집 창"),("創", "비롯할 창, 비로소 창"),("蒼", "푸를 창"),("暢", "펼 창, 화창할 창"),("彰", "밝을 창"),("滄", "찰 창, 서늘할 창"),("敞", "높을 창, 열 창"),("昶", "밝을 창"),("倡", "여광대 창, 계집광대 창"),("漲", "불을 창, 넘칠 창"),("槍", "창 창, 나무창 창"),("瘡", "부스럼 창"),("愴", "슬퍼할 창"),("脹", "배부를 창, 배불룩할 창"),("娼", "몸 파는 여자 창, 창녀 창"),("猖", "미쳐 날뛸 창, 놀랄 창"),("菖", "창포 창"),("廠", "헛간 창"),("艙", "선창 창"),("悵", "슬퍼할 창"),("搶", "닿을 창"),("鬯", "술"),("刱", "비롯할 창"),("倀", "미칠 창"),("蹌", "추창할 창"),("氅", "새털 창"),("惝", "멍할 창"),("窻", "창 창"),("傖", "천할 창"),("窗", "창 창"),("瑲", "옥 소리 창"),("凔", "찰 창"),("戧", "다칠 창"),]),
("창곡", &[("倉谷", "지명"),]),
("창곡동", &[("昌谷洞", "지명"),]),
("창구동", &[("倉邱洞", "지명"),]),
("창녕군", &[("昌寧郡", "지명"),]),
("창녕읍", &[("昌寧邑", "지명"),]),
("창동", &[("倉洞", "지명"),]),
("창선동", &[("昌善洞", "지명"),]),
("창선면", &[("昌善面", "지명"),]),
("창성동", &[("昌成洞", "지명"),("昌城洞", "지명"),]),
("창수면", &[("蒼水面", "지명"),]),
("창신동", &[("昌信洞", "지명"),]),
("창영동", &[("昌榮洞", "지명"),]),
("창우동", &[("倉隅洞", "지명"),]),
("창원시", &[("昌原市", "지명"),]),
("창인동", &[("昌仁洞", "지명"),]),
("창전동", &[("倉前洞", "지명"),("創前洞", "지명"),]),
("창죽동", &[("蒼竹洞", "지명"),]),
("창진동", &[("昌津洞", "지명"),]),
("창천동", &[("滄川洞", "지명"),]),
("창평동", &[("昌平洞", "지명"),("倉平洞", "지명"),]),
("창평면", &[("昌平面", "지명"),]),
("창포동", &[("昌浦洞", "지명"),]),
("채", &[("採", "캘 채"),("菜", "나물 채"),("采", "캘 채, 취할 채"),("彩", "무늬 채, 채색 채"),("債", "빚 채, 빚질 채"),("蔡", "거북 채, 채나라 채"),("埰", "영지 채, 사패땅 채"),("寨", "울짱 채, 나무우리 채"),("綵", "비단 채, 오색비단 채"),("釵", "비녀 채"),("寀", "녹봉 채, 동관 채"),("砦", "울타리 채, 울타리칠 채"),("茝", "구리때 채"),("棌", "참나무 채"),]),
("채색탁", &[("莱索托", "레소토"),]),
("채신동", &[("采新洞", "지명"),]),
("채운면", &[("彩雲面", "지명"),]),
("책", &[("責", "꾸짖을 책"),("冊", "책 책"),("策", "채찍 책, 꾀 책"),("柵", "울짱 책, 우리 책"),("翟", "꿩 책"),("簀", "살평상 책"),("嘖", "외칠 책"),("磔", "찢을 책"),("幘", "건 책"),("笧", "책 상자 책"),("蚱", "벼메뚜기 책"),]),
("처", &[("處", "살 처, 곳 처"),("妻", "아내 처"),("悽", "슬퍼할 처"),("凄", "쓸쓸할 처"),("萋", "풀 성하게 우거진 모양 처"),("淒", "쓸쓸할 처"),("覷", "엿볼 처"),("褄", "깃의 가 처"),("郪", "고을 이름 처"),]),
("척", &[("尺", "자 척"),("拓", "주울 척"),("斥", "물리칠 척, 내칠 척"),("戚", "겨레 척"),("刺", "찌를 척"),("隻", "새 한 마리 척, 짝 척"),("陟", "오를 척, 나아갈 척"),("滌", "씻을 척"),("擲", "던질 척, 버릴 척"),("瘠", "파리할 척"),("脊", "등성마루 척"),("倜", "대범할 척, 빼어날 척"),("慽", "근심할 척"),("剔", "바를 척, 없앨 척"),("蹠", "밟을 척, 뛸 척"),("惕", "두려워할 척"),("跖", "발바닥 척"),("摭", "주울 척"),("躑", "머뭇거릴 척"),("俶", "시작할 척"),("蜴", "도마뱀 척"),("塉", "메마른 땅 척"),("呎", "길이 단위 척"),("坧", "기지 척"),("彳", "자축거리다"),]),
("천", &[("天", "하늘 천"),("千", "일천 천"),("川", "내 천"),("泉", "샘 천"),("淺", "얕을 천"),("遷", "옮길 천"),("賤", "천할 천"),("薦", "천거할 천"),("踐", "밟을 천"),("串", "꿸 천"),("釧", "팔찌 천"),("擅", "멋대로 천, 오로지 천"),("穿", "뚫을 천, 통할 천"),("喘", "헐떡거릴 천, 헐떡일 천"),("闡", "열 천, 밝힐 천"),("阡", "두렁 천, 밭둑길 천"),("舛", "어그러질 천, 어수선할 천"),("韆", "그네 천"),("仟", "일천 천, 천사람 천"),("玔", "옥고리 천"),("蚕", "지렁이 천"),("荐", "거듭할 천"),("倩", "예쁠 천"),("濺", "흩뿌릴 천"),("洊", "이를 천"),("蕆", "경계할 천"),("蒨", "대가 우거질 천"),("芊", "풀 무성할 천"),("俴", "엷을 천"),("儃", "머뭇거릴 천"),("辿", "천천히 걸을 천"),("祆", "하늘 천"),("僢", "어그러질 천"),("瓩", "킬로그램 천"),("粁", "킬로메트르 천"),("臶", "거듭 천"),("靝", "하늘 천"),("巛", "내"),]),
("천가동", &[("天加洞", "지명"),]),
("천거동", &[("川渠洞", "지명"),]),
("천곡동", &[("泉谷洞", "지명"),]),
("천군동", &[("千軍洞", "지명"),]),
("천남동", &[("泉南洞", "지명"),]),
("천동", &[("泉洞", "지명"),]),
("천리달", &[("千里達", "트리니다드 토바고"),]),
("천리동", &[("泉里洞", "지명"),]),
("천북면", &[("川北面", "지명"),]),
("천선동", &[("遷善洞", "지명"),]),
("천성동", &[("天城洞", "지명"),]),
("천안시", &[("天安市", "지명"),]),
("천연동", &[("天然洞", "지명"),]),
("천왕동", &[("天旺洞", "지명"),]),
("천지동", &[("天池洞", "지명"),]),
("천천동", &[("泉川洞", "지명"),]),
("천천면", &[("天川面", "지명"),]),
("천현동", &[("泉峴洞", "지명"),]),
("천호동", &[("千戶洞", "지명"),]),
("철", &[("鐵", "쇠 철"),("哲", "밝을 철"),("徹", "통할 철, 관철할 철"),("撤", "거둘 철, 걷을 철"),("澈", "물 맑을 철"),("喆", "哲과 同字, 밝을 철"),("轍", "바퀴 자국 철, 수레자국 철"),("綴", "꿰맬 철, 맺을 철"),("凸", "볼록할 철, 뾰족할 철"),("輟", "그칠 철"),("銕", "鐵의 古字"),("掇", "주울 철"),("啜", "마실 철"),("惙", "근심할 철"),("餮", "탐할 철"),("歠", "마실 철"),("剟", "깎을 철"),("埑", "밝을 철"),("錣", "물미 철"),("飻", "탐할 철"),]),
("철마면", &[("鐵馬面", "지명"),]),
("철산동", &[("鐵山洞", "지명"),]),
("철암동", &[("鐵岩洞", "지명"),]),
("철원군", &[("鐵原郡", "지명"),]),
("철원읍", &[("鐵原邑", "지명"),]),
("첨", &[("添", "더할 첨"),("尖", "뾰족할 첨"),("瞻", "볼 첨, 쳐다볼 첨"),("僉", "다 첨"),("諂", "아첨할 첨"),("籤", "제비 첨"),("沾", "더할 첨, 절일 첨"),("詹", "이를 첨"),("簽", "농 첨"),("甛", "달 첨, 단 첨"),("忝", "더럽힐 첨"),("簷", "처마 첨"),("檐", "처마 첨"),("槧", "편지 첨"),("襜", "행주치마 첨"),("惉", "팰 첨"),("瀸", "적실 첨"),("幨", "휘장 첨"),("櫼", "쐐기 첨"),]),
("첩", &[("妾", "첩 첩"),("諜", "염탐할 첩, 이간할 첩"),("帖", "표제 첩, 문서 첩"),("牒", "글씨판 첩, 편지 첩"),("疊", "거듭 첩, 포갤 첩"),("貼", "붙을 첩, 붙일 첩"),("捷", "이길 첩"),("輒", "문득 첩"),("堞", "성가퀴 첩, 담 첩"),("睫", "속눈썹 첩, 속눈섭 첩"),("褶", "덧옷 첩, 겹옷 첩"),("喋", "재잘거릴 첩"),("怗", "고요할 첩"),("褺", "겹옷 첩"),("倢", "빠를 첩"),("呫", "맛 볼 첩, 귀에 대고 소근거릴 첩, 앙징할 첩"),]),
("첩고", &[("捷古", "체코"),]),
("첩극", &[("捷克", "체코"),]),
("청", &[("靑", "푸를 청"),("淸", "맑을 청"),("請", "청할 청"),("聽", "들을 청"),("晴", "갤 청"),("廳", "관청 청"),("菁", "부추꽃 청, 초목무성한 모양 청"),("鯖", "청어 청"),("凊", "서늘할 청"),("圊", "뒷간 청"),("蜻", "귀뚜라미 청"),("鶄", "교청새 청"),]),
("청계동", &[("淸溪洞", "지명"),]),
("청계면", &[("靑溪面", "지명"),]),
("청기면", &[("靑杞面", "지명"),]),
("청남면", &[("靑南面", "지명"),]),
("청담동", &[("淸潭洞", "지명"),]),
("청당동", &[("淸堂洞", "지명"),]),
("청덕면", &[("靑德面", "지명"),]),
("청도군", &[("淸道郡", "지명"),]),
("청도면", &[("淸道面", "지명"),]),
("청도읍", &[("淸道邑", "지명"),]),
("청동", &[("靑洞", "지명"),]),
("청라면", &[("靑蘿面", "지명"),]),
("청량동", &[("靑良洞", "지명"),("淸凉洞", "지명"),]),
("청량리동", &[("淸凉里洞", "지명"),]),
("청량면", &[("靑良面", "지명"),]),
("청룡동", &[("靑龍洞", "지명"),]),
("청리면", &[("靑里面", "지명"),]),
("청림동", &[("靑林洞", "지명"),]),
("청북면", &[("靑北面", "지명"),]),
("청산면", &[("靑山面", "지명"),]),
("청성면", &[("靑城面", "지명"),]),
("청소면", &[("靑所面", "지명"),]),
("청송군", &[("靑松郡", "지명"),]),
("청송읍", &[("靑松邑", "지명"),]),
("청수동", &[("淸水洞", "지명"),]),
("청안동", &[("晴安洞", "지명"),]),
("청안면", &[("淸安面", "지명"),]),
("청암동", &[("淸岩洞", "지명"),]),
("청암면", &[("靑岩面", "지명"),]),
("청양군", &[("靑陽郡", "지명"),]),
("청양읍", &[("靑陽邑", "지명"),]),
("청운동", &[("淸雲洞", "지명"),]),
("청운면", &[("靑雲面", "지명"),]),
("청웅면", &[("靑雄面", "지명"),]),
("청원군", &[("淸原郡", "지명"),]),
("청일면", &[("晴日面", "지명"),]),
("청전동", &[("靑田洞", "지명"),]),
("청주시", &[("淸州市", "지명"),]),
("청진동", &[("淸進洞", "지명"),]),
("청천동", &[("淸川洞", "지명"),]),
("청천면", &[("靑川面", "지명"),]),
("청통면", &[("淸通面", "지명"),]),
("청파동", &[("靑坡洞", "지명"),]),
("청풍동", &[("淸風洞", "지명"),]),
("청풍면", &[("淸風面", "지명"),("淸豊面", "지명"),]),
("청하면", &[("淸河面", "지명"),("靑蝦面", "지명"),]),
("청학동", &[("靑鶴洞", "지명"),]),
("청호동", &[("靑湖洞", "지명"),("淸湖洞", "지명"),]),
("체", &[("體", "몸 체"),("切", "자를 체, 끊을 체"),("遞", "갈마들 체"),("滯", "막힐 체, 쌓일 체"),("替", "바꿀 체, 대신할 체"),("逮", "미칠 체, 잡아가둘 체"),("締", "맺을 체"),("涕", "눈물 체"),("綴", "꿰멜 체"),("諦", "살필 체"),("剃", "머리 깎을 체, 머리깍을 체"),("体", "몸 체"),("軆", "몸 체"),("砌", "섬돌 체"),("棣", "산앵두나무 체"),("彘", "돼지 체"),("蔕", "작은 가시 체"),("蒂", "작은 가시 체"),("殢", "나른할 체"),("靆", "구름 낄 체"),("嚏", "재채기 할 체"),]),
("체부동", &[("體府洞", "지명"),]),
("초", &[("草", "풀 초"),("初", "처음 초"),("招", "부를 초"),("超", "뛰어넘을 초"),("礎", "주춧돌 초"),("抄", "베낄 초"),("肖", "닮을 초"),("秒", "시간 단위 초"),("哨", "망 볼 초"),("楚", "회초리 초, 초나라 초"),("焦", "그슬릴 초, 탈 초"),("礁", "암초 초"),("稍", "벼 줄기 끝 초, 점점 초"),("樵", "땔나무 초"),("貂", "담비 초, 돈피 초"),("梢", "나무 끝 초, 농기 초"),("炒", "볶을 초"),("憔", "수척할 초, 파리할 초"),("硝", "초석 초"),("蕉", "파초 초"),("醋", "초산 초"),("醮", "초례 초"),("椒", "산초나무 초, 후추 초"),("酢", "초 초"),("剿", "죽일 초, 노략질할 초"),("艸", "풀 초"),("苕", "능소화 초, 능토풀 초"),("迢", "멀 초"),("誚", "꾸짖을 초"),("勦", "수고롭게 할 초"),("悄", "근심할 초"),("綃", "생명주실 초"),("鈔", "노략질할 초"),("軺", "수레 초"),("峭", "가파를 초"),("怊", "슬퍼할 초"),("愀", "정색할 초"),("髫", "다박머리 초"),("鞘", "칼집 초"),("譙", "꾸짖을 초"),("杪", "끝 초"),("噍", "먹을 초"),("岧", "산이 높을 초"),("燋", "홰 초"),("鷦", "뱁새 초"),("顦", "야윌 초"),("趠", "멀 초"),("僬", "밝게 살필 초"),("嶕", "높을 초"),("鍬", "가래 초"),("偢", "얼이 빠져 있을 초"),("嫶", "수척할 초"),("耖", "밭 거듭 갈 초"),("鍫", "가래 초"),("齠", "이를 갈 초"),("艹", "초두"),]),
("초계면", &[("草溪面", "지명"),]),
("초구동", &[("草邱洞", "지명"),]),
("초당동", &[("草堂洞", "지명"),]),
("초동", &[("草洞", "지명"),]),
("초동면", &[("初同面", "지명"),]),
("초량동", &[("草梁洞", "지명"),]),
("초사동", &[("草沙洞", "지명"),]),
("초산동", &[("草山洞", "지명"),]),
("초월읍", &[("草月邑", "지명"),]),
("초읍동", &[("草邑洞", "지명"),]),
("초이동", &[("草二洞", "지명"),]),
("초일동", &[("草一洞", "지명"),]),
("초장동", &[("草場洞", "지명"),]),
("초전동", &[("草田洞", "지명"),]),
("초전면", &[("草田面", "지명"),]),
("초지동", &[("草芝洞", "지명"),]),
("초촌면", &[("草村面", "지명"),]),
("초평동", &[("草坪洞", "지명"),]),
("초평면", &[("草坪面", "지명"),]),
("촉", &[("觸", "받을 촉, 느낄 촉, 지날 촉, 범할 촉, 찌를 촉"),("屬", "이을 촉, 닿을 촉, 부탁할 촉, 모을 촉, 조심할 촉"),("燭", "爥의 俗字, 촛불 촉"),("促", "핍박할 촉, 촉박할 촉, 좁을 촉, 빠를 촉, 짧을 촉, 재촉할 촉"),("蜀", "촉규화벌레 촉, 큰 닭 촉, 나라이름 촉"),("囑", "부탁할 촉"),("矗", "곧을 촉, 우뚝 솟을 촉, 우뚝할 촉"),("躅", "자취 촉, 강동강동 뛸 촉, 철쭉꽃 촉"),("矚", "볼 촉"),("髑", "해골 촉"),("爥", "비칠 촉"),("曯", "비칠 촉"),("薥", "촉규화 촉, 자귀밥 촉"),]),
("촌", &[("寸", "치 촌, 마디 촌, 헤아릴 촌, 조금 촌"),("村", "마을 촌, 밭집 촌, 시골 촌"),("忖", "헤아릴 촌, 짐작할 촌"),("邨", "村과 同字, 마을 촌"),("吋", "인치(inch) 촌"),]),
("총", &[("總", "꿰맬 총, 거느릴 총, 합할 총, 끄덩이 잡을 총"),("聰", "귀 밝을 총, 민첩할 총, 귀맑을 총"),("銃", "도끼 구멍 총, 총 총"),("寵", "사랑할 총, 임금께 총애받을 총, 은혜 총, 첩 총"),("叢", "떨기 총, 모을 총, 번잡할 총"),("塚", "冢의 俗字, 무덤 총"),("摠", "거느릴 총, 모을 총, 무리 총, 장수 총"),("悤", "바쁠 총, 덤빌 총"),("蔥", "파 총, 파 뿌리 총, 푸를 총"),("憁", "바쁠"),("葱", "풀 더북할 총"),("驄", "총이말 총"),("蓯", "풀 더북할 총"),("鏦", "창 총, 찌를 총"),("騘", "驄과 同字"),]),
("촬", &[("撮", "머리 끄덩이 잡을 촬, 당길 촬, 비칠 촬, 사진찍을 촬"),]),
("최", &[("最", "가장 최, 우뚝할 최, 넉넉할 최"),("催", "재촉할 최, 핍박할 최, 일어날 최"),("崔", "산 우뚝할 최, 높고 가파를 최, 성씨 최"),("摧", "꺾을 최, 망할 최, 저지할 최"),("榱", "서까래 최"),("璀", "옥빛 찬란할 최, 구슬 주렁주렁 달릴 최"),("漼", "깊을 최, 고을 최, 눈물 줄줄 흘릴 최, 눈서리 쌓일 최"),("縗", "상복 최, 상옷 최"),("嘬", "물 최, 산적 한 입에 넣을 최"),("磪", "험하고 높을 최"),]),
("추", &[("秋", "가을 추, 세월 추, 때 추, 말이 뛰놀 추, 성씨 추"),("推", "옮길 추, 가릴 추, 궁구할 추, 차례로옮길 추"),("丑", "수갑 추, 사람이름 추"),("追", "쫓을 추, 따를 추"),("抽", "뺄 추, 뽑을 추, 당길 추, 거둘 추"),("醜", "추할 추, 같을 추, 무리 추, 자라똥구멍 추, 부끄러울 추"),("趨", "달아날 추, 추창할 추"),("鄒", "추나라 추, 나라이름 추"),("楸", "가래나무 추, 노나무 추, 산유자 추, 바둑판 추"),("椎", "쇠몽둥이 추, 칠 추, 짓찧을 추, 참나무 추, 쇠뭉치 추"),("樞", "밑둥 추, 지두리 추, 고동 추, 북두 첫째 별 추, 긴요할 추, 달 추, 가운데 추, 지도리 추"),("墜", "떨어질 추, 잃을 추, 추락할 추"),("酋", "괴수 추, 두목 추, 숙 익을 추, 끝날 추"),("芻", "꼴 추, 짐승먹이 추, 풀벨 추"),("錐", "송곳 추"),("槌", "칠 추"),("錘", "저울눈 추, 마치 추, 저울 추"),("鎚", "쇠마치 추, 저울 추"),("鰍", "미꾸라지 추"),("雛", "새 새끼 추, 병아리 추, 어린아이 추, 날짐승 새끼 추"),("騶", "거덜 추, 마부 추, 짐승이름 추"),("皺", "쭈그러질 추, 추할 추"),("諏", "꾀할 추, 물을 추"),("湫", "늪 추, 폭포 추, 찌푸릴 추, 서늘할 추"),("杻", "수갑 추, 조막손이 추"),("萩", "맑은 대쑥 추, 가래나무 추"),("麤", "성길 추, 클 추, 거칠 추"),("蒭", "芻와 同字"),("瘳", "병 나을 추, 덜릴 추"),("惆", "실심할 추, 섭섭할 추"),("簉", "버금 추, 가지런히 날 추"),("陬", "벼루 추, 정월 추, 부끄러울 추, 마을 추"),("箠", "채찍 추, 볼기채 추"),("啾", "두런거릴 추, 찍찍거릴 추"),("箒", "비 추"),("搥", "북 칠 추"),("帚", "비 추, 털 추"),("鞦", "그네 추, 말고들개 추"),("僦", "임금 추, 고용할 추"),("甃", "우물 벽돌 추"),("捶", "종아리 칠 추, 짓찧을 추"),("縋", "줄에 달릴 추"),("魋", "북상투 추"),("娵", "젊을 추, 물고기 추, 예쁜 여자 추"),("騅", "청부루말 추"),("鰌", "미꾸라지 추, 빙자할 추, 해추 추"),("縐", "주름 추, 구길 추"),("鶖", "두루미 추"),("隹", "새 추"),("揫", "묶을 추, 거둘 추, 모을 추"),("鵻", "아롱비둘기 추"),("龝", "秋의 古字"),]),
("추동", &[("秋洞", "지명"),]),
("추목동", &[("秋木洞", "지명"),]),
("추부면", &[("秋富面", "지명"),]),
("추산동", &[("騶山洞", "지명"),]),
("추암동", &[("湫岩洞", "지명"),]),
("추자면", &[("楸子面", "지명"),]),
("추풍령면", &[("秋風嶺面", "지명"),]),
("축", &[("祝", "빌 축, 끊을 축, 비로소 축"),("丑", "소 축, 축시 축, 북동쪽 축"),("築", "다질 축, 쌓을 축"),("逐", "쫓을 축, 물리칠 축"),("縮", "줄어들 축, 물러갈 축, 거둘 축, 모자랄 축, 오그라질 축"),("畜", "가축 축, 쌓을 축, 그칠 축"),("蓄", "쌓을 축, 모을 축, 감출 축"),("軸", "바디집 축, 질책 축, 속바퀴 축, 얇을 축, 굴대 축"),("蹴", "찰 축, 밟을 축"),("柚", "북 축"),("蹙", "찡그릴 축, 쭈그러질 축"),("筑", "비파 축"),("竺", "나라이름 축"),("舳", "고물 축, 배 꼬리 축"),("蹜", "발 끌어 디딜 축"),("豖", "발 얽은 돼지걸음 축"),("槭", "단풍나무 축"),("妯", "동서 축"),("鼀", "두꺼비 축"),]),
("축복동", &[("祝福洞", "지명"),]),
("축산면", &[("丑山面", "지명"),]),
("춘", &[("春", "봄 춘, 남녀의 정 춘, 술 춘, 온화할 춘"),("椿", "참죽나무 춘, 대춘나무 춘, 어르신네 춘"),("瑃", "옥이름"),]),
("춘궁동", &[("春宮洞", "지명"),]),
("춘산면", &[("春山面", "지명"),]),
("춘양면", &[("春陽面", "지명"),]),
("춘의동", &[("春衣洞", "지명"),]),
("춘천시", &[("春川市", "지명"),]),
("춘포면", &[("春浦面", "지명"),]),
("출", &[("出", "날 출, 게울 출, 도망할 출, 보일 출, 낳을 출, 물러갈 출, 생질 출"),("黜", "내칠 출, 물리칠 출"),("朮", "삽주뿌리 출"),("秫", "차조 출"),]),
("충", &[("忠", "충성 충, 곧을 충"),("充", "가득찰 충, 막을 충, 당할 충"),("蟲", "벌레 충, 김 오를 충"),("衝", "충돌할 충, 찌를 충, 거리 충, 돌파할 충"),("衷", "가운데 충, 정성 충, 착할 충, 속곳 충, 마음 충"),("沖", "깊을 충, 온화할 충, 어릴 충"),("冲", "깊을 충, 온화할 충, 어릴 충"),("虫", "벌레 충"),("忡", "근심할 충"),]),
("충무동", &[("忠武洞", "지명"),]),
("충무로", &[("忠武路", "지명"),]),
("충신동", &[("忠信洞", "지명"),]),
("충의동", &[("忠義洞", "지명"),]),
("충인동", &[("忠仁洞", "지명"),]),
("충장로", &[("忠壯路", "지명"),]),
("충정로", &[("忠正路", "지명"),]),
("충주시", &[("忠州市", "지명"),]),
("충청남도", &[("忠淸南道", "지명"),]),
("충청북도", &[("忠淸北道", "지명"),]),
("충화면", &[("忠化面", "지명"),]),
("충효동", &[("忠孝洞", "지명"),]),
("췌", &[("悴", "근심할 췌, 파리할 췌, 피폐할 췌, 초췌할 췌"),("萃", "모을 췌, 괘 이름 췌"),("贅", "붙일 췌, 데릴사위 췌, 혹 췌, 군더더기 췌"),("膵", "첩육경 췌, 지라 췌, 췌장 췌"),("惴", "두려워할 췌"),]),
("취", &[("取", "거둘 취, 찾을 취, 받을 취, 빼앗을 취, 장가들 취, 취할 취"),("就", "좇을 취, 이룰 취, 곧 취, 가령 취, 능할 취, 저자 취, 나아갈 취"),("吹", "불 취, 숨쉴 취, 악기 불 취, 부를 취, 충동할 취"),("趣", "추창할 취, 뜻 취"),("臭", "냄새 취, 향기 취, 썪을 취, 고약한 이름 취"),("醉", "술취할 취, 궤란할 취"),("聚", "모을 취, 고을 취, 걷을 취, 쌓을 취"),("炊", "불 지필 취, 밥 지을 취, 불땔 취"),("娶", "장가들 취, 중개인 취"),("翠", "비취 취, 푸를 취, 깃푸른새 취"),("脆", "연할 취, 약할 취"),("驟", "몰아갈 취, 달릴 취, 별안간 취, 말몰 취"),("鷲", "독수리 취"),("嘴", "부리 취"),("揣", "잴 취, 시험할 취, 요량할 취"),("觜", "부리 취"),("毳", "솜털 취, 연하고 부드러울 취"),("冣", "쌓을 취, 모을 취"),]),
("취암동", &[("鷲岩洞", "지명"),]),
("측", &[("測", "측량할 측, 깊을 측, 맑을 측, 날카로울 측, 헤아릴 측"),("側", "곁 측, 기울어질 측, 저물 측, 배반할 측, 가까울 측, 미천할 측, 아플 측"),("惻", "슬플 측, 감창할 측, 아플 측, 불쌍할 측, 불쌍히여길 측"),("仄", "기울 측, 성조 측, 물이 괄괄 흐를 측, 희미할 측, 옆 측, 돈 이름 측"),("厠", "뒷간 측, 평상 가장자리 측, 섞일 측, 기울 측"),]),
("측후동", &[("測候洞", "지명"),]),
("층", &[("層", "겹 층, 거듭 층, 층층대 층"),]),
("치", &[("治", "다스릴 치, 다듬을 치, 익을 치, 치료할 치"),("致", "이를 치, 극진할 치, 버릴 치, 불러올 치, 풍치 치, 드릴 치, 보낼 치, 연구할 치"),("齒", "이 치, 나이 치, 같을 치"),("置", "베풀 치, 버릴 치, 역말 치, 안치할 치, 둘 치"),("恥", "부끄럼 치, 욕될 치, 부끄러울 치"),("値", "값 치, 가치있을 치, 만날 치, 당할 치"),("徵", "치성 치"),("雉", "꿩 치, 폐백 치, 성 윗담 치, 목맬 치"),("痴", "癡의 俗字, 어리석을 치"),("稚", "어린 벼 치, 어릴 치, 늦을 치"),("峙", "산이 우뚝 솟을 치, 갖출 치, 쌓을 치, 산우뚝할 치"),("馳", "달릴 치, 거동길 치, 전할 치"),("侈", "사치할 치, 넓을 치, 많을 치, 풍부할 치"),("熾", "불 활활 붙을 치, 불성할 치"),("幟", "깃대 치, 표기 치"),("嗤", "비웃을 치, 냉소 치"),("緻", "톡톡할 치, 빽빽할 치, 헌 옷 기울 치"),("痔", "치질 치, 풍병 치"),("癡", "어리석을 치, 미련할 치, 미치광이 치, 주근깨 치"),("緇", "검을 치, 검은비단 치"),("蚩", "치벌레 치, 어리석을 치, 업신여길 치, 벌레이름 치"),("穉", "稚와 同字, 어린벼 치"),("嵯", "산 울뚝질뚝할 치"),("埴", "찰진흙 치, 흙 이길 치"),("梔", "치자 치"),("淄", "물이름 치, 검을 치"),("輜", "짐수레 치, 휘장 친 수레 치"),("寘", "둘 치, 폐할 치, 쉴 치"),("鴟", "솔개 치, 수알치 치, 부엉이 치, 말똥구리 치, 토란 치, 마음대로 날릴 치, 올빼미 치"),("廁", "뒷간 치, 평상 가장자리 치, 섞일 치, 버금 치"),("巵", "잔 치, 연지 치"),("菑", "따비밭 치"),("錙", "저울눈 치, 조금 치"),("褫", "옷 빼앗을 치, 벗을 치, 넋 잃을 치"),("豸", "발 없는 벌레 치, 풀 치, 해치양 치, 발없는벌레의총칭 치"),("絺", "가는 칡베 치, 가는 갈포 치"),("薙", "풀 깎을 치"),("哆", "입 딱 벌일 치"),("畤", "제터 치"),("卮", "술잔 치, 연지 치"),("鵄", "솔개 치"),("跱", "머뭇거릴 치, 주저할 치, 갖출 치"),("阤", "떨어질 치, 헐릴 치, 언덕 치, 사태날 치"),("痓", "풍병 치, 악할 치"),("鯔", "숭어 치"),("鴙", "雉와 同字"),("夂", "뒤처져오다"),("黹", "바느질하다"),]),
("치평동", &[("治平洞", "지명"),]),
("칙", &[("則", "법칙 칙, 본받을 칙, 모범 칙, 조목 칙"),("勅", "신칙할 칙, 칙령 칙"),("飭", "갖출 칙, 닦을 칙, 부지런할 칙"),("敕", "경계할 칙, 다스릴 칙, 삼갈 칙, 바를 칙, 칙서 칙, 기릴 칙, 신칙할 칙"),]),
("친", &[("親", "사랑할 친, 친할 친, 몸소 친, 일가 친, 사돈 친"),("襯", "속옷 친, 접근할 친, 베풀 친"),("櫬", "관 친, 무궁화나무 친, 땔나무 친"),("齔", "이 갈 친, 어릴 친"),]),
("칠", &[("七", "일곱 칠, 글체이름 칠"),("漆", "옻나무 칠, 물이름 칠"),("柒", "漆의 俗字, 옻칠할 칠"),]),
("칠곡군", &[("漆谷郡", "지명"),]),
("칠곡면", &[("七谷面", "지명"),]),
("칠괴동", &[("七槐洞", "지명"),]),
("칠금동", &[("漆琴洞", "지명"),]),
("칠량면", &[("七良面", "지명"),]),
("칠보면", &[("七寶面", "지명"),]),
("칠북면", &[("漆北面", "지명"),]),
("칠산동", &[("漆山洞", "지명"),]),
("칠서면", &[("漆西面", "지명"),]),
("칠석동", &[("漆石洞", "지명"),]),
("칠성동", &[("七星洞", "지명"),]),
("칠성면", &[("七星面", "지명"),]),
("칠암동", &[("七岩洞", "지명"),]),
("칠원동", &[("七院洞", "지명"),]),
("칠원면", &[("漆原面", "지명"),]),
("칠전동", &[("漆田洞", "지명"),]),
("침", &[("針", "바늘 침, 침 침, 바느질할 침, 찌를 침"),("沈", "장마물 침, 진펄 침, 잠길 침, 채색할 침, 고요할 침, 가라앉을 침"),("侵", "범할 침, 침노할 침, 습격할 침, 흉작 침"),("寢", "잠잘 침, 쉴 침, 방 침, 못생길 침"),("浸", "적실 침, 불릴 침, 번질 침, 빠질 침"),("枕", "베개 침, 수레뒤 가로댄 나무 침, 소말뚝 침, 베게 침"),("鍼", "바늘 침, 침 침"),("砧", "방칫돌 침, 다듬잇돌 침"),("湛", "빠질 침, 잠길 침"),("琛", "보배 침"),("忱", "믿을 침, 정성 침"),("沉", "沈의 俗字"),("駸", "말 몰아 달릴 침"),("鋟", "새길 침"),("寖", "젖을 침, 점점 침"),("椹", "모탕 침, 도끼바탕 침, 토막 침"),("郴", "땅이름 침"),]),
("침산동", &[("砧山洞", "지명"),]),
("칩", &[("蟄", "벌레 움츠릴 칩, 우물거릴 칩"),]),
("칭", &[("稱", "저울질할 칭, 일컬을 칭, 헤아릴 칭, 같을 칭"),("秤", "저울 칭, 백 근 칭"),]),
("쾌", &[("快", "기분이 좋을 쾌, 시원할 쾌, 빠를 쾌, 쾌할 쾌"),("獪", "간교할 쾌, 교활할 쾌"),("夬", "결단할 쾌, 나누어 정할 쾌, 괘 이름 쾌"),("噲", "목구멍 쾌, 훨할 쾌"),]),
("타", &[("他", "다를 타, 저 타, 간사할 타"),("打", "때릴 타, 칠 타"),("妥", "편안할 타, 일 없을 타, 타협할 타, 떨어질 타"),("墮", "떨어질 타, 상투 타, 잃을 타"),("惰", "게으를 타, 태만할 타"),("唾", "침 타, 버릴 타"),("陀", "비탈 타, 땅이름 타"),("駝", "약대 타, 곱사등이 타"),("舵", "키 타"),("楕", "橢의 略字, 나무그릇 타"),("馱", "탈 타, 짐 실을 타"),("朶", "나무가지 휘늘어질 타, 떨기 타, 움킬 타, 휘늘어진 타"),("咤", "꾸짖을 타, 슬플 타, 뿜을 타, 쩍쩍 씹는소리 타"),("拖", "拕와 同字, 당길 타"),("迤", "어정거릴 타"),("駄", "馱의 俗字"),("躱", "피할 타"),("沱", "물이 갈래질 타, 큰 비 타, 눈물이 흐를 타"),("跎", "미끄러질 타"),("詫", "자랑할 타, 풍칠 타, 신통할 타"),("佗", "다를 타, 저 타, 마음에 든든할 타, 더할 타, 입을 타, 짊어질 타"),("鼉", "자라 타"),("駞", "駞와 同字"),("柁", "키 타"),("拕", "끌 타, 당길 타"),("橢", "둥글길죽할 타, 수레통 가운데그릇 타, 길죽한 그릇 타"),("鮀", "모래무지 타"),("鴕", "타조 타"),]),
("탁", &[("度", "꾀할 탁, 헤아릴 탁, 벼슬이름 탁, 법도 탁"),("濁", "흐릴 탁, 더러울 탁, 물이름 탁"),("拓", "물리칠 탁, 헤칠 탁, 밀칠 탁, 주울 탁"),("托", "밀칠 탁, 떡국 탁, 차반 탁"),("卓", "높을 탁, 뛰어날 탁, 책상 탁, 성씨 탁"),("濯", "씻을 탁, 빨래할 탁, 적실 탁, 클 탁, 빛날 탁, 산 민둥민둥할 탁, 살찔 탁, 놀 탁"),("託", "맡길 탁, 부탁할 탁, 핑계할 탁"),("琢", "옥 쪼을 탁, 옥 다듬을 탁, 가릴 탁, 쫄 탁"),("擢", "뽑을 탁, 뺄 탁, 솟을 탁, 이길 탁"),("鐸", "요령 탁, 목탁 탁, 큰방울 탁"),("坼", "찢을 탁, 터질 탁, 난산할 탁, 싹 트일 탁"),("啄", "쪼을 탁, 문 두드릴 탁"),("倬", "환할 탁, 클 탁"),("柝", "쪼갤 탁, 조두 탁, 목탁 탁"),("晫", "환할 탁, 밝을 탁"),("琸", "사람이름 탁"),("拆", "터질 탁, 찢어질 탁, 열릴 탁"),("橐", "전대 탁, 자루 탁, 도가니 탁, 공잇소리 탁, 짐승이름 탁"),("涿", "물방울 떨어질 탁, 칠 탁, 물이름 탁, 땅이름 탁"),("逴", "멀 탁, 절름거릴 탁, 뛰어날 탁"),("籜", "대 껍질 탁"),("踔", "우뚝 설 탁, 앙감질 탁"),("沰", "떨어뜨릴 탁, 돌 던질 탁, 떨어질 탁"),("矺", "나무이름 탁"),("蘀", "떨어질 탁, 마를 탁"),]),
("탄", &[("歎", "탄식할 탄, 아름답다 할 탄, 화답할 탄"),("彈", "쏠 탄, 악기부릴 탄, 탄알 탄, 탄핵할 탄, 퉁길 탄"),("炭", "숯 탄, 불똥 탄, 볶일 탄"),("誕", "기를 탄, 클 탄, 속일 탄, 넓을 탄, 탄생할 탄, 방탕할 탄"),("灘", "여울 탄, 해 이름 탄"),("綻", "옷 터질 탄, 나타날 탄, 파할 탄"),("憚", "수고로울 탄, 꺼릴 탄"),("呑", "삼킬 탄, 휩쌀 탄, 감출 탄, 멸할 탄"),("坦", "너그러울 탄, 평평할 탄, 넓을 탄"),("嘆", "한숨쉴 탄, 탄식할 탄"),("殫", "다할 탄"),("癱", "중풍증 탄, 사지 틀릴 탄"),("攤", "열 탄, 펼칠 탄"),("憻", "坦과 同字"),("驒", "돈짝무늬총이말 탄"),]),
("탄방동", &[("炭坊洞", "지명"),]),
("탄벌동", &[("炭筏洞", "지명"),]),
("탄부면", &[("炭釜面", "지명"),]),
("탄천면", &[("灘川面", "지명"),]),
("탄현동", &[("炭峴洞", "지명"),]),
("탄현면", &[("炭縣面", "지명"),]),
("탈", &[("脫", "벗어날 탈, 간략할 탈, 뼈 바를 탈, 그르칠 탈, 벗을 탈"),("奪", "빼앗을 탈, 잃어버릴 탈, 좁은 길 탈, 깎을 탈"),("侻", "간사할 탈, 가벼울 탈, 간략할 탈"),]),
("탐", &[("探", "더듬을 탐, 찾을 탐, 취할 탐, 염탐할 탐"),("貪", "탐할 탐, 욕심낼 탐"),("耽", "즐길 탐, 귀 축 늘어질 탐, 웅크리고 볼 탐, 즐거울 탐, 깊고 멀 탐"),("眈", "노려볼 탐, 즐길 탐"),("酖", "술 즐길 탐"),("嗿", "여럿이 먹는 소리 탐"),]),
("탑", &[("塔", "탑 탑"),("搭", "모뜰 탑, 박을 탑, 탈 탑"),("榻", "평상 탑, 모직 탑, 자리 탑"),("搨", "비문 박을 탑, 베낄 탑"),("塌", "낮은 땅 탑, 초벌갈 탑, 떨어질 탑"),("傝", "답답할 탑, 불안할 탑, 어리석을 탑, 용렬할 탑"),]),
("탑길극사단", &[("塔吉克斯坦", "타지키스탄"),]),
("탑동", &[("塔洞", "지명"),]),
("탑립동", &[("塔立洞", "지명"),]),
("탕", &[("糖", "엿"),("湯", "물 끓일 탕, 물이름 탕, 씻을 탕, 끓을 탕"),("蕩", "넓고 클 탕, 없어질 탕, 방탕할 탕, 소탕할 탕"),("宕", "골집 탕, 방탕할 탕, 석수 탕"),("帑", "나라 곳집 탕, 처자식 탕"),("盪", "씻을 탕, 움직일 탕, 진동할 탕, 그릇 부실 탕, 뭍 배질할 탕"),("碭", "무늬진 돌 탕, 흰 기운 탕, 넘칠 탕, 산이름 탕"),("蘯", "盪과 同字"),("燙", "씻을 탕, 불에 델 탕"),]),
("탕가", &[("湯加", "통가"),]),
("탕정면", &[("湯井面", "지명"),]),
("태", &[("太", "클 태, 굵을 태, 심할 태, 처음 태, 콩 태"),("泰", "클 태, 통할 태, 너그러울 태, 편안할 태, 괘 이름 태, 타이"),("態", "모양 태, 뜻 태"),("殆", "위태할 태, 가까이할 태, 비롯할 태"),("怠", "게으를 태, 느릴 태, 거만할 태"),("台", "별 태, 늙을 태"),("胎", "아이 밸 태, 시작 태, 애밸 태"),("兌", "기쁠 태, 지름길 태, 모일 태, 통할 태, 곧을 태, 구멍 태, 바꿀 태, 괘 이름 태"),("跆", "밟을 태"),("颱", "몹시 부는 바람 태, 태풍 태"),("汰", "미끄러울 태, 넘칠 태, 씻길 태, 사치할 태, 미끄러질 태"),("苔", "이끼 태"),("笞", "볼기칠 태"),("邰", "태나라 태"),("迨", "미칠 태"),("埭", "보뚝 태"),("娧", "기뻐할 태, 더딜 태"),("抬", "칠 태"),]),
("태국", &[("泰國", "타이"),]),
("태령동", &[("台領洞", "지명"),]),
("태백동", &[("太白洞", "지명"),]),
("태백시", &[("太白市", "지명"),]),
("태봉동", &[("胎封洞", "지명"),]),
("태안군", &[("泰安郡", "지명"),]),
("태안읍", &[("泰安邑", "지명"),("台安邑", "지명"),]),
("태이기사단", &[("汰爾奇斯坦", "타지키스탄"),]),
("태인동", &[("太仁洞", "지명"),]),
("태인면", &[("泰仁面", "지명"),]),
("태장동", &[("台壯洞", "지명"),]),
("태전동", &[("太田洞", "지명"),("胎田洞", "지명"),]),
("태평", &[("太平", "지명"),]),
("태평동", &[("太平洞", "지명"),]),
("태평로", &[("太平路", "지명"),]),
("태화동", &[("太和洞", "지명"),("太華洞", "지명"),]),
("택", &[("宅", "집 택, 자리 택, 살 택, 정할 택, 묘 구덩이 택"),("擇", "가릴 택, 추릴 택, 차별할 택"),("澤", "못 택, 진펄 택, 진액 택, 윤택할 택, 비와 이슬 택, 늪 택"),]),
("탱", &[("撑", "撐의 俗字, 버틸 탱"),("撐", "버틸 탱, 취할 탱, 헤칠 탱"),]),
("터", &[("攄", "펼칠 터, 흩을 터, 날칠 터, 비길 터, 헤칠 터"),]),
("토", &[("土", "흙 토, 뿌리 토, 나라 토, 뭍 토"),("討", "다스릴 토, 칠 토, 찾을 토, 벨 토, 꾸짖을 토"),("吐", "토할 토, 나올 토, 펼 토"),("兎", "兔의 俗字, 토끼 토"),]),
("토계동", &[("土界洞", "지명"),]),
("토고만사단", &[("土庫曼斯坦", "투르크메니스탄"),]),
("토당동", &[("土堂洞", "지명"),]),
("토미니가공화국", &[("土彌尼加共和國", "도미니카공화국"),]),
("토미니가국", &[("土彌尼加國", "도미니카"),]),
("토성동", &[("土城洞", "지명"),]),
("토성면", &[("土城面", "지명"),]),
("토월동", &[("吐月洞", "지명"),]),
("토이고", &[("土耳古", "터키"),]),
("토이고사단", &[("土耳古斯坦", "투르크메니스탄"),]),
("토이기", &[("土耳其", "터키"),]),
("토정동", &[("土亭洞", "지명"),]),
("토지면", &[("土旨面", "지명"),]),
("토평동", &[("土坪洞", "지명"),("吐坪洞", "지명"),]),
("톤", &[("噋", "啍과 同字"),]),
("통", &[("通", "뚫릴 통, 사무칠 통, 형통할 통, 사귈 통, 다닐 통, 간음할 통"),("洞", "구렁 통, 깊을 통, 빌 통, 밝을 통, 고을 통"),("統", "거느릴 통, 벼리 통, 실마디 통, 근본 통, 이을 통"),("痛", "아플 통, 상할 통, 심할 통, 몹시 통"),("慟", "서러울 통, 애통할 통"),("筒", "사통대 통, 통 통"),("桶", "엿되들이 통 통"),("恫", "슬플 통, 아플 통, 앓을 통"),("筩", "대나무통 통, 낚시 통"),("樋", "대 홈 통, 어름나무 통"),]),
("통동", &[("桶洞", "지명"),]),
("통복동", &[("通伏洞", "지명"),]),
("통신동", &[("通信洞", "지명"),]),
("통영시", &[("統營市", "지명"),]),
("통의동", &[("通義洞", "지명"),]),
("통인동", &[("通仁洞", "지명"),]),
("통진", &[("通津", "지명"),]),
("퇴", &[("退", "물러갈 퇴, 겸양할 퇴, 물리칠 퇴"),("頹", "기울어질 퇴, 사나운 바람 퇴, 쇠할 퇴, 무너질 퇴, 대머리 퇴"),("堆", "흙무더기 퇴 놓을 퇴, 언덕 퇴"),("槌", "몽둥이 퇴, 너스레 퇴, 누에시렁 퇴, 던질 퇴"),("腿", "넓적다리 퇴"),("鎚", "옥 다듬을 퇴"),("褪", "옷 벗을 퇴, 꽃빛 옅어질 퇴"),("隤", "무너질 퇴, 미끄러질 퇴, 부드러울 퇴, 땅이름 퇴"),]),
("퇴계동", &[("退溪洞", "지명"),]),
("퇴계원면", &[("退溪院面", "지명"),]),
("퇴촌동", &[("退村洞", "지명"),]),
("퇴촌면", &[("退村面", "지명"),]),
("투", &[("投", "던질 투, 버릴 투, 줄 투, 의탁할 투"),("鬪", "싸움 투"),("透", "통할 투, 사무칠 투, 지나칠 투"),("套", "전례 투, 덮게 투"),("妬", "투기할 투, 자식 없는 계집 투, 질투할 투"),("偸", "훔칠 투, 엷을 투, 구차할 투, 인정머리없을 투"),("渝", "빛 변할 투, 더러워질 투, 고을이름 투"),("妒", "투기할 투, 미워할 투, 강샘할 투, 부러워할 투"),("骰", "주사위 투"),]),
("특", &[("特", "우뚝할 특, 숫소 특, 뛰어날 특, 다만 특, 세 살 먹은 짐승 특, 특별할 특"),("慝", "간악할 특, 간사할 특, 더러울 특"),("忒", "변할 특, 의심할 특, 어기어질 특"),]),
("특다", &[("特多", "트리니다드 토바고"),]),
("특립니달화다파가", &[("特立尼達和多巴哥", "트리니다드 토바고"),]),
("틈", &[("闖", "엿볼"),]),
("파", &[("破", "깨뜨릴 파, 다할 파, 갈라질 파"),("波", "물결 파, 물 젖을 파, 눈 광채 파, 움직일 파, 달빛 파"),("罷", "파할 파, 내칠 파"),("播", "심을 파, 펼칠 파, 버릴 파, 까불 파, 달아날 파"),("派", "물 갈래 파, 보낼 파, 나눌 파, 파벌 파, 물가닥 파"),("頗", "비뚤어질 파, 자못 파"),("把", "잡을 파, 헤칠 파"),("坡", "언덕 파, 제방 파"),("巴", "꼬리 파, 뱀 파, 땅이름 파"),("婆", "할머니 파, 너풀너풀 춤출 파, 할미 파"),("跛", "절뚝발이 파, 절름발이 파"),("琶", "비파 파"),("芭", "파초 파"),("爬", "긁을 파, 기어다닐 파"),("擺", "열 파, 헤칠 파, 제거할 파, 손뼉칠 파"),("杷", "비파나무 파, 써레 파, 칼자루 파, 악기이름 파"),("叵", "못할 파, 드디어 파, 술잔 파"),("怕", "두려울 파"),("葩", "꽃봉오리 파"),("皤", "흴 파, 배 불룩할 파, 귀 밑에 희끗희끗할 파"),("帕", "머리 동이수건 파"),("簸", "까부를 파, 키 파"),("灞", "물이름 파"),("玻", "파려옥 파, 유리옥 파"),("笆", "가시 대 파, 울타리 파"),("鄱", "땅이름 파"),("妑", "새앙머리 파, 갈래머리 파"),("岥", "산 비알질 파"),("爸", "아비 파"),("耙", "쇠시랑 파"),("菠", "시금치 파"),]),
("파기사단", &[("巴基斯坦", "파키스탄"),]),
("파나마", &[("巴奈馬", "파나마"),]),
("파동", &[("巴洞", "지명"),]),
("파란", &[("波蘭", "폴란드"),]),
("파랍규", &[("巴拉圭", "파라과이"),]),
("파리비", &[("玻里非", "볼리비아"),]),
("파리비아", &[("玻利維亞", "볼리비아"),]),
("파림", &[("巴林", "바레인"),]),
("파사", &[("波斯", "페르시아 제국"),]),
("파사니아흑새가유나", &[("波斯尼亞黒塞哥維那", "보스니아 헤르체고비나"),]),
("파서", &[("巴西", "브라질"),]),
("파서국", &[("巴西國", "브라질"),]),
("파장동", &[("芭長洞", "지명"),]),
("파주시", &[("坡州市", "지명"),]),
("파주읍", &[("坡州邑", "지명"),]),
("파천면", &[("巴川面", "지명"),]),
("파파다사", &[("巴巴多斯", "바베이도스"),]),
("파평면", &[("坡平面", "지명"),]),
("파포아신기내아", &[("巴布亞新幾內亞", "파푸아뉴기니"),]),
("파호동", &[("巴湖洞", "지명"),]),
("판", &[("判", "판단할 판, 쪼갤 판, 맡을 판"),("板", "널조각 판, 널기와 판, 풍류이름 판"),("版", "조각 판, 호적 판, 국경 판, 한 길 판, 인쇄할 판"),("販", "장사 판, 팔 판"),("阪", "산비탈 판, 언덕 판"),("辦", "힘들일 판, 갖출 판"),("坂", "언덕 판, 산비탈 판, 순나라 서울이름 판"),("瓣", "외씨 판, 실과씨 판, 꽃잎 판"),("鈑", "불린 금 판, 불린 금덩이 판"),]),
("판교", &[("板橋", "지명"),]),
("판교면", &[("板橋面", "지명"),]),
("판문동", &[("板門洞", "지명"),]),
("판부면", &[("板富面", "지명"),]),
("판암동", &[("板岩洞", "지명"),]),
("팔", &[("八", "여덟 팔"),("叭", "나팔 팔, 입 벌릴 팔"),("捌", "깨뜨릴 팔, 나눌 팔, 칠 팔"),]),
("팔곡이동", &[("八谷二洞", "지명"),]),
("팔곡일동", &[("八谷一洞", "지명"),]),
("팔금면", &[("八禽面", "지명"),]),
("팔달", &[("八達", "지명"),]),
("팔달구", &[("八達區", "지명"),]),
("팔달로", &[("八達路", "지명"),]),
("팔덕면", &[("八德面", "지명"),]),
("팔복동", &[("八福洞", "지명"),]),
("팔봉동", &[("八峰洞", "지명"),]),
("팔봉면", &[("八峰面", "지명"),]),
("팔용동", &[("八龍洞", "지명"),]),
("팔탄면", &[("八灘面", "지명"),]),
("팔판동", &[("八判洞", "지명"),]),
("패", &[("貝", "조개 패, 재물 패, 비단 패"),("敗", "헐어질 패, 무너질 패, 깨어질 패, 썪을 패, 패할 패"),("牌", "방 붙일 패, 호패 패, 방패 패"),("悖", "거스를 패, 어지러울 패, 거슬릴 패"),("覇", "霸의 俗字, 두목 패"),("佩", "패옥 패, 찰 패, 마음에 먹을 패, 물이 흘러서 합할 패"),("沛", "둥둥 뜰 패, 비 쏟아질 패, 넉넉할 패, 비가쏟아지는모양 패"),("稗", "돌피 패, 조그마할 패"),("唄", "염불소리 패, 노래부를 패"),("狽", "이리 패"),("浿", "물이름 패, 물가 패"),("霈", "비 쏟아질 패"),("霸", "으뜸 패, 패왕 패"),("孛", "혜성 패"),("旆", "기 패, 깃발 날릴 패"),("珮", "노리개 패, 찰 패"),]),
("패녕", &[("貝甯", "베냉"),]),
("팽", &[("彭", "성씨 팽, 땅이름 팽, 방패 팽, 총소리 팽, 북소리 팽"),("膨", "배 불룩할 팽, 큰배 팽"),("澎", "물소리 팽, 물결 부딛는 형세 팽"),("烹", "삶을 팽, 요리 팽, 삶는 팽"),("祊", "사당문 제사 팽"),("砰", "여울 물소리 팽"),("蟚", "蟛과 同字"),("蟛", "방게 팽"),]),
("팽성읍", &[("彭城邑", "지명"),]),
("퍅", &[("愎", "사나울 퍅, 고집할 퍅"),]),
("편", &[("便", "편할 편, 소식 편, 익힐 편, 오줌 편, 문득 편"),("篇", "책 편, 편차할 편"),("片", "조각 편, 쪼갤 편, 성씨 편"),("遍", "두루 편"),("偏", "치우칠 편, 무리 편, 오십명 편, 간사한 모양 편"),("編", "책편 편, 기록할 편, 첩지 편, 벌릴 편, 엮을 편"),("扁", "특별할 편, 거룻배 편, 작을 편"),("鞭", "채찍 편, 볼기채 편, 태장 편"),("騙", "속일 편, 말에 뛰어 오를 편"),("翩", "훌쩍 날 편, 오락가락할 편, 훌쩍나는 모양 편"),("褊", "좁을 편, 급할 편, 옷이 몸에 낄 편"),("艑", "거룻배 편"),("蝙", "박쥐 편"),("諞", "공교한 말 편"),("惼", "조급할 편, 편협할 편"),("緶", "꿰맬 편"),]),
("폄", &[("貶", "떨어질 폄, 덜릴 폄, 꺾을 폄, 귀양보낼 폄, 감할 폄"),("窆", "하관할 폄, 광중 폄"),("砭", "돌침 폄"),]),
("평", &[("平", "평탄할 평, 바를 평, 고를 평, 다스릴 평, 쉬울 평, 풍년 평, 화친할 평, 재관관 평, 평평할 평"),("評", "평론할 평, 헤아릴 평, 고칠 평, 기롱할 평"),("坪", "벌판 평, 평평할 평, 평수 평"),("萍", "마름 평, 머구리밥 평, 개구리밥 평"),("枰", "장기판 평, 바둑판 평, 회양목 평"),("苹", "맑은 대쑥 평, 사과 평"),("抨", "탄핵할 평"),("怦", "맘 급할 평, 칼칼할 평"),("泙", "물소리 평, 물결 셀 평"),("蓱", "마름 평, 머구리밥 평, 개구리밥 평"),("鮃", "가자미 평"),]),
("평거동", &[("平居洞", "지명"),]),
("평광동", &[("坪廣洞", "지명"),]),
("평내동", &[("坪內洞", "지명"),]),
("평동", &[("平洞", "지명"),("坪洞", "지명"),]),
("평려동", &[("平呂洞", "지명"),]),
("평릉동", &[("平陵洞", "지명"),]),
("평리동", &[("坪里洞", "지명"),]),
("평림동", &[("坪林洞", "지명"),]),
("평산동", &[("平山洞", "지명"),("坪山洞", "지명"),]),
("평안동", &[("平安洞", "지명"),("坪安洞", "지명"),]),
("평원동", &[("平原洞", "지명"),]),
("평은면", &[("平恩面", "지명"),]),
("평전동", &[("平田洞", "지명"),]),
("평창군", &[("平昌郡", "지명"),]),
("평창동", &[("平倉洞", "지명"),]),
("평창읍", &[("平昌邑", "지명"),]),
("평촌동", &[("坪村洞", "지명"),]),
("평택동", &[("平澤洞", "지명"),]),
("평택시", &[("平澤市", "지명"),]),
("평해읍", &[("平海邑", "지명"),]),
("평화동", &[("平和洞", "지명"),]),
("폐", &[("閉", "닫을 폐, 마칠 폐, 가릴 폐"),("廢", "폐할 폐, 내칠 폐, 집 쏠릴 폐, 떨어질 폐"),("肺", "허파 폐, 부아 폐, 친할 폐, 마음속 폐"),("弊", "해질 폐, 폐단 폐, 곤할 폐, 곰곰 궁리할 폐, 결단할 폐, 엎드릴 폐"),("蔽", "가리울 폐, 다할 폐, 정할 폐, 가릴 폐"),("幣", "폐백 폐, 예물 폐, 재물 폐, 돈 폐"),("陛", "대궐 섬돌 폐"),("斃", "죽을 폐, 엎드러질 폐, 자빠질 폐"),("吠", "짖을 폐, 땅이름 폐"),("嬖", "사랑할 폐, 윗사람으로부터 사랑받을 폐, 벼슬이름 폐"),("獘", "곤할 폐, 폐단 폐, 죽을 폐, 엎드러질 폐"),("敝", "옷 해질 폐, 버릴 폐, 무너질 폐, 실패할 폐, 활줌통 폐"),("癈", "고질병 폐"),("狴", "짐승이름 폐, 옥 폐, 들개 폐"),]),
("포", &[("布", "베 포, 피륙 포, 벌릴 포, 돈 포, 베풀 포"),("抱", "안을 포, 품을 포, 낄 포"),("暴", "사나울 포, 급할 포, 맨손으로 칠 포, 불끈 일어날 포, 마를 포, 상할 포"),("捕", "사로잡을 포"),("浦", "물가 포, 갯가 포, 개 포"),("胞", "태보 포, 한 배 포, 동포 포"),("包", "꾸릴 포, 용납할 포, 더부룩히 날 포, 보따리 포, 쌀 포"),("飽", "배부를 포, 물릴 포, 먹기 싫을 포, 흡족할 포"),("砲", "큰 대포 포, 돌쇠뇌 포, 돌 튀기는 화살 포"),("抛", "拋와 同字, 버릴 포"),("鋪", "전방 포, 베풀 포, 문고리 포, 펼 포, 아플 포, 벌릴 포"),("逋", "달아날 포, 포흠할 포, 도망갈 포"),("怖", "두려울 포, 놀래킬 포"),("鮑", "절인 생선 포, 성씨 포"),("泡", "물거품 포, 물이 솟아날 포, 물 흐를 포, 성할 포"),("葡", "포도 포, 들머리 포, 나라이름 포"),("褒", "포장할 포, 옷 뒤길 포, 도포 포, 고을이름 포"),("袍", "도포 포, 관디 포, 앞섶 포, 두루마기 포"),("蒲", "부들풀 포, 창포 포, 개버들 포"),("圃", "채마밭 포, 밭 갈 포, 곳 포, 산이름 포, 나물밭 포"),("脯", "포 포, 말린 과실 포"),("哺", "씹어 먹을 포, 먹일 포"),("曝", "볕 쬘 포, 볕 쏘일 포"),("匍", "엉금엉금 길 포, 엎드러질 포"),("咆", "고함지를 포, 짐승소리 포, 불끈 성낼 포, 으르릉거릴 포"),("疱", "부풀 포, 부르틀 포"),("苞", "그령풀 포, 밑둥 포, 초목이 다복히 날 포, 꾸러피 포, 꾸러미 포"),("佈", "펼칠 포, 널리알릴 포"),("匏", "박 포, 바가지 포, 퉁소 포"),("庖", "푸줏간 포, 부엌 포"),("炮", "그슬릴 포, 싸서 구울 포, 형벌 포"),("晡", "신시 포, 해질 포"),("餔", "저녁 곁두리 포, 먹을 포"),("舖", "鋪의 俗字"),("炰", "그슬 포, 까불거릴 포"),("誧", "꾀할 포, 클 포, 도울 포, 간할 포"),("鞄", "가방 포, 가죽 다로는 장인 포"),("鯆", "매가리 포, 물아지 포"),("曓", "급할 포, 창졸 포"),("鉋", "대패 포"),("勹", "싸다"),]),
("포곡면", &[("蒲谷面", "지명"),]),
("포기납법색", &[("布基納法索", "부르키나파소"),]),
("포남동", &[("浦南洞", "지명"),]),
("포도아", &[("葡萄牙", "포르투갈"),]),
("포동", &[("浦洞", "지명"),]),
("포두면", &[("浦頭面", "지명"),]),
("포륭적", &[("布隆迪", "부룬디"),]),
("포승면", &[("浦升面", "지명"),]),
("포이동", &[("浦二洞", "지명"),]),
("포일동", &[("浦一洞", "지명"),]),
("포정", &[("布政", "지명"),]),
("포천군", &[("抱川郡", "지명"),]),
("포천읍", &[("抱川邑", "지명"),]),
("포항시", &[("浦項市", "지명"),]),
("폭", &[("暴", "햇빛 쪼일 폭, 나타날 폭, 드러날 폭, 사나울 폭"),("爆", "불터질 폭, 폭발할 폭"),("幅", "폭 폭, 겉치레할 폭"),("瀑", "폭포수 폭, 소나기 폭"),("曝", "햇볕에 말릴 폭"),("輻", "바퀴살통 폭"),]),
("표", &[("表", "겉 표, 윗옷 표, 밝을 표"),("標", "표시할 표, 높은 가지 표, 적을 표, 나무 끝 표, 표할 표"),("票", "쪽지 표, 문서 표, 불날릴 표, 훌쩍 날 표, 날랠 표"),("漂", "뜰 표, 움직일 표, 으스스할 표, 높이 훨훨 날 표"),("杓", "북두자루 표, 북두자리 표"),("豹", "표범 표, 아롱범 표"),("飄", "회오리바람 표, 나부낄 표, 떨어질 표, 회리바람 표"),("剽", "표독할 표, 긁을 표, 겁박할 표, 끝 표, 찌를 표, 빠를 표"),("慓", "급할 표"),("瓢", "표주박 표"),("俵", "나누어 줄 표, 흩어질 표, 가마니 표"),("彪", "칡범 표, 문채 표, 작은 범 표"),("驃", "날쌜 표, 누런 말 표"),("飇", "회오리바람 표"),("縹", "옥빛 표, 훌쩍 날 표"),("摽", "칠 표, 두를 표, 찔러 밀칠 표, 가슴 만질 표"),("殍", "굶어 죽을 표"),("鑣", "말 재갈 표, 성할 표"),("裱", "목수건 표"),("僄", "몸이 가벼울 표, 진중치 못할 표"),("嫖", "가벼울 표, 날랠 표, 색에 빠질 표"),("勡", "겁탈할 표, 겁박할 표"),("嘌", "휙 불 표, 몰아갈 표"),("熛", "불똥 튈 표, 성낼 표, 붉을 표, 빛날 표"),("鏢", "칼날 표, 비수 표"),("髟", "머리털 희뜩희뜩할 표, 깃발 날릴 표, 머리 늘일 표, 머리털이길게드리워진모양 표"),("鰾", "부레 표"),]),
("표선면", &[("表善面", "지명"),]),
("품", &[("品", "뭇 품, 품수 품, 가지 품, 벼슬 차례 품"),("稟", "여쭐 품, 줄 품, 받을 품, 성품 품, 품할 품"),("禀", "여쭐 품, 사뢸 품, 받을 품, 성품 품"),]),
("풍", &[("風", "바람 풍, 흘레할 풍, 울릴 풍, 풍속 풍, 경치 풍, 위엄 풍, 병풍 풍, 모양 풍"),("豊", "豐의 略字, 풍년 풍"),("楓", "단풍나무 풍, 신나무 풍"),("諷", "비유로 간할 풍, 외울 풍, 욀 풍"),("馮", "벼슬이름 풍, 성씨 풍, 물귀신이름 풍, 고을이름 풍"),("瘋", "두풍 풍, 미치광이 풍"),]),
("풍각면", &[("豊角面", "지명"),]),
("풍기동", &[("豊基洞", "지명"),]),
("풍기읍", &[("豊基邑", "지명"),]),
("풍남동", &[("豊南洞", "지명"),]),
("풍납동", &[("風納洞", "지명"),]),
("풍덕동", &[("豊德洞", "지명"),]),
("풍덕천동", &[("豊德川洞", "지명"),]),
("풍도동", &[("豊島洞", "지명"),]),
("풍동", &[("楓洞", "지명"),]),
("풍류동", &[("豊留洞", "지명"),]),
("풍무동", &[("豊舞洞", "지명"),]),
("풍산동", &[("豊山洞", "지명"),]),
("풍산면", &[("豊山面", "지명"),]),
("풍산읍", &[("豊山邑", "지명"),]),
("풍세면", &[("豊歲面", "지명"),]),
("풍암동", &[("楓岩洞", "지명"),]),
("풍양면", &[("豊陽面", "지명"),("豊壤面", "지명"),]),
("풍천면", &[("豊川面", "지명"),]),
("풍향동", &[("豊鄕洞", "지명"),]),
("풍호동", &[("豊湖洞", "지명"),]),
("피", &[("皮", "가죽 피, 껍질 피, 성씨 피"),("彼", "저 피"),("被", "이불 피, 덥힐 피, 미칠 피, 나타날 피, 창피할 피, 덮을 피"),("避", "숨을 피, 어길 피, 싫어할 피, 피할 피"),("疲", "피곤할 피, 나른할 피, 느른할 피"),("披", "헤칠 피, 흩어질 피, 찢어질 피, 펼 피"),("跛", "기울어 지게 설 피"),("陂", "기울어질 피, 치우칠 피"),("詖", "말 잘할 피, 간사할 피, 알소할 피"),("鞁", "말 가슴걸이 피, 안갑 피"),("髲", "머리쓰개 피, 첩지 피"),]),
("픽", &[("腷", "뜩 막힐 픽, 답답할 픽, 닭 홰치는 소리 픽"),]),
("필", &[("必", "반드시 필, 오로지 필, 살필 필, 기약 필"),("筆", "붓 필, 오랑캐 이름 필"),("匹", "짝 필, 둘 필, 한마리 필, 벗 필, 무리 필"),("畢", "마칠 필, 토끼그물 필, 다할 필, 편지 필, 책 필, 고기 꿰 다는 나무 필"),("弼", "도울 필, 도지개 필, 거듭 필"),("泌", "졸졸흐르는 모양"),("疋", "짝 필, 끝 필"),("苾", "향기날"),("珌", "칼 장식 옥 필"),("馝", "향내날 필"),("蹕", "길 치울 필"),("蓽", "휘추리 필, 약이름 필"),("韠", "슬갑 필"),("篳", "대 사립문 필, 나무 실은 수레 필"),("觱", "바람이 쌀쌀할 필, 대평수 필"),("佖", "점잔피울 필, 가득할 필"),("滭", "샘 끓어 솟을 필"),("駜", "살찐 말 필"),("鵯", "갈가마귀 필"),("咇", "향기날 필"),("罼", "토끼그물 필"),("鞸", "슬갑 필"),]),
("필동", &[("筆洞", "지명"),]),
("필운동", &[("弼雲洞", "지명"),]),
("핍", &[("乏", "없을 핍, 옹색할 핍, 다할 핍, 모자랄 핍"),("逼", "가까울 핍, 궁핍할 핍, 핍박학 핍, 핍박할 핍"),("偪", "핍박할 핍, 가까울 핍"),]),
("하", &[("下", "아래 하"),("夏", "여름 하"),("河", "물 하"),("何", "어찌 하"),("賀", "축하할 하, 하례할 하"),("荷", "연 하, 연꽃 하"),("瑕", "티 하, 옥의 티 하"),("遐", "멀 하"),("霞", "놀 하, 노을 하"),("蝦", "새우 하, 개구리 하"),("厦", "큰 집 하"),("廈", "큰 집 하"),("鰕", "새우 하, 암고래 하"),("昰", "是와 同字, 여름 하"),("嚇", "놀라게 할 하"),("罅", "틈 하"),("呀", "입 벌릴 하"),("鍜", "목투구 하"),("煆", "불사를 하"),("岈", "휑뎅그렁할 하"),("懗", "속일 하"),("瘕", "이질 하"),]),
("하계동", &[("下溪洞", "지명"),]),
("하광교동", &[("下光敎洞", "지명"),]),
("하기동", &[("下基洞", "지명"),]),
("하남동", &[("河南洞", "지명"),]),
("하남면", &[("下南面", "지명"),]),
("하남시", &[("河南市", "지명"),]),
("하남읍", &[("下南邑", "지명"),]),
("하단동", &[("下端洞", "지명"),]),
("하당동", &[("下塘洞", "지명"),]),
("하대동", &[("下大洞", "지명"),]),
("하대원동", &[("下大院洞", "지명"),]),
("하동", &[("下洞", "지명"),("鰕洞", "지명"),]),
("하동군", &[("河東郡", "지명"),]),
("하동면", &[("下東面", "지명"),]),
("하동읍", &[("河東邑", "지명"),]),
("하리면", &[("下里面", "지명"),]),
("하망동", &[("下望洞", "지명"),]),
("하맥륜", &[("夏麥論", "카메룬"),]),
("하면", &[("下面", "지명"),]),
("하모동", &[("下茅洞", "지명"),]),
("하봉암", &[("下鳳岩", "지명"),]),
("하북면", &[("下北面", "지명"),]),
("하빈면", &[("河濱面", "지명"),]),
("하사미동", &[("下士美洞", "지명"),]),
("하사창동", &[("下司倉洞", "지명"),]),
("하산곡동", &[("下山谷洞", "지명"),]),
("하산동", &[("下山洞", "지명"),]),
("하산운", &[("下山雲", "지명"),]),
("하상동", &[("下上洞", "지명"),]),
("하서동", &[("下西洞", "지명"),]),
("하서면", &[("下西面", "지명"),]),
("하성면", &[("霞城面", "지명"),]),
("하소동", &[("下所洞", "지명"),]),
("하안", &[("下安", "지명"),]),
("하야동", &[("下野洞", "지명"),]),
("하양읍", &[("河陽邑", "지명"),]),
("하예동", &[("下猊洞", "지명"),]),
("하왕십리", &[("下往十里", "지명"),]),
("하원동", &[("河源洞", "지명"),]),
("하월곡동", &[("下月谷洞", "지명"),]),
("하의면", &[("荷衣面", "지명"),]),
("하이면", &[("下二面", "지명"),]),
("하일동", &[("下一洞", "지명"),]),
("하일면", &[("下一面", "지명"),]),
("하장면", &[("下長面", "지명"),]),
("하점면", &[("河岾面", "지명"),]),
("하정동", &[("下井洞", "지명"),]),
("하중동", &[("下中洞", "지명"),("賀中洞", "지명"),]),
("하청면", &[("河淸面", "지명"),]),
("하촌동", &[("下村洞", "지명"),]),
("하효동", &[("下孝洞", "지명"),]),
("학", &[("學", "배울 학"),("鶴", "두루미 학"),("虐", "사나울 학, 혹독할 학"),("壑", "골짜기 학"),("謔", "희롱할 학"),("瘧", "학질 학"),("确", "확실할 학"),("涸", "마를 학"),("郝", "고을 이름 학"),("狢", "오소리 학"),("鷽", "메까치 학"),("皬", "흴 학"),]),
("학교면", &[("鶴橋面", "지명"),]),
("학동", &[("鶴洞", "지명"),]),
("학룡동", &[("鶴龍洞", "지명"),]),
("학산동", &[("鶴山洞", "지명"),]),
("학산면", &[("鶴山面", "지명"),]),
("학성동", &[("鶴城洞", "지명"),]),
("학암동", &[("鶴岩洞", "지명"),]),
("학의동", &[("鶴儀洞", "지명"),]),
("학익동", &[("鶴翼洞", "지명"),]),
("학잠동", &[("鶴岑洞", "지명"),]),
("학장동", &[("鶴章洞", "지명"),]),
("학정동", &[("鶴亭洞", "지명"),]),
("학하동", &[("鶴下洞", "지명"),]),
("한", &[("韓", "나라 이름 한, 한나라 한"),("漢", "한수 한"),("寒", "찰 한"),("限", "한정할 한"),("閑", "한가할 한"),("恨", "한탄할 한, 한될 한"),("旱", "가물 한"),("汗", "땀 한"),("翰", "날개 한, 벼슬이름 한"),("邯", "고을 이름 한"),("罕", "드물 한"),("悍", "사나울 한, 모질 한"),("澣", "빨 한, 빨래할 한"),("閒", "한가할 한, 겨를 한"),("瀚", "넓고 큰 한, 넓고클 한"),("桿", "막대기 한"),("捍", "막을 한"),("閈", "마을 문 한"),("暵", "말릴 한"),("鼾", "코골 한"),("僩", "노할 한"),("嫺", "우아할 한"),("嫻", "우아할 한"),("駻", "사나운 말 한"),("鷳", "소리개 한"),]),
("한강로", &[("漢江路", "지명"),]),
("한경면", &[("翰京面", "지명"),]),
("한국", &[("韓國", "대한민국"),]),
("한남동", &[("漢南洞", "지명"),]),
("한림면", &[("翰林面", "지명"),]),
("한림읍", &[("翰林邑", "지명"),]),
("한산면", &[("韓山面", "지명"),("閑山面", "지명"),]),
("한수면", &[("寒水面", "지명"),]),
("한천면", &[("寒泉面", "지명"),]),
("할", &[("割", "벨 할"),("轄", "다스릴 할, 맡아볼 할"),("瞎", "애꾸눈 할"),]),
("함", &[("咸", "모두 함, 다 함"),("陷", "빠질 함"),("含", "머금을 함"),("函", "상자 함"),("艦", "싸움배"),("喊", "소리 함, 고함칠 함"),("涵", "젖을 함"),("銜", "재갈 함"),("緘", "봉할 함"),("檻", "우리 함, 난간 함"),("鹹", "짤 함"),("啣", "재갈 함, 머금을 함"),("諴", "화할 함"),("菡", "연봉오리 함"),("闞", "범 소리 함"),("莟", "꽃봉오리 함"),("轞", "함거 함"),]),
("함라면", &[("咸羅面", "지명"),]),
("함안군", &[("咸安郡", "지명"),]),
("함안면", &[("咸安面", "지명"),]),
("함양군", &[("咸陽郡", "지명"),]),
("함양읍", &[("咸陽邑", "지명"),]),
("함열읍", &[("咸悅邑", "지명"),]),
("함창읍", &[("咸昌邑", "지명"),]),
("함평군", &[("咸平郡", "지명"),]),
("함평읍", &[("咸平邑", "지명"),]),
("합", &[("合", "합할 합, 같을 합, 짝 합, 대답할 합"),("陜", "고을이름"),("蛤", "조개 합, 두꺼비 합"),("盒", "소반 뚜껑 합, 합 합"),("閤", "도장 합, 침방 합, 개구리소리 합, 규방 합"),("哈", "한 모금 합, 마실 합"),("闔", "문짝 합, 닫을 합"),("盍", "덮을 합, 합할 합, 어찌 아니할 합"),("溘", "문득 합, 이를 합, 의지할 합"),("榼", "술그릇 합, 물통 합, 뚜껑 합"),("郃", "땅이름 합"),("柙", "우리 합, 향나무 합"),("匌", "기운 답답할 합"),("嗑", "잔말할 합, 웃는 소리 합, 입 다물 합, 괘 이름 합"),]),
("합덕읍", &[("合德邑", "지명"),]),
("합동", &[("蛤洞", "지명"),]),
("합성동", &[("合城洞", "지명"),]),
("합정동", &[("合井洞", "지명"),("蛤井洞", "지명"),]),
("합천군", &[("陜川郡", "지명"),]),
("합천읍", &[("陜川邑", "지명"),]),
("합포구", &[("合浦區", "지명"),]),
("항", &[("行", "시장 항, 항렬 항, 굳셀 항"),("恒", "늘 항, 옛 항, 항상 항"),("降", "항복할 항, 떨어질 항"),("項", "목덜미 항, 클 항, 항목 항, 목뒤 항"),("抗", "막을 항, 들 항, 겨룰 항, 항거할 항"),("巷", "거리 항, 마을 항, 복도 항, 내시 항, 골목 항"),("港", "물 갈라질 항, 항구 항, 뱃길 항"),("航", "쌍배 항, 배질할 항"),("沆", "큰 물 항, 진펀할 항, 이슬 항"),("亢", "목 항, 높을 항, 별이름 항, 기둥 항, 가릴 항"),("缸", "항아리 항"),("肛", "똥구멍 항, 배 뚱뚱할 항, 항문 항"),("杭", "건널 항, 거루 항, 고을이름 항, 모진 배 항"),("伉", "강직할 항, 우뚝할 항, 배필 항, 겨룰 항, 짝 항"),("姮", "항아 항, 달에 사는 미녀 항, 달 부르는 다른 이름 항, 계집이름 항"),("桁", "수갑 항, 배다리 항, 횃대 항, 시렁 항"),("嫦", "항아"),("恆", "恒의 本字"),("頏", "목 항, 오르락 내리락할 항"),("炕", "마를 항, 구울 항, 구들 항"),("夯", "멜 항, 다질 항"),("缿", "항통 항, 문서함 항, 벙어리 항"),]),
("항구동", &[("港口洞", "지명"),]),
("항남동", &[("港南洞", "지명"),]),
("항동", &[("項洞", "지명"),("港洞", "지명"),("航洞", "지명"),]),
("해", &[("海", "바다 해, 많을 해, 세계 해"),("害", "해할 해, 시기할 해, 죽일 해"),("解", "쪼갤 해, 꺠우칠 해, 풀 해, 괘 이름 해, 벗을 해"),("亥", "열 둘째 지지 해, 서북쪽과 북쪽의 사이 방향 해, 음력 시월 해, 돼지 해"),("該", "갖출 해, 모두 해, 겸할 해, 마땅할 해, 그 해"),("奚", "어찌 해, 종 해, 큰 배 해"),("偕", "함께할 해, 굳셀 해"),("駭", "놀랄 해, 북 울릴 해"),("骸", "뼈 해"),("諧", "조화할 해, 글 해, 기롱지거리할 해, 고를 해"),("楷", "해나무 해, 본뜰 해, 해자 해, 법 해"),("懈", "게으를 해"),("咳", "기침 해, 침 뱉을 해, 방글방글 웃을 해"),("邂", "우연히 만날 해"),("孩", "어린아이 해, 방글방글 웃을 해"),("垓", "땅 가장자리 해, 햇수 해, 계단 해"),("瀣", "찬이슬 해, 이슬 기운 해"),("蟹", "게 해"),("醢", "젓 해, 젓 담글 해, 젓 담그는 형벌 해"),("廨", "관청 해, 공해 해"),("薤", "염교 해, 부추 해"),("獬", "신통한 양 해, 해갓 해"),("欬", "기침할 해, 크게 부를 해, 일깨울 해"),("咍", "비웃을 해"),("嶰", "골짝 사이 해, 골 이름 해"),("痎", "학질 해, 하루거리 해"),("鮭", "어채 해, 복 해"),("頦", "턱 해"),]),
("해곡동", &[("海谷洞", "지명"),]),
("해남군", &[("海南郡", "지명"),]),
("해남읍", &[("海南邑", "지명"),]),
("해도동", &[("海島洞", "지명"),]),
("해룡면", &[("海龍面", "지명"),]),
("해리면", &[("海里面", "지명"),]),
("해망동", &[("海望洞", "지명"),]),
("해미면", &[("海美面", "지명"),]),
("해보면", &[("海保面", "지명"),]),
("해산동", &[("蟹山洞", "지명"),]),
("해안동", &[("海安洞", "지명"),("海岸洞", "지명"),]),
("해안면", &[("亥安面", "지명"),]),
("해운대구", &[("海雲臺區", "지명"),]),
("해운동", &[("海雲洞", "지명"),]),
("해제면", &[("海際面", "지명"),]),
("해지", &[("海地", "아이티"),]),
("해평면", &[("海平面", "지명"),]),
("핵", &[("核", "실과 핵, 자세할 핵, 씨 핵"),("劾", "캐물을 핵, 핵실할 핵, 죄를캐물 핵"),("覈", "핵실할 핵, 겨무거리 핵, 씨 핵, 액색할 핵"),("翮", "깃촉 핵, 쭉지 핵, 칼 갓 핵"),]),
("행", &[("行", "다닐 행, 길귀신 행, 오행 행, 그릇 얄긋거릴 행, 행서 행, 행실 행, 항렬 행"),("幸", "다행할 행, 바랄 행"),("杏", "살구 행, 은행 행"),("倖", "요행 행, 괴일 행, 아당할 행, 친할 행, 사랑할 행"),("荇", "마름풀 행, 조아기 행"),("悻", "발끈 성낼 행"),]),
("행구동", &[("杏邱洞", "지명"),]),
("행당동", &[("杏堂洞", "지명"),]),
("행동", &[("幸洞", "지명"),]),
("행복동", &[("幸福洞", "지명"),]),
("행신동", &[("幸信洞", "지명"),]),
("행안면", &[("幸安面", "지명"),]),
("행암동", &[("行岩洞", "지명"),("杏岩洞", "지명"),]),
("행주내동", &[("幸州內洞", "지명"),]),
("행주외동", &[("幸州外洞", "지명"),]),
("행촌동", &[("杏村洞", "지명"),]),
("향", &[("向", "향할 향, 나아갈 향, 북쪽 창 향, 기울어질 향"),("鄕", "시골 향, 고향 향"),("香", "향내 향, 약이름 향, 향기 향"),("享", "드릴 향, 제사지낼 향, 잔치 향, 흠향할 향"),("響", "소리 울릴 향, 소리 마주칠 향, 악기 향"),("饗", "잔치할 향, 흠향할 향"),("嚮", "향할 향, 누릴 향, 울릴 향, 받을 향"),("餉", "먹일 향, 군량 향, 점심 향"),("珦", "옥이름"),("薌", "곡기 향, 향기 향, 기장 향"),]),
("향교동", &[("鄕校洞", "지명"),]),
("향남면", &[("鄕南面", "지명"),]),
("향동", &[("香洞", "지명"),]),
("향정동", &[("香亭洞", "지명"),]),
("향좌부사단", &[("香佐富斯坦", "카자흐스탄"),]),
("향촌동", &[("香村洞", "지명"),]),
("허", &[("許", "허락할 허, 나아갈 허, 기약할 허, 여럿이 힘쓰는 소리 허"),("虛", "빌 허, 헛될 허, 다할 허, 약할 허, 거짓 허, 하늘 허"),("墟", "옛 터 허, 장 허, 큰 두덕 허, 옛성터 허"),("噓", "불 허, 뿜을 허, 탄식할 허"),("歔", "한숨 쉴 허, 흑흑 느껴 울 허, 코로 숨 내쉴 허"),]),
("헌", &[("憲", "법 헌, 표준될 헌, 고시할 헌, 기뻐할 헌"),("獻", "바칠 헌, 음식 헌, 어진이 헌, 드릴 헌"),("軒", "초헌 헌, 껄껄 웃을 헌, 주적댈 헌, 추녀끝 헌, 고기 굵게 저밀 헌"),("櫶", "나무이름"),("巚", "봉우리 헌, 시루봉 헌"),("幰", "수레 안장 헌, 휘장 헌"),("攇", "비길 헌, 물건 맬 헌"),]),
("헌신동", &[("軒新洞", "지명"),]),
("헐", &[("歇", "쉴 헐, 나른할 헐, 다할 헐, 으슥할 헐, 스러질 헐, 흩어질 헐"),]),
("험", &[("險", "험할 험, 험난할 험"),("驗", "시험할 험, 중험할 험, 보람 험"),("嶮", "산 가파를 험"),("玁", "獫과 同字"),("獫", "험윤 오랑캐 험"),]),
("혁", &[("革", "가죽 혁, 고칠 혁, 갑주 혁"),("赫", "불 이글이글할 혁, 빛날 혁, 성할 혁, 밝을 혁"),("爀", "불빛 혁, 빛날 혁"),("奕", "아름다울 혁, 클 혁, 차례 혁, 바둑 혁, 빛날 혁, 근심할 혁"),("嚇", "노할 혁, 꾸짖을 혁"),("洫", "넘칠 혁, 빌 혁, 봇도랑 혁"),("鬩", "송사할 혁, 싸울 혁"),("弈", "바둑둘 혁"),]),
("현", &[("見", "나타날 현, 드러날 현, 있을 현, 보일 현, 볼 현"),("現", "나타날 현, 지금 현, 옥빛 현"),("賢", "어질 현, 좋을 현, 구멍 현"),("顯", "나타날 현, 밝을 현, 통달할 현, 높을 현"),("玄", "검을 현, 검붉을 현, 하늘 현, 아득할 현, 고요할 현"),("縣", "매달릴 현, 끊어질 현, 고을 현"),("懸", "매달 현, 멀 현"),("絃", "줄풍류 현"),("弦", "시위 현, 반달 현, 맥박 잦을 현, 땅이름 현, 활시위 현"),("鉉", "솥귀 현"),("峴", "고개 현, 산이름 현"),("炫", "밝을 현, 불빛 현"),("洵", "멀 현"),("眩", "아찔할 현, 현혹할 현"),("衒", "자랑할 현, 팔릴 현"),("絢", "채색무늬 현, 수놓을 현"),("晛", "햇발 현, 볕기운 현"),("俔", "연탐할 현, 풍세보는 깃 현, 정탐할 현"),("玹", "옥돌"),("泫", "물 깊을 현, 이슬 맺힐 현, 눈물 줄줄 흘릴 현"),("睍", "물끄러미 볼 현, 고울 현"),("舷", "뱃전 현"),("儇", "영리할 현, 빠를 현"),("嬛", "산뜻할 현"),("昡", "햇빛 현"),("繯", "얽힐 현, 둘릴 현, 맬 현"),("痃", "힘줄 당기는 병 현, 적병 현"),("県", "고을 현, 지방 현"),("翾", "파뜩파뜩 날 현, 경박할 현, 영리할 현, 급할 현"),("蜆", "가막조개 현, 호수이름 현"),("鋗", "노구솥 현, 퉁노구 현"),("駽", "돗총이 현, 철총이 현"),]),
("현경면", &[("玄慶面", "지명"),]),
("현곡면", &[("見谷面", "지명"),]),
("현남면", &[("縣南面", "지명"),]),
("현내면", &[("縣內面", "지명"),]),
("현덕면", &[("玄德面", "지명"),]),
("현도면", &[("賢都面", "지명"),]),
("현동", &[("縣洞", "지명"),]),
("현동면", &[("縣東面", "지명"),]),
("현북면", &[("縣北面", "지명"),]),
("현산면", &[("縣山面", "지명"),]),
("현서면", &[("縣西面", "지명"),]),
("현석동", &[("玄石洞", "지명"),]),
("현수동", &[("玄水洞", "지명"),]),
("현암동", &[("玄岩洞", "지명"),]),
("현영동", &[("玄永洞", "지명"),]),
("현저동", &[("峴底洞", "지명"),]),
("현천동", &[("玄川洞", "지명"),]),
("현풍면", &[("玄風面", "지명"),]),
("혈", &[("血", "피 혈, 피붙이 혈, 씩씩할 혈"),("穴", "굴 혈, 움 혈, 틈 혈, 굿 혈"),("孑", "외로울 혈, 나머지 혈, 창갈구리 혈"),("頁", "머리 혈, 마리 혈, 페이지(page) 혈"),("絜", "헤아릴 혈, 묶을 혈"),("趐", "새가 떼로 날 혈, 나아갈 혈"),]),
("혈동", &[("穴洞", "지명"),]),
("혐", &[("嫌", "싫어할 혐, 의심할 혐, 유쾌하지 않을 혐"),]),
("협", &[("協", "조화할 협, 맞을 협, 도울 협"),("脅", "갈빗대 협, 위협할 협"),("狹", "좁을 협"),("峽", "물 낀 두메 협, 산이름 협"),("陜", "좁을 협"),("挾", "낄 협, 도울 협, 품을 협"),("俠", "의기 협, 사이에 낄 협, 협기 협"),("頰", "뺨 협, 천천히 말할 협"),("夾", "곁 협, 낄 협, 잡을 협, 성씨 협, 가까울 협"),("浹", "사무칠 협, 둘릴 협"),("脇", "脅과 同字, 갈비 협"),("鋏", "칼 손잡이 협, 집개 협, 집게 협"),("莢", "콩 꼬투리 협, 명협 협"),("叶", "화합할 협"),("恊", "겁낼 협, 위협할 협"),("愜", "쾌할 협, 뜻에 맞을 협"),("篋", "상자 협, 행담 협"),("匧", "옷상자 협, 꿰맬 협"),]),
("형", &[("兄", "맏이 형"),("形", "모양 형, 몸 형, 형상 형"),("刑", "형벌 형, 죽일 형"),("亨", "형통할 형, 제사 형"),("螢", "개똥벌레 형, 반딧불 형"),("衡", "저울대 형"),("炯", "빛날 형, 밝을 형"),("馨", "향기 형, 향기로울 형"),("邢", "나라 이름 형, 땅 이름 형"),("瀅", "맑을 형, 개천 형, 물맑을 형"),("型", "거푸집 형, 본보기 형"),("荊", "모형나무 형, 곤장 형, 가시 형"),("熒", "등불 형, 밝을 형"),("瑩", "밝을 형"),("泂", "멀 형, 깊고 넓은 모양 형, 차가운 형, 찰 형"),("珩", "노리개 형, 갓끈 형"),("逈", "멀 형, 빛날 형"),("桁", "시렁 형, 마개 형"),("滎", "실개천 형, 물결 일 형, 맑을 형"),("鎣", "줄 형, 꾸밀 형"),("灐", "물 이름 형"),("迥", "막을 형, 차단할 형"),("詗", "염탐할 형, 구할 형"),("夐", "멀 형, 바라보는 모양 형"),("陘", "지레목 형, 비탈 형"),("娙", "여관 이름 형, 예쁠 형"),]),
("형곡동", &[("荊谷洞", "지명"),]),
("혜", &[("惠", "은혜 혜, 사랑할 혜"),("慧", "슬기로울 혜, 총명할 혜, 지혜 혜"),("兮", "어조사 혜"),("彗", "비 혜, 꼬리별 혜"),("醯", "초 혜, 위대로울 혜, 식혜 혜"),("鞋", "신 혜, 가죽신 혜"),("蹊", "지름길 혜, 건널 혜"),("蕙", "혜초 혜, 난초 혜"),("暳", "잔별"),("盻", "흘겨볼 혜, 돌아볼 혜"),("徯", "기다릴 혜, 사잇길 혜"),("槥", "널 혜, 작은 관 혜"),("傒", "묶을 혜"),("嘒", "가냘플 혜"),("寭", "밝힐 혜, 깨달을 혜"),("謑", "창피줄 혜"),("譿", "슬기로울 혜"),("嵇", "산이름"),("匸", "감추다"),]),
("혜화동", &[("惠化洞", "지명"),]),
("호", &[("好", "좋을 호, 옳을 호"),("戶", "지게 호"),("號", "울부짖을 호, 부르짖을 호"),("湖", "호수 호"),("乎", "인가 호, 어조사 호"),("呼", "부를 호, 숨 내쉴 호"),("虎", "범 호"),("胡", "턱밑살 호, 오랑캐 호"),("護", "보호할 호, 감쌀 호, 호위할 호"),("毫", "가는 털 호"),("浩", "클 호"),("豪", "호걸 호, 귀인 호"),("互", "서로 호, 함께 호"),("扈", "뒤따를 호, 호위할 호"),("鎬", "호경 호"),("皓", "흴 호, 깨끗할 호"),("糊", "풀 호, 끈끈할 호, 풀칠할 호"),("昊", "하늘 호, 큰 모양 호, 여름하늘 호"),("濠", "해자 호, 강 이름 호, 고을이름 호"),("祜", "복 호"),("晧", "밝을 호, 빛날 호, 해돋을 호"),("澔", "浩와 同字, 채색빛날 호"),("壕", "해자 호, 성밑해자 호"),("狐", "여우 호"),("瑚", "산호 호"),("弧", "활 호, 나무활 호"),("琥", "호박 호"),("壺", "병 호, 단지 호, 항아리 호"),("蒿", "쑥 호, 향기날 호, 지칠 호, 다북쑥 호"),("濩", "퍼질 호"),("芦", "芐와 同字, 蔖의 俗字, 갈대 호"),("灝", "넓을 호, 콩 삶은 물 호, 물줄기멀 호"),("瓠", "표주박 호, 단지 호"),("縞", "명주 호, 흴 호, 흰비단 호"),("顥", "클 호, 빛나는 모양 호"),("岵", "산 호, 산초목 호"),("蝴", "나비"),("滸", "물가 호"),("頀", "구할 호, 지킬 호, 풍류이름 호"),("淏", "맑을 호"),("葫", "마늘 호, 조롱박 호, 굵은 마늘 호"),("犒", "호궤할 호"),("怙", "믿을 호"),("沍", "冱의 譌字"),("箎", "긴 대 호"),("餬", "기식할 호"),("皞", "밝을 호, 흴 호"),("醐", "제호 호"),("嘷", "짖을 호, 외칠 호"),("滈", "장마 호"),("冱", "찰 호, 얼 호, 막을 호"),("嫮", "아름다울 호, 시기할 호"),("滬", "강 이름 호"),("皜", "흴 호, 흰 모양 호"),("儫", "영웅 호"),("猢", "원숭이 호"),("聕", "들릴 호, 긴 귀 호"),("鬍", "수염 호"),("虍", "범"),]),
("호계동", &[("虎溪洞", "지명"),]),
("호계면", &[("虎溪面", "지명"),]),
("호근동", &[("好近洞", "지명"),]),
("호남동", &[("湖南洞", "지명"),]),
("호동", &[("虎洞", "지명"),]),
("호동동", &[("虎洞洞", "지명"),]),
("호림동", &[("狐林洞", "지명"),]),
("호매실동", &[("好梅實洞", "지명"),]),
("호명동", &[("虎鳴洞", "지명"),]),
("호명면", &[("虎鳴面", "지명"),]),
("호법면", &[("戶法面", "지명"),]),
("호사다자리", &[("豪斯多剌利", "오스트레일리아"),]),
("호사자리", &[("濠斯剌利", "오스트레일리아"),]),
("호산동", &[("虎山洞", "지명"),]),
("호성동", &[("湖城洞", "지명"),]),
("호암동", &[("虎岩洞", "지명"),]),
("호원동", &[("虎院洞", "지명"),]),
("호저면", &[("好楮面", "지명"),]),
("호주", &[("濠州", "오스트레일리아"),]),
("호탄동", &[("虎灘洞", "지명"),]),
("호태자리", &[("濠太剌利", "오스트레일리아"),]),
("호태자리아", &[("濠太剌利亞", "오스트레일리아"),]),
("호평", &[("好坪", "지명"),]),
("호현동", &[("虎峴洞", "지명"),]),
("혹", &[("或", "혹 혹"),("惑", "미혹할 혹"),("酷", "독할 혹, 혹독할 혹"),("鵠", "고니 혹"),]),
("혼", &[("混", "섞을 혼, 섞일 혼"),("婚", "혼인할 혼"),("昏", "어두울 혼"),("魂", "넋 혼"),("渾", "흐릴 혼"),("琿", "아름다운옥"),("溷", "어지러울 혼"),("閽", "문지기 혼"),("惛", "흐릴 혼"),("焜", "빛날 혼"),("圂", "뒷간 혼"),]),
("홀", &[("忽", "소흘히 할 홀, 홀연 홀"),("笏", "홀 홀"),("惚", "황홀할 홀"),("囫", "온전할 홀"),]),
("홍", &[("紅", "붉을 홍"),("洪", "큰물 홍, 넓을 홍"),("弘", "넓을 홍, 클 홍"),("鴻", "큰 기러기 홍"),("泓", "깊을 홍, 물깊을 홍"),("訌", "무너질 홍, 무너뜨릴 홍"),("虹", "무지개 홍"),("哄", "떠들썩할 홍"),("烘", "횃불 홍"),("汞", "수은 홍"),("鬨", "싸울 홍"),("澒", "수은 홍"),("晎", "날 밝으려 할 홍"),("篊", "홈통 홍"),("鉷", "돌쇠뇌 홍"),]),
("홍내동", &[("鴻內洞", "지명"),]),
("홍농읍", &[("弘農邑", "지명"),]),
("홍도동", &[("弘道洞", "지명"),]),
("홍도랍사", &[("洪都拉斯", "온두라스"),]),
("홍동면", &[("洪東面", "지명"),]),
("홍문동", &[("弘文洞", "지명"),]),
("홍북면", &[("洪北面", "지명"),]),
("홍산면", &[("鴻山面", "지명"),]),
("홍성군", &[("洪城郡", "지명"),]),
("홍성읍", &[("洪城邑", "지명"),]),
("홍아리", &[("洪牙利", "헝가리"),]),
("홍은동", &[("弘恩洞", "지명"),]),
("홍익동", &[("弘益洞", "지명"),]),
("홍제동", &[("弘濟洞", "지명"),]),
("홍지동", &[("弘智洞", "지명"),]),
("홍천군", &[("洪川郡", "지명"),]),
("홍천읍", &[("洪川邑", "지명"),]),
("홍파동", &[("紅把洞", "지명"),]),
("화", &[("火", "불 화"),("花", "꽃 화"),("化", "될 화"),("話", "말할 화, 이야기 화"),("和", "화할 화"),("畵", "그림 화"),("華", "꽃 화, 빛날 화"),("貨", "재화 화, 재물 화"),("禍", "재화 화"),("禾", "벼 화"),("靴", "신 화"),("樺", "자작나무 화, 벗나무 화"),("嬅", "여자 이름 화, 탐스러울 화"),("譁", "시끄러울 화, 떠들썩할 화"),("畫", "그림 화"),("嘩", "譁와 同字"),("驊", "준마 화"),("俰", "화할 화"),("婲", "예쁠 화"),("龢", "풍류 조화될 화"),("灬", "불화발"),]),
("화개동", &[("花開洞", "지명"),]),
("화개면", &[("花開面", "지명"),]),
("화계동", &[("花溪洞", "지명"),]),
("화곡동", &[("禾谷洞", "지명"),]),
("화남면", &[("化南面", "지명"),("華南面", "지명"),]),
("화도면", &[("華道面", "지명"),]),
("화도읍", &[("和道邑", "지명"),]),
("화동", &[("花洞", "지명"),]),
("화동면", &[("化東面", "지명"),]),
("화란", &[("和蘭", "네덜란드"),]),
("화란타", &[("和蘭陀", "네덜란드"),]),
("화룡동", &[("化龍洞", "지명"),]),
("화명동", &[("華明洞", "지명"),]),
("화목동", &[("花木洞", "지명"),]),
("화봉동", &[("華峰洞", "지명"),]),
("화북동", &[("禾北洞", "지명"),]),
("화북면", &[("化北面", "지명"),("華北面", "지명"),]),
("화산동", &[("花山洞", "지명"),]),
("화산면", &[("花山面", "지명"),("華山面", "지명"),]),
("화서동", &[("華西洞", "지명"),]),
("화서면", &[("化西面", "지명"),]),
("화성동", &[("華城洞", "지명"),]),
("화성면", &[("化城面", "지명"),]),
("화성시", &[("華城市", "지명"),]),
("화수동", &[("花水洞", "지명"),]),
("화순군", &[("和順郡", "지명"),]),
("화순읍", &[("和順邑", "지명"),]),
("화암동", &[("花岩洞", "지명"),]),
("화양동", &[("華陽洞", "지명"),]),
("화양면", &[("華陽面", "지명"),]),
("화양읍", &[("華陽邑", "지명"),]),
("화영동", &[("花英洞", "지명"),]),
("화원면", &[("花源面", "지명"),]),
("화원읍", &[("花園邑", "지명"),]),
("화장동", &[("禾長洞", "지명"),("禾場洞", "지명"),]),
("화전동", &[("花田洞", "지명"),("華田洞", "지명"),("禾田洞", "지명"),]),
("화정동", &[("花井洞", "지명"),("花亭洞", "지명"),("華亭洞", "지명"),]),
("화정면", &[("華正面", "지명"),("華井面", "지명"),]),
("화지관", &[("和地關", "바티칸"),]),
("화지동", &[("花枝洞", "지명"),]),
("화천군", &[("華川郡", "지명"),]),
("화천동", &[("和泉洞", "지명"),]),
("화천읍", &[("華川邑", "지명"),]),
("화촌면", &[("化村面", "지명"),]),
("화치동", &[("花峙洞", "지명"),]),
("화태류", &[("華太瑠", "카타르"),]),
("화평동", &[("花平洞", "지명"),]),
("화하", &[("華夏", "중화인민공화국"),]),
("화현면", &[("花峴面", "지명"),]),
("확", &[("確", "굳을 확, 확실할 확"),("擴", "넓힐 확"),("穫", "벼 벨 확, 곡식거둘 확"),("廓", "둘레 확, 클 확"),("攫", "붙잡을 확, 움킬 확"),("碻", "굳을 확, 확실할 확"),("鑊", "가마 확"),("矍", "두리번거릴 확"),]),
("환", &[("患", "근심 환"),("歡", "기뻐할 환"),("還", "돌아올 환"),("換", "바꿀 환"),("丸", "알 환, 둥글 환"),("環", "고리 환, 옥고리 환"),("喚", "부를 환"),("煥", "불꽃 환, 빛날 환"),("桓", "푯말 환, 굳셀 환"),("幻", "변할 환, 허깨비 환"),("宦", "벼슬 환, 환관 환"),("鰥", "환어 환, 홀아비 환"),("驩", "기뻐할 환, 환말 환"),("渙", "흩어질 환, 물성할 환"),("紈", "흰 비단 환"),("奐", "빛날 환, 클 환"),("晥", "환할 환"),("懽", "기뻐할 환"),("圜", "두를 환"),("寰", "기내 환"),("豢", "기를 환"),("鬟", "쪽찐 머리 환"),("擐", "입을 환"),("轘", "환형 환"),("瓛", "옥홀 환"),("睆", "가득 차 있는 모양 환"),("鍰", "무게 단위 환"),("絙", "끈목 환"),("鐶", "고리 환"),("皖", "샛별 환"),]),
("환전", &[("丸田", "몰타"),]),
("환호동", &[("環湖洞", "지명"),]),
("활", &[("活", "살 활"),("闊", "트일 활, 넓을 활"),("滑", "미끄러울 활, 어지러울 활"),("猾", "교활할 활"),("豁", "뚫린 골 활, 골짜기 활"),("蛞", "괄태충 활"),]),
("활성동", &[("活城洞", "지명"),]),
("활초동", &[("活草洞", "지명"),]),
("황", &[("黃", "누를 황"),("皇", "임금 황"),("況", "하물며 황"),("荒", "거칠 황"),("滉", "물 깊고 넓을 황"),("慌", "어렴풋할 황, 어리둥절할 황"),("徨", "노닐 황, 방황할 황"),("晃", "밝을 황, 햇빛 황"),("惶", "두려워할 황, 두려울 황"),("遑", "허둥거릴 황, 급할 황"),("煌", "빛날 황, 환히밝을 황"),("凰", "봉황새 황, 암봉황새 황"),("潢", "웅덩이 황"),("璜", "서옥 황, 반둥근패옥 황"),("蝗", "누리 황, 메뚜기 황"),("榥", "책상 황"),("隍", "해자 황, 산골짜기 황"),("篁", "대숲 황, 대밭 황"),("愰", "밝을 황, 마음밝을 황"),("簧", "혀 황, 생황 황"),("恍", "황홀할 황"),("幌", "휘장 황"),("湟", "해자 황, 물결빨리내려가는 모양 황"),("晄", "晃과 同字, 밝을 황"),("怳", "멍할 황"),("貺", "줄 황"),("肓", "명치 끝 황"),("喤", "어린아이 울음 황"),("鎤", "종소리 황"),("瑝", "옥 소리 황"),("媓", "어머니 황"),]),
("황간면", &[("黃澗面", "지명"),]),
("황금동", &[("黃金洞", "지명"),]),
("황길동", &[("黃吉洞", "지명"),]),
("황남동", &[("皇南洞", "지명"),]),
("황등면", &[("黃登面", "지명"),]),
("황룡동", &[("黃龍洞", "지명"),]),
("황룡면", &[("黃龍面", "지명"),]),
("황산동", &[("凰山洞", "지명"),]),
("황산면", &[("黃山面", "지명"),("凰山面", "지명"),]),
("황상동", &[("黃桑洞", "지명"),]),
("황성동", &[("黃城洞", "지명"),("皇城洞", "지명"),]),
("황오동", &[("皇吾洞", "지명"),]),
("황용동", &[("黃龍洞", "지명"),]),
("황전면", &[("黃田面", "지명"),]),
("황지동", &[("黃池洞", "지명"),]),
("황학동", &[("黃鶴洞", "지명"),]),
("황호동", &[("黃湖洞", "지명"),]),
("회", &[("回", "돌 회, 돌아올 회"),("會", "모일 회, 모을 회"),("悔", "뉘우칠 회"),("懷", "품을 회"),("淮", "강 이름 회, 물이름 회"),("恢", "넓을 회, 클 회"),("灰", "재 회"),("廻", "돌 회, 돌아올 회"),("檜", "노송나무 회"),("膾", "회 회, 회칠 회"),("晦", "그믐 회"),("徊", "노닐 회, 배회할 회"),("誨", "가르칠 회"),("賄", "뇌물 회, 재물 회"),("繪", "그림 회"),("蛔", "거위 회"),("澮", "봇도랑 회, 우물도랑 회"),("匯", "물돌 회, 물이돌아가는 회"),("獪", "교활할 회, 간교할 회"),("茴", "회향풀 회"),("迴", "回와 同字"),("洄", "거슬러 올라 갈 회"),("詼", "조롱할 회"),("鱠", "회 회"),("佪", "어정거릴 회"),("滙", "匯와 同字"),("頮", "세수할 회"),("盔", "바리 회"),("栃", "상수리나무 회"),]),
("회기동", &[("回基洞", "지명"),]),
("회남면", &[("懷南面", "지명"),]),
("회덕", &[("回德", "지명"),]),
("회동동", &[("回東洞", "지명"),]),
("회북면", &[("懷北面", "지명"),]),
("회산동", &[("淮山洞", "지명"),]),
("회성동", &[("檜城洞", "지명"),]),
("회수동", &[("廻水洞", "지명"),]),
("회원구", &[("檜原區", "지명"),]),
("회원동", &[("檜原洞", "지명"),]),
("회진면", &[("會鎭面", "지명"),]),
("회천동", &[("回泉洞", "지명"),]),
("회천면", &[("會泉面", "지명"),]),
("회천읍", &[("檜泉邑", "지명"),]),
("회현동", &[("會賢洞", "지명"),]),
("회현면", &[("澮縣面", "지명"),]),
("회화면", &[("會華面", "지명"),]),
("획", &[("畵", "畫의 俗字"),("獲", "얻을 획"),("劃", "쪼갤 획, 그을 획"),("畫", "그을 획"),("嚄", "외칠 획"),]),
("횡", &[("橫", "가로 횡"),("薨", "많을 횡"),("宖", "집 울릴 횡, 평안할 횡"),("鐄", "종 횡, 큰 종 횡"),("黌", "글방 횡"),("鈜", "쇳소리 횡"),("澋", "물이 빙 돌 횡"),]),
("횡성군", &[("橫城郡", "지명"),]),
("횡성읍", &[("橫城邑", "지명"),]),
("횡천면", &[("橫川面", "지명"),]),
("효", &[("孝", "효도 효, 효도할 효"),("效", "본받을 효"),("曉", "새벽 효"),("酵", "삭일 효, 술괼 효"),("爻", "효 효, 괘이름 효"),("嚆", "울릴 효, 부르짖을 효"),("哮", "으르렁거릴 효, 성낼 효"),("梟", "올배미 효, 올빼미 효"),("肴", "안주 효"),("淆", "뒤섞일 효, 흙탕칠 효"),("驍", "날랠 효"),("斅", "가르칠 효, 깨우칠 효"),("涍", "성 효, 물가 효"),("囂", "시끄럽다 효"),("傚", "본받을 효"),("殽", "섞일 효"),("崤", "산 이름 효"),("熇", "불김 효"),("皛", "나타날 효"),("虓", "울부짖을 효"),("餚", "반찬 효"),]),
("효가동", &[("孝街洞", "지명"),]),
("효동", &[("孝洞", "지명"),]),
("효령동", &[("孝領洞", "지명"),]),
("효령면", &[("孝令面", "지명"),]),
("효목동", &[("孝睦洞", "지명"),]),
("효문동", &[("孝門洞", "지명"),]),
("효성동", &[("曉星洞", "지명"),]),
("효자동", &[("孝子洞", "지명"),]),
("효제동", &[("孝悌洞", "지명"),]),
("효창동", &[("孝昌洞", "지명"),]),
("효평동", &[("孝坪洞", "지명"),]),
("효현동", &[("孝峴洞", "지명"),]),
("후", &[("後", "뒤 후"),("厚", "두터울 후"),("侯", "과녁 후, 벼슬이름 후"),("后", "임금 후"),("候", "물을 후, 기후 후"),("喉", "목구멍 후"),("吼", "울 후, 우는소리 후"),("朽", "섞을 후, 썩을 후"),("逅", "만날 후"),("嗅", "맡을 후, 냄새맡을 후"),("煦", "따뜻하게 할 후, 뜨거울 후"),("帿", "과녁 후"),("珝", "옥 이름 후"),("垕", "厚의 古字"),("詡", "자랑할 후"),("酗", "주정할 후"),("猴", "원숭이 후"),("堠", "봉화대 후"),("喣", "불 후"),("餱", "건량 후"),("篌", "공후 후"),("譃", "망녕된 말 후"),]),
("후암동", &[("厚岩洞", "지명"),]),
("후평동", &[("後坪洞", "지명"),]),
("후포면", &[("厚浦面", "지명"),]),
("훈", &[("訓", "가르칠 훈"),("薰", "향불 훈, 향풀 훈"),("熏", "연기 낄 훈, 불기운 훈"),("勳", "공 훈"),("壎", "진나팔 훈, 질나팔 훈"),("暈", "무리 훈"),("塤", "壎과 同字, 질나팔 훈"),("勛", "勳의 古字, 공적 훈"),("焄", "연기에 그을릴 훈, 향내 훈"),("燻", "연기 낄 훈, 불기운성할 훈"),("曛", "삭양 빛 훈"),("纁", "분홍빛 훈"),("葷", "매운 채소 훈"),("獯", "오랑캐 이름 훈"),("鑂", "금빛 투색할 훈"),("爋", "불에 말릴 훈"),]),
("훈정동", &[("薰井洞", "지명"),]),
("훌", &[("欻", "문득 훌"),]),
("훙", &[("薨", "죽을 훙"),]),
("훤", &[("喧", "의젓할 훤, 지껄일 훤"),("萱", "원추리 훤"),("暄", "따뜻할 훤, 날따뜻할 훤"),("煊", "따뜻할 훤"),("諼", "속일 훤"),("諠", "잊을 훤"),("烜", "마를 훤"),]),
("훼", &[("毁", "毀의 俗字, 헐 훼"),("喙", "부리 훼, 주둥이 훼"),("卉", "풀 훼"),("虫", "벌레 훼"),("虺", "살무사 훼"),("燬", "불 훼"),("芔", "풀 훼"),]),
("휘", &[("揮", "휘두를 휘"),("輝", "빛날 휘"),("徽", "아름다울 휘"),("諱", "꺼릴 휘, 피할 휘"),("麾", "대장기 휘"),("彙", "무리 휘, 모을 휘"),("暉", "빛 휘, 햇빛 휘"),("煇", "빛날 휘"),("撝", "찣을 휘"),("翬", "훨훨날 휘"),]),
("휘경동", &[("徽慶洞", "지명"),]),
("휴", &[("休", "쉴 휴"),("携", "끌 휴, 가질 휴, 떠날 휴, 나눌 휴, 연속할 휴"),("烋", "경사로울 휴, 아름다울 휴"),("虧", "이지러질 휴"),("畦", "밭두둑 휴"),("隳", "무너뜨릴 휴"),("鵂", "수리부엉이 휴"),("咻", "떠들 휴"),("擕", "携와 同字"),("髹", "옻칠할 휴"),]),
("휴암동", &[("休岩洞", "지명"),]),
("휴천동", &[("休川洞", "지명"),]),
("휴천면", &[("休川面", "지명"),]),
("휵", &[("畜", "기를 휵, 용납할 휵"),]),
("휼", &[("恤", "구휼할 휼, 근심할 휼"),("譎", "속일 휼, 간사할 휼"),("鷸", "황새"),]),
("흉", &[("凶", "흉할 흉"),("胸", "가슴 흉"),("匈", "가슴"),("兇", "흉악할 흉, 나쁜 흉"),("洶", "물살세찰 흉, 물소리 흉"),("胷", "胸과 同字"),("恟", "두려워할 흉"),]),
("흉아리", &[("匈牙利", "헝가리"),]),
("흑", &[("黑", "검을 흑"),]),
("흑산면", &[("黑山面", "지명"),]),
("흑석동", &[("黑石洞", "지명"),]),
("흑암동", &[("黑岩洞", "지명"),]),
("흔", &[("痕", "흉터 흔"),("欣", "기뻐할 흔, 기쁠 흔"),("昕", "아침 흔, 해돋을 흔"),("炘", "화끈거릴 흔"),("釁", "피바를 흔"),("忻", "기뻐할 흔"),("訢", "기뻐할 흔"),("掀", "치켜들 흔"),("焮", "불사를 흔"),("很", "패려궂을 흔"),]),
("흘", &[("汽", "汔과 同字"),("訖", "이를 흘"),("吃", "말더듬을 흘, 말더듬는 흘"),("屹", "산 우뚝솟을 흘, 산모양 흘"),("紇", "질 낮은 명주실 흘, 실밑 흘"),("迄", "이를 흘"),("汔", "거의 흘"),("仡", "날랠 흘"),("疙", "쥐부스럼 흘"),("齕", "깨물 흘"),]),
("흠", &[("欽", "공경할 흠"),("欠", "하품 흠, 하품할 흠"),("歆", "받을 흠, 흠향할 흠"),("廞", "진열할 흠"),]),
("흡", &[("吸", "숨 들이쉴 흡"),("洽", "윤태하게 할 흡, 화할 흡"),("恰", "마치 흡, 흡족할 흡"),("翕", "합할 흡"),("潝", "빨리 흐르는 소리 흡"),("歙", "줄일 흡"),("噏", "숨 들이쉴 흡"),("翖", "翕과 同字"),]),
("흥", &[("興", "일 흥, 일어날 흥"),]),
("흥각동", &[("興角洞", "지명"),]),
("흥덕구", &[("興德區", "지명"),]),
("흥덕동", &[("興德洞", "지명"),]),
("흥덕면", &[("흥덕面", "지명"),]),
("흥동", &[("興洞", "지명"),]),
("흥사동", &[("興寺洞", "지명"),]),
("흥업면", &[("興業面", "지명"),]),
("흥인동", &[("興仁洞", "지명"),]),
("흥천면", &[("興川面", "지명"),]),
("흥해읍", &[("興海邑", "지명"),]),
("희", &[("希", "바랄 희"),("喜", "기뻐할 희, 기쁠 희"),("稀", "드물 희"),("戱", "戲의 俗字, 희롱할 희"),("嬉", "즐길 희, 아름다울 희"),("熙", "빛날 희"),("噫", "탄식할 희, 슬플 희"),("羲", "숨 희, 복희 희"),("禧", "복 희"),("犧", "희생 희"),("姬", "성 희, 계집 희"),("熹", "성할 희, 밝을 희"),("憙", "성할 희, 기뻐할 희"),("愾", "한숨 희"),("僖", "기쁠 희, 즐거울 희"),("曦", "햇빛 희"),("凞", "빛날 희, 화할 희"),("晞", "마를 희"),("憘", "憙의 古字, 기쁠 희"),("熺", "熹와 同字, 밝을 희"),("囍", "쌍희 희"),("戲", "탄식할 희, 희롱할 희"),("嘻", "웃을 희"),("餼", "꾸밀 희"),("欷", "흐느낄 희"),("唏", "슬퍼할 희"),("暿", "웃을 희"),("咥", "허허 웃을 희"),("悕", "슬퍼할 희"),("豨", "멧돼지 희"),("爔", "불 희"),]),
("희랍", &[("希臘", "그리스"),]),
("힐", &[("詰", "물을 힐, 힐문할 힐"),("黠", "약을 힐"),("頡", "곧은목 힐"),("纈", "홀치기염색 힐"),("犵", "오랑캐이름 힐"),("襭", "옷자락 꽂을 힐"),]),
("힐알사", &[("黠戞斯", "키르기스스탄"),]),
];
pub static MATH_SYMBOL_ENTRIES: &[(SymbolKey, &str)] = &[(SymbolKey("&", Style(0)), "⅋"), (SymbolKey("((", Style(0)), "⦅"), (SymbolKey("(b", Style(0)), "⟅"), (SymbolKey("(|", Style(0)), "⦇"), (SymbolKey("))", Style(0)), "⦆"), (SymbolKey(")b", Style(0)), "⟆"), (SymbolKey("0", Style(1)), "𝟢"), (SymbolKey("0", Style(2)), "𝟎"), (SymbolKey("0", Style(3)), "𝟬"), (SymbolKey("0", Style(8)), "𝟶"), (SymbolKey("0", Style(16)), "𝟘"), (SymbolKey("1", Style(1)), "𝟣"), (SymbolKey("1", Style(2)), "𝟏"), (SymbolKey("1", Style(3)), "𝟭"), (SymbolKey("1", Style(8)), "𝟷"), (SymbolKey("1", Style(16)), "𝟙"), (SymbolKey("2", Style(1)), "𝟤"), (SymbolKey("2", Style(2)), "𝟐"), (SymbolKey("2", Style(3)), "𝟮"), (SymbolKey("2", Style(8)), "𝟸"), (SymbolKey("2", Style(16)), "𝟚"), (SymbolKey("3", Style(1)), "𝟥"), (SymbolKey("3", Style(2)), "𝟑"), (SymbolKey("3", Style(3)), "𝟯"), (SymbolKey("3", Style(8)), "𝟹"), (SymbolKey("3", Style(16)), "𝟛"), (SymbolKey("4", Style(1)), "𝟦"), (SymbolKey("4", Style(2)), "𝟒"), (SymbolKey("4", Style(3)), "𝟰"), (SymbolKey("4", Style(8)), "𝟺"), (SymbolKey("4", Style(16)), "𝟜"), (SymbolKey("5", Style(1)), "𝟧"), (SymbolKey("5", Style(2)), "𝟓"), (SymbolKey("5", Style(3)), "𝟱"), (SymbolKey("5", Style(8)), "𝟻"), (SymbolKey("5", Style(16)), "𝟝"), (SymbolKey("6", Style(1)), "𝟨"), (SymbolKey("6", Style(2)), "𝟔"), (SymbolKey("6", Style(3)), "𝟲"), (SymbolKey("6", Style(8)), "𝟼"), (SymbolKey("6", Style(16)), "𝟞"), (SymbolKey("7", Style(1)), "𝟩"), (SymbolKey("7", Style(2)), "𝟕"), (SymbolKey("7", Style(3)), "𝟳"), (SymbolKey("7", Style(8)), "𝟽"), (SymbolKey("7", Style(16)), "𝟟"), (SymbolKey("8", Style(1)), "𝟪"), (SymbolKey("8", Style(2)), "𝟖"), (SymbolKey("8", Style(3)), "𝟴"), (SymbolKey("8", Style(8)), "𝟾"), (SymbolKey("8", Style(16)), "𝟠"), (SymbolKey("9", Style(1)), "𝟫"), (SymbolKey("9", Style(2)), "𝟗"), (SymbolKey("9", Style(3)), "𝟵"), (SymbolKey("9", Style(8)), "𝟿"), (SymbolKey("9", Style(16)), "𝟡"), (SymbolKey("<", Style(0)), "⟨"), (SymbolKey("<<", Style(0)), "⟪"), (SymbolKey(">", Style(0)), "⟩"), (SymbolKey(">>", Style(0)), "⟫"), (SymbolKey("A", Style(1)), "𝖠"), (SymbolKey("A", Style(2)), "𝐀"), (SymbolKey("A", Style(3)), "𝗔"), (SymbolKey("A", Style(4)), "𝐴"), (SymbolKey("A", Style(5)), "𝘈"), (SymbolKey("A", Style(6)), "𝑨"), (SymbolKey("A", Style(7)), "𝘼"), (SymbolKey("A", Style(8)), "𝙰"), (SymbolKey("A", Style(16)), "𝔸"), (SymbolKey("A", Style(32)), "𝒜"), (SymbolKey("A", Style(64)), "𝓐"), (SymbolKey("A", Style(128)), "𝔄"), (SymbolKey("A", Style(130)), "𝕬"), (SymbolKey("Alpha", Style(0)), "Α"), (SymbolKey("Alpha", Style(2)), "𝚨"), (SymbolKey("Alpha", Style(3)), "𝝖"), (SymbolKey("Alpha", Style(4)), "𝛢"), (SymbolKey("Alpha", Style(6)), "𝜜"), (SymbolKey("Alpha", Style(7)), "𝞐"), (SymbolKey("B", Style(1)), "𝖡"), (SymbolKey("B", Style(2)), "𝐁"), (SymbolKey("B", Style(3)), "𝗕"), (SymbolKey("B", Style(4)), "𝐵"), (SymbolKey("B", Style(5)), "𝘉"), (SymbolKey("B", Style(6)), "𝑩"), (SymbolKey("B", Style(7)), "𝘽"), (SymbolKey("B", Style(8)), "𝙱"), (SymbolKey("B", Style(16)), "𝔹"), (SymbolKey("B", Style(32)), "ℬ"), (SymbolKey("B", Style(64)), "𝓑"), (SymbolKey("B", Style(128)), "𝔅"), (SymbolKey("B", Style(130)), "𝕭"), (SymbolKey("Beta", Style(0)), "Β"), (SymbolKey("Beta", Style(2)), "𝚩"), (SymbolKey("Beta", Style(3)), "𝝗"), (SymbolKey("Beta", Style(4)), "𝛣"), (SymbolKey("Beta", Style(6)), "𝜝"), (SymbolKey("Beta", Style(7)), "𝞑"), (SymbolKey("Box", Style(0)), "□"), (SymbolKey("C", Style(1)), "𝖢"), (SymbolKey("C", Style(2)), "𝐂"), (SymbolKey("C", Style(3)), "𝗖"), (SymbolKey("C", Style(4)), "𝐶"), (SymbolKey("C", Style(5)), "𝘊"), (SymbolKey("C", Style(6)), "𝑪"), (SymbolKey("C", Style(7)), "𝘾"), (SymbolKey("C", Style(8)), "𝙲"), (SymbolKey("C", Style(16)), "ℂ"), (SymbolKey("C", Style(32)), "𝒞"), (SymbolKey("C", Style(64)), "𝓒"), (SymbolKey("C", Style(128)), "ℭ"), (SymbolKey("C", Style(130)), "𝕮"), (SymbolKey("Chi", Style(0)), "Χ"), (SymbolKey("Chi", Style(2)), "𝚾"), (SymbolKey("Chi", Style(3)), "𝝬"), (SymbolKey("Chi", Style(4)), "𝛸"), (SymbolKey("Chi", Style(6)), "𝜲"), (SymbolKey("Chi", Style(7)), "𝞦"), (SymbolKey("D", Style(1)), "𝖣"), (SymbolKey("D", Style(2)), "𝐃"), (SymbolKey("D", Style(3)), "𝗗"), (SymbolKey("D", Style(4)), "𝐷"), (SymbolKey("D", Style(5)), "𝘋"), (SymbolKey("D", Style(6)), "𝑫"), (SymbolKey("D", Style(7)), "𝘿"), (SymbolKey("D", Style(8)), "𝙳"), (SymbolKey("D", Style(16)), "𝔻"), (SymbolKey("D", Style(32)), "𝒟"), (SymbolKey("D", Style(64)), "𝓓"), (SymbolKey("D", Style(128)), "𝔇"), (SymbolKey("D", Style(130)), "𝕯"), (SymbolKey("Delta", Style(0)), "Δ"), (SymbolKey("Delta", Style(2)), "𝚫"), (SymbolKey("Delta", Style(3)), "𝝙"), (SymbolKey("Delta", Style(4)), "𝛥"), (SymbolKey("Delta", Style(6)), "𝜟"), (SymbolKey("Delta", Style(7)), "𝞓"), (SymbolKey("Diamond", Style(0)), "⋄"), (SymbolKey("Digamma", Style(0)), "Ϝ"), (SymbolKey("Digamma", Style(2)), "𝟊"), (SymbolKey("Downarrow", Style(0)), "⇓"), (SymbolKey("E", Style(1)), "𝖤"), (SymbolKey("E", Style(2)), "𝐄"), (SymbolKey("E", Style(3)), "𝗘"), (SymbolKey("E", Style(4)), "𝐸"), (SymbolKey("E", Style(5)), "𝘌"), (SymbolKey("E", Style(6)), "𝑬"), (SymbolKey("E", Style(7)), "𝙀"), (SymbolKey("E", Style(8)), "𝙴"), (SymbolKey("E", Style(16)), "𝔼"), (SymbolKey("E", Style(32)), "ℰ"), (SymbolKey("E", Style(64)), "𝓔"), (SymbolKey("E", Style(128)), "𝔈"), (SymbolKey("E", Style(130)), "𝕰"), (SymbolKey("Epsilon", Style(0)), "Ε"), (SymbolKey("Epsilon", Style(2)), "𝚬"), (SymbolKey("Epsilon", Style(3)), "𝝚"), (SymbolKey("Epsilon", Style(4)), "𝛦"), (SymbolKey("Epsilon", Style(6)), "𝜠"), (SymbolKey("Epsilon", Style(7)), "𝞔"), (SymbolKey("Eta", Style(0)), "Η"), (SymbolKey("Eta", Style(2)), "𝚮"), (SymbolKey("Eta", Style(3)), "𝝜"), (SymbolKey("Eta", Style(4)), "𝛨"), (SymbolKey("Eta", Style(6)), "𝜢"), (SymbolKey("Eta", Style(7)), "𝞖"), (SymbolKey("F", Style(1)), "𝖥"), (SymbolKey("F", Style(2)), "𝐅"), (SymbolKey("F", Style(3)), "𝗙"), (SymbolKey("F", Style(4)), "𝐹"), (SymbolKey("F", Style(5)), "𝘍"), (SymbolKey("F", Style(6)), "𝑭"), (SymbolKey("F", Style(7)), "𝙁"), (SymbolKey("F", Style(8)), "𝙵"), (SymbolKey("F", Style(16)), "𝔽"), (SymbolKey("F", Style(32)), "ℱ"), (SymbolKey("F", Style(64)), "𝓕"), (SymbolKey("F", Style(128)), "𝔉"), (SymbolKey("F", Style(130)), "𝕱"), (SymbolKey("G", Style(1)), "𝖦"), (SymbolKey("G", Style(2)), "𝐆"), (SymbolKey("G", Style(3)), "𝗚"), (SymbolKey("G", Style(4)), "𝐺"), (SymbolKey("G", Style(5)), "𝘎"), (SymbolKey("G", Style(6)), "𝑮"), (SymbolKey("G", Style(7)), "𝙂"), (SymbolKey("G", Style(8)), "𝙶"), (SymbolKey("G", Style(16)), "𝔾"), (SymbolKey("G", Style(32)), "𝒢"), (SymbolKey("G", Style(64)), "𝓖"), (SymbolKey("G", Style(128)), "𝔊"), (SymbolKey("G", Style(130)), "𝕲"), (SymbolKey("Gamma", Style(0)), "Γ"), (SymbolKey("Gamma", Style(2)), "𝚪"), (SymbolKey("Gamma", Style(3)), "𝝘"), (SymbolKey("Gamma", Style(4)), "𝛤"), (SymbolKey("Gamma", Style(6)), "𝜞"), (SymbolKey("Gamma", Style(7)), "𝞒"), (SymbolKey("Gamma", Style(16)), "ℾ"), (SymbolKey("H", Style(1)), "𝖧"), (SymbolKey("H", Style(2)), "𝐇"), (SymbolKey("H", Style(3)), "𝗛"), (SymbolKey("H", Style(4)), "𝐻"), (SymbolKey("H", Style(5)), "𝘏"), (SymbolKey("H", Style(6)), "𝑯"), (SymbolKey("H", Style(7)), "𝙃"), (SymbolKey("H", Style(8)), "𝙷"), (SymbolKey("H", Style(16)), "ℍ"), (SymbolKey("H", Style(32)), "ℋ"), (SymbolKey("H", Style(64)), "𝓗"), (SymbolKey("H", Style(128)), "ℌ"), (SymbolKey("H", Style(130)), "𝕳"), (SymbolKey("I", Style(1)), "𝖨"), (SymbolKey("I", Style(2)), "𝐈"), (SymbolKey("I", Style(3)), "𝗜"), (SymbolKey("I", Style(4)), "𝐼"), (SymbolKey("I", Style(5)), "𝘐"), (SymbolKey("I", Style(6)), "𝑰"), (SymbolKey("I", Style(7)), "𝙄"), (SymbolKey("I", Style(8)), "𝙸"), (SymbolKey("I", Style(16)), "𝕀"), (SymbolKey("I", Style(32)), "ℐ"), (SymbolKey("I", Style(64)), "𝓘"), (SymbolKey("I", Style(128)), "ℑ"), (SymbolKey("I", Style(130)), "𝕴"), (SymbolKey("Im", Style(0)), "ℑ"), (SymbolKey("Iota", Style(0)), "Ι"), (SymbolKey("Iota", Style(2)), "𝚰"), (SymbolKey("Iota", Style(3)), "𝝞"), (SymbolKey("Iota", Style(4)), "𝛪"), (SymbolKey("Iota", Style(6)), "𝜤"), (SymbolKey("Iota", Style(7)), "𝞘"), (SymbolKey("J", Style(1)), "𝖩"), (SymbolKey("J", Style(2)), "𝐉"), (SymbolKey("J", Style(3)), "𝗝"), (SymbolKey("J", Style(4)), "𝐽"), (SymbolKey("J", Style(5)), "𝘑"), (SymbolKey("J", Style(6)), "𝑱"), (SymbolKey("J", Style(7)), "𝙅"), (SymbolKey("J", Style(8)), "𝙹"), (SymbolKey("J", Style(16)), "𝕁"), (SymbolKey("J", Style(32)), "𝒥"), (SymbolKey("J", Style(64)), "𝓙"), (SymbolKey("J", Style(128)), "𝔍"), (SymbolKey("J", Style(130)), "𝕵"), (SymbolKey("Join", Style(0)), "⋈"), (SymbolKey("K", Style(1)), "𝖪"), (SymbolKey("K", Style(2)), "𝐊"), (SymbolKey("K", Style(3)), "𝗞"), (SymbolKey("K", Style(4)), "𝐾"), (SymbolKey("K", Style(5)), "𝘒"), (SymbolKey("K", Style(6)), "𝑲"), (SymbolKey("K", Style(7)), "𝙆"), (SymbolKey("K", Style(8)), "𝙺"), (SymbolKey("K", Style(16)), "𝕂"), (SymbolKey("K", Style(32)), "𝒦"), (SymbolKey("K", Style(64)), "𝓚"), (SymbolKey("K", Style(128)), "𝔎"), (SymbolKey("K", Style(130)), "𝕶"), (SymbolKey("Kappa", Style(0)), "Κ"), (SymbolKey("Kappa", Style(2)), "𝚱"), (SymbolKey("Kappa", Style(3)), "𝝟"), (SymbolKey("Kappa", Style(4)), "𝛫"), (SymbolKey("Kappa", Style(6)), "𝜥"), (SymbolKey("Kappa", Style(7)), "𝞙"), (SymbolKey("L", Style(1)), "𝖫"), (SymbolKey("L", Style(2)), "𝐋"), (SymbolKey("L", Style(3)), "𝗟"), (SymbolKey("L", Style(4)), "𝐿"), (SymbolKey("L", Style(5)), "𝘓"), (SymbolKey("L", Style(6)), "𝑳"), (SymbolKey("L", Style(7)), "𝙇"), (SymbolKey("L", Style(8)), "𝙻"), (SymbolKey("L", Style(16)), "𝕃"), (SymbolKey("L", Style(32)), "ℒ"), (SymbolKey("L", Style(64)), "𝓛"), (SymbolKey("L", Style(128)), "𝔏"), (SymbolKey("L", Style(130)), "𝕷"), (SymbolKey("Lambda", Style(0)), "Λ"), (SymbolKey("Lambda", Style(2)), "𝚲"), (SymbolKey("Lambda", Style(3)), "𝝠"), (SymbolKey("Lambda", Style(4)), "𝛬"), (SymbolKey("Lambda", Style(6)), "𝜦"), (SymbolKey("Lambda", Style(7)), "𝞚"), (SymbolKey("Leftarrow", Style(0)), "⇐"), (SymbolKey("Leftrightarrow", Style(0)), "⇔"), (SymbolKey("M", Style(1)), "𝖬"), (SymbolKey("M", Style(2)), "𝐌"), (SymbolKey("M", Style(3)), "𝗠"), (SymbolKey("M", Style(4)), "𝑀"), (SymbolKey("M", Style(5)), "𝘔"), (SymbolKey("M", Style(6)), "𝑴"), (SymbolKey("M", Style(7)), "𝙈"), (SymbolKey("M", Style(8)), "𝙼"), (SymbolKey("M", Style(16)), "𝕄"), (SymbolKey("M", Style(32)), "ℳ"), (SymbolKey("M", Style(64)), "𝓜"), (SymbolKey("M", Style(128)), "𝔐"), (SymbolKey("M", Style(130)), "𝕸"), (SymbolKey("Mu", Style(0)), "Μ"), (SymbolKey("Mu", Style(2)), "𝚳"), (SymbolKey("Mu", Style(3)), "𝝡"), (SymbolKey("Mu", Style(4)), "𝛭"), (SymbolKey("Mu", Style(6)), "𝜧"), (SymbolKey("Mu", Style(7)), "𝞛"), (SymbolKey("N", Style(1)), "𝖭"), (SymbolKey("N", Style(2)), "𝐍"), (SymbolKey("N", Style(3)), "𝗡"), (SymbolKey("N", Style(4)), "𝑁"), (SymbolKey("N", Style(5)), "𝘕"), (SymbolKey("N", Style(6)), "𝑵"), (SymbolKey("N", Style(7)), "𝙉"), (SymbolKey("N", Style(8)), "𝙽"), (SymbolKey("N", Style(16)), "ℕ"), (SymbolKey("N", Style(32)), "𝒩"), (SymbolKey("N", Style(64)), "𝓝"), (SymbolKey("N", Style(128)), "𝔑"), (SymbolKey("N", Style(130)), "𝕹"), (SymbolKey("Nu", Style(0)), "Ν"), (SymbolKey("Nu", Style(2)), "𝚴"), (SymbolKey("Nu", Style(3)), "𝝢"), (SymbolKey("Nu", Style(4)), "𝛮"), (SymbolKey("Nu", Style(6)), "𝜨"), (SymbolKey("Nu", Style(7)), "𝞜"), (SymbolKey("O", Style(1)), "𝖮"), (SymbolKey("O", Style(2)), "𝐎"), (SymbolKey("O", Style(3)), "𝗢"), (SymbolKey("O", Style(4)), "𝑂"), (SymbolKey("O", Style(5)), "𝘖"), (SymbolKey("O", Style(6)), "𝑶"), (SymbolKey("O", Style(7)), "𝙊"), (SymbolKey("O", Style(8)), "𝙾"), (SymbolKey("O", Style(16)), "𝕆"), (SymbolKey("O", Style(32)), "𝒪"), (SymbolKey("O", Style(64)), "𝓞"), (SymbolKey("O", Style(128)), "𝔒"), (SymbolKey("O", Style(130)), "𝕺"), (SymbolKey("Omega", Style(0)), "Ω"), (SymbolKey("Omega", Style(2)), "𝛀"), (SymbolKey("Omega", Style(3)), "𝝮"), (SymbolKey("Omega", Style(4)), "𝛺"), (SymbolKey("Omega", Style(6)), "𝜴"), (SymbolKey("Omega", Style(7)), "𝞨"), (SymbolKey("Omicron", Style(0)), "Ο"), (SymbolKey("Omicron", Style(2)), "𝚶"), (SymbolKey("Omicron", Style(3)), "𝝤"), (SymbolKey("Omicron", Style(4)), "𝛰"), (SymbolKey("Omicron", Style(6)), "𝜪"), (SymbolKey("Omicron", Style(7)), "𝞞"), (SymbolKey("P", Style(0)), "¶"), (SymbolKey("P", Style(1)), "𝖯"), (SymbolKey("P", Style(2)), "𝐏"), (SymbolKey("P", Style(3)), "𝗣"), (SymbolKey("P", Style(4)), "𝑃"), (SymbolKey("P", Style(5)), "𝘗"), (SymbolKey("P", Style(6)), "𝑷"), (SymbolKey("P", Style(7)), "𝙋"), (SymbolKey("P", Style(8)), "𝙿"), (SymbolKey("P", Style(16)), "ℙ"), (SymbolKey("P", Style(32)), "𝒫"), (SymbolKey("P", Style(64)), "𝓟"), (SymbolKey("P", Style(128)), "𝔓"), (SymbolKey("P", Style(130)), "𝕻"), (SymbolKey("Phi", Style(0)), "Φ"), (SymbolKey("Phi", Style(2)), "𝚽"), (SymbolKey("Phi", Style(3)), "𝝫"), (SymbolKey("Phi", Style(4)), "𝛷"), (SymbolKey("Phi", Style(6)), "𝜱"), (SymbolKey("Phi", Style(7)), "𝞥"), (SymbolKey("Pi", Style(0)), "Π"), (SymbolKey("Pi", Style(2)), "𝚷"), (SymbolKey("Pi", Style(3)), "𝝥"), (SymbolKey("Pi", Style(4)), "𝛱"), (SymbolKey("Pi", Style(6)), "𝜫"), (SymbolKey("Pi", Style(7)), "𝞟"), (SymbolKey("Pi", Style(16)), "ℿ"), (SymbolKey("Psi", Style(0)), "Ψ"), (SymbolKey("Psi", Style(2)), "𝚿"), (SymbolKey("Psi", Style(3)), "𝝭"), (SymbolKey("Psi", Style(4)), "𝛹"), (SymbolKey("Psi", Style(6)), "𝜳"), (SymbolKey("Psi", Style(7)), "𝞧"), (SymbolKey("Q", Style(1)), "𝖰"), (SymbolKey("Q", Style(2)), "𝐐"), (SymbolKey("Q", Style(3)), "𝗤"), (SymbolKey("Q", Style(4)), "𝑄"), (SymbolKey("Q", Style(5)), "𝘘"), (SymbolKey("Q", Style(6)), "𝑸"), (SymbolKey("Q", Style(7)), "𝙌"), (SymbolKey("Q", Style(8)), "𝚀"), (SymbolKey("Q", Style(16)), "ℚ"), (SymbolKey("Q", Style(32)), "𝒬"), (SymbolKey("Q", Style(64)), "𝓠"), (SymbolKey("Q", Style(128)), "𝔔"), (SymbolKey("Q", Style(130)), "𝕼"), (SymbolKey("R", Style(1)), "𝖱"), (SymbolKey("R", Style(2)), "𝐑"), (SymbolKey("R", Style(3)), "𝗥"), (SymbolKey("R", Style(4)), "𝑅"), (SymbolKey("R", Style(5)), "𝘙"), (SymbolKey("R", Style(6)), "𝑹"), (SymbolKey("R", Style(7)), "𝙍"), (SymbolKey("R", Style(8)), "𝚁"), (SymbolKey("R", Style(16)), "ℝ"), (SymbolKey("R", Style(32)), "ℛ"), (SymbolKey("R", Style(64)), "𝓡"), (SymbolKey("R", Style(128)), "ℜ"), (SymbolKey("R", Style(130)), "𝕽"), (SymbolKey("Re", Style(0)), "ℜ"), (SymbolKey("Rho", Style(0)), "Ρ"), (SymbolKey("Rho", Style(2)), "𝚸"), (SymbolKey("Rho", Style(3)), "𝝦"), (SymbolKey("Rho", Style(4)), "𝛲"), (SymbolKey("Rho", Style(6)), "𝜬"), (SymbolKey("Rho", Style(7)), "𝞠"), (SymbolKey("Rightarrow", Style(0)), "⇒"), (SymbolKey("S", Style(0)), "§"), (SymbolKey("S", Style(1)), "𝖲"), (SymbolKey("S", Style(2)), "𝐒"), (SymbolKey("S", Style(3)), "𝗦"), (SymbolKey("S", Style(4)), "𝑆"), (SymbolKey("S", Style(5)), "𝘚"), (SymbolKey("S", Style(6)), "𝑺"), (SymbolKey("S", Style(7)), "𝙎"), (SymbolKey("S", Style(8)), "𝚂"), (SymbolKey("S", Style(16)), "𝕊"), (SymbolKey("S", Style(32)), "𝒮"), (SymbolKey("S", Style(64)), "𝓢"), (SymbolKey("S", Style(128)), "𝔖"), (SymbolKey("S", Style(130)), "𝕾"), (SymbolKey("Sigma", Style(0)), "Σ"), (SymbolKey("Sigma", Style(2)), "𝚺"), (SymbolKey("Sigma", Style(3)), "𝝨"), (SymbolKey("Sigma", Style(4)), "𝛴"), (SymbolKey("Sigma", Style(6)), "𝜮"), (SymbolKey("Sigma", Style(7)), "𝞢"), (SymbolKey("Sigma", Style(16)), "⅀"), (SymbolKey("T", Style(1)), "𝖳"), (SymbolKey("T", Style(2)), "𝐓"), (SymbolKey("T", Style(3)), "𝗧"), (SymbolKey("T", Style(4)), "𝑇"), (SymbolKey("T", Style(5)), "𝘛"), (SymbolKey("T", Style(6)), "𝑻"), (SymbolKey("T", Style(7)), "𝙏"), (SymbolKey("T", Style(8)), "𝚃"), (SymbolKey("T", Style(16)), "𝕋"), (SymbolKey("T", Style(32)), "𝒯"), (SymbolKey("T", Style(64)), "𝓣"), (SymbolKey("T", Style(128)), "𝔗"), (SymbolKey("T", Style(130)), "𝕿"), (SymbolKey("Tau", Style(0)), "Τ"), (SymbolKey("Tau", Style(2)), "𝚻"), (SymbolKey("Tau", Style(3)), "𝝩"), (SymbolKey("Tau", Style(4)), "𝛵"), (SymbolKey("Tau", Style(6)), "𝜯"), (SymbolKey("Tau", Style(7)), "𝞣"), (SymbolKey("Theta", Style(0)), "Θ"), (SymbolKey("Theta", Style(2)), "𝚯"), (SymbolKey("Theta", Style(3)), "𝝝"), (SymbolKey("Theta", Style(4)), "𝛩"), (SymbolKey("Theta", Style(6)), "𝜣"), (SymbolKey("Theta", Style(7)), "𝞗"), (SymbolKey("U", Style(1)), "𝖴"), (SymbolKey("U", Style(2)), "𝐔"), (SymbolKey("U", Style(3)), "𝗨"), (SymbolKey("U", Style(4)), "𝑈"), (SymbolKey("U", Style(5)), "𝘜"), (SymbolKey("U", Style(6)), "𝑼"), (SymbolKey("U", Style(7)), "𝙐"), (SymbolKey("U", Style(8)), "𝚄"), (SymbolKey("U", Style(16)), "𝕌"), (SymbolKey("U", Style(32)), "𝒰"), (SymbolKey("U", Style(64)), "𝓤"), (SymbolKey("U", Style(128)), "𝔘"), (SymbolKey("U", Style(130)), "𝖀"), (SymbolKey("Uparrow", Style(0)), "⇑"), (SymbolKey("Updownarrow", Style(0)), "⇕"), (SymbolKey("Upsilon", Style(0)), "Υ"), (SymbolKey("Upsilon", Style(2)), "𝚼"), (SymbolKey("Upsilon", Style(3)), "𝝪"), (SymbolKey("Upsilon", Style(4)), "𝛶"), (SymbolKey("Upsilon", Style(6)), "𝜰"), (SymbolKey("Upsilon", Style(7)), "𝞤"), (SymbolKey("V", Style(1)), "𝖵"), (SymbolKey("V", Style(2)), "𝐕"), (SymbolKey("V", Style(3)), "𝗩"), (SymbolKey("V", Style(4)), "𝑉"), (SymbolKey("V", Style(5)), "𝘝"), (SymbolKey("V", Style(6)), "𝑽"), (SymbolKey("V", Style(7)), "𝙑"), (SymbolKey("V", Style(8)), "𝚅"), (SymbolKey("V", Style(16)), "𝕍"), (SymbolKey("V", Style(32)), "𝒱"), (SymbolKey("V", Style(64)), "𝓥"), (SymbolKey("V", Style(128)), "𝔙"), (SymbolKey("V", Style(130)), "𝖁"), (SymbolKey("Vdash", Style(0)), "⊩"), (SymbolKey("Vvdash", Style(0)), "⊪"), (SymbolKey("W", Style(1)), "𝖶"), (SymbolKey("W", Style(2)), "𝐖"), (SymbolKey("W", Style(3)), "𝗪"), (SymbolKey("W", Style(4)), "𝑊"), (SymbolKey("W", Style(5)), "𝘞"), (SymbolKey("W", Style(6)), "𝑾"), (SymbolKey("W", Style(7)), "𝙒"), (SymbolKey("W", Style(8)), "𝚆"), (SymbolKey("W", Style(16)), "𝕎"), (SymbolKey("W", Style(32)), "𝒲"), (SymbolKey("W", Style(64)), "𝓦"), (SymbolKey("W", Style(128)), "𝔚"), (SymbolKey("W", Style(130)), "𝖂"), (SymbolKey("X", Style(1)), "𝖷"), (SymbolKey("X", Style(2)), "𝐗"), (SymbolKey("X", Style(3)), "𝗫"), (SymbolKey("X", Style(4)), "𝑋"), (SymbolKey("X", Style(5)), "𝘟"), (SymbolKey("X", Style(6)), "𝑿"), (SymbolKey("X", Style(7)), "𝙓"), (SymbolKey("X", Style(8)), "𝚇"), (SymbolKey("X", Style(16)), "𝕏"), (SymbolKey("X", Style(32)), "𝒳"), (SymbolKey("X", Style(64)), "𝓧"), (SymbolKey("X", Style(128)), "𝔛"), (SymbolKey("X", Style(130)), "𝖃"), (SymbolKey("Xi", Style(0)), "Ξ"), (SymbolKey("Xi", Style(2)), "𝚵"), (SymbolKey("Xi", Style(3)), "𝝣"), (SymbolKey("Xi", Style(4)), "𝛯"), (SymbolKey("Xi", Style(6)), "𝜩"), (SymbolKey("Xi", Style(7)), "𝞝"), (SymbolKey("Y", Style(1)), "𝖸"), (SymbolKey("Y", Style(2)), "𝐘"), (SymbolKey("Y", Style(3)), "𝗬"), (SymbolKey("Y", Style(4)), "𝑌"), (SymbolKey("Y", Style(5)), "𝘠"), (SymbolKey("Y", Style(6)), "𝒀"), (SymbolKey("Y", Style(7)), "𝙔"), (SymbolKey("Y", Style(8)), "𝚈"), (SymbolKey("Y", Style(16)), "𝕐"), (SymbolKey("Y", Style(32)), "𝒴"), (SymbolKey("Y", Style(64)), "𝓨"), (SymbolKey("Y", Style(128)), "𝔜"), (SymbolKey("Y", Style(130)), "𝖄"), (SymbolKey("Z", Style(1)), "𝖹"), (SymbolKey("Z", Style(2)), "𝐙"), (SymbolKey("Z", Style(3)), "𝗭"), (SymbolKey("Z", Style(4)), "𝑍"), (SymbolKey("Z", Style(5)), "𝘡"), (SymbolKey("Z", Style(6)), "𝒁"), (SymbolKey("Z", Style(7)), "𝙕"), (SymbolKey("Z", Style(8)), "𝚉"), (SymbolKey("Z", Style(16)), "ℤ"), (SymbolKey("Z", Style(32)), "𝒵"), (SymbolKey("Z", Style(64)), "𝓩"), (SymbolKey("Z", Style(128)), "ℨ"), (SymbolKey("Z", Style(130)), "𝖅"), (SymbolKey("Zeta", Style(0)), "Ζ"), (SymbolKey("Zeta", Style(2)), "𝚭"), (SymbolKey("Zeta", Style(3)), "𝝛"), (SymbolKey("Zeta", Style(4)), "𝛧"), (SymbolKey("Zeta", Style(6)), "𝜡"), (SymbolKey("Zeta", Style(7)), "𝞕"), (SymbolKey("[[", Style(0)), "⟦"), (SymbolKey("]]", Style(0)), "⟧"), (SymbolKey("^(", Style(0)), "⁽"), (SymbolKey("^)", Style(0)), "⁾"), (SymbolKey("^+", Style(0)), "⁺"), (SymbolKey("^-", Style(0)), "⁻"), (SymbolKey("^0", Style(0)), "⁰"), (SymbolKey("^1", Style(0)), "¹"), (SymbolKey("^2", Style(0)), "²"), (SymbolKey("^3", Style(0)), "³"), (SymbolKey("^4", Style(0)), "⁴"), (SymbolKey("^5", Style(0)), "⁵"), (SymbolKey("^6", Style(0)), "⁶"), (SymbolKey("^7", Style(0)), "⁷"), (SymbolKey("^8", Style(0)), "⁸"), (SymbolKey("^9", Style(0)), "⁹"), (SymbolKey("^=", Style(0)), "⁼"), (SymbolKey("^A", Style(0)), "ᴬ"), (SymbolKey("^B", Style(0)), "ᴮ"), (SymbolKey("^D", Style(0)), "ᴰ"), (SymbolKey("^E", Style(0)), "ᴱ"), (SymbolKey("^G", Style(0)), "ᴳ"), (SymbolKey("^H", Style(0)), "ᴴ"), (SymbolKey("^I", Style(0)), "ᴵ"), (SymbolKey("^J", Style(0)), "ᴶ"), (SymbolKey("^K", Style(0)), "ᴷ"), (SymbolKey("^L", Style(0)), "ᴸ"), (SymbolKey("^M", Style(0)), "ᴹ"), (SymbolKey("^N", Style(0)), "ᴺ"), (SymbolKey("^O", Style(0)), "ᴼ"), (SymbolKey("^P", Style(0)), "ᴾ"), (SymbolKey("^R", Style(0)), "ᴿ"), (SymbolKey("^T", Style(0)), "ᵀ"), (SymbolKey("^U", Style(0)), "ᵁ"), (SymbolKey("^V", Style(0)), "ⱽ"), (SymbolKey("^W", Style(0)), "ᵂ"), (SymbolKey("^a", Style(0)), "ᵃ"), (SymbolKey("^b", Style(0)), "ᵇ"), (SymbolKey("^beta", Style(0)), "ᵝ"), (SymbolKey("^c", Style(0)), "ᶜ"), (SymbolKey("^chi", Style(0)), "ᵡ"), (SymbolKey("^d", Style(0)), "ᵈ"), (SymbolKey("^delta", Style(0)), "ᵟ"), (SymbolKey("^e", Style(0)), "ᵉ"), (SymbolKey("^epsilon", Style(0)), "ᵋ"), (SymbolKey("^f", Style(0)), "ᶠ"), (SymbolKey("^g", Style(0)), "ᵍ"), (SymbolKey("^gamma", Style(0)), "ᵞ"), (SymbolKey("^h", Style(0)), "ʰ"), (SymbolKey("^i", Style(0)), "ⁱ"), (SymbolKey("^iota", Style(0)), "ᶥ"), (SymbolKey("^j", Style(0)), "ʲ"), (SymbolKey("^k", Style(0)), "ᵏ"), (SymbolKey("^l", Style(0)), "ˡ"), (SymbolKey("^m", Style(0)), "ᵐ"), (SymbolKey("^n", Style(0)), "ⁿ"), (SymbolKey("^o", Style(0)), "ᵒ"), (SymbolKey("^p", Style(0)), "ᵖ"), (SymbolKey("^phi", Style(0)), "ᵠ"), (SymbolKey("^r", Style(0)), "ʳ"), (SymbolKey("^s", Style(0)), "ˢ"), (SymbolKey("^t", Style(0)), "ᵗ"), (SymbolKey("^theta", Style(0)), "ᶿ"), (SymbolKey("^u", Style(0)), "ᵘ"), (SymbolKey("^upsilon", Style(0)), "ᶹ"), (SymbolKey("^v", Style(0)), "ᵛ"), (SymbolKey("^w", Style(0)), "ʷ"), (SymbolKey("^x", Style(0)), "ˣ"), (SymbolKey("^y", Style(0)), "ʸ"), (SymbolKey("^z", Style(0)), "ᶻ"), (SymbolKey("_(", Style(0)), "₍"), (SymbolKey("_)", Style(0)), "₎"), (SymbolKey("_+", Style(0)), "₊"), (SymbolKey("_-", Style(0)), "₋"), (SymbolKey("_0", Style(0)), "₀"), (SymbolKey("_1", Style(0)), "₁"), (SymbolKey("_2", Style(0)), "₂"), (SymbolKey("_3", Style(0)), "₃"), (SymbolKey("_4", Style(0)), "₄"), (SymbolKey("_5", Style(0)), "₅"), (SymbolKey("_6", Style(0)), "₆"), (SymbolKey("_7", Style(0)), "₇"), (SymbolKey("_8", Style(0)), "₈"), (SymbolKey("_9", Style(0)), "₉"), (SymbolKey("_=", Style(0)), "₌"), (SymbolKey("_a", Style(0)), "ₐ"), (SymbolKey("_beta", Style(0)), "ᵦ"), (SymbolKey("_chi", Style(0)), "ᵪ"), (SymbolKey("_e", Style(0)), "ₑ"), (SymbolKey("_gamma", Style(0)), "ᵧ"), (SymbolKey("_h", Style(0)), "ₕ"), (SymbolKey("_i", Style(0)), "ᵢ"), (SymbolKey("_j", Style(0)), "ⱼ"), (SymbolKey("_k", Style(0)), "ₖ"), (SymbolKey("_l", Style(0)), "ₗ"), (SymbolKey("_m", Style(0)), "ₘ"), (SymbolKey("_n", Style(0)), "ₙ"), (SymbolKey("_o", Style(0)), "ₒ"), (SymbolKey("_p", Style(0)), "ₚ"), (SymbolKey("_phi", Style(0)), "ᵩ"), (SymbolKey("_q", Style(0)), " "), (SymbolKey("_r", Style(0)), "ᵣ"), (SymbolKey("_rho", Style(0)), "ᵨ"), (SymbolKey("_s", Style(0)), "ₛ"), (SymbolKey("_schwa", Style(0)), "ₔ"), (SymbolKey("_t", Style(0)), "ₜ"), (SymbolKey("_u", Style(0)), "ᵤ"), (SymbolKey("_v", Style(0)), "ᵥ"), (SymbolKey("_x", Style(0)), "ₓ"), (SymbolKey("a", Style(1)), "𝖺"), (SymbolKey("a", Style(2)), "𝐚"), (SymbolKey("a", Style(3)), "𝗮"), (SymbolKey("a", Style(4)), "𝑎"), (SymbolKey("a", Style(5)), "𝘢"), (SymbolKey("a", Style(6)), "𝒂"), (SymbolKey("a", Style(7)), "𝙖"), (SymbolKey("a", Style(8)), "𝚊"), (SymbolKey("a", Style(16)), "𝕒"), (SymbolKey("a", Style(32)), "𝒶"), (SymbolKey("a", Style(64)), "𝓪"), (SymbolKey("a", Style(128)), "𝔞"), (SymbolKey("a", Style(130)), "𝖆"), (SymbolKey("aleph", Style(0)), "ℵ"), (SymbolKey("alpha", Style(0)), "α"), (SymbolKey("alpha", Style(2)), "𝛂"), (SymbolKey("alpha", Style(3)), "𝝰"), (SymbolKey("alpha", Style(4)), "𝛼"), (SymbolKey("alpha", Style(6)), "𝜶"), (SymbolKey("alpha", Style(7)), "𝞪"), (SymbolKey("angle", Style(0)), "∠"), (SymbolKey("approx", Style(0)), "≈"), (SymbolKey("ast", Style(0)), "∗"), (SymbolKey("b", Style(1)), "𝖻"), (SymbolKey("b", Style(2)), "𝐛"), (SymbolKey("b", Style(3)), "𝗯"), (SymbolKey("b", Style(4)), "𝑏"), (SymbolKey("b", Style(5)), "𝘣"), (SymbolKey("b", Style(6)), "𝒃"), (SymbolKey("b", Style(7)), "𝙗"), (SymbolKey("b", Style(8)), "𝚋"), (SymbolKey("b", Style(16)), "𝕓"), (SymbolKey("b", Style(32)), "𝒷"), (SymbolKey("b", Style(64)), "𝓫"), (SymbolKey("b", Style(128)), "𝔟"), (SymbolKey("b", Style(130)), "𝖇"), (SymbolKey("barwedge", Style(0)), "⊼"), (SymbolKey("because", Style(0)), "∵"), (SymbolKey("beta", Style(0)), "β"), (SymbolKey("beta", Style(2)), "𝛃"), (SymbolKey("beta", Style(3)), "𝝱"), (SymbolKey("beta", Style(4)), "𝛽"), (SymbolKey("beta", Style(6)), "𝜷"), (SymbolKey("beta", Style(7)), "𝞫"), (SymbolKey("beth", Style(0)), "ℶ"), (SymbolKey("blacksquare", Style(0)), "▪"), (SymbolKey("blacktriangle", Style(0)), "▴"), (SymbolKey("bot", Style(0)), "⊥"), (SymbolKey("bowtie", Style(0)), "⋈"), (SymbolKey("boxminus", Style(0)), "⊟"), (SymbolKey("boxplus", Style(0)), "⊞"), (SymbolKey("boxtimes", Style(0)), "⊠"), (SymbolKey("c", Style(1)), "𝖼"), (SymbolKey("c", Style(2)), "𝐜"), (SymbolKey("c", Style(3)), "𝗰"), (SymbolKey("c", Style(4)), "𝑐"), (SymbolKey("c", Style(5)), "𝘤"), (SymbolKey("c", Style(6)), "𝒄"), (SymbolKey("c", Style(7)), "𝙘"), (SymbolKey("c", Style(8)), "𝚌"), (SymbolKey("c", Style(16)), "𝕔"), (SymbolKey("c", Style(32)), "𝒸"), (SymbolKey("c", Style(64)), "𝓬"), (SymbolKey("c", Style(128)), "𝔠"), (SymbolKey("c", Style(130)), "𝖈"), (SymbolKey("cap", Style(0)), "∩"), (SymbolKey("cdot", Style(0)), "·"), (SymbolKey("cdots", Style(0)), "⋯"), (SymbolKey("chi", Style(0)), "χ"), (SymbolKey("chi", Style(2)), "𝛘"), (SymbolKey("chi", Style(3)), "𝞆"), (SymbolKey("chi", Style(4)), "𝜒"), (SymbolKey("chi", Style(6)), "𝝌"), (SymbolKey("chi", Style(7)), "𝟀"), (SymbolKey("circ", Style(0)), "∘"), (SymbolKey("circledast", Style(0)), "⊛"), (SymbolKey("cong", Style(0)), "≅"), (SymbolKey("cup", Style(0)), "∪"), (SymbolKey("curlyvee", Style(0)), "⋎"), (SymbolKey("d", Style(1)), "𝖽"), (SymbolKey("d", Style(2)), "𝐝"), (SymbolKey("d", Style(3)), "𝗱"), (SymbolKey("d", Style(4)), "𝑑"), (SymbolKey("d", Style(5)), "𝘥"), (SymbolKey("d", Style(6)), "𝒅"), (SymbolKey("d", Style(7)), "𝙙"), (SymbolKey("d", Style(8)), "𝚍"), (SymbolKey("d", Style(16)), "𝕕"), (SymbolKey("d", Style(32)), "𝒹"), (SymbolKey("d", Style(64)), "𝓭"), (SymbolKey("d", Style(128)), "𝔡"), (SymbolKey("d", Style(130)), "𝖉"), (SymbolKey("dagger", Style(0)), "†"), (SymbolKey("dashv", Style(0)), "⊣"), (SymbolKey("delta", Style(0)), "δ"), (SymbolKey("delta", Style(2)), "𝛅"), (SymbolKey("delta", Style(3)), "𝝳"), (SymbolKey("delta", Style(4)), "𝛿"), (SymbolKey("delta", Style(6)), "𝜹"), (SymbolKey("delta", Style(7)), "𝞭"), (SymbolKey("digamma", Style(0)), "ϝ"), (SymbolKey("digamma", Style(2)), "𝟋"), (SymbolKey("div", Style(0)), "÷"), (SymbolKey("divideontimes", Style(0)), "⋇"), (SymbolKey("doteq", Style(0)), "≐"), (SymbolKey("downarrow", Style(0)), "↓"), (SymbolKey("e", Style(1)), "𝖾"), (SymbolKey("e", Style(2)), "𝐞"), (SymbolKey("e", Style(3)), "𝗲"), (SymbolKey("e", Style(4)), "𝑒"), (SymbolKey("e", Style(5)), "𝘦"), (SymbolKey("e", Style(6)), "𝒆"), (SymbolKey("e", Style(7)), "𝙚"), (SymbolKey("e", Style(8)), "𝚎"), (SymbolKey("e", Style(16)), "𝕖"), (SymbolKey("e", Style(32)), "ℯ"), (SymbolKey("e", Style(64)), "𝓮"), (SymbolKey("e", Style(128)), "𝔢"), (SymbolKey("e", Style(130)), "𝖊"), (SymbolKey("ell", Style(0)), "ℓ"), (SymbolKey("emptyset", Style(0)), "∅"), (SymbolKey("epsilon", Style(0)), "ϵ"), (SymbolKey("epsilon", Style(2)), "𝛜"), (SymbolKey("epsilon", Style(3)), "𝞊"), (SymbolKey("epsilon", Style(4)), "𝜖"), (SymbolKey("epsilon", Style(6)), "𝝐"), (SymbolKey("epsilon", Style(7)), "𝟄"), (SymbolKey("equiv", Style(0)), "≡"), (SymbolKey("eta", Style(0)), "η"), (SymbolKey("eta", Style(2)), "𝛈"), (SymbolKey("eta", Style(3)), "𝝶"), (SymbolKey("eta", Style(4)), "𝜂"), (SymbolKey("eta", Style(6)), "𝜼"), (SymbolKey("eta", Style(7)), "𝞰"), (SymbolKey("exists", Style(0)), "∃"), (SymbolKey("f", Style(1)), "𝖿"), (SymbolKey("f", Style(2)), "𝐟"), (SymbolKey("f", Style(3)), "𝗳"), (SymbolKey("f", Style(4)), "𝑓"), (SymbolKey("f", Style(5)), "𝘧"), (SymbolKey("f", Style(6)), "𝒇"), (SymbolKey("f", Style(7)), "𝙛"), (SymbolKey("f", Style(8)), "𝚏"), (SymbolKey("f", Style(16)), "𝕗"), (SymbolKey("f", Style(32)), "𝒻"), (SymbolKey("f", Style(64)), "𝓯"), (SymbolKey("f", Style(128)), "𝔣"), (SymbolKey("f", Style(130)), "𝖋"), (SymbolKey("flat", Style(0)), "♭"), (SymbolKey("forall", Style(0)), "∀"), (SymbolKey("g", Style(1)), "𝗀"), (SymbolKey("g", Style(2)), "𝐠"), (SymbolKey("g", Style(3)), "𝗴"), (SymbolKey("g", Style(4)), "𝑔"), (SymbolKey("g", Style(5)), "𝘨"), (SymbolKey("g", Style(6)), "𝒈"), (SymbolKey("g", Style(7)), "𝙜"), (SymbolKey("g", Style(8)), "𝚐"), (SymbolKey("g", Style(16)), "𝕘"), (SymbolKey("g", Style(32)), "ℊ"), (SymbolKey("g", Style(64)), "𝓰"), (SymbolKey("g", Style(128)), "𝔤"), (SymbolKey("g", Style(130)), "𝖌"), (SymbolKey("gamma", Style(0)), "γ"), (SymbolKey("gamma", Style(2)), "𝛄"), (SymbolKey("gamma", Style(3)), "𝝲"), (SymbolKey("gamma", Style(4)), "𝛾"), (SymbolKey("gamma", Style(6)), "𝜸"), (SymbolKey("gamma", Style(7)), "𝞬"), (SymbolKey("gamma", Style(16)), "ℽ"), (SymbolKey("geq", Style(0)), "≥"), (SymbolKey("geqq", Style(0)), "≧"), (SymbolKey("geqslant", Style(0)), "⩾"), (SymbolKey("gets", Style(0)), "←"), (SymbolKey("gg", Style(0)), "≫"), (SymbolKey("ggg", Style(0)), "⋙"), (SymbolKey("gimel", Style(0)), "ℷ"), (SymbolKey("gnapprox", Style(0)), "⪊"), (SymbolKey("gneq", Style(0)), "⪈"), (SymbolKey("gneqq", Style(0)), "≩"), (SymbolKey("gnsim", Style(0)), "⋧"), (SymbolKey("gtrapprox", Style(0)), "⪆"), (SymbolKey("gtrsim", Style(0)), "≳"), (SymbolKey("h", Style(1)), "𝗁"), (SymbolKey("h", Style(2)), "𝐡"), (SymbolKey("h", Style(3)), "𝗵"), (SymbolKey("h", Style(4)), "ℎ"), (SymbolKey("h", Style(5)), "𝘩"), (SymbolKey("h", Style(6)), "𝒉"), (SymbolKey("h", Style(7)), "𝙝"), (SymbolKey("h", Style(8)), "𝚑"), (SymbolKey("h", Style(16)), "𝕙"), (SymbolKey("h", Style(32)), "𝒽"), (SymbolKey("h", Style(64)), "𝓱"), (SymbolKey("h", Style(128)), "𝔥"), (SymbolKey("h", Style(130)), "𝖍"), (SymbolKey("hbar", Style(0)), "ℏ"), (SymbolKey("hslash", Style(0)), "ℏ"), (SymbolKey("i", Style(1)), "𝗂"), (SymbolKey("i", Style(2)), "𝐢"), (SymbolKey("i", Style(3)), "𝗶"), (SymbolKey("i", Style(4)), "𝑖"), (SymbolKey("i", Style(5)), "𝘪"), (SymbolKey("i", Style(6)), "𝒊"), (SymbolKey("i", Style(7)), "𝙞"), (SymbolKey("i", Style(8)), "𝚒"), (SymbolKey("i", Style(16)), "𝕚"), (SymbolKey("i", Style(32)), "𝒾"), (SymbolKey("i", Style(64)), "𝓲"), (SymbolKey("i", Style(128)), "𝔦"), (SymbolKey("i", Style(130)), "𝖎"), (SymbolKey("imath", Style(0)), "ı"), (SymbolKey("imath", Style(4)), "𝚤"), (SymbolKey("in", Style(0)), "∈"), (SymbolKey("infty", Style(0)), "∞"), (SymbolKey("iota", Style(0)), "ι"), (SymbolKey("iota", Style(2)), "𝛊"), (SymbolKey("iota", Style(3)), "𝝸"), (SymbolKey("iota", Style(4)), "𝜄"), (SymbolKey("iota", Style(6)), "𝜾"), (SymbolKey("iota", Style(7)), "𝞲"), (SymbolKey("j", Style(1)), "𝗃"), (SymbolKey("j", Style(2)), "𝐣"), (SymbolKey("j", Style(3)), "𝗷"), (SymbolKey("j", Style(4)), "𝑗"), (SymbolKey("j", Style(5)), "𝘫"), (SymbolKey("j", Style(6)), "𝒋"), (SymbolKey("j", Style(7)), "𝙟"), (SymbolKey("j", Style(8)), "𝚓"), (SymbolKey("j", Style(16)), "𝕛"), (SymbolKey("j", Style(32)), "𝒿"), (SymbolKey("j", Style(64)), "𝓳"), (SymbolKey("j", Style(128)), "𝔧"), (SymbolKey("j", Style(130)), "𝖏"), (SymbolKey("jmath", Style(0)), "ȷ"), (SymbolKey("jmath", Style(4)), "𝚥"), (SymbolKey("k", Style(1)), "𝗄"), (SymbolKey("k", Style(2)), "𝐤"), (SymbolKey("k", Style(3)), "𝗸"), (SymbolKey("k", Style(4)), "𝑘"), (SymbolKey("k", Style(5)), "𝘬"), (SymbolKey("k", Style(6)), "𝒌"), (SymbolKey("k", Style(7)), "𝙠"), (SymbolKey("k", Style(8)), "𝚔"), (SymbolKey("k", Style(16)), "𝕜"), (SymbolKey("k", Style(32)), "𝓀"), (SymbolKey("k", Style(64)), "𝓴"), (SymbolKey("k", Style(128)), "𝔨"), (SymbolKey("k", Style(130)), "𝖐"), (SymbolKey("kappa", Style(0)), "κ"), (SymbolKey("kappa", Style(2)), "𝛋"), (SymbolKey("kappa", Style(3)), "𝝹"), (SymbolKey("kappa", Style(4)), "𝜅"), (SymbolKey("kappa", Style(6)), "𝜿"), (SymbolKey("kappa", Style(7)), "𝞳"), (SymbolKey("l", Style(1)), "𝗅"), (SymbolKey("l", Style(2)), "𝐥"), (SymbolKey("l", Style(3)), "𝗹"), (SymbolKey("l", Style(4)), "𝑙"), (SymbolKey("l", Style(5)), "𝘭"), (SymbolKey("l", Style(6)), "𝒍"), (SymbolKey("l", Style(7)), "𝙡"), (SymbolKey("l", Style(8)), "𝚕"), (SymbolKey("l", Style(16)), "𝕝"), (SymbolKey("l", Style(32)), "𝓁"), (SymbolKey("l", Style(64)), "𝓵"), (SymbolKey("l", Style(128)), "𝔩"), (SymbolKey("l", Style(130)), "𝖑"), (SymbolKey("lambda", Style(0)), "λ"), (SymbolKey("lambda", Style(2)), "𝛌"), (SymbolKey("lambda", Style(3)), "𝝺"), (SymbolKey("lambda", Style(4)), "𝜆"), (SymbolKey("lambda", Style(6)), "𝝀"), (SymbolKey("lambda", Style(7)), "𝞴"), (SymbolKey("langle", Style(0)), "⟨"), (SymbolKey("lbag", Style(0)), "⟅"), (SymbolKey("lceil", Style(0)), "⌈"), (SymbolKey("ldots", Style(0)), "…"), (SymbolKey("leftarrow", Style(0)), "←"), (SymbolKey("leftharpoondown", Style(0)), "↽"), (SymbolKey("leftharpoonup", Style(0)), "↼"), (SymbolKey("leftrightarrow", Style(0)), "↔"), (SymbolKey("leq", Style(0)), "≤"), (SymbolKey("leqq", Style(0)), "≦"), (SymbolKey("leqslant", Style(0)), "⩽"), (SymbolKey("lessapprox", Style(0)), "⪅"), (SymbolKey("lesseqgtr", Style(0)), "⋚"), (SymbolKey("lessgtr", Style(0)), "≶"), (SymbolKey("lesssim", Style(0)), "≲"), (SymbolKey("lfloor", Style(0)), "⌊"), (SymbolKey("ll", Style(0)), "≪"), (SymbolKey("llcorner", Style(0)), "⌞"), (SymbolKey("lll", Style(0)), "⋘"), (SymbolKey("lnapprox", Style(0)), "⪉"), (SymbolKey("lneq", Style(0)), "⪇"), (SymbolKey("lneqq", Style(0)), "≨"), (SymbolKey("lnsim", Style(0)), "⋦"), (SymbolKey("longleftarrow", Style(0)), "⟵"), (SymbolKey("longmapsto", Style(0)), "⟼"), (SymbolKey("longrightarrow", Style(0)), "⟶"), (SymbolKey("lrcorner", Style(0)), "⌟"), (SymbolKey("ltimes", Style(0)), "⋉"), (SymbolKey("m", Style(1)), "𝗆"), (SymbolKey("m", Style(2)), "𝐦"), (SymbolKey("m", Style(3)), "𝗺"), (SymbolKey("m", Style(4)), "𝑚"), (SymbolKey("m", Style(5)), "𝘮"), (SymbolKey("m", Style(6)), "𝒎"), (SymbolKey("m", Style(7)), "𝙢"), (SymbolKey("m", Style(8)), "𝚖"), (SymbolKey("m", Style(16)), "𝕞"), (SymbolKey("m", Style(32)), "𝓂"), (SymbolKey("m", Style(64)), "𝓶"), (SymbolKey("m", Style(128)), "𝔪"), (SymbolKey("m", Style(130)), "𝖒"), (SymbolKey("mapsto", Style(0)), "↦"), (SymbolKey("mp", Style(0)), "∓"), (SymbolKey("mu", Style(0)), "μ"), (SymbolKey("mu", Style(2)), "𝛍"), (SymbolKey("mu", Style(3)), "𝝻"), (SymbolKey("mu", Style(4)), "𝜇"), (SymbolKey("mu", Style(6)), "𝝁"), (SymbolKey("mu", Style(7)), "𝞵"), (SymbolKey("n", Style(1)), "𝗇"), (SymbolKey("n", Style(2)), "𝐧"), (SymbolKey("n", Style(3)), "𝗻"), (SymbolKey("n", Style(4)), "𝑛"), (SymbolKey("n", Style(5)), "𝘯"), (SymbolKey("n", Style(6)), "𝒏"), (SymbolKey("n", Style(7)), "𝙣"), (SymbolKey("n", Style(8)), "𝚗"), (SymbolKey("n", Style(16)), "𝕟"), (SymbolKey("n", Style(32)), "𝓃"), (SymbolKey("n", Style(64)), "𝓷"), (SymbolKey("n", Style(128)), "𝔫"), (SymbolKey("n", Style(130)), "𝖓"), (SymbolKey("nabla", Style(0)), "∇"), (SymbolKey("nabla", Style(2)), "𝛁"), (SymbolKey("nabla", Style(3)), "𝝯"), (SymbolKey("nabla", Style(4)), "𝛻"), (SymbolKey("nabla", Style(6)), "𝜵"), (SymbolKey("nabla", Style(7)), "𝞩"), (SymbolKey("napprox", Style(0)), "≉"), (SymbolKey("natural", Style(0)), "♮"), (SymbolKey("ncong", Style(0)), "≇"), (SymbolKey("nearrow", Style(0)), "↗"), (SymbolKey("neg", Style(0)), "¬"), (SymbolKey("neq", Style(0)), "≠"), (SymbolKey("nequiv", Style(0)), "≢"), (SymbolKey("nexists", Style(0)), "∄"), (SymbolKey("ngeq", Style(0)), "≱"), (SymbolKey("ngtr", Style(0)), "≯"), (SymbolKey("ni", Style(0)), "∋"), (SymbolKey("nleq", Style(0)), "≰"), (SymbolKey("nless", Style(0)), "≮"), (SymbolKey("notin", Style(0)), "∉"), (SymbolKey("notni", Style(0)), "∌"), (SymbolKey("nprec", Style(0)), "⊀"), (SymbolKey("npreceq", Style(0)), "⪯\u{338}"), (SymbolKey("nsim", Style(0)), "≁"), (SymbolKey("nsimeq", Style(0)), "≄"), (SymbolKey("nsubset", Style(0)), "⊄"), (SymbolKey("nsubseteq", Style(0)), "⊈"), (SymbolKey("nsucc", Style(0)), "⊁"), (SymbolKey("nsucceq", Style(0)), "⪰\u{338}"), (SymbolKey("nsupset", Style(0)), "⊅"), (SymbolKey("nsupseteq", Style(0)), "⊉"), (SymbolKey("nu", Style(0)), "ν"), (SymbolKey("nu", Style(2)), "𝛎"), (SymbolKey("nu", Style(3)), "𝝼"), (SymbolKey("nu", Style(4)), "𝜈"), (SymbolKey("nu", Style(6)), "𝝂"), (SymbolKey("nu", Style(7)), "𝞶"), (SymbolKey("nwarrow", Style(0)), "↖"), (SymbolKey("o", Style(1)), "𝗈"), (SymbolKey("o", Style(2)), "𝐨"), (SymbolKey("o", Style(3)), "𝗼"), (SymbolKey("o", Style(4)), "𝑜"), (SymbolKey("o", Style(5)), "𝘰"), (SymbolKey("o", Style(6)), "𝒐"), (SymbolKey("o", Style(7)), "𝙤"), (SymbolKey("o", Style(8)), "𝚘"), (SymbolKey("o", Style(16)), "𝕠"), (SymbolKey("o", Style(32)), "ℴ"), (SymbolKey("o", Style(64)), "𝓸"), (SymbolKey("o", Style(128)), "𝔬"), (SymbolKey("o", Style(130)), "𝖔"), (SymbolKey("odot", Style(0)), "⊙"), (SymbolKey("omega", Style(0)), "ω"), (SymbolKey("omega", Style(2)), "𝛚"), (SymbolKey("omega", Style(3)), "𝞈"), (SymbolKey("omega", Style(4)), "𝜔"), (SymbolKey("omega", Style(6)), "𝝎"), (SymbolKey("omega", Style(7)), "𝟂"), (SymbolKey("omicron", Style(0)), "ο"), (SymbolKey("omicron", Style(2)), "𝛐"), (SymbolKey("omicron", Style(3)), "𝝾"), (SymbolKey("omicron", Style(4)), "𝜊"), (SymbolKey("omicron", Style(6)), "𝝄"), (SymbolKey("omicron", Style(7)), "𝞸"), (SymbolKey("ominus", Style(0)), "⊖"), (SymbolKey("oplus", Style(0)), "⊕"), (SymbolKey("oslash", Style(0)), "⊘"), (SymbolKey("otimes", Style(0)), "⊗"), (SymbolKey("p", Style(1)), "𝗉"), (SymbolKey("p", Style(2)), "𝐩"), (SymbolKey("p", Style(3)), "𝗽"), (SymbolKey("p", Style(4)), "𝑝"), (SymbolKey("p", Style(5)), "𝘱"), (SymbolKey("p", Style(6)), "𝒑"), (SymbolKey("p", Style(7)), "𝙥"), (SymbolKey("p", Style(8)), "𝚙"), (SymbolKey("p", Style(16)), "𝕡"), (SymbolKey("p", Style(32)), "𝓅"), (SymbolKey("p", Style(64)), "𝓹"), (SymbolKey("p", Style(128)), "𝔭"), (SymbolKey("p", Style(130)), "𝖕"), (SymbolKey("parallel", Style(0)), "∥"), (SymbolKey("partial", Style(0)), "∂"), (SymbolKey("partial", Style(2)), "𝛛"), (SymbolKey("partial", Style(3)), "𝞉"), (SymbolKey("partial", Style(4)), "𝜕"), (SymbolKey("partial", Style(6)), "𝝏"), (SymbolKey("partial", Style(7)), "𝟃"), (SymbolKey("perp", Style(0)), "⊥"), (SymbolKey("phi", Style(0)), "ϕ"), (SymbolKey("phi", Style(2)), "𝛟"), (SymbolKey("phi", Style(3)), "𝞍"), (SymbolKey("phi", Style(4)), "𝜙"), (SymbolKey("phi", Style(6)), "𝝓"), (SymbolKey("phi", Style(7)), "𝟇"), (SymbolKey("pi", Style(0)), "π"), (SymbolKey("pi", Style(2)), "𝛑"), (SymbolKey("pi", Style(3)), "𝝿"), (SymbolKey("pi", Style(4)), "𝜋"), (SymbolKey("pi", Style(6)), "𝝅"), (SymbolKey("pi", Style(7)), "𝞹"), (SymbolKey("pi", Style(16)), "ℼ"), (SymbolKey("pm", Style(0)), "±"), (SymbolKey("pppprime", Style(0)), "⁗"), (SymbolKey("ppprime", Style(0)), "‴"), (SymbolKey("pprime", Style(0)), "″"), (SymbolKey("prec", Style(0)), "≺"), (SymbolKey("preceq", Style(0)), "⪯"), (SymbolKey("precsim", Style(0)), "≾"), (SymbolKey("prime", Style(0)), "′"), (SymbolKey("propto", Style(0)), "∝"), (SymbolKey("psi", Style(0)), "ψ"), (SymbolKey("psi", Style(2)), "𝛙"), (SymbolKey("psi", Style(3)), "𝞇"), (SymbolKey("psi", Style(4)), "𝜓"), (SymbolKey("psi", Style(6)), "𝝍"), (SymbolKey("psi", Style(7)), "𝟁"), (SymbolKey("q", Style(1)), "𝗊"), (SymbolKey("q", Style(2)), "𝐪"), (SymbolKey("q", Style(3)), "𝗾"), (SymbolKey("q", Style(4)), "𝑞"), (SymbolKey("q", Style(5)), "𝘲"), (SymbolKey("q", Style(6)), "𝒒"), (SymbolKey("q", Style(7)), "𝙦"), (SymbolKey("q", Style(8)), "𝚚"), (SymbolKey("q", Style(16)), "𝕢"), (SymbolKey("q", Style(32)), "𝓆"), (SymbolKey("q", Style(64)), "𝓺"), (SymbolKey("q", Style(128)), "𝔮"), (SymbolKey("q", Style(130)), "𝖖"), (SymbolKey("qed", Style(0)), "∎"), (SymbolKey("r", Style(1)), "𝗋"), (SymbolKey("r", Style(2)), "𝐫"), (SymbolKey("r", Style(3)), "𝗿"), (SymbolKey("r", Style(4)), "𝑟"), (SymbolKey("r", Style(5)), "𝘳"), (SymbolKey("r", Style(6)), "𝒓"), (SymbolKey("r", Style(7)), "𝙧"), (SymbolKey("r", Style(8)), "𝚛"), (SymbolKey("r", Style(16)), "𝕣"), (SymbolKey("r", Style(32)), "𝓇"), (SymbolKey("r", Style(64)), "𝓻"), (SymbolKey("r", Style(128)), "𝔯"), (SymbolKey("r", Style(130)), "𝖗"), (SymbolKey("rangle", Style(0)), "⟩"), (SymbolKey("rbag", Style(0)), "⟆"), (SymbolKey("rceil", Style(0)), "⌉"), (SymbolKey("rfloor", Style(0)), "⌋"), (SymbolKey("rho", Style(0)), "ρ"), (SymbolKey("rho", Style(2)), "𝛒"), (SymbolKey("rho", Style(3)), "𝞀"), (SymbolKey("rho", Style(4)), "𝜌"), (SymbolKey("rho", Style(6)), "𝝆"), (SymbolKey("rho", Style(7)), "𝞺"), (SymbolKey("rightarrow", Style(0)), "→"), (SymbolKey("rightharpoondown", Style(0)), "⇁"), (SymbolKey("rightharpoonup", Style(0)), "⇀"), (SymbolKey("rightleftharpoons", Style(0)), "⇋"), (SymbolKey("rtimes", Style(0)), "⋊"), (SymbolKey("s", Style(1)), "𝗌"), (SymbolKey("s", Style(2)), "𝐬"), (SymbolKey("s", Style(3)), "𝘀"), (SymbolKey("s", Style(4)), "𝑠"), (SymbolKey("s", Style(5)), "𝘴"), (SymbolKey("s", Style(6)), "𝒔"), (SymbolKey("s", Style(7)), "𝙨"), (SymbolKey("s", Style(8)), "𝚜"), (SymbolKey("s", Style(16)), "𝕤"), (SymbolKey("s", Style(32)), "𝓈"), (SymbolKey("s", Style(64)), "𝓼"), (SymbolKey("s", Style(128)), "𝔰"), (SymbolKey("s", Style(130)), "𝖘"), (SymbolKey("searrow", Style(0)), "↘"), (SymbolKey("setminus", Style(0)), "∖"), (SymbolKey("sharp", Style(0)), "♯"), (SymbolKey("sigma", Style(0)), "σ"), (SymbolKey("sigma", Style(2)), "𝛔"), (SymbolKey("sigma", Style(3)), "𝞂"), (SymbolKey("sigma", Style(4)), "𝜎"), (SymbolKey("sigma", Style(6)), "𝝈"), (SymbolKey("sigma", Style(7)), "𝞼"), (SymbolKey("sim", Style(0)), "∼"), (SymbolKey("simeq", Style(0)), "≃"), (SymbolKey("sqcap", Style(0)), "⊓"), (SymbolKey("sqcup", Style(0)), "⊔"), (SymbolKey("sqquotl", Style(0)), "『"), (SymbolKey("sqquotr", Style(0)), "』"), (SymbolKey("sqsubset", Style(0)), "⊏"), (SymbolKey("sqsubseteq", Style(0)), "⊑"), (SymbolKey("sqsupset", Style(0)), "⊐"), (SymbolKey("sqsupseteq", Style(0)), "⊒"), (SymbolKey("square", Style(0)), "□"), (SymbolKey("squotl", Style(0)), "「"), (SymbolKey("squotr", Style(0)), "」"), (SymbolKey("ss", Style(0)), "ß"), (SymbolKey("star", Style(0)), "⋆"), (SymbolKey("subset", Style(0)), "⊂"), (SymbolKey("subseteq", Style(0)), "⊆"), (SymbolKey("subsetneq", Style(0)), "⊊"), (SymbolKey("succ", Style(0)), "≻"), (SymbolKey("succeq", Style(0)), "⪰"), (SymbolKey("succsim", Style(0)), "≿"), (SymbolKey("supset", Style(0)), "⊃"), (SymbolKey("supseteq", Style(0)), "⊇"), (SymbolKey("supsetneq", Style(0)), "⊋"), (SymbolKey("swarrow", Style(0)), "↙"), (SymbolKey("t", Style(1)), "𝗍"), (SymbolKey("t", Style(2)), "𝐭"), (SymbolKey("t", Style(3)), "𝘁"), (SymbolKey("t", Style(4)), "𝑡"), (SymbolKey("t", Style(5)), "𝘵"), (SymbolKey("t", Style(6)), "𝒕"), (SymbolKey("t", Style(7)), "𝙩"), (SymbolKey("t", Style(8)), "𝚝"), (SymbolKey("t", Style(16)), "𝕥"), (SymbolKey("t", Style(32)), "𝓉"), (SymbolKey("t", Style(64)), "𝓽"), (SymbolKey("t", Style(128)), "𝔱"), (SymbolKey("t", Style(130)), "𝖙"), (SymbolKey("tau", Style(0)), "τ"), (SymbolKey("tau", Style(2)), "𝛕"), (SymbolKey("tau", Style(3)), "𝞃"), (SymbolKey("tau", Style(4)), "𝜏"), (SymbolKey("tau", Style(6)), "𝝉"), (SymbolKey("tau", Style(7)), "𝞽"), (SymbolKey("therefore", Style(0)), "∴"), (SymbolKey("theta", Style(0)), "θ"), (SymbolKey("theta", Style(2)), "𝛉"), (SymbolKey("theta", Style(3)), "𝝷"), (SymbolKey("theta", Style(4)), "𝜃"), (SymbolKey("theta", Style(6)), "𝜽"), (SymbolKey("theta", Style(7)), "𝞱"), (SymbolKey("times", Style(0)), "×"), (SymbolKey("to", Style(0)), "→"), (SymbolKey("top", Style(0)), "⊤"), (SymbolKey("triangle", Style(0)), "▵"), (SymbolKey("u", Style(1)), "𝗎"), (SymbolKey("u", Style(2)), "𝐮"), (SymbolKey("u", Style(3)), "𝘂"), (SymbolKey("u", Style(4)), "𝑢"), (SymbolKey("u", Style(5)), "𝘶"), (SymbolKey("u", Style(6)), "𝒖"), (SymbolKey("u", Style(7)), "𝙪"), (SymbolKey("u", Style(8)), "𝚞"), (SymbolKey("u", Style(16)), "𝕦"), (SymbolKey("u", Style(32)), "𝓊"), (SymbolKey("u", Style(64)), "𝓾"), (SymbolKey("u", Style(128)), "𝔲"), (SymbolKey("u", Style(130)), "𝖚"), (SymbolKey("ulcorner", Style(0)), "⌜"), (SymbolKey("uparrow", Style(0)), "↑"), (SymbolKey("updownarrow", Style(0)), "↕"), (SymbolKey("uplus", Style(0)), "⊎"), (SymbolKey("upsilon", Style(0)), "υ"), (SymbolKey("upsilon", Style(2)), "𝛖"), (SymbolKey("upsilon", Style(3)), "𝞄"), (SymbolKey("upsilon", Style(4)), "𝜐"), (SymbolKey("upsilon", Style(6)), "𝝊"), (SymbolKey("upsilon", Style(7)), "𝞾"), (SymbolKey("urcorner", Style(0)), "⌝"), (SymbolKey("v", Style(1)), "𝗏"), (SymbolKey("v", Style(2)), "𝐯"), (SymbolKey("v", Style(3)), "𝘃"), (SymbolKey("v", Style(4)), "𝑣"), (SymbolKey("v", Style(5)), "𝘷"), (SymbolKey("v", Style(6)), "𝒗"), (SymbolKey("v", Style(7)), "𝙫"), (SymbolKey("v", Style(8)), "𝚟"), (SymbolKey("v", Style(16)), "𝕧"), (SymbolKey("v", Style(32)), "𝓋"), (SymbolKey("v", Style(64)), "𝓿"), (SymbolKey("v", Style(128)), "𝔳"), (SymbolKey("v", Style(130)), "𝖛"), (SymbolKey("vDash", Style(0)), "⊨"), (SymbolKey("varTheta", Style(0)), "ϴ"), (SymbolKey("varTheta", Style(2)), "𝚹"), (SymbolKey("varTheta", Style(3)), "𝝧"), (SymbolKey("varTheta", Style(4)), "𝛳"), (SymbolKey("varTheta", Style(6)), "𝜭"), (SymbolKey("varTheta", Style(7)), "𝞡"), (SymbolKey("varepsilon", Style(0)), "ε"), (SymbolKey("varepsilon", Style(2)), "𝛆"), (SymbolKey("varepsilon", Style(3)), "𝝴"), (SymbolKey("varepsilon", Style(4)), "𝜀"), (SymbolKey("varepsilon", Style(6)), "𝜺"), (SymbolKey("varepsilon", Style(7)), "𝞮"), (SymbolKey("varkappa", Style(0)), "ϰ"), (SymbolKey("varkappa", Style(2)), "𝛞"), (SymbolKey("varkappa", Style(3)), "𝞌"), (SymbolKey("varkappa", Style(4)), "𝜘"), (SymbolKey("varkappa", Style(6)), "𝝒"), (SymbolKey("varkappa", Style(7)), "𝟆"), (SymbolKey("varphi", Style(0)), "φ"), (SymbolKey("varphi", Style(2)), "𝛗"), (SymbolKey("varphi", Style(3)), "𝞅"), (SymbolKey("varphi", Style(4)), "𝜑"), (SymbolKey("varphi", Style(6)), "𝝋"), (SymbolKey("varphi", Style(7)), "𝞿"), (SymbolKey("varpi", Style(0)), "ϖ"), (SymbolKey("varpi", Style(2)), "𝛡"), (SymbolKey("varpi", Style(3)), "𝞏"), (SymbolKey("varpi", Style(4)), "𝜛"), (SymbolKey("varpi", Style(6)), "𝝕"), (SymbolKey("varpi", Style(7)), "𝟉"), (SymbolKey("varrho", Style(0)), "ϱ"), (SymbolKey("varrho", Style(2)), "𝛠"), (SymbolKey("varrho", Style(3)), "𝞎"), (SymbolKey("varrho", Style(4)), "𝜚"), (SymbolKey("varrho", Style(6)), "𝝔"), (SymbolKey("varrho", Style(7)), "𝟈"), (SymbolKey("varsigma", Style(0)), "ς"), (SymbolKey("varsigma", Style(2)), "𝛓"), (SymbolKey("varsigma", Style(3)), "𝞁"), (SymbolKey("varsigma", Style(4)), "𝜍"), (SymbolKey("varsigma", Style(6)), "𝝇"), (SymbolKey("varsigma", Style(7)), "𝞻"), (SymbolKey("vartheta", Style(0)), "ϑ"), (SymbolKey("vartheta", Style(2)), "𝛝"), (SymbolKey("vartheta", Style(3)), "𝞋"), (SymbolKey("vartheta", Style(4)), "𝜗"), (SymbolKey("vartheta", Style(6)), "𝝑"), (SymbolKey("vartheta", Style(7)), "𝟅"), (SymbolKey("vdash", Style(0)), "⊢"), (SymbolKey("vee", Style(0)), "∨"), (SymbolKey("veebar", Style(0)), "⊻"), (SymbolKey("w", Style(1)), "𝗐"), (SymbolKey("w", Style(2)), "𝐰"), (SymbolKey("w", Style(3)), "𝘄"), (SymbolKey("w", Style(4)), "𝑤"), (SymbolKey("w", Style(5)), "𝘸"), (SymbolKey("w", Style(6)), "𝒘"), (SymbolKey("w", Style(7)), "𝙬"), (SymbolKey("w", Style(8)), "𝚠"), (SymbolKey("w", Style(16)), "𝕨"), (SymbolKey("w", Style(32)), "𝓌"), (SymbolKey("w", Style(64)), "𝔀"), (SymbolKey("w", Style(128)), "𝔴"), (SymbolKey("w", Style(130)), "𝖜"), (SymbolKey("wedge", Style(0)), "∧"), (SymbolKey("wp", Style(0)), "℘"), (SymbolKey("x", Style(1)), "𝗑"), (SymbolKey("x", Style(2)), "𝐱"), (SymbolKey("x", Style(3)), "𝘅"), (SymbolKey("x", Style(4)), "𝑥"), (SymbolKey("x", Style(5)), "𝘹"), (SymbolKey("x", Style(6)), "𝒙"), (SymbolKey("x", Style(7)), "𝙭"), (SymbolKey("x", Style(8)), "𝚡"), (SymbolKey("x", Style(16)), "𝕩"), (SymbolKey("x", Style(32)), "𝓍"), (SymbolKey("x", Style(64)), "𝔁"), (SymbolKey("x", Style(128)), "𝔵"), (SymbolKey("x", Style(130)), "𝖝"), (SymbolKey("xi", Style(0)), "ξ"), (SymbolKey("xi", Style(2)), "𝛏"), (SymbolKey("xi", Style(3)), "𝝽"), (SymbolKey("xi", Style(4)), "𝜉"), (SymbolKey("xi", Style(6)), "𝝃"), (SymbolKey("xi", Style(7)), "𝞷"), (SymbolKey("y", Style(1)), "𝗒"), (SymbolKey("y", Style(2)), "𝐲"), (SymbolKey("y", Style(3)), "𝘆"), (SymbolKey("y", Style(4)), "𝑦"), (SymbolKey("y", Style(5)), "𝘺"), (SymbolKey("y", Style(6)), "𝒚"), (SymbolKey("y", Style(7)), "𝙮"), (SymbolKey("y", Style(8)), "𝚢"), (SymbolKey("y", Style(16)), "𝕪"), (SymbolKey("y", Style(32)), "𝓎"), (SymbolKey("y", Style(64)), "𝔂"), (SymbolKey("y", Style(128)), "𝔶"), (SymbolKey("y", Style(130)), "𝖞"), (SymbolKey("z", Style(1)), "𝗓"), (SymbolKey("z", Style(2)), "𝐳"), (SymbolKey("z", Style(3)), "𝘇"), (SymbolKey("z", Style(4)), "𝑧"), (SymbolKey("z", Style(5)), "𝘻"), (SymbolKey("z", Style(6)), "𝒛"), (SymbolKey("z", Style(7)), "𝙯"), (SymbolKey("z", Style(8)), "𝚣"), (SymbolKey("z", Style(16)), "𝕫"), (SymbolKey("z", Style(32)), "𝓏"), (SymbolKey("z", Style(64)), "𝔃"), (SymbolKey("z", Style(128)), "𝔷"), (SymbolKey("z", Style(130)), "𝖟"), (SymbolKey("zeta", Style(0)), "ζ"), (SymbolKey("zeta", Style(2)), "𝛇"), (SymbolKey("zeta", Style(3)), "𝝵"), (SymbolKey("zeta", Style(4)), "𝜁"), (SymbolKey("zeta", Style(6)), "𝜻"), (SymbolKey("zeta", Style(7)), "𝞯"), (SymbolKey("{{", Style(0)), "⦃"), (SymbolKey("|", Style(0)), "‖"), (SymbolKey("|)", Style(0)), "⦈"), (SymbolKey("}}", Style(0)), "⦄")];
#[derive(Clone, Copy, Debug)] pub struct UnicodeAnnotation { pub codepoint: &'static str, pub tts: &'static str, }
pub static UNICODE_ANNOTATIONS: &[UnicodeAnnotation] = &[
UnicodeAnnotation { codepoint: "🏻", tts: "light skin tone" },
UnicodeAnnotation { codepoint: "🏼", tts: "medium-light skin tone" },
UnicodeAnnotation { codepoint: "🏽", tts: "medium skin tone" },
UnicodeAnnotation { codepoint: "🏾", tts: "medium-dark skin tone" },
UnicodeAnnotation { codepoint: "🏿", tts: "dark skin tone" },
UnicodeAnnotation { codepoint: "*", tts: "asterisk" },
UnicodeAnnotation { codepoint: "#", tts: "hash sign" },
UnicodeAnnotation { codepoint: "😀", tts: "grinning face" },
UnicodeAnnotation { codepoint: "😃", tts: "grinning face with big eyes" },
UnicodeAnnotation { codepoint: "😄", tts: "grinning face with smiling eyes" },
UnicodeAnnotation { codepoint: "😁", tts: "beaming face with smiling eyes" },
UnicodeAnnotation { codepoint: "😆", tts: "grinning squinting face" },
UnicodeAnnotation { codepoint: "😅", tts: "grinning face with sweat" },
UnicodeAnnotation { codepoint: "🤣", tts: "rolling on the floor laughing" },
UnicodeAnnotation { codepoint: "😂", tts: "face with tears of joy" },
UnicodeAnnotation { codepoint: "🙂", tts: "slightly smiling face" },
UnicodeAnnotation { codepoint: "🙃", tts: "upside-down face" },
UnicodeAnnotation { codepoint: "😉", tts: "winking face" },
UnicodeAnnotation { codepoint: "😊", tts: "smiling face with smiling eyes" },
UnicodeAnnotation { codepoint: "😇", tts: "smiling face with halo" },
UnicodeAnnotation { codepoint: "😍", tts: "smiling face with heart-eyes" },
UnicodeAnnotation { codepoint: "🤩", tts: "star-struck" },
UnicodeAnnotation { codepoint: "😘", tts: "face blowing a kiss" },
UnicodeAnnotation { codepoint: "😗", tts: "kissing face" },
UnicodeAnnotation { codepoint: "☺", tts: "smiling face" },
UnicodeAnnotation { codepoint: "😚", tts: "kissing face with closed eyes" },
UnicodeAnnotation { codepoint: "😙", tts: "kissing face with smiling eyes" },
UnicodeAnnotation { codepoint: "😋", tts: "face savoring food" },
UnicodeAnnotation { codepoint: "😛", tts: "face with tongue" },
UnicodeAnnotation { codepoint: "😜", tts: "winking face with tongue" },
UnicodeAnnotation { codepoint: "🤪", tts: "zany face" },
UnicodeAnnotation { codepoint: "😝", tts: "squinting face with tongue" },
UnicodeAnnotation { codepoint: "🤑", tts: "money-mouth face" },
UnicodeAnnotation { codepoint: "🤗", tts: "smiling face with open hands" },
UnicodeAnnotation { codepoint: "🤭", tts: "face with hand over mouth" },
UnicodeAnnotation { codepoint: "🤫", tts: "shushing face" },
UnicodeAnnotation { codepoint: "🤔", tts: "thinking face" },
UnicodeAnnotation { codepoint: "🤐", tts: "zipper-mouth face" },
UnicodeAnnotation { codepoint: "🤨", tts: "face with raised eyebrow" },
UnicodeAnnotation { codepoint: "😐", tts: "neutral face" },
UnicodeAnnotation { codepoint: "😑", tts: "expressionless face" },
UnicodeAnnotation { codepoint: "😶", tts: "face without mouth" },
UnicodeAnnotation { codepoint: "😶‍🌫", tts: "face in clouds" },
UnicodeAnnotation { codepoint: "😏", tts: "smirking face" },
UnicodeAnnotation { codepoint: "😒", tts: "unamused face" },
UnicodeAnnotation { codepoint: "🙄", tts: "face with rolling eyes" },
UnicodeAnnotation { codepoint: "😬", tts: "grimacing face" },
UnicodeAnnotation { codepoint: "😮‍💨", tts: "face exhaling" },
UnicodeAnnotation { codepoint: "🤥", tts: "lying face" },
UnicodeAnnotation { codepoint: "🙂‍↔", tts: "head shaking horizontally" },
UnicodeAnnotation { codepoint: "🙂‍↕", tts: "head shaking vertically" },
UnicodeAnnotation { codepoint: "😌", tts: "relieved face" },
UnicodeAnnotation { codepoint: "😔", tts: "pensive face" },
UnicodeAnnotation { codepoint: "😪", tts: "sleepy face" },
UnicodeAnnotation { codepoint: "🤤", tts: "drooling face" },
UnicodeAnnotation { codepoint: "😴", tts: "sleeping face" },
UnicodeAnnotation { codepoint: "😷", tts: "face with medical mask" },
UnicodeAnnotation { codepoint: "🤒", tts: "face with thermometer" },
UnicodeAnnotation { codepoint: "🤕", tts: "face with head-bandage" },
UnicodeAnnotation { codepoint: "🤢", tts: "nauseated face" },
UnicodeAnnotation { codepoint: "🤮", tts: "face vomiting" },
UnicodeAnnotation { codepoint: "🤧", tts: "sneezing face" },
UnicodeAnnotation { codepoint: "😵", tts: "face with crossed-out eyes" },
UnicodeAnnotation { codepoint: "😵‍💫", tts: "face with spiral eyes" },
UnicodeAnnotation { codepoint: "🤯", tts: "exploding head" },
UnicodeAnnotation { codepoint: "🤠", tts: "cowboy hat face" },
UnicodeAnnotation { codepoint: "😎", tts: "smiling face with sunglasses" },
UnicodeAnnotation { codepoint: "🤓", tts: "nerd face" },
UnicodeAnnotation { codepoint: "🧐", tts: "face with monocle" },
UnicodeAnnotation { codepoint: "😕", tts: "confused face" },
UnicodeAnnotation { codepoint: "😟", tts: "worried face" },
UnicodeAnnotation { codepoint: "🙁", tts: "slightly frowning face" },
UnicodeAnnotation { codepoint: "☹", tts: "frowning face" },
UnicodeAnnotation { codepoint: "😮", tts: "face with open mouth" },
UnicodeAnnotation { codepoint: "😯", tts: "hushed face" },
UnicodeAnnotation { codepoint: "😲", tts: "astonished face" },
UnicodeAnnotation { codepoint: "😳", tts: "flushed face" },
UnicodeAnnotation { codepoint: "😦", tts: "frowning face with open mouth" },
UnicodeAnnotation { codepoint: "😧", tts: "anguished face" },
UnicodeAnnotation { codepoint: "😨", tts: "fearful face" },
UnicodeAnnotation { codepoint: "😰", tts: "anxious face with sweat" },
UnicodeAnnotation { codepoint: "😥", tts: "sad but relieved face" },
UnicodeAnnotation { codepoint: "😢", tts: "crying face" },
UnicodeAnnotation { codepoint: "😭", tts: "loudly crying face" },
UnicodeAnnotation { codepoint: "😱", tts: "face screaming in fear" },
UnicodeAnnotation { codepoint: "😖", tts: "confounded face" },
UnicodeAnnotation { codepoint: "😣", tts: "persevering face" },
UnicodeAnnotation { codepoint: "😞", tts: "disappointed face" },
UnicodeAnnotation { codepoint: "😓", tts: "downcast face with sweat" },
UnicodeAnnotation { codepoint: "😩", tts: "weary face" },
UnicodeAnnotation { codepoint: "😫", tts: "tired face" },
UnicodeAnnotation { codepoint: "😤", tts: "face with steam from nose" },
UnicodeAnnotation { codepoint: "😡", tts: "enraged face" },
UnicodeAnnotation { codepoint: "😠", tts: "angry face" },
UnicodeAnnotation { codepoint: "🤬", tts: "face with symbols on mouth" },
UnicodeAnnotation { codepoint: "😈", tts: "smiling face with horns" },
UnicodeAnnotation { codepoint: "👿", tts: "angry face with horns" },
UnicodeAnnotation { codepoint: "💀", tts: "skull" },
UnicodeAnnotation { codepoint: "☠", tts: "skull and crossbones" },
UnicodeAnnotation { codepoint: "💩", tts: "pile of poo" },
UnicodeAnnotation { codepoint: "🤡", tts: "clown face" },
UnicodeAnnotation { codepoint: "👹", tts: "ogre" },
UnicodeAnnotation { codepoint: "👺", tts: "goblin" },
UnicodeAnnotation { codepoint: "👻", tts: "ghost" },
UnicodeAnnotation { codepoint: "👽", tts: "alien" },
UnicodeAnnotation { codepoint: "👾", tts: "alien monster" },
UnicodeAnnotation { codepoint: "🤖", tts: "robot" },
UnicodeAnnotation { codepoint: "😺", tts: "grinning cat" },
UnicodeAnnotation { codepoint: "😸", tts: "grinning cat with smiling eyes" },
UnicodeAnnotation { codepoint: "😹", tts: "cat with tears of joy" },
UnicodeAnnotation { codepoint: "😻", tts: "smiling cat with heart-eyes" },
UnicodeAnnotation { codepoint: "😼", tts: "cat with wry smile" },
UnicodeAnnotation { codepoint: "😽", tts: "kissing cat" },
UnicodeAnnotation { codepoint: "🙀", tts: "weary cat" },
UnicodeAnnotation { codepoint: "😿", tts: "crying cat" },
UnicodeAnnotation { codepoint: "😾", tts: "pouting cat" },
UnicodeAnnotation { codepoint: "🙈", tts: "see-no-evil monkey" },
UnicodeAnnotation { codepoint: "🙉", tts: "hear-no-evil monkey" },
UnicodeAnnotation { codepoint: "🙊", tts: "speak-no-evil monkey" },
UnicodeAnnotation { codepoint: "💌", tts: "love letter" },
UnicodeAnnotation { codepoint: "💘", tts: "heart with arrow" },
UnicodeAnnotation { codepoint: "💝", tts: "heart with ribbon" },
UnicodeAnnotation { codepoint: "💖", tts: "sparkling heart" },
UnicodeAnnotation { codepoint: "💗", tts: "growing heart" },
UnicodeAnnotation { codepoint: "💓", tts: "beating heart" },
UnicodeAnnotation { codepoint: "💞", tts: "revolving hearts" },
UnicodeAnnotation { codepoint: "💕", tts: "two hearts" },
UnicodeAnnotation { codepoint: "💟", tts: "heart decoration" },
UnicodeAnnotation { codepoint: "❣", tts: "heart exclamation" },
UnicodeAnnotation { codepoint: "💔", tts: "broken heart" },
UnicodeAnnotation { codepoint: "❤‍🔥", tts: "heart on fire" },
UnicodeAnnotation { codepoint: "❤‍🩹", tts: "mending heart" },
UnicodeAnnotation { codepoint: "❤", tts: "red heart" },
UnicodeAnnotation { codepoint: "🧡", tts: "orange heart" },
UnicodeAnnotation { codepoint: "💛", tts: "yellow heart" },
UnicodeAnnotation { codepoint: "💚", tts: "green heart" },
UnicodeAnnotation { codepoint: "💙", tts: "blue heart" },
UnicodeAnnotation { codepoint: "💜", tts: "purple heart" },
UnicodeAnnotation { codepoint: "🖤", tts: "black heart" },
UnicodeAnnotation { codepoint: "💋", tts: "kiss mark" },
UnicodeAnnotation { codepoint: "💯", tts: "hundred points" },
UnicodeAnnotation { codepoint: "💢", tts: "anger symbol" },
UnicodeAnnotation { codepoint: "💥", tts: "collision" },
UnicodeAnnotation { codepoint: "💫", tts: "dizzy" },
UnicodeAnnotation { codepoint: "💦", tts: "sweat droplets" },
UnicodeAnnotation { codepoint: "💨", tts: "dashing away" },
UnicodeAnnotation { codepoint: "🕳", tts: "hole" },
UnicodeAnnotation { codepoint: "💬", tts: "speech balloon" },
UnicodeAnnotation { codepoint: "👁‍🗨", tts: "eye in speech bubble" },
UnicodeAnnotation { codepoint: "🗨", tts: "left speech bubble" },
UnicodeAnnotation { codepoint: "🗯", tts: "right anger bubble" },
UnicodeAnnotation { codepoint: "💭", tts: "thought balloon" },
UnicodeAnnotation { codepoint: "💤", tts: "ZZZ" },
UnicodeAnnotation { codepoint: "👋", tts: "waving hand" },
UnicodeAnnotation { codepoint: "🤚", tts: "raised back of hand" },
UnicodeAnnotation { codepoint: "🖐", tts: "hand with fingers splayed" },
UnicodeAnnotation { codepoint: "✋", tts: "raised hand" },
UnicodeAnnotation { codepoint: "🖖", tts: "vulcan salute" },
UnicodeAnnotation { codepoint: "👌", tts: "OK hand" },
UnicodeAnnotation { codepoint: "✌", tts: "victory hand" },
UnicodeAnnotation { codepoint: "🤞", tts: "crossed fingers" },
UnicodeAnnotation { codepoint: "🤟", tts: "love-you gesture" },
UnicodeAnnotation { codepoint: "🤘", tts: "sign of the horns" },
UnicodeAnnotation { codepoint: "🤙", tts: "call me hand" },
UnicodeAnnotation { codepoint: "👈", tts: "backhand index pointing left" },
UnicodeAnnotation { codepoint: "👉", tts: "backhand index pointing right" },
UnicodeAnnotation { codepoint: "👆", tts: "backhand index pointing up" },
UnicodeAnnotation { codepoint: "🖕", tts: "middle finger" },
UnicodeAnnotation { codepoint: "👇", tts: "backhand index pointing down" },
UnicodeAnnotation { codepoint: "☝", tts: "index pointing up" },
UnicodeAnnotation { codepoint: "👍", tts: "thumbs up" },
UnicodeAnnotation { codepoint: "👎", tts: "thumbs down" },
UnicodeAnnotation { codepoint: "✊", tts: "raised fist" },
UnicodeAnnotation { codepoint: "👊", tts: "oncoming fist" },
UnicodeAnnotation { codepoint: "🤛", tts: "left-facing fist" },
UnicodeAnnotation { codepoint: "🤜", tts: "right-facing fist" },
UnicodeAnnotation { codepoint: "👏", tts: "clapping hands" },
UnicodeAnnotation { codepoint: "🙌", tts: "raising hands" },
UnicodeAnnotation { codepoint: "👐", tts: "open hands" },
UnicodeAnnotation { codepoint: "🤲", tts: "palms up together" },
UnicodeAnnotation { codepoint: "🤝", tts: "handshake" },
UnicodeAnnotation { codepoint: "🙏", tts: "folded hands" },
UnicodeAnnotation { codepoint: "✍", tts: "writing hand" },
UnicodeAnnotation { codepoint: "💅", tts: "nail polish" },
UnicodeAnnotation { codepoint: "🤳", tts: "selfie" },
UnicodeAnnotation { codepoint: "💪", tts: "flexed biceps" },
UnicodeAnnotation { codepoint: "👂", tts: "ear" },
UnicodeAnnotation { codepoint: "👃", tts: "nose" },
UnicodeAnnotation { codepoint: "🧠", tts: "brain" },
UnicodeAnnotation { codepoint: "👀", tts: "eyes" },
UnicodeAnnotation { codepoint: "👁", tts: "eye" },
UnicodeAnnotation { codepoint: "👅", tts: "tongue" },
UnicodeAnnotation { codepoint: "👄", tts: "mouth" },
UnicodeAnnotation { codepoint: "👶", tts: "baby" },
UnicodeAnnotation { codepoint: "🧒", tts: "child" },
UnicodeAnnotation { codepoint: "👦", tts: "boy" },
UnicodeAnnotation { codepoint: "👧", tts: "girl" },
UnicodeAnnotation { codepoint: "🧑", tts: "person" },
UnicodeAnnotation { codepoint: "👱", tts: "person: blond hair" },
UnicodeAnnotation { codepoint: "👨", tts: "man" },
UnicodeAnnotation { codepoint: "🧔", tts: "person: beard" },
UnicodeAnnotation { codepoint: "🧔‍♂", tts: "man: beard" },
UnicodeAnnotation { codepoint: "👱‍♂", tts: "man: blond hair" },
UnicodeAnnotation { codepoint: "👩", tts: "woman" },
UnicodeAnnotation { codepoint: "🧔‍♀", tts: "woman: beard" },
UnicodeAnnotation { codepoint: "👱‍♀", tts: "woman: blond hair" },
UnicodeAnnotation { codepoint: "🧓", tts: "older person" },
UnicodeAnnotation { codepoint: "👴", tts: "old man" },
UnicodeAnnotation { codepoint: "👵", tts: "old woman" },
UnicodeAnnotation { codepoint: "🙍", tts: "person frowning" },
UnicodeAnnotation { codepoint: "🙍‍♂", tts: "man frowning" },
UnicodeAnnotation { codepoint: "🙍‍♀", tts: "woman frowning" },
UnicodeAnnotation { codepoint: "🙎", tts: "person pouting" },
UnicodeAnnotation { codepoint: "🙎‍♂", tts: "man pouting" },
UnicodeAnnotation { codepoint: "🙎‍♀", tts: "woman pouting" },
UnicodeAnnotation { codepoint: "🙅", tts: "person gesturing NO" },
UnicodeAnnotation { codepoint: "🙅‍♂", tts: "man gesturing NO" },
UnicodeAnnotation { codepoint: "🙅‍♀", tts: "woman gesturing NO" },
UnicodeAnnotation { codepoint: "🙆", tts: "person gesturing OK" },
UnicodeAnnotation { codepoint: "🙆‍♂", tts: "man gesturing OK" },
UnicodeAnnotation { codepoint: "🙆‍♀", tts: "woman gesturing OK" },
UnicodeAnnotation { codepoint: "💁", tts: "person tipping hand" },
UnicodeAnnotation { codepoint: "💁‍♂", tts: "man tipping hand" },
UnicodeAnnotation { codepoint: "💁‍♀", tts: "woman tipping hand" },
UnicodeAnnotation { codepoint: "🙋", tts: "person raising hand" },
UnicodeAnnotation { codepoint: "🙋‍♂", tts: "man raising hand" },
UnicodeAnnotation { codepoint: "🙋‍♀", tts: "woman raising hand" },
UnicodeAnnotation { codepoint: "🧏‍♂", tts: "deaf man" },
UnicodeAnnotation { codepoint: "🧏‍♀", tts: "deaf woman" },
UnicodeAnnotation { codepoint: "🙇", tts: "person bowing" },
UnicodeAnnotation { codepoint: "🙇‍♂", tts: "man bowing" },
UnicodeAnnotation { codepoint: "🙇‍♀", tts: "woman bowing" },
UnicodeAnnotation { codepoint: "🤦", tts: "person facepalming" },
UnicodeAnnotation { codepoint: "🤦‍♂", tts: "man facepalming" },
UnicodeAnnotation { codepoint: "🤦‍♀", tts: "woman facepalming" },
UnicodeAnnotation { codepoint: "🤷", tts: "person shrugging" },
UnicodeAnnotation { codepoint: "🤷‍♂", tts: "man shrugging" },
UnicodeAnnotation { codepoint: "🤷‍♀", tts: "woman shrugging" },
UnicodeAnnotation { codepoint: "🧑‍⚕", tts: "health worker" },
UnicodeAnnotation { codepoint: "👨‍⚕", tts: "man health worker" },
UnicodeAnnotation { codepoint: "👩‍⚕", tts: "woman health worker" },
UnicodeAnnotation { codepoint: "🧑‍🎓", tts: "student" },
UnicodeAnnotation { codepoint: "👨‍🎓", tts: "man student" },
UnicodeAnnotation { codepoint: "👩‍🎓", tts: "woman student" },
UnicodeAnnotation { codepoint: "🧑‍🏫", tts: "teacher" },
UnicodeAnnotation { codepoint: "👨‍🏫", tts: "man teacher" },
UnicodeAnnotation { codepoint: "👩‍🏫", tts: "woman teacher" },
UnicodeAnnotation { codepoint: "🧑‍⚖", tts: "judge" },
UnicodeAnnotation { codepoint: "👨‍⚖", tts: "man judge" },
UnicodeAnnotation { codepoint: "👩‍⚖", tts: "woman judge" },
UnicodeAnnotation { codepoint: "🧑‍🌾", tts: "farmer" },
UnicodeAnnotation { codepoint: "👨‍🌾", tts: "man farmer" },
UnicodeAnnotation { codepoint: "👩‍🌾", tts: "woman farmer" },
UnicodeAnnotation { codepoint: "🧑‍🍳", tts: "cook" },
UnicodeAnnotation { codepoint: "👨‍🍳", tts: "man cook" },
UnicodeAnnotation { codepoint: "👩‍🍳", tts: "woman cook" },
UnicodeAnnotation { codepoint: "🧑‍🔧", tts: "mechanic" },
UnicodeAnnotation { codepoint: "👨‍🔧", tts: "man mechanic" },
UnicodeAnnotation { codepoint: "👩‍🔧", tts: "woman mechanic" },
UnicodeAnnotation { codepoint: "🧑‍🏭", tts: "factory worker" },
UnicodeAnnotation { codepoint: "👨‍🏭", tts: "man factory worker" },
UnicodeAnnotation { codepoint: "👩‍🏭", tts: "woman factory worker" },
UnicodeAnnotation { codepoint: "🧑‍💼", tts: "office worker" },
UnicodeAnnotation { codepoint: "👨‍💼", tts: "man office worker" },
UnicodeAnnotation { codepoint: "👩‍💼", tts: "woman office worker" },
UnicodeAnnotation { codepoint: "🧑‍🔬", tts: "scientist" },
UnicodeAnnotation { codepoint: "👨‍🔬", tts: "man scientist" },
UnicodeAnnotation { codepoint: "👩‍🔬", tts: "woman scientist" },
UnicodeAnnotation { codepoint: "🧑‍💻", tts: "technologist" },
UnicodeAnnotation { codepoint: "👨‍💻", tts: "man technologist" },
UnicodeAnnotation { codepoint: "👩‍💻", tts: "woman technologist" },
UnicodeAnnotation { codepoint: "🧑‍🎤", tts: "singer" },
UnicodeAnnotation { codepoint: "👨‍🎤", tts: "man singer" },
UnicodeAnnotation { codepoint: "👩‍🎤", tts: "woman singer" },
UnicodeAnnotation { codepoint: "🧑‍🎨", tts: "artist" },
UnicodeAnnotation { codepoint: "👨‍🎨", tts: "man artist" },
UnicodeAnnotation { codepoint: "👩‍🎨", tts: "woman artist" },
UnicodeAnnotation { codepoint: "🧑‍✈", tts: "pilot" },
UnicodeAnnotation { codepoint: "👨‍✈", tts: "man pilot" },
UnicodeAnnotation { codepoint: "👩‍✈", tts: "woman pilot" },
UnicodeAnnotation { codepoint: "🧑‍🚀", tts: "astronaut" },
UnicodeAnnotation { codepoint: "👨‍🚀", tts: "man astronaut" },
UnicodeAnnotation { codepoint: "👩‍🚀", tts: "woman astronaut" },
UnicodeAnnotation { codepoint: "🧑‍🚒", tts: "firefighter" },
UnicodeAnnotation { codepoint: "👨‍🚒", tts: "man firefighter" },
UnicodeAnnotation { codepoint: "👩‍🚒", tts: "woman firefighter" },
UnicodeAnnotation { codepoint: "👮", tts: "police officer" },
UnicodeAnnotation { codepoint: "👮‍♂", tts: "man police officer" },
UnicodeAnnotation { codepoint: "👮‍♀", tts: "woman police officer" },
UnicodeAnnotation { codepoint: "🕵", tts: "detective" },
UnicodeAnnotation { codepoint: "🕵‍♂", tts: "man detective" },
UnicodeAnnotation { codepoint: "🕵‍♀", tts: "woman detective" },
UnicodeAnnotation { codepoint: "💂", tts: "guard" },
UnicodeAnnotation { codepoint: "💂‍♂", tts: "man guard" },
UnicodeAnnotation { codepoint: "💂‍♀", tts: "woman guard" },
UnicodeAnnotation { codepoint: "👷", tts: "construction worker" },
UnicodeAnnotation { codepoint: "👷‍♂", tts: "man construction worker" },
UnicodeAnnotation { codepoint: "👷‍♀", tts: "woman construction worker" },
UnicodeAnnotation { codepoint: "🤴", tts: "prince" },
UnicodeAnnotation { codepoint: "👸", tts: "princess" },
UnicodeAnnotation { codepoint: "👳", tts: "person wearing turban" },
UnicodeAnnotation { codepoint: "👳‍♂", tts: "man wearing turban" },
UnicodeAnnotation { codepoint: "👳‍♀", tts: "woman wearing turban" },
UnicodeAnnotation { codepoint: "👲", tts: "person with skullcap" },
UnicodeAnnotation { codepoint: "🧕", tts: "woman with headscarf" },
UnicodeAnnotation { codepoint: "🤵", tts: "person in tuxedo" },
UnicodeAnnotation { codepoint: "🤵‍♂", tts: "man in tuxedo" },
UnicodeAnnotation { codepoint: "🤵‍♀", tts: "woman in tuxedo" },
UnicodeAnnotation { codepoint: "👰", tts: "person with veil" },
UnicodeAnnotation { codepoint: "👰‍♂", tts: "man with veil" },
UnicodeAnnotation { codepoint: "👰‍♀", tts: "woman with veil" },
UnicodeAnnotation { codepoint: "🤰", tts: "pregnant woman" },
UnicodeAnnotation { codepoint: "🤱", tts: "breast-feeding" },
UnicodeAnnotation { codepoint: "👩‍🍼", tts: "woman feeding baby" },
UnicodeAnnotation { codepoint: "👨‍🍼", tts: "man feeding baby" },
UnicodeAnnotation { codepoint: "🧑‍🍼", tts: "person feeding baby" },
UnicodeAnnotation { codepoint: "👼", tts: "baby angel" },
UnicodeAnnotation { codepoint: "🎅", tts: "Santa Claus" },
UnicodeAnnotation { codepoint: "🤶", tts: "Mrs. Claus" },
UnicodeAnnotation { codepoint: "🧑‍🎄", tts: "mx claus" },
UnicodeAnnotation { codepoint: "🦸‍♂", tts: "man superhero" },
UnicodeAnnotation { codepoint: "🦸‍♀", tts: "woman superhero" },
UnicodeAnnotation { codepoint: "🦹‍♂", tts: "man supervillain" },
UnicodeAnnotation { codepoint: "🦹‍♀", tts: "woman supervillain" },
UnicodeAnnotation { codepoint: "🧙", tts: "mage" },
UnicodeAnnotation { codepoint: "🧙‍♂", tts: "man mage" },
UnicodeAnnotation { codepoint: "🧙‍♀", tts: "woman mage" },
UnicodeAnnotation { codepoint: "🧚", tts: "fairy" },
UnicodeAnnotation { codepoint: "🧚‍♂", tts: "man fairy" },
UnicodeAnnotation { codepoint: "🧚‍♀", tts: "woman fairy" },
UnicodeAnnotation { codepoint: "🧛", tts: "vampire" },
UnicodeAnnotation { codepoint: "🧛‍♂", tts: "man vampire" },
UnicodeAnnotation { codepoint: "🧛‍♀", tts: "woman vampire" },
UnicodeAnnotation { codepoint: "🧜", tts: "merperson" },
UnicodeAnnotation { codepoint: "🧜‍♂", tts: "merman" },
UnicodeAnnotation { codepoint: "🧜‍♀", tts: "mermaid" },
UnicodeAnnotation { codepoint: "🧝", tts: "elf" },
UnicodeAnnotation { codepoint: "🧝‍♂", tts: "man elf" },
UnicodeAnnotation { codepoint: "🧝‍♀", tts: "woman elf" },
UnicodeAnnotation { codepoint: "🧞", tts: "genie" },
UnicodeAnnotation { codepoint: "🧞‍♂", tts: "man genie" },
UnicodeAnnotation { codepoint: "🧞‍♀", tts: "woman genie" },
UnicodeAnnotation { codepoint: "🧟", tts: "zombie" },
UnicodeAnnotation { codepoint: "🧟‍♂", tts: "man zombie" },
UnicodeAnnotation { codepoint: "🧟‍♀", tts: "woman zombie" },
UnicodeAnnotation { codepoint: "💆", tts: "person getting massage" },
UnicodeAnnotation { codepoint: "💆‍♂", tts: "man getting massage" },
UnicodeAnnotation { codepoint: "💆‍♀", tts: "woman getting massage" },
UnicodeAnnotation { codepoint: "💇", tts: "person getting haircut" },
UnicodeAnnotation { codepoint: "💇‍♂", tts: "man getting haircut" },
UnicodeAnnotation { codepoint: "💇‍♀", tts: "woman getting haircut" },
UnicodeAnnotation { codepoint: "🚶", tts: "person walking" },
UnicodeAnnotation { codepoint: "🚶‍♂", tts: "man walking" },
UnicodeAnnotation { codepoint: "🚶‍♀", tts: "woman walking" },
UnicodeAnnotation { codepoint: "🧍‍♂", tts: "man standing" },
UnicodeAnnotation { codepoint: "🧍‍♀", tts: "woman standing" },
UnicodeAnnotation { codepoint: "🧎‍♂", tts: "man kneeling" },
UnicodeAnnotation { codepoint: "🧎‍♀", tts: "woman kneeling" },
UnicodeAnnotation { codepoint: "🧑‍🦯", tts: "person with white cane" },
UnicodeAnnotation { codepoint: "👨‍🦯", tts: "man with white cane" },
UnicodeAnnotation { codepoint: "👩‍🦯", tts: "woman with white cane" },
UnicodeAnnotation { codepoint: "🧑‍🦼", tts: "person in motorized wheelchair" },
UnicodeAnnotation { codepoint: "👨‍🦼", tts: "man in motorized wheelchair" },
UnicodeAnnotation { codepoint: "👩‍🦼", tts: "woman in motorized wheelchair" },
UnicodeAnnotation { codepoint: "🧑‍🦽", tts: "person in manual wheelchair" },
UnicodeAnnotation { codepoint: "👨‍🦽", tts: "man in manual wheelchair" },
UnicodeAnnotation { codepoint: "👩‍🦽", tts: "woman in manual wheelchair" },
UnicodeAnnotation { codepoint: "🏃", tts: "person running" },
UnicodeAnnotation { codepoint: "🏃‍♂", tts: "man running" },
UnicodeAnnotation { codepoint: "🏃‍♀", tts: "woman running" },
UnicodeAnnotation { codepoint: "💃", tts: "woman dancing" },
UnicodeAnnotation { codepoint: "🕺", tts: "man dancing" },
UnicodeAnnotation { codepoint: "🕴", tts: "person in suit levitating" },
UnicodeAnnotation { codepoint: "👯", tts: "people with bunny ears" },
UnicodeAnnotation { codepoint: "👯‍♂", tts: "men with bunny ears" },
UnicodeAnnotation { codepoint: "👯‍♀", tts: "women with bunny ears" },
UnicodeAnnotation { codepoint: "🧖", tts: "person in steamy room" },
UnicodeAnnotation { codepoint: "🧖‍♂", tts: "man in steamy room" },
UnicodeAnnotation { codepoint: "🧖‍♀", tts: "woman in steamy room" },
UnicodeAnnotation { codepoint: "🧗", tts: "person climbing" },
UnicodeAnnotation { codepoint: "🧗‍♂", tts: "man climbing" },
UnicodeAnnotation { codepoint: "🧗‍♀", tts: "woman climbing" },
UnicodeAnnotation { codepoint: "🤺", tts: "person fencing" },
UnicodeAnnotation { codepoint: "🏇", tts: "horse racing" },
UnicodeAnnotation { codepoint: "⛷", tts: "skier" },
UnicodeAnnotation { codepoint: "🏂", tts: "snowboarder" },
UnicodeAnnotation { codepoint: "🏌", tts: "person golfing" },
UnicodeAnnotation { codepoint: "🏌‍♂", tts: "man golfing" },
UnicodeAnnotation { codepoint: "🏌‍♀", tts: "woman golfing" },
UnicodeAnnotation { codepoint: "🏄", tts: "person surfing" },
UnicodeAnnotation { codepoint: "🏄‍♂", tts: "man surfing" },
UnicodeAnnotation { codepoint: "🏄‍♀", tts: "woman surfing" },
UnicodeAnnotation { codepoint: "🚣", tts: "person rowing boat" },
UnicodeAnnotation { codepoint: "🚣‍♂", tts: "man rowing boat" },
UnicodeAnnotation { codepoint: "🚣‍♀", tts: "woman rowing boat" },
UnicodeAnnotation { codepoint: "🏊", tts: "person swimming" },
UnicodeAnnotation { codepoint: "🏊‍♂", tts: "man swimming" },
UnicodeAnnotation { codepoint: "🏊‍♀", tts: "woman swimming" },
UnicodeAnnotation { codepoint: "⛹", tts: "person bouncing ball" },
UnicodeAnnotation { codepoint: "⛹‍♂", tts: "man bouncing ball" },
UnicodeAnnotation { codepoint: "⛹‍♀", tts: "woman bouncing ball" },
UnicodeAnnotation { codepoint: "🏋", tts: "person lifting weights" },
UnicodeAnnotation { codepoint: "🏋‍♂", tts: "man lifting weights" },
UnicodeAnnotation { codepoint: "🏋‍♀", tts: "woman lifting weights" },
UnicodeAnnotation { codepoint: "🚴", tts: "person biking" },
UnicodeAnnotation { codepoint: "🚴‍♂", tts: "man biking" },
UnicodeAnnotation { codepoint: "🚴‍♀", tts: "woman biking" },
UnicodeAnnotation { codepoint: "🚵", tts: "person mountain biking" },
UnicodeAnnotation { codepoint: "🚵‍♂", tts: "man mountain biking" },
UnicodeAnnotation { codepoint: "🚵‍♀", tts: "woman mountain biking" },
UnicodeAnnotation { codepoint: "🤸", tts: "person cartwheeling" },
UnicodeAnnotation { codepoint: "🤸‍♂", tts: "man cartwheeling" },
UnicodeAnnotation { codepoint: "🤸‍♀", tts: "woman cartwheeling" },
UnicodeAnnotation { codepoint: "🤼", tts: "people wrestling" },
UnicodeAnnotation { codepoint: "🤼‍♂", tts: "men wrestling" },
UnicodeAnnotation { codepoint: "🤼‍♀", tts: "women wrestling" },
UnicodeAnnotation { codepoint: "🤽", tts: "person playing water polo" },
UnicodeAnnotation { codepoint: "🤽‍♂", tts: "man playing water polo" },
UnicodeAnnotation { codepoint: "🤽‍♀", tts: "woman playing water polo" },
UnicodeAnnotation { codepoint: "🤾", tts: "person playing handball" },
UnicodeAnnotation { codepoint: "🤾‍♂", tts: "man playing handball" },
UnicodeAnnotation { codepoint: "🤾‍♀", tts: "woman playing handball" },
UnicodeAnnotation { codepoint: "🤹", tts: "person juggling" },
UnicodeAnnotation { codepoint: "🤹‍♂", tts: "man juggling" },
UnicodeAnnotation { codepoint: "🤹‍♀", tts: "woman juggling" },
UnicodeAnnotation { codepoint: "🧘", tts: "person in lotus position" },
UnicodeAnnotation { codepoint: "🧘‍♂", tts: "man in lotus position" },
UnicodeAnnotation { codepoint: "🧘‍♀", tts: "woman in lotus position" },
UnicodeAnnotation { codepoint: "🛀", tts: "person taking bath" },
UnicodeAnnotation { codepoint: "🛌", tts: "person in bed" },
UnicodeAnnotation { codepoint: "🧑‍🤝‍🧑", tts: "people holding hands" },
UnicodeAnnotation { codepoint: "👭", tts: "women holding hands" },
UnicodeAnnotation { codepoint: "👫", tts: "woman and man holding hands" },
UnicodeAnnotation { codepoint: "👬", tts: "men holding hands" },
UnicodeAnnotation { codepoint: "💏", tts: "kiss" },
UnicodeAnnotation { codepoint: "💑", tts: "couple with heart" },
UnicodeAnnotation { codepoint: "🗣", tts: "speaking head" },
UnicodeAnnotation { codepoint: "👤", tts: "bust in silhouette" },
UnicodeAnnotation { codepoint: "👥", tts: "busts in silhouette" },
UnicodeAnnotation { codepoint: "👪", tts: "family" },
UnicodeAnnotation { codepoint: "🧑‍🧑‍🧒", tts: "family: adult, adult, child" },
UnicodeAnnotation { codepoint: "🧑‍🧑‍🧒‍🧒", tts: "family: adult, adult, child, child" },
UnicodeAnnotation { codepoint: "🧑‍🧒", tts: "family: adult, child" },
UnicodeAnnotation { codepoint: "🧑‍🧒‍🧒", tts: "family: adult, child, child" },
UnicodeAnnotation { codepoint: "👣", tts: "footprints" },
UnicodeAnnotation { codepoint: "🐵", tts: "monkey face" },
UnicodeAnnotation { codepoint: "🐒", tts: "monkey" },
UnicodeAnnotation { codepoint: "🦍", tts: "gorilla" },
UnicodeAnnotation { codepoint: "🐶", tts: "dog face" },
UnicodeAnnotation { codepoint: "🐕", tts: "dog" },
UnicodeAnnotation { codepoint: "🐕‍🦺", tts: "service dog" },
UnicodeAnnotation { codepoint: "🐩", tts: "poodle" },
UnicodeAnnotation { codepoint: "🐺", tts: "wolf" },
UnicodeAnnotation { codepoint: "🦊", tts: "fox" },
UnicodeAnnotation { codepoint: "🐱", tts: "cat face" },
UnicodeAnnotation { codepoint: "🐈", tts: "cat" },
UnicodeAnnotation { codepoint: "🐈‍⬛", tts: "black cat" },
UnicodeAnnotation { codepoint: "🦁", tts: "lion" },
UnicodeAnnotation { codepoint: "🐯", tts: "tiger face" },
UnicodeAnnotation { codepoint: "🐅", tts: "tiger" },
UnicodeAnnotation { codepoint: "🐆", tts: "leopard" },
UnicodeAnnotation { codepoint: "🐴", tts: "horse face" },
UnicodeAnnotation { codepoint: "🐎", tts: "horse" },
UnicodeAnnotation { codepoint: "🦄", tts: "unicorn" },
UnicodeAnnotation { codepoint: "🦓", tts: "zebra" },
UnicodeAnnotation { codepoint: "🦌", tts: "deer" },
UnicodeAnnotation { codepoint: "🐮", tts: "cow face" },
UnicodeAnnotation { codepoint: "🐂", tts: "ox" },
UnicodeAnnotation { codepoint: "🐃", tts: "water buffalo" },
UnicodeAnnotation { codepoint: "🐄", tts: "cow" },
UnicodeAnnotation { codepoint: "🐷", tts: "pig face" },
UnicodeAnnotation { codepoint: "🐖", tts: "pig" },
UnicodeAnnotation { codepoint: "🐗", tts: "boar" },
UnicodeAnnotation { codepoint: "🐽", tts: "pig nose" },
UnicodeAnnotation { codepoint: "🐏", tts: "ram" },
UnicodeAnnotation { codepoint: "🐑", tts: "ewe" },
UnicodeAnnotation { codepoint: "🐐", tts: "goat" },
UnicodeAnnotation { codepoint: "🐪", tts: "camel" },
UnicodeAnnotation { codepoint: "🐫", tts: "two-hump camel" },
UnicodeAnnotation { codepoint: "🦒", tts: "giraffe" },
UnicodeAnnotation { codepoint: "🐘", tts: "elephant" },
UnicodeAnnotation { codepoint: "🦏", tts: "rhinoceros" },
UnicodeAnnotation { codepoint: "🐭", tts: "mouse face" },
UnicodeAnnotation { codepoint: "🐁", tts: "mouse" },
UnicodeAnnotation { codepoint: "🐀", tts: "rat" },
UnicodeAnnotation { codepoint: "🐹", tts: "hamster" },
UnicodeAnnotation { codepoint: "🐰", tts: "rabbit face" },
UnicodeAnnotation { codepoint: "🐇", tts: "rabbit" },
UnicodeAnnotation { codepoint: "🐿", tts: "chipmunk" },
UnicodeAnnotation { codepoint: "🦔", tts: "hedgehog" },
UnicodeAnnotation { codepoint: "🦇", tts: "bat" },
UnicodeAnnotation { codepoint: "🐻", tts: "bear" },
UnicodeAnnotation { codepoint: "🐻‍❄", tts: "polar bear" },
UnicodeAnnotation { codepoint: "🐨", tts: "koala" },
UnicodeAnnotation { codepoint: "🐼", tts: "panda" },
UnicodeAnnotation { codepoint: "🐾", tts: "paw prints" },
UnicodeAnnotation { codepoint: "🦃", tts: "turkey" },
UnicodeAnnotation { codepoint: "🐔", tts: "chicken" },
UnicodeAnnotation { codepoint: "🐓", tts: "rooster" },
UnicodeAnnotation { codepoint: "🐣", tts: "hatching chick" },
UnicodeAnnotation { codepoint: "🐤", tts: "baby chick" },
UnicodeAnnotation { codepoint: "🐥", tts: "front-facing baby chick" },
UnicodeAnnotation { codepoint: "🐦", tts: "bird" },
UnicodeAnnotation { codepoint: "🐧", tts: "penguin" },
UnicodeAnnotation { codepoint: "🕊", tts: "dove" },
UnicodeAnnotation { codepoint: "🦅", tts: "eagle" },
UnicodeAnnotation { codepoint: "🦆", tts: "duck" },
UnicodeAnnotation { codepoint: "🦉", tts: "owl" },
UnicodeAnnotation { codepoint: "🐦‍⬛", tts: "black bird" },
UnicodeAnnotation { codepoint: "🐦‍🔥", tts: "phoenix" },
UnicodeAnnotation { codepoint: "🐸", tts: "frog" },
UnicodeAnnotation { codepoint: "🐊", tts: "crocodile" },
UnicodeAnnotation { codepoint: "🐢", tts: "turtle" },
UnicodeAnnotation { codepoint: "🦎", tts: "lizard" },
UnicodeAnnotation { codepoint: "🐍", tts: "snake" },
UnicodeAnnotation { codepoint: "🐲", tts: "dragon face" },
UnicodeAnnotation { codepoint: "🐉", tts: "dragon" },
UnicodeAnnotation { codepoint: "🦕", tts: "sauropod" },
UnicodeAnnotation { codepoint: "🦖", tts: "T-Rex" },
UnicodeAnnotation { codepoint: "🐳", tts: "spouting whale" },
UnicodeAnnotation { codepoint: "🐋", tts: "whale" },
UnicodeAnnotation { codepoint: "🐬", tts: "dolphin" },
UnicodeAnnotation { codepoint: "🐟", tts: "fish" },
UnicodeAnnotation { codepoint: "🐠", tts: "tropical fish" },
UnicodeAnnotation { codepoint: "🐡", tts: "blowfish" },
UnicodeAnnotation { codepoint: "🦈", tts: "shark" },
UnicodeAnnotation { codepoint: "🐙", tts: "octopus" },
UnicodeAnnotation { codepoint: "🐚", tts: "spiral shell" },
UnicodeAnnotation { codepoint: "🐌", tts: "snail" },
UnicodeAnnotation { codepoint: "🦋", tts: "butterfly" },
UnicodeAnnotation { codepoint: "🐛", tts: "bug" },
UnicodeAnnotation { codepoint: "🐜", tts: "ant" },
UnicodeAnnotation { codepoint: "🐝", tts: "honeybee" },
UnicodeAnnotation { codepoint: "🐞", tts: "lady beetle" },
UnicodeAnnotation { codepoint: "🦗", tts: "cricket" },
UnicodeAnnotation { codepoint: "🕷", tts: "spider" },
UnicodeAnnotation { codepoint: "🕸", tts: "spider web" },
UnicodeAnnotation { codepoint: "🦂", tts: "scorpion" },
UnicodeAnnotation { codepoint: "💐", tts: "bouquet" },
UnicodeAnnotation { codepoint: "🌸", tts: "cherry blossom" },
UnicodeAnnotation { codepoint: "💮", tts: "white flower" },
UnicodeAnnotation { codepoint: "🏵", tts: "rosette" },
UnicodeAnnotation { codepoint: "🌹", tts: "rose" },
UnicodeAnnotation { codepoint: "🥀", tts: "wilted flower" },
UnicodeAnnotation { codepoint: "🌺", tts: "hibiscus" },
UnicodeAnnotation { codepoint: "🌻", tts: "sunflower" },
UnicodeAnnotation { codepoint: "🌼", tts: "blossom" },
UnicodeAnnotation { codepoint: "🌷", tts: "tulip" },
UnicodeAnnotation { codepoint: "🌱", tts: "seedling" },
UnicodeAnnotation { codepoint: "🌲", tts: "evergreen tree" },
UnicodeAnnotation { codepoint: "🌳", tts: "deciduous tree" },
UnicodeAnnotation { codepoint: "🌴", tts: "palm tree" },
UnicodeAnnotation { codepoint: "🌵", tts: "cactus" },
UnicodeAnnotation { codepoint: "🌾", tts: "sheaf of rice" },
UnicodeAnnotation { codepoint: "🌿", tts: "herb" },
UnicodeAnnotation { codepoint: "☘", tts: "shamrock" },
UnicodeAnnotation { codepoint: "🍀", tts: "four leaf clover" },
UnicodeAnnotation { codepoint: "🍁", tts: "maple leaf" },
UnicodeAnnotation { codepoint: "🍂", tts: "fallen leaf" },
UnicodeAnnotation { codepoint: "🍃", tts: "leaf fluttering in wind" },
UnicodeAnnotation { codepoint: "🍄", tts: "mushroom" },
UnicodeAnnotation { codepoint: "🍇", tts: "grapes" },
UnicodeAnnotation { codepoint: "🍈", tts: "melon" },
UnicodeAnnotation { codepoint: "🍉", tts: "watermelon" },
UnicodeAnnotation { codepoint: "🍊", tts: "tangerine" },
UnicodeAnnotation { codepoint: "🍋", tts: "lemon" },
UnicodeAnnotation { codepoint: "🍋‍🟩", tts: "lime" },
UnicodeAnnotation { codepoint: "🍌", tts: "banana" },
UnicodeAnnotation { codepoint: "🍍", tts: "pineapple" },
UnicodeAnnotation { codepoint: "🍎", tts: "red apple" },
UnicodeAnnotation { codepoint: "🍏", tts: "green apple" },
UnicodeAnnotation { codepoint: "🍐", tts: "pear" },
UnicodeAnnotation { codepoint: "🍑", tts: "peach" },
UnicodeAnnotation { codepoint: "🍒", tts: "cherries" },
UnicodeAnnotation { codepoint: "🍓", tts: "strawberry" },
UnicodeAnnotation { codepoint: "🥝", tts: "kiwi fruit" },
UnicodeAnnotation { codepoint: "🍅", tts: "tomato" },
UnicodeAnnotation { codepoint: "🥥", tts: "coconut" },
UnicodeAnnotation { codepoint: "🥑", tts: "avocado" },
UnicodeAnnotation { codepoint: "🍆", tts: "eggplant" },
UnicodeAnnotation { codepoint: "🥔", tts: "potato" },
UnicodeAnnotation { codepoint: "🥕", tts: "carrot" },
UnicodeAnnotation { codepoint: "🌽", tts: "ear of corn" },
UnicodeAnnotation { codepoint: "🌶", tts: "hot pepper" },
UnicodeAnnotation { codepoint: "🥒", tts: "cucumber" },
UnicodeAnnotation { codepoint: "🥦", tts: "broccoli" },
UnicodeAnnotation { codepoint: "🥜", tts: "peanuts" },
UnicodeAnnotation { codepoint: "🌰", tts: "chestnut" },
UnicodeAnnotation { codepoint: "🍄‍🟫", tts: "brown mushroom" },
UnicodeAnnotation { codepoint: "🍞", tts: "bread" },
UnicodeAnnotation { codepoint: "🥐", tts: "croissant" },
UnicodeAnnotation { codepoint: "🥖", tts: "baguette bread" },
UnicodeAnnotation { codepoint: "🥨", tts: "pretzel" },
UnicodeAnnotation { codepoint: "🥞", tts: "pancakes" },
UnicodeAnnotation { codepoint: "🧀", tts: "cheese wedge" },
UnicodeAnnotation { codepoint: "🍖", tts: "meat on bone" },
UnicodeAnnotation { codepoint: "🍗", tts: "poultry leg" },
UnicodeAnnotation { codepoint: "🥩", tts: "cut of meat" },
UnicodeAnnotation { codepoint: "🥓", tts: "bacon" },
UnicodeAnnotation { codepoint: "🍔", tts: "hamburger" },
UnicodeAnnotation { codepoint: "🍟", tts: "french fries" },
UnicodeAnnotation { codepoint: "🍕", tts: "pizza" },
UnicodeAnnotation { codepoint: "🌭", tts: "hot dog" },
UnicodeAnnotation { codepoint: "🥪", tts: "sandwich" },
UnicodeAnnotation { codepoint: "🌮", tts: "taco" },
UnicodeAnnotation { codepoint: "🌯", tts: "burrito" },
UnicodeAnnotation { codepoint: "🥙", tts: "stuffed flatbread" },
UnicodeAnnotation { codepoint: "🥚", tts: "egg" },
UnicodeAnnotation { codepoint: "🍳", tts: "cooking" },
UnicodeAnnotation { codepoint: "🥘", tts: "shallow pan of food" },
UnicodeAnnotation { codepoint: "🍲", tts: "pot of food" },
UnicodeAnnotation { codepoint: "🥣", tts: "bowl with spoon" },
UnicodeAnnotation { codepoint: "🥗", tts: "green salad" },
UnicodeAnnotation { codepoint: "🍿", tts: "popcorn" },
UnicodeAnnotation { codepoint: "🥫", tts: "canned food" },
UnicodeAnnotation { codepoint: "🍱", tts: "bento box" },
UnicodeAnnotation { codepoint: "🍘", tts: "rice cracker" },
UnicodeAnnotation { codepoint: "🍙", tts: "rice ball" },
UnicodeAnnotation { codepoint: "🍚", tts: "cooked rice" },
UnicodeAnnotation { codepoint: "🍛", tts: "curry rice" },
UnicodeAnnotation { codepoint: "🍜", tts: "steaming bowl" },
UnicodeAnnotation { codepoint: "🍝", tts: "spaghetti" },
UnicodeAnnotation { codepoint: "🍠", tts: "roasted sweet potato" },
UnicodeAnnotation { codepoint: "🍢", tts: "oden" },
UnicodeAnnotation { codepoint: "🍣", tts: "sushi" },
UnicodeAnnotation { codepoint: "🍤", tts: "fried shrimp" },
UnicodeAnnotation { codepoint: "🍥", tts: "fish cake with swirl" },
UnicodeAnnotation { codepoint: "🍡", tts: "dango" },
UnicodeAnnotation { codepoint: "🥟", tts: "dumpling" },
UnicodeAnnotation { codepoint: "🥠", tts: "fortune cookie" },
UnicodeAnnotation { codepoint: "🥡", tts: "takeout box" },
UnicodeAnnotation { codepoint: "🦀", tts: "crab" },
UnicodeAnnotation { codepoint: "🦐", tts: "shrimp" },
UnicodeAnnotation { codepoint: "🦑", tts: "squid" },
UnicodeAnnotation { codepoint: "🍦", tts: "soft ice cream" },
UnicodeAnnotation { codepoint: "🍧", tts: "shaved ice" },
UnicodeAnnotation { codepoint: "🍨", tts: "ice cream" },
UnicodeAnnotation { codepoint: "🍩", tts: "doughnut" },
UnicodeAnnotation { codepoint: "🍪", tts: "cookie" },
UnicodeAnnotation { codepoint: "🎂", tts: "birthday cake" },
UnicodeAnnotation { codepoint: "🍰", tts: "shortcake" },
UnicodeAnnotation { codepoint: "🥧", tts: "pie" },
UnicodeAnnotation { codepoint: "🍫", tts: "chocolate bar" },
UnicodeAnnotation { codepoint: "🍬", tts: "candy" },
UnicodeAnnotation { codepoint: "🍭", tts: "lollipop" },
UnicodeAnnotation { codepoint: "🍮", tts: "custard" },
UnicodeAnnotation { codepoint: "🍯", tts: "honey pot" },
UnicodeAnnotation { codepoint: "🍼", tts: "baby bottle" },
UnicodeAnnotation { codepoint: "🥛", tts: "glass of milk" },
UnicodeAnnotation { codepoint: "☕", tts: "hot beverage" },
UnicodeAnnotation { codepoint: "🍵", tts: "teacup without handle" },
UnicodeAnnotation { codepoint: "🍶", tts: "sake" },
UnicodeAnnotation { codepoint: "🍾", tts: "bottle with popping cork" },
UnicodeAnnotation { codepoint: "🍷", tts: "wine glass" },
UnicodeAnnotation { codepoint: "🍸", tts: "cocktail glass" },
UnicodeAnnotation { codepoint: "🍹", tts: "tropical drink" },
UnicodeAnnotation { codepoint: "🍺", tts: "beer mug" },
UnicodeAnnotation { codepoint: "🍻", tts: "clinking beer mugs" },
UnicodeAnnotation { codepoint: "🥂", tts: "clinking glasses" },
UnicodeAnnotation { codepoint: "🥃", tts: "tumbler glass" },
UnicodeAnnotation { codepoint: "🥤", tts: "cup with straw" },
UnicodeAnnotation { codepoint: "🥢", tts: "chopsticks" },
UnicodeAnnotation { codepoint: "🍽", tts: "fork and knife with plate" },
UnicodeAnnotation { codepoint: "🍴", tts: "fork and knife" },
UnicodeAnnotation { codepoint: "🥄", tts: "spoon" },
UnicodeAnnotation { codepoint: "🔪", tts: "kitchen knife" },
UnicodeAnnotation { codepoint: "🏺", tts: "amphora" },
UnicodeAnnotation { codepoint: "🌍", tts: "globe showing Europe-Africa" },
UnicodeAnnotation { codepoint: "🌎", tts: "globe showing Americas" },
UnicodeAnnotation { codepoint: "🌏", tts: "globe showing Asia-Australia" },
UnicodeAnnotation { codepoint: "🌐", tts: "globe with meridians" },
UnicodeAnnotation { codepoint: "🗺", tts: "world map" },
UnicodeAnnotation { codepoint: "🗾", tts: "map of Japan" },
UnicodeAnnotation { codepoint: "🏔", tts: "snow-capped mountain" },
UnicodeAnnotation { codepoint: "⛰", tts: "mountain" },
UnicodeAnnotation { codepoint: "🌋", tts: "volcano" },
UnicodeAnnotation { codepoint: "🗻", tts: "mount fuji" },
UnicodeAnnotation { codepoint: "🏕", tts: "camping" },
UnicodeAnnotation { codepoint: "🏖", tts: "beach with umbrella" },
UnicodeAnnotation { codepoint: "🏜", tts: "desert" },
UnicodeAnnotation { codepoint: "🏝", tts: "desert island" },
UnicodeAnnotation { codepoint: "🏞", tts: "national park" },
UnicodeAnnotation { codepoint: "🏟", tts: "stadium" },
UnicodeAnnotation { codepoint: "🏛", tts: "classical building" },
UnicodeAnnotation { codepoint: "🏗", tts: "building construction" },
UnicodeAnnotation { codepoint: "🏘", tts: "houses" },
UnicodeAnnotation { codepoint: "🏚", tts: "derelict house" },
UnicodeAnnotation { codepoint: "🏠", tts: "house" },
UnicodeAnnotation { codepoint: "🏡", tts: "house with garden" },
UnicodeAnnotation { codepoint: "🏢", tts: "office building" },
UnicodeAnnotation { codepoint: "🏣", tts: "Japanese post office" },
UnicodeAnnotation { codepoint: "🏤", tts: "post office" },
UnicodeAnnotation { codepoint: "🏥", tts: "hospital" },
UnicodeAnnotation { codepoint: "🏦", tts: "bank" },
UnicodeAnnotation { codepoint: "🏨", tts: "hotel" },
UnicodeAnnotation { codepoint: "🏩", tts: "love hotel" },
UnicodeAnnotation { codepoint: "🏪", tts: "convenience store" },
UnicodeAnnotation { codepoint: "🏫", tts: "school" },
UnicodeAnnotation { codepoint: "🏬", tts: "department store" },
UnicodeAnnotation { codepoint: "🏭", tts: "factory" },
UnicodeAnnotation { codepoint: "🏯", tts: "Japanese castle" },
UnicodeAnnotation { codepoint: "🏰", tts: "castle" },
UnicodeAnnotation { codepoint: "💒", tts: "wedding" },
UnicodeAnnotation { codepoint: "🗼", tts: "Tokyo tower" },
UnicodeAnnotation { codepoint: "🗽", tts: "Statue of Liberty" },
UnicodeAnnotation { codepoint: "⛪", tts: "church" },
UnicodeAnnotation { codepoint: "🕌", tts: "mosque" },
UnicodeAnnotation { codepoint: "🕍", tts: "synagogue" },
UnicodeAnnotation { codepoint: "⛩", tts: "shinto shrine" },
UnicodeAnnotation { codepoint: "🕋", tts: "kaaba" },
UnicodeAnnotation { codepoint: "⛲", tts: "fountain" },
UnicodeAnnotation { codepoint: "⛺", tts: "tent" },
UnicodeAnnotation { codepoint: "🌁", tts: "foggy" },
UnicodeAnnotation { codepoint: "🌃", tts: "night with stars" },
UnicodeAnnotation { codepoint: "🏙", tts: "cityscape" },
UnicodeAnnotation { codepoint: "🌄", tts: "sunrise over mountains" },
UnicodeAnnotation { codepoint: "🌅", tts: "sunrise" },
UnicodeAnnotation { codepoint: "🌆", tts: "cityscape at dusk" },
UnicodeAnnotation { codepoint: "🌇", tts: "sunset" },
UnicodeAnnotation { codepoint: "🌉", tts: "bridge at night" },
UnicodeAnnotation { codepoint: "♨", tts: "hot springs" },
UnicodeAnnotation { codepoint: "🎠", tts: "carousel horse" },
UnicodeAnnotation { codepoint: "🎡", tts: "ferris wheel" },
UnicodeAnnotation { codepoint: "🎢", tts: "roller coaster" },
UnicodeAnnotation { codepoint: "💈", tts: "barber pole" },
UnicodeAnnotation { codepoint: "🎪", tts: "circus tent" },
UnicodeAnnotation { codepoint: "🚂", tts: "locomotive" },
UnicodeAnnotation { codepoint: "🚃", tts: "railway car" },
UnicodeAnnotation { codepoint: "🚄", tts: "high-speed train" },
UnicodeAnnotation { codepoint: "🚅", tts: "bullet train" },
UnicodeAnnotation { codepoint: "🚆", tts: "train" },
UnicodeAnnotation { codepoint: "🚇", tts: "metro" },
UnicodeAnnotation { codepoint: "🚈", tts: "light rail" },
UnicodeAnnotation { codepoint: "🚉", tts: "station" },
UnicodeAnnotation { codepoint: "🚊", tts: "tram" },
UnicodeAnnotation { codepoint: "🚝", tts: "monorail" },
UnicodeAnnotation { codepoint: "🚞", tts: "mountain railway" },
UnicodeAnnotation { codepoint: "🚋", tts: "tram car" },
UnicodeAnnotation { codepoint: "🚌", tts: "bus" },
UnicodeAnnotation { codepoint: "🚍", tts: "oncoming bus" },
UnicodeAnnotation { codepoint: "🚎", tts: "trolleybus" },
UnicodeAnnotation { codepoint: "🚐", tts: "minibus" },
UnicodeAnnotation { codepoint: "🚑", tts: "ambulance" },
UnicodeAnnotation { codepoint: "🚒", tts: "fire engine" },
UnicodeAnnotation { codepoint: "🚓", tts: "police car" },
UnicodeAnnotation { codepoint: "🚔", tts: "oncoming police car" },
UnicodeAnnotation { codepoint: "🚕", tts: "taxi" },
UnicodeAnnotation { codepoint: "🚖", tts: "oncoming taxi" },
UnicodeAnnotation { codepoint: "🚗", tts: "automobile" },
UnicodeAnnotation { codepoint: "🚘", tts: "oncoming automobile" },
UnicodeAnnotation { codepoint: "🚙", tts: "sport utility vehicle" },
UnicodeAnnotation { codepoint: "🚚", tts: "delivery truck" },
UnicodeAnnotation { codepoint: "🚛", tts: "articulated lorry" },
UnicodeAnnotation { codepoint: "🚜", tts: "tractor" },
UnicodeAnnotation { codepoint: "🏎", tts: "racing car" },
UnicodeAnnotation { codepoint: "🏍", tts: "motorcycle" },
UnicodeAnnotation { codepoint: "🛵", tts: "motor scooter" },
UnicodeAnnotation { codepoint: "🚲", tts: "bicycle" },
UnicodeAnnotation { codepoint: "🛴", tts: "kick scooter" },
UnicodeAnnotation { codepoint: "🚏", tts: "bus stop" },
UnicodeAnnotation { codepoint: "🛣", tts: "motorway" },
UnicodeAnnotation { codepoint: "🛤", tts: "railway track" },
UnicodeAnnotation { codepoint: "🛢", tts: "oil drum" },
UnicodeAnnotation { codepoint: "⛽", tts: "fuel pump" },
UnicodeAnnotation { codepoint: "🚨", tts: "police car light" },
UnicodeAnnotation { codepoint: "🚥", tts: "horizontal traffic light" },
UnicodeAnnotation { codepoint: "🚦", tts: "vertical traffic light" },
UnicodeAnnotation { codepoint: "🛑", tts: "stop sign" },
UnicodeAnnotation { codepoint: "🚧", tts: "construction" },
UnicodeAnnotation { codepoint: "⚓", tts: "anchor" },
UnicodeAnnotation { codepoint: "⛵", tts: "sailboat" },
UnicodeAnnotation { codepoint: "🛶", tts: "canoe" },
UnicodeAnnotation { codepoint: "🚤", tts: "speedboat" },
UnicodeAnnotation { codepoint: "🛳", tts: "passenger ship" },
UnicodeAnnotation { codepoint: "⛴", tts: "ferry" },
UnicodeAnnotation { codepoint: "🛥", tts: "motor boat" },
UnicodeAnnotation { codepoint: "🚢", tts: "ship" },
UnicodeAnnotation { codepoint: "✈", tts: "airplane" },
UnicodeAnnotation { codepoint: "🛩", tts: "small airplane" },
UnicodeAnnotation { codepoint: "🛫", tts: "airplane departure" },
UnicodeAnnotation { codepoint: "🛬", tts: "airplane arrival" },
UnicodeAnnotation { codepoint: "💺", tts: "seat" },
UnicodeAnnotation { codepoint: "🚁", tts: "helicopter" },
UnicodeAnnotation { codepoint: "🚟", tts: "suspension railway" },
UnicodeAnnotation { codepoint: "🚠", tts: "mountain cableway" },
UnicodeAnnotation { codepoint: "🚡", tts: "aerial tramway" },
UnicodeAnnotation { codepoint: "🛰", tts: "satellite" },
UnicodeAnnotation { codepoint: "🚀", tts: "rocket" },
UnicodeAnnotation { codepoint: "🛸", tts: "flying saucer" },
UnicodeAnnotation { codepoint: "🛎", tts: "bellhop bell" },
UnicodeAnnotation { codepoint: "⌛", tts: "hourglass done" },
UnicodeAnnotation { codepoint: "⏳", tts: "hourglass not done" },
UnicodeAnnotation { codepoint: "⌚", tts: "watch" },
UnicodeAnnotation { codepoint: "⏰", tts: "alarm clock" },
UnicodeAnnotation { codepoint: "⏱", tts: "stopwatch" },
UnicodeAnnotation { codepoint: "⏲", tts: "timer clock" },
UnicodeAnnotation { codepoint: "🕰", tts: "mantelpiece clock" },
UnicodeAnnotation { codepoint: "🕛", tts: "twelve o’clock" },
UnicodeAnnotation { codepoint: "🕧", tts: "twelve-thirty" },
UnicodeAnnotation { codepoint: "🕐", tts: "one o’clock" },
UnicodeAnnotation { codepoint: "🕜", tts: "one-thirty" },
UnicodeAnnotation { codepoint: "🕑", tts: "two o’clock" },
UnicodeAnnotation { codepoint: "🕝", tts: "two-thirty" },
UnicodeAnnotation { codepoint: "🕒", tts: "three o’clock" },
UnicodeAnnotation { codepoint: "🕞", tts: "three-thirty" },
UnicodeAnnotation { codepoint: "🕓", tts: "four o’clock" },
UnicodeAnnotation { codepoint: "🕟", tts: "four-thirty" },
UnicodeAnnotation { codepoint: "🕔", tts: "five o’clock" },
UnicodeAnnotation { codepoint: "🕠", tts: "five-thirty" },
UnicodeAnnotation { codepoint: "🕕", tts: "six o’clock" },
UnicodeAnnotation { codepoint: "🕡", tts: "six-thirty" },
UnicodeAnnotation { codepoint: "🕖", tts: "seven o’clock" },
UnicodeAnnotation { codepoint: "🕢", tts: "seven-thirty" },
UnicodeAnnotation { codepoint: "🕗", tts: "eight o’clock" },
UnicodeAnnotation { codepoint: "🕣", tts: "eight-thirty" },
UnicodeAnnotation { codepoint: "🕘", tts: "nine o’clock" },
UnicodeAnnotation { codepoint: "🕤", tts: "nine-thirty" },
UnicodeAnnotation { codepoint: "🕙", tts: "ten o’clock" },
UnicodeAnnotation { codepoint: "🕥", tts: "ten-thirty" },
UnicodeAnnotation { codepoint: "🕚", tts: "eleven o’clock" },
UnicodeAnnotation { codepoint: "🕦", tts: "eleven-thirty" },
UnicodeAnnotation { codepoint: "🌑", tts: "new moon" },
UnicodeAnnotation { codepoint: "🌒", tts: "waxing crescent moon" },
UnicodeAnnotation { codepoint: "🌓", tts: "first quarter moon" },
UnicodeAnnotation { codepoint: "🌔", tts: "waxing gibbous moon" },
UnicodeAnnotation { codepoint: "🌕", tts: "full moon" },
UnicodeAnnotation { codepoint: "🌖", tts: "waning gibbous moon" },
UnicodeAnnotation { codepoint: "🌗", tts: "last quarter moon" },
UnicodeAnnotation { codepoint: "🌘", tts: "waning crescent moon" },
UnicodeAnnotation { codepoint: "🌙", tts: "crescent moon" },
UnicodeAnnotation { codepoint: "🌚", tts: "new moon face" },
UnicodeAnnotation { codepoint: "🌛", tts: "first quarter moon face" },
UnicodeAnnotation { codepoint: "🌜", tts: "last quarter moon face" },
UnicodeAnnotation { codepoint: "🌡", tts: "thermometer" },
UnicodeAnnotation { codepoint: "☀", tts: "sun" },
UnicodeAnnotation { codepoint: "🌝", tts: "full moon face" },
UnicodeAnnotation { codepoint: "🌞", tts: "sun with face" },
UnicodeAnnotation { codepoint: "⭐", tts: "star" },
UnicodeAnnotation { codepoint: "🌟", tts: "glowing star" },
UnicodeAnnotation { codepoint: "🌠", tts: "shooting star" },
UnicodeAnnotation { codepoint: "🌌", tts: "milky way" },
UnicodeAnnotation { codepoint: "☁", tts: "cloud" },
UnicodeAnnotation { codepoint: "⛅", tts: "sun behind cloud" },
UnicodeAnnotation { codepoint: "⛈", tts: "cloud with lightning and rain" },
UnicodeAnnotation { codepoint: "🌤", tts: "sun behind small cloud" },
UnicodeAnnotation { codepoint: "🌥", tts: "sun behind large cloud" },
UnicodeAnnotation { codepoint: "🌦", tts: "sun behind rain cloud" },
UnicodeAnnotation { codepoint: "🌧", tts: "cloud with rain" },
UnicodeAnnotation { codepoint: "🌨", tts: "cloud with snow" },
UnicodeAnnotation { codepoint: "🌩", tts: "cloud with lightning" },
UnicodeAnnotation { codepoint: "🌪", tts: "tornado" },
UnicodeAnnotation { codepoint: "🌫", tts: "fog" },
UnicodeAnnotation { codepoint: "🌬", tts: "wind face" },
UnicodeAnnotation { codepoint: "🌀", tts: "cyclone" },
UnicodeAnnotation { codepoint: "🌈", tts: "rainbow" },
UnicodeAnnotation { codepoint: "🌂", tts: "closed umbrella" },
UnicodeAnnotation { codepoint: "☂", tts: "umbrella" },
UnicodeAnnotation { codepoint: "☔", tts: "umbrella with rain drops" },
UnicodeAnnotation { codepoint: "⛱", tts: "umbrella on ground" },
UnicodeAnnotation { codepoint: "⚡", tts: "high voltage" },
UnicodeAnnotation { codepoint: "❄", tts: "snowflake" },
UnicodeAnnotation { codepoint: "☃", tts: "snowman" },
UnicodeAnnotation { codepoint: "⛄", tts: "snowman without snow" },
UnicodeAnnotation { codepoint: "☄", tts: "comet" },
UnicodeAnnotation { codepoint: "🔥", tts: "fire" },
UnicodeAnnotation { codepoint: "💧", tts: "droplet" },
UnicodeAnnotation { codepoint: "🌊", tts: "water wave" },
UnicodeAnnotation { codepoint: "🎃", tts: "jack-o-lantern" },
UnicodeAnnotation { codepoint: "🎄", tts: "Christmas tree" },
UnicodeAnnotation { codepoint: "🎆", tts: "fireworks" },
UnicodeAnnotation { codepoint: "🎇", tts: "sparkler" },
UnicodeAnnotation { codepoint: "✨", tts: "sparkles" },
UnicodeAnnotation { codepoint: "🎈", tts: "balloon" },
UnicodeAnnotation { codepoint: "🎉", tts: "party popper" },
UnicodeAnnotation { codepoint: "🎊", tts: "confetti ball" },
UnicodeAnnotation { codepoint: "🎋", tts: "tanabata tree" },
UnicodeAnnotation { codepoint: "🎍", tts: "pine decoration" },
UnicodeAnnotation { codepoint: "🎎", tts: "Japanese dolls" },
UnicodeAnnotation { codepoint: "🎏", tts: "carp streamer" },
UnicodeAnnotation { codepoint: "🎐", tts: "wind chime" },
UnicodeAnnotation { codepoint: "🎑", tts: "moon viewing ceremony" },
UnicodeAnnotation { codepoint: "🎀", tts: "ribbon" },
UnicodeAnnotation { codepoint: "🎁", tts: "wrapped gift" },
UnicodeAnnotation { codepoint: "🎗", tts: "reminder ribbon" },
UnicodeAnnotation { codepoint: "🎟", tts: "admission tickets" },
UnicodeAnnotation { codepoint: "🎫", tts: "ticket" },
UnicodeAnnotation { codepoint: "🎖", tts: "military medal" },
UnicodeAnnotation { codepoint: "🏆", tts: "trophy" },
UnicodeAnnotation { codepoint: "🏅", tts: "sports medal" },
UnicodeAnnotation { codepoint: "🥇", tts: "1st place medal" },
UnicodeAnnotation { codepoint: "🥈", tts: "2nd place medal" },
UnicodeAnnotation { codepoint: "🥉", tts: "3rd place medal" },
UnicodeAnnotation { codepoint: "⚽", tts: "soccer ball" },
UnicodeAnnotation { codepoint: "⚾", tts: "baseball" },
UnicodeAnnotation { codepoint: "🏀", tts: "basketball" },
UnicodeAnnotation { codepoint: "🏐", tts: "volleyball" },
UnicodeAnnotation { codepoint: "🏈", tts: "american football" },
UnicodeAnnotation { codepoint: "🏉", tts: "rugby football" },
UnicodeAnnotation { codepoint: "🎾", tts: "tennis" },
UnicodeAnnotation { codepoint: "🎳", tts: "bowling" },
UnicodeAnnotation { codepoint: "🏏", tts: "cricket game" },
UnicodeAnnotation { codepoint: "🏑", tts: "field hockey" },
UnicodeAnnotation { codepoint: "🏒", tts: "ice hockey" },
UnicodeAnnotation { codepoint: "🏓", tts: "ping pong" },
UnicodeAnnotation { codepoint: "🏸", tts: "badminton" },
UnicodeAnnotation { codepoint: "🥊", tts: "boxing glove" },
UnicodeAnnotation { codepoint: "🥋", tts: "martial arts uniform" },
UnicodeAnnotation { codepoint: "🥅", tts: "goal net" },
UnicodeAnnotation { codepoint: "⛳", tts: "flag in hole" },
UnicodeAnnotation { codepoint: "⛸", tts: "ice skate" },
UnicodeAnnotation { codepoint: "🎣", tts: "fishing pole" },
UnicodeAnnotation { codepoint: "🎽", tts: "running shirt" },
UnicodeAnnotation { codepoint: "🎿", tts: "skis" },
UnicodeAnnotation { codepoint: "🛷", tts: "sled" },
UnicodeAnnotation { codepoint: "🥌", tts: "curling stone" },
UnicodeAnnotation { codepoint: "🎯", tts: "bullseye" },
UnicodeAnnotation { codepoint: "🔫", tts: "water pistol" },
UnicodeAnnotation { codepoint: "🎱", tts: "pool 8 ball" },
UnicodeAnnotation { codepoint: "🔮", tts: "crystal ball" },
UnicodeAnnotation { codepoint: "🎮", tts: "video game" },
UnicodeAnnotation { codepoint: "🕹", tts: "joystick" },
UnicodeAnnotation { codepoint: "🎰", tts: "slot machine" },
UnicodeAnnotation { codepoint: "🎲", tts: "game die" },
UnicodeAnnotation { codepoint: "♠", tts: "spade suit" },
UnicodeAnnotation { codepoint: "♥", tts: "heart suit" },
UnicodeAnnotation { codepoint: "♦", tts: "diamond suit" },
UnicodeAnnotation { codepoint: "♣", tts: "club suit" },
UnicodeAnnotation { codepoint: "🃏", tts: "joker" },
UnicodeAnnotation { codepoint: "🀄", tts: "mahjong red dragon" },
UnicodeAnnotation { codepoint: "🎴", tts: "flower playing cards" },
UnicodeAnnotation { codepoint: "🎭", tts: "performing arts" },
UnicodeAnnotation { codepoint: "🖼", tts: "framed picture" },
UnicodeAnnotation { codepoint: "🎨", tts: "artist palette" },
UnicodeAnnotation { codepoint: "👓", tts: "glasses" },
UnicodeAnnotation { codepoint: "🕶", tts: "sunglasses" },
UnicodeAnnotation { codepoint: "👔", tts: "necktie" },
UnicodeAnnotation { codepoint: "👕", tts: "t-shirt" },
UnicodeAnnotation { codepoint: "👖", tts: "jeans" },
UnicodeAnnotation { codepoint: "🧣", tts: "scarf" },
UnicodeAnnotation { codepoint: "🧤", tts: "gloves" },
UnicodeAnnotation { codepoint: "🧥", tts: "coat" },
UnicodeAnnotation { codepoint: "🧦", tts: "socks" },
UnicodeAnnotation { codepoint: "👗", tts: "dress" },
UnicodeAnnotation { codepoint: "👘", tts: "kimono" },
UnicodeAnnotation { codepoint: "👙", tts: "bikini" },
UnicodeAnnotation { codepoint: "👚", tts: "woman’s clothes" },
UnicodeAnnotation { codepoint: "👛", tts: "purse" },
UnicodeAnnotation { codepoint: "👜", tts: "handbag" },
UnicodeAnnotation { codepoint: "👝", tts: "clutch bag" },
UnicodeAnnotation { codepoint: "🛍", tts: "shopping bags" },
UnicodeAnnotation { codepoint: "🎒", tts: "backpack" },
UnicodeAnnotation { codepoint: "👞", tts: "man’s shoe" },
UnicodeAnnotation { codepoint: "👟", tts: "running shoe" },
UnicodeAnnotation { codepoint: "👠", tts: "high-heeled shoe" },
UnicodeAnnotation { codepoint: "👡", tts: "woman’s sandal" },
UnicodeAnnotation { codepoint: "👢", tts: "woman’s boot" },
UnicodeAnnotation { codepoint: "👑", tts: "crown" },
UnicodeAnnotation { codepoint: "👒", tts: "woman’s hat" },
UnicodeAnnotation { codepoint: "🎩", tts: "top hat" },
UnicodeAnnotation { codepoint: "🎓", tts: "graduation cap" },
UnicodeAnnotation { codepoint: "🧢", tts: "billed cap" },
UnicodeAnnotation { codepoint: "⛑", tts: "rescue worker’s helmet" },
UnicodeAnnotation { codepoint: "📿", tts: "prayer beads" },
UnicodeAnnotation { codepoint: "💄", tts: "lipstick" },
UnicodeAnnotation { codepoint: "💍", tts: "ring" },
UnicodeAnnotation { codepoint: "💎", tts: "gem stone" },
UnicodeAnnotation { codepoint: "🔇", tts: "muted speaker" },
UnicodeAnnotation { codepoint: "🔈", tts: "speaker low volume" },
UnicodeAnnotation { codepoint: "🔉", tts: "speaker medium volume" },
UnicodeAnnotation { codepoint: "🔊", tts: "speaker high volume" },
UnicodeAnnotation { codepoint: "📢", tts: "loudspeaker" },
UnicodeAnnotation { codepoint: "📣", tts: "megaphone" },
UnicodeAnnotation { codepoint: "📯", tts: "postal horn" },
UnicodeAnnotation { codepoint: "🔔", tts: "bell" },
UnicodeAnnotation { codepoint: "🔕", tts: "bell with slash" },
UnicodeAnnotation { codepoint: "🎼", tts: "musical score" },
UnicodeAnnotation { codepoint: "🎵", tts: "musical note" },
UnicodeAnnotation { codepoint: "🎶", tts: "musical notes" },
UnicodeAnnotation { codepoint: "🎙", tts: "studio microphone" },
UnicodeAnnotation { codepoint: "🎚", tts: "level slider" },
UnicodeAnnotation { codepoint: "🎛", tts: "control knobs" },
UnicodeAnnotation { codepoint: "🎤", tts: "microphone" },
UnicodeAnnotation { codepoint: "🎧", tts: "headphone" },
UnicodeAnnotation { codepoint: "📻", tts: "radio" },
UnicodeAnnotation { codepoint: "🎷", tts: "saxophone" },
UnicodeAnnotation { codepoint: "🎸", tts: "guitar" },
UnicodeAnnotation { codepoint: "🎹", tts: "musical keyboard" },
UnicodeAnnotation { codepoint: "🎺", tts: "trumpet" },
UnicodeAnnotation { codepoint: "🎻", tts: "violin" },
UnicodeAnnotation { codepoint: "🥁", tts: "drum" },
UnicodeAnnotation { codepoint: "📱", tts: "mobile phone" },
UnicodeAnnotation { codepoint: "📲", tts: "mobile phone with arrow" },
UnicodeAnnotation { codepoint: "☎", tts: "telephone" },
UnicodeAnnotation { codepoint: "📞", tts: "telephone receiver" },
UnicodeAnnotation { codepoint: "📟", tts: "pager" },
UnicodeAnnotation { codepoint: "📠", tts: "fax machine" },
UnicodeAnnotation { codepoint: "🔋", tts: "battery" },
UnicodeAnnotation { codepoint: "🔌", tts: "electric plug" },
UnicodeAnnotation { codepoint: "💻", tts: "laptop" },
UnicodeAnnotation { codepoint: "🖥", tts: "desktop computer" },
UnicodeAnnotation { codepoint: "🖨", tts: "printer" },
UnicodeAnnotation { codepoint: "⌨", tts: "keyboard" },
UnicodeAnnotation { codepoint: "🖱", tts: "computer mouse" },
UnicodeAnnotation { codepoint: "🖲", tts: "trackball" },
UnicodeAnnotation { codepoint: "💽", tts: "computer disk" },
UnicodeAnnotation { codepoint: "💾", tts: "floppy disk" },
UnicodeAnnotation { codepoint: "💿", tts: "optical disk" },
UnicodeAnnotation { codepoint: "📀", tts: "dvd" },
UnicodeAnnotation { codepoint: "🎥", tts: "movie camera" },
UnicodeAnnotation { codepoint: "🎞", tts: "film frames" },
UnicodeAnnotation { codepoint: "📽", tts: "film projector" },
UnicodeAnnotation { codepoint: "🎬", tts: "clapper board" },
UnicodeAnnotation { codepoint: "📺", tts: "television" },
UnicodeAnnotation { codepoint: "📷", tts: "camera" },
UnicodeAnnotation { codepoint: "📸", tts: "camera with flash" },
UnicodeAnnotation { codepoint: "📹", tts: "video camera" },
UnicodeAnnotation { codepoint: "📼", tts: "videocassette" },
UnicodeAnnotation { codepoint: "🔍", tts: "magnifying glass tilted left" },
UnicodeAnnotation { codepoint: "🔎", tts: "magnifying glass tilted right" },
UnicodeAnnotation { codepoint: "🕯", tts: "candle" },
UnicodeAnnotation { codepoint: "💡", tts: "light bulb" },
UnicodeAnnotation { codepoint: "🔦", tts: "flashlight" },
UnicodeAnnotation { codepoint: "🏮", tts: "red paper lantern" },
UnicodeAnnotation { codepoint: "📔", tts: "notebook with decorative cover" },
UnicodeAnnotation { codepoint: "📕", tts: "closed book" },
UnicodeAnnotation { codepoint: "📖", tts: "open book" },
UnicodeAnnotation { codepoint: "📗", tts: "green book" },
UnicodeAnnotation { codepoint: "📘", tts: "blue book" },
UnicodeAnnotation { codepoint: "📙", tts: "orange book" },
UnicodeAnnotation { codepoint: "📚", tts: "books" },
UnicodeAnnotation { codepoint: "📓", tts: "notebook" },
UnicodeAnnotation { codepoint: "📒", tts: "ledger" },
UnicodeAnnotation { codepoint: "📃", tts: "page with curl" },
UnicodeAnnotation { codepoint: "📜", tts: "scroll" },
UnicodeAnnotation { codepoint: "📄", tts: "page facing up" },
UnicodeAnnotation { codepoint: "📰", tts: "newspaper" },
UnicodeAnnotation { codepoint: "🗞", tts: "rolled-up newspaper" },
UnicodeAnnotation { codepoint: "📑", tts: "bookmark tabs" },
UnicodeAnnotation { codepoint: "🔖", tts: "bookmark" },
UnicodeAnnotation { codepoint: "🏷", tts: "label" },
UnicodeAnnotation { codepoint: "💰", tts: "money bag" },
UnicodeAnnotation { codepoint: "💴", tts: "yen banknote" },
UnicodeAnnotation { codepoint: "💵", tts: "dollar banknote" },
UnicodeAnnotation { codepoint: "💶", tts: "euro banknote" },
UnicodeAnnotation { codepoint: "💷", tts: "pound banknote" },
UnicodeAnnotation { codepoint: "💸", tts: "money with wings" },
UnicodeAnnotation { codepoint: "💳", tts: "credit card" },
UnicodeAnnotation { codepoint: "💹", tts: "chart increasing with yen" },
UnicodeAnnotation { codepoint: "✉", tts: "envelope" },
UnicodeAnnotation { codepoint: "📧", tts: "e-mail" },
UnicodeAnnotation { codepoint: "📨", tts: "incoming envelope" },
UnicodeAnnotation { codepoint: "📩", tts: "envelope with arrow" },
UnicodeAnnotation { codepoint: "📤", tts: "outbox tray" },
UnicodeAnnotation { codepoint: "📥", tts: "inbox tray" },
UnicodeAnnotation { codepoint: "📦", tts: "package" },
UnicodeAnnotation { codepoint: "📫", tts: "closed mailbox with raised flag" },
UnicodeAnnotation { codepoint: "📪", tts: "closed mailbox with lowered flag" },
UnicodeAnnotation { codepoint: "📬", tts: "open mailbox with raised flag" },
UnicodeAnnotation { codepoint: "📭", tts: "open mailbox with lowered flag" },
UnicodeAnnotation { codepoint: "📮", tts: "postbox" },
UnicodeAnnotation { codepoint: "🗳", tts: "ballot box with ballot" },
UnicodeAnnotation { codepoint: "✏", tts: "pencil" },
UnicodeAnnotation { codepoint: "✒", tts: "black nib" },
UnicodeAnnotation { codepoint: "🖋", tts: "fountain pen" },
UnicodeAnnotation { codepoint: "🖊", tts: "pen" },
UnicodeAnnotation { codepoint: "🖌", tts: "paintbrush" },
UnicodeAnnotation { codepoint: "🖍", tts: "crayon" },
UnicodeAnnotation { codepoint: "📝", tts: "memo" },
UnicodeAnnotation { codepoint: "💼", tts: "briefcase" },
UnicodeAnnotation { codepoint: "📁", tts: "file folder" },
UnicodeAnnotation { codepoint: "📂", tts: "open file folder" },
UnicodeAnnotation { codepoint: "🗂", tts: "card index dividers" },
UnicodeAnnotation { codepoint: "📅", tts: "calendar" },
UnicodeAnnotation { codepoint: "📆", tts: "tear-off calendar" },
UnicodeAnnotation { codepoint: "🗒", tts: "spiral notepad" },
UnicodeAnnotation { codepoint: "🗓", tts: "spiral calendar" },
UnicodeAnnotation { codepoint: "📇", tts: "card index" },
UnicodeAnnotation { codepoint: "📈", tts: "chart increasing" },
UnicodeAnnotation { codepoint: "📉", tts: "chart decreasing" },
UnicodeAnnotation { codepoint: "📊", tts: "bar chart" },
UnicodeAnnotation { codepoint: "📋", tts: "clipboard" },
UnicodeAnnotation { codepoint: "📌", tts: "pushpin" },
UnicodeAnnotation { codepoint: "📍", tts: "round pushpin" },
UnicodeAnnotation { codepoint: "📎", tts: "paperclip" },
UnicodeAnnotation { codepoint: "🖇", tts: "linked paperclips" },
UnicodeAnnotation { codepoint: "📏", tts: "straight ruler" },
UnicodeAnnotation { codepoint: "📐", tts: "triangular ruler" },
UnicodeAnnotation { codepoint: "✂", tts: "scissors" },
UnicodeAnnotation { codepoint: "🗃", tts: "card file box" },
UnicodeAnnotation { codepoint: "🗄", tts: "file cabinet" },
UnicodeAnnotation { codepoint: "🗑", tts: "wastebasket" },
UnicodeAnnotation { codepoint: "🔒", tts: "locked" },
UnicodeAnnotation { codepoint: "🔓", tts: "unlocked" },
UnicodeAnnotation { codepoint: "🔏", tts: "locked with pen" },
UnicodeAnnotation { codepoint: "🔐", tts: "locked with key" },
UnicodeAnnotation { codepoint: "🔑", tts: "key" },
UnicodeAnnotation { codepoint: "🗝", tts: "old key" },
UnicodeAnnotation { codepoint: "🔨", tts: "hammer" },
UnicodeAnnotation { codepoint: "⛏", tts: "pick" },
UnicodeAnnotation { codepoint: "⚒", tts: "hammer and pick" },
UnicodeAnnotation { codepoint: "🛠", tts: "hammer and wrench" },
UnicodeAnnotation { codepoint: "🗡", tts: "dagger" },
UnicodeAnnotation { codepoint: "⚔", tts: "crossed swords" },
UnicodeAnnotation { codepoint: "💣", tts: "bomb" },
UnicodeAnnotation { codepoint: "🏹", tts: "bow and arrow" },
UnicodeAnnotation { codepoint: "🛡", tts: "shield" },
UnicodeAnnotation { codepoint: "🔧", tts: "wrench" },
UnicodeAnnotation { codepoint: "🔩", tts: "nut and bolt" },
UnicodeAnnotation { codepoint: "⚙", tts: "gear" },
UnicodeAnnotation { codepoint: "🗜", tts: "clamp" },
UnicodeAnnotation { codepoint: "⚖", tts: "balance scale" },
UnicodeAnnotation { codepoint: "🔗", tts: "link" },
UnicodeAnnotation { codepoint: "⛓‍💥", tts: "broken chain" },
UnicodeAnnotation { codepoint: "⛓", tts: "chains" },
UnicodeAnnotation { codepoint: "⚗", tts: "alembic" },
UnicodeAnnotation { codepoint: "🔬", tts: "microscope" },
UnicodeAnnotation { codepoint: "🔭", tts: "telescope" },
UnicodeAnnotation { codepoint: "📡", tts: "satellite antenna" },
UnicodeAnnotation { codepoint: "💉", tts: "syringe" },
UnicodeAnnotation { codepoint: "💊", tts: "pill" },
UnicodeAnnotation { codepoint: "🚪", tts: "door" },
UnicodeAnnotation { codepoint: "🛏", tts: "bed" },
UnicodeAnnotation { codepoint: "🛋", tts: "couch and lamp" },
UnicodeAnnotation { codepoint: "🚽", tts: "toilet" },
UnicodeAnnotation { codepoint: "🚿", tts: "shower" },
UnicodeAnnotation { codepoint: "🛁", tts: "bathtub" },
UnicodeAnnotation { codepoint: "🛒", tts: "shopping cart" },
UnicodeAnnotation { codepoint: "🚬", tts: "cigarette" },
UnicodeAnnotation { codepoint: "⚰", tts: "coffin" },
UnicodeAnnotation { codepoint: "⚱", tts: "funeral urn" },
UnicodeAnnotation { codepoint: "🗿", tts: "moai" },
UnicodeAnnotation { codepoint: "🏧", tts: "ATM sign" },
UnicodeAnnotation { codepoint: "🚮", tts: "litter in bin sign" },
UnicodeAnnotation { codepoint: "🚰", tts: "potable water" },
UnicodeAnnotation { codepoint: "♿", tts: "wheelchair symbol" },
UnicodeAnnotation { codepoint: "🚹", tts: "men’s room" },
UnicodeAnnotation { codepoint: "🚺", tts: "women’s room" },
UnicodeAnnotation { codepoint: "🚻", tts: "restroom" },
UnicodeAnnotation { codepoint: "🚼", tts: "baby symbol" },
UnicodeAnnotation { codepoint: "🚾", tts: "water closet" },
UnicodeAnnotation { codepoint: "🛂", tts: "passport control" },
UnicodeAnnotation { codepoint: "🛃", tts: "customs" },
UnicodeAnnotation { codepoint: "🛄", tts: "baggage claim" },
UnicodeAnnotation { codepoint: "🛅", tts: "left luggage" },
UnicodeAnnotation { codepoint: "⚠", tts: "warning" },
UnicodeAnnotation { codepoint: "🚸", tts: "children crossing" },
UnicodeAnnotation { codepoint: "⛔", tts: "no entry" },
UnicodeAnnotation { codepoint: "🚫", tts: "prohibited" },
UnicodeAnnotation { codepoint: "🚳", tts: "no bicycles" },
UnicodeAnnotation { codepoint: "🚭", tts: "no smoking" },
UnicodeAnnotation { codepoint: "🚯", tts: "no littering" },
UnicodeAnnotation { codepoint: "🚱", tts: "non-potable water" },
UnicodeAnnotation { codepoint: "🚷", tts: "no pedestrians" },
UnicodeAnnotation { codepoint: "📵", tts: "no mobile phones" },
UnicodeAnnotation { codepoint: "🔞", tts: "no one under eighteen" },
UnicodeAnnotation { codepoint: "☢", tts: "radioactive" },
UnicodeAnnotation { codepoint: "☣", tts: "biohazard" },
UnicodeAnnotation { codepoint: "⬆", tts: "up arrow" },
UnicodeAnnotation { codepoint: "↗", tts: "up-right arrow" },
UnicodeAnnotation { codepoint: "➡", tts: "right arrow" },
UnicodeAnnotation { codepoint: "↘", tts: "down-right arrow" },
UnicodeAnnotation { codepoint: "⬇", tts: "down arrow" },
UnicodeAnnotation { codepoint: "↙", tts: "down-left arrow" },
UnicodeAnnotation { codepoint: "⬅", tts: "left arrow" },
UnicodeAnnotation { codepoint: "↖", tts: "up-left arrow" },
UnicodeAnnotation { codepoint: "↕", tts: "up-down arrow" },
UnicodeAnnotation { codepoint: "↔", tts: "left-right arrow" },
UnicodeAnnotation { codepoint: "↩", tts: "right arrow curving left" },
UnicodeAnnotation { codepoint: "↪", tts: "left arrow curving right" },
UnicodeAnnotation { codepoint: "⤴", tts: "right arrow curving up" },
UnicodeAnnotation { codepoint: "⤵", tts: "right arrow curving down" },
UnicodeAnnotation { codepoint: "🔃", tts: "clockwise vertical arrows" },
UnicodeAnnotation { codepoint: "🔄", tts: "counterclockwise arrows button" },
UnicodeAnnotation { codepoint: "🔙", tts: "BACK arrow" },
UnicodeAnnotation { codepoint: "🔚", tts: "END arrow" },
UnicodeAnnotation { codepoint: "🔛", tts: "ON! arrow" },
UnicodeAnnotation { codepoint: "🔜", tts: "SOON arrow" },
UnicodeAnnotation { codepoint: "🔝", tts: "TOP arrow" },
UnicodeAnnotation { codepoint: "🛐", tts: "place of worship" },
UnicodeAnnotation { codepoint: "⚛", tts: "atom symbol" },
UnicodeAnnotation { codepoint: "🕉", tts: "om" },
UnicodeAnnotation { codepoint: "✡", tts: "star of David" },
UnicodeAnnotation { codepoint: "☸", tts: "wheel of dharma" },
UnicodeAnnotation { codepoint: "☯", tts: "yin yang" },
UnicodeAnnotation { codepoint: "✝", tts: "latin cross" },
UnicodeAnnotation { codepoint: "☦", tts: "orthodox cross" },
UnicodeAnnotation { codepoint: "☪", tts: "star and crescent" },
UnicodeAnnotation { codepoint: "☮", tts: "peace symbol" },
UnicodeAnnotation { codepoint: "🕎", tts: "menorah" },
UnicodeAnnotation { codepoint: "🔯", tts: "dotted six-pointed star" },
UnicodeAnnotation { codepoint: "♈", tts: "Aries" },
UnicodeAnnotation { codepoint: "♉", tts: "Taurus" },
UnicodeAnnotation { codepoint: "♊", tts: "Gemini" },
UnicodeAnnotation { codepoint: "♋", tts: "Cancer" },
UnicodeAnnotation { codepoint: "♌", tts: "Leo" },
UnicodeAnnotation { codepoint: "♍", tts: "Virgo" },
UnicodeAnnotation { codepoint: "♎", tts: "Libra" },
UnicodeAnnotation { codepoint: "♏", tts: "Scorpio" },
UnicodeAnnotation { codepoint: "♐", tts: "Sagittarius" },
UnicodeAnnotation { codepoint: "♑", tts: "Capricorn" },
UnicodeAnnotation { codepoint: "♒", tts: "Aquarius" },
UnicodeAnnotation { codepoint: "♓", tts: "Pisces" },
UnicodeAnnotation { codepoint: "⛎", tts: "Ophiuchus" },
UnicodeAnnotation { codepoint: "🔀", tts: "shuffle tracks button" },
UnicodeAnnotation { codepoint: "🔁", tts: "repeat button" },
UnicodeAnnotation { codepoint: "🔂", tts: "repeat single button" },
UnicodeAnnotation { codepoint: "▶", tts: "play button" },
UnicodeAnnotation { codepoint: "⏩", tts: "fast-forward button" },
UnicodeAnnotation { codepoint: "⏭", tts: "next track button" },
UnicodeAnnotation { codepoint: "⏯", tts: "play or pause button" },
UnicodeAnnotation { codepoint: "◀", tts: "reverse button" },
UnicodeAnnotation { codepoint: "⏪", tts: "fast reverse button" },
UnicodeAnnotation { codepoint: "⏮", tts: "last track button" },
UnicodeAnnotation { codepoint: "🔼", tts: "upwards button" },
UnicodeAnnotation { codepoint: "⏫", tts: "fast up button" },
UnicodeAnnotation { codepoint: "🔽", tts: "downwards button" },
UnicodeAnnotation { codepoint: "⏬", tts: "fast down button" },
UnicodeAnnotation { codepoint: "⏸", tts: "pause button" },
UnicodeAnnotation { codepoint: "⏹", tts: "stop button" },
UnicodeAnnotation { codepoint: "⏺", tts: "record button" },
UnicodeAnnotation { codepoint: "⏏", tts: "eject button" },
UnicodeAnnotation { codepoint: "🎦", tts: "cinema" },
UnicodeAnnotation { codepoint: "🔅", tts: "dim button" },
UnicodeAnnotation { codepoint: "🔆", tts: "bright button" },
UnicodeAnnotation { codepoint: "📶", tts: "antenna bars" },
UnicodeAnnotation { codepoint: "📳", tts: "vibration mode" },
UnicodeAnnotation { codepoint: "📴", tts: "mobile phone off" },
UnicodeAnnotation { codepoint: "♀", tts: "female sign" },
UnicodeAnnotation { codepoint: "♂", tts: "male sign" },
UnicodeAnnotation { codepoint: "✖", tts: "multiply" },
UnicodeAnnotation { codepoint: "➕", tts: "plus" },
UnicodeAnnotation { codepoint: "➖", tts: "minus" },
UnicodeAnnotation { codepoint: "➗", tts: "divide" },
UnicodeAnnotation { codepoint: "‼", tts: "double exclamation mark" },
UnicodeAnnotation { codepoint: "⁉", tts: "exclamation question mark" },
UnicodeAnnotation { codepoint: "❓", tts: "red question mark" },
UnicodeAnnotation { codepoint: "❔", tts: "white question mark" },
UnicodeAnnotation { codepoint: "❕", tts: "white exclamation mark" },
UnicodeAnnotation { codepoint: "❗", tts: "red exclamation mark" },
UnicodeAnnotation { codepoint: "〰", tts: "wavy dash" },
UnicodeAnnotation { codepoint: "💱", tts: "currency exchange" },
UnicodeAnnotation { codepoint: "💲", tts: "heavy dollar sign" },
UnicodeAnnotation { codepoint: "⚕", tts: "medical symbol" },
UnicodeAnnotation { codepoint: "♻", tts: "recycling symbol" },
UnicodeAnnotation { codepoint: "⚜", tts: "fleur-de-lis" },
UnicodeAnnotation { codepoint: "🔱", tts: "trident emblem" },
UnicodeAnnotation { codepoint: "📛", tts: "name badge" },
UnicodeAnnotation { codepoint: "🔰", tts: "Japanese symbol for beginner" },
UnicodeAnnotation { codepoint: "⭕", tts: "hollow red circle" },
UnicodeAnnotation { codepoint: "✅", tts: "check mark button" },
UnicodeAnnotation { codepoint: "☑", tts: "check box with check" },
UnicodeAnnotation { codepoint: "✔", tts: "check mark" },
UnicodeAnnotation { codepoint: "❌", tts: "cross mark" },
UnicodeAnnotation { codepoint: "❎", tts: "cross mark button" },
UnicodeAnnotation { codepoint: "➰", tts: "curly loop" },
UnicodeAnnotation { codepoint: "➿", tts: "double curly loop" },
UnicodeAnnotation { codepoint: "〽", tts: "part alternation mark" },
UnicodeAnnotation { codepoint: "✳", tts: "eight-spoked asterisk" },
UnicodeAnnotation { codepoint: "✴", tts: "eight-pointed star" },
UnicodeAnnotation { codepoint: "❇", tts: "sparkle" },
UnicodeAnnotation { codepoint: "©", tts: "copyright" },
UnicodeAnnotation { codepoint: "®", tts: "registered" },
UnicodeAnnotation { codepoint: "™", tts: "trade mark" },
UnicodeAnnotation { codepoint: "🔠", tts: "input latin uppercase" },
UnicodeAnnotation { codepoint: "🔡", tts: "input latin lowercase" },
UnicodeAnnotation { codepoint: "🔢", tts: "input numbers" },
UnicodeAnnotation { codepoint: "🔣", tts: "input symbols" },
UnicodeAnnotation { codepoint: "🔤", tts: "input latin letters" },
UnicodeAnnotation { codepoint: "🅰", tts: "A button (blood type)" },
UnicodeAnnotation { codepoint: "🆎", tts: "AB button (blood type)" },
UnicodeAnnotation { codepoint: "🅱", tts: "B button (blood type)" },
UnicodeAnnotation { codepoint: "🆑", tts: "CL button" },
UnicodeAnnotation { codepoint: "🆒", tts: "COOL button" },
UnicodeAnnotation { codepoint: "🆓", tts: "FREE button" },
UnicodeAnnotation { codepoint: "ℹ", tts: "information" },
UnicodeAnnotation { codepoint: "🆔", tts: "ID button" },
UnicodeAnnotation { codepoint: "Ⓜ", tts: "circled M" },
UnicodeAnnotation { codepoint: "🆕", tts: "NEW button" },
UnicodeAnnotation { codepoint: "🆖", tts: "NG button" },
UnicodeAnnotation { codepoint: "🅾", tts: "O button (blood type)" },
UnicodeAnnotation { codepoint: "🆗", tts: "OK button" },
UnicodeAnnotation { codepoint: "🅿", tts: "P button" },
UnicodeAnnotation { codepoint: "🆘", tts: "SOS button" },
UnicodeAnnotation { codepoint: "🆙", tts: "UP! button" },
UnicodeAnnotation { codepoint: "🆚", tts: "VS button" },
UnicodeAnnotation { codepoint: "🈁", tts: "Japanese “here” button" },
UnicodeAnnotation { codepoint: "🈂", tts: "Japanese “service charge” button" },
UnicodeAnnotation { codepoint: "🈷", tts: "Japanese “monthly amount” button" },
UnicodeAnnotation { codepoint: "🈶", tts: "Japanese “not free of charge” button" },
UnicodeAnnotation { codepoint: "🈯", tts: "Japanese “reserved” button" },
UnicodeAnnotation { codepoint: "🉐", tts: "Japanese “bargain” button" },
UnicodeAnnotation { codepoint: "🈹", tts: "Japanese “discount” button" },
UnicodeAnnotation { codepoint: "🈚", tts: "Japanese “free of charge” button" },
UnicodeAnnotation { codepoint: "🈲", tts: "Japanese “prohibited” button" },
UnicodeAnnotation { codepoint: "🉑", tts: "Japanese “acceptable” button" },
UnicodeAnnotation { codepoint: "🈸", tts: "Japanese “application” button" },
UnicodeAnnotation { codepoint: "🈴", tts: "Japanese “passing grade” button" },
UnicodeAnnotation { codepoint: "🈳", tts: "Japanese “vacancy” button" },
UnicodeAnnotation { codepoint: "㊗", tts: "Japanese “congratulations” button" },
UnicodeAnnotation { codepoint: "㊙", tts: "Japanese “secret” button" },
UnicodeAnnotation { codepoint: "🈺", tts: "Japanese “open for business” button" },
UnicodeAnnotation { codepoint: "🈵", tts: "Japanese “no vacancy” button" },
UnicodeAnnotation { codepoint: "🔴", tts: "red circle" },
UnicodeAnnotation { codepoint: "🔵", tts: "blue circle" },
UnicodeAnnotation { codepoint: "⚫", tts: "black circle" },
UnicodeAnnotation { codepoint: "⚪", tts: "white circle" },
UnicodeAnnotation { codepoint: "⬛", tts: "black large square" },
UnicodeAnnotation { codepoint: "⬜", tts: "white large square" },
UnicodeAnnotation { codepoint: "◼", tts: "black medium square" },
UnicodeAnnotation { codepoint: "◻", tts: "white medium square" },
UnicodeAnnotation { codepoint: "◾", tts: "black medium-small square" },
UnicodeAnnotation { codepoint: "◽", tts: "white medium-small square" },
UnicodeAnnotation { codepoint: "▪", tts: "black small square" },
UnicodeAnnotation { codepoint: "▫", tts: "white small square" },
UnicodeAnnotation { codepoint: "🔶", tts: "large orange diamond" },
UnicodeAnnotation { codepoint: "🔷", tts: "large blue diamond" },
UnicodeAnnotation { codepoint: "🔸", tts: "small orange diamond" },
UnicodeAnnotation { codepoint: "🔹", tts: "small blue diamond" },
UnicodeAnnotation { codepoint: "🔺", tts: "red triangle pointed up" },
UnicodeAnnotation { codepoint: "🔻", tts: "red triangle pointed down" },
UnicodeAnnotation { codepoint: "💠", tts: "diamond with a dot" },
UnicodeAnnotation { codepoint: "🔘", tts: "radio button" },
UnicodeAnnotation { codepoint: "🔳", tts: "white square button" },
UnicodeAnnotation { codepoint: "🔲", tts: "black square button" },
UnicodeAnnotation { codepoint: "🏁", tts: "chequered flag" },
UnicodeAnnotation { codepoint: "🚩", tts: "triangular flag" },
UnicodeAnnotation { codepoint: "🎌", tts: "crossed flags" },
UnicodeAnnotation { codepoint: "🏴", tts: "black flag" },
UnicodeAnnotation { codepoint: "🏳", tts: "white flag" },
UnicodeAnnotation { codepoint: "🏳‍🌈", tts: "rainbow flag" },
UnicodeAnnotation { codepoint: "🏳‍⚧", tts: "transgender flag" },
UnicodeAnnotation { codepoint: "🏴‍☠", tts: "pirate flag" },
];
